=== modified file '.bzrignore'
--- .bzrignore	2010-09-30 06:24:20 +0000
+++ .bzrignore	2012-05-17 01:55:58 +0000
@@ -3,6 +3,7 @@
 *.8mandos
 confdir
 keydir
+statedir
 man
 plugin-runner
 plugins.d/askpass-fifo

=== modified file 'DBUS-API'
--- DBUS-API	2010-09-26 18:32:58 +0000
+++ DBUS-API	2016-02-28 14:22:10 +0000
@@ -5,7 +5,7 @@
 This file documents the D-Bus interface to the Mandos server.
 
 * Bus: System bus
-  Bus name: "se.bsnet.fukt.Mandos"
+  Bus name: "se.recompile.Mandos"
 
 
 * Object Paths:
@@ -13,38 +13,29 @@
   | Path                  | Object            |
   |-----------------------+-------------------|
   | "/"                   | The Mandos Server |
-  | "/clients/CLIENTNAME" | Mandos Client     |
-
-  
+
+  (To get a list of paths to client objects, use the standard D-Bus
+  org.freedesktop.DBus.ObjectManager interface, which the server
+  object supports.)
+
+
 * Mandos Server Interface:
-  Interface name: "se.bsnet.fukt.Mandos"
+  Interface name: "se.recompile.Mandos"
   
 ** Methods:
-*** GetAllClients() → (ao: Clients)
-    Returns an array of all client D-Bus object paths
-   
-*** GetAllClientsWithProperties() → (a{oa{sv}}: ClientProperties)
-    Returns an array of all clients and all their properties
-   
 *** RemoveClient(o: ObjectPath) → nothing
     Removes a client
    
 ** Signals:
-*** ClientAdded(o: ObjectPath)
-    A new client was added.
-   
 *** ClientNotFound(s: Fingerprint, s: Address)
     A client connected from Address using Fingerprint, but was
     rejected because it was not found in the server.  The fingerprint
     is represented as a string of hexadecimal digits.  The address is
     an IPv4 or IPv6 address in its normal string format.
-   
-*** ClientRemoved(o: ObjectPath, s: Name)
-    A client named Name on ObjectPath was removed.
 
 
 * Mandos Client Interface:
-  Interface name: "se.bsnet.fukt.Mandos.Client"
+  Interface name: "se.recompile.Mandos.Client"
   
 ** Methods
 *** Approve(b: Approve) → nothing
@@ -55,20 +46,6 @@
     Assert that this client has been checked and found to be alive.
     This will restart the timeout before disabling this client.  See
     also the "LastCheckedOK" property.
-    
-*** Disable() → nothing
-    Disable this client.  See also the "Enabled" property.
-    
-*** Enable() → nothing
-    Enable this client.  See also the "Enabled" property.
-    
-*** StartChecker() → nothing
-    Start a new checker for this client, if none is currently
-    running.  See also the "CheckerRunning" property.
-    
-*** StopChecker() → nothing
-    Abort a running checker process for this client, if any.  See also
-    the "CheckerRunning" property.
 
 ** Properties
    
@@ -86,43 +63,50 @@
    | CheckerRunning (c)      | b    | Read/Write | N/A                 |
    | Created (d)             | s    | Read       | N/A                 |
    | Enabled (e)             | b    | Read/Write | N/A                 |
+   | Expires (f)             | s    | Read       | N/A                 |
+   | ExtendedTimeout (a)     | t    | Read/Write | extended_timeout    |
    | Fingerprint             | s    | Read       | fingerprint         |
    | Host                    | s    | Read/Write | host                |
    | Interval (a)            | t    | Read/Write | interval            |
-   | LastApprovalRequest (f) | s    | Read       | N/A                 |
-   | LastCheckedOK (g)       | s    | Read/Write | N/A                 |
-   | LastEnabled (h)         | s    | Read       | N/A                 |
+   | LastApprovalRequest (g) | s    | Read       | N/A                 |
+   | LastCheckedOK (h)       | s    | Read/Write | N/A                 |
+   | LastCheckerStatus (i)   | n    | Read       | N/A                 |
+   | LastEnabled (j)         | s    | Read       | N/A                 |
    | Name                    | s    | Read       | (Section name)      |
-   | ObjectPath              | o    | Read       | N/A                 |
-   | Secret (i)              | ay   | Write      | secret (or secfile) |
+   | Secret (k)              | ay   | Write      | secret (or secfile) |
    | Timeout (a)             | t    | Read/Write | timeout             |
    
    a) Represented as milliseconds.
    
    b) An approval is currently pending.
    
-   c) Setting this property is equivalent to calling StartChecker() or
-      StopChecker().
-   
-   d) The creation time of this client object, as a RFC 3339 string.
-   
-   e) Setting this property is equivalent to calling Enable() or
-      Disable().
-   
-   f) The time of the last approval request, as a RFC 3339 string, or
-      an empty string if this has not happened.
-   
-   g) The last time a checker was successful, as a RFC 3339 string, or
-      an empty string if this has not happened.  Setting this property
-      is equivalent to calling CheckedOK(), i.e. the current time is
-      set, regardless of the string sent.  Please always use an empty
-      string when setting this property, to allow for possible future
-      expansion.
-   
-   h) The last time this client was enabled, as a RFC 3339 string, or
-      an empty string if this has not happened.
-   
-   i) A raw byte array, not hexadecimal digits.
+   c) Changing this property can either start a new checker or abort a
+      running one.
+   
+   d) The creation time of this client object, as an RFC 3339 string.
+   
+   e) Changing this property enables or disables a client.
+   
+   f) The date and time this client will be disabled, as an RFC 3339
+      string, or an empty string if this is not scheduled.
+   
+   g) The date and time of the last approval request, as an RFC 3339
+      string, or an empty string if this has not happened.
+   
+   h) The date and time a checker was last successful, as an RFC 3339
+      string, or an empty string if this has not happened.  Setting
+      this property is equivalent to calling CheckedOK(), i.e. the
+      current time is set, regardless of the string sent.  Please
+      always use an empty string when setting this property, to allow
+      for possible future expansion.
+   
+   i) The exit status of the last checker, -1 if it did not exit
+      cleanly, -2 if a checker has not yet returned.
+   
+   j) The date and time this client was last enabled, as an RFC 3339
+      string, or an empty string if this has not happened.
+   
+   k) A raw byte array, not hexadecimal digits.
 
 ** Signals
 *** CheckerCompleted(n: Exitcode, x: Waitstatus, s: Command)
@@ -140,17 +124,14 @@
     This client will be approved or denied in exactly Timeout
     milliseconds, depending on ApprovedByDefault.  Approve() can now
     usefully be called on this client object.
-
-*** PropertyChanged(s: Property, v: Value)
-    The Property on this client has changed to Value.
-
+    
 *** Rejected(s: Reason)
     This client was not given its secret for a specified Reason.
 
 * Copyright
 
-    Copyright © 2010 Teddy Hogeborn
-    Copyright © 2010 Björn Påhlsson
+    Copyright © 2010-2016 Teddy Hogeborn
+    Copyright © 2010-2016 Björn Påhlsson
   
 ** License:
    

=== modified file 'INSTALL'
--- INSTALL	2009-02-15 09:28:06 +0000
+++ INSTALL	2016-07-03 03:32:28 +0000
@@ -4,15 +4,16 @@
   
 ** Operating System
    
-   Debian 5.0 "lenny" or Ubuntu 8.04 "Hardy Heron".
+   Debian 8.0 "jessie" or Ubuntu 15.10 "Wily Werewolf" (or later).
    
    This is mostly for the support scripts which make sure that the
    client is installed and started in the initial RAM disk environment
-   and that the initrd.img file is automatically made unreadable.  The
-   server and client programs themselves *could* be run in other
-   distributions, but they *are* specific to GNU/Linux systems, and
-   are not intended to be portable to other Unixes.
-  
+   and that the initial RAM file system image file is automatically
+   made unreadable.  The server and client programs themselves *could*
+   be run in other distributions, but they *are* specific to GNU/Linux
+   systems, and are not written with portabillity to other Unixes in
+   mind.
+   
 ** Libraries
    
    The following libraries and packages are needed.  (It is possible
@@ -27,7 +28,7 @@
     + DocBook 4.5         http://www.docbook.org/
       Note: DocBook 5.0 is not compatible.
     + DocBook XSL stylesheets 1.71.0
-                   http://wiki.docbook.org/topic/DocBookXslStylesheets
+                         http://wiki.docbook.org/DocBookXslStylesheets
     
     Package names:
     docbook docbook-xsl
@@ -35,34 +36,41 @@
     To build just the documentation, run the command "make doc".  Then
     the manual page "mandos.8", for example, can be read by running
     "man -l mandos.8".
-   
+    
 *** Mandos Server
-    + GnuTLS 2.4          http://www.gnu.org/software/gnutls/
+    + GnuTLS 3.3          https://www.gnutls.org/
     + Avahi 0.6.16        http://www.avahi.org/
-    + Python 2.5          http://www.python.org/
-    + Python-GnuTLS 1.1.5 http://pypi.python.org/pypi/python-gnutls/
-    + dbus-python 0.82.4  http://dbus.freedesktop.org/doc/dbus-python/
-    + python-ctypes 1.0.0 http://pypi.python.org/pypi/ctypes
-    + PyGObject 2.14.2    http://library.gnome.org/devel/pygobject/
+    + Python 2.7          https://www.python.org/
+    + dbus-python 0.82.4 https://dbus.freedesktop.org/doc/dbus-python/
+    + PyGObject 3.7.1     https://wiki.gnome.org/Projects/PyGObject
+    + pkg-config https://www.freedesktop.org/wiki/Software/pkg-config/
+    + Urwid 1.0.1         http://urwid.org/
+      (Only needed by the "mandos-monitor" tool.)
     
     Strongly recommended:
-    + fping 2.4b2-to-ipv6 http://www.fping.com/
+    + fping 2.4b2-to-ipv6      http://www.fping.org/
+    + ssh-keyscan from OpenSSH http://www.openssh.com/
     
     Package names:
-    python-gnutls avahi-daemon python python-avahi python-dbus
-    python-ctypes python-gobject
-   
+    avahi-daemon python python-dbus python-gi python-urwid pkg-config
+    fping ssh-client
+    
 *** Mandos Client
+    + GNU C Library 2.16 https://gnu.org/software/libc/
     + initramfs-tools 0.85i
-                  http://packages.qa.debian.org/i/initramfs-tools.html
-    + GnuTLS 2.4          http://www.gnu.org/software/gnutls/
-    + Avahi 0.6.16        http://www.avahi.org/
-    + GnuPG 1.4.9         http://www.gnupg.org/
-    + GPGME 1.1.6         http://www.gnupg.org/related_software/gpgme/
+                        https://tracker.debian.org/pkg/initramfs-tools
+    + GnuTLS 3.3        https://www.gnutls.org/
+    + Avahi 0.6.16      http://www.avahi.org/
+    + GnuPG 1.4.9       https://www.gnupg.org/
+    + GPGME 1.1.6       https://www.gnupg.org/related_software/gpgme/
+    + pkg-config https://www.freedesktop.org/wiki/Software/pkg-config/
+    
+    Strongly recommended:
+    + OpenSSH           http://www.openssh.com/
     
     Package names:
     initramfs-tools libgnutls-dev libavahi-core-dev gnupg
-    libgpgme11-dev
+    libgpgme11-dev pkg-config ssh
 
 * Installing the Mandos server
   
@@ -98,17 +106,17 @@
      and append this to the file "/etc/mandos/clients.conf" *on the
      server computer*.
   
-  4. Configure the client to use the correct network interface.  The
-     default is "eth0", and if this needs to be adjusted, it will be
-     necessary to edit /etc/mandos/plugin-runner.conf to uncomment and
-     change the line there.  If that file is changed, the initrd.img
+  4. Configure the client to use any special configuration needed for
+     your local system.  Note: This is not necessary if the server is
+     present on the same wired local network as the client.  If you do
+     make changes to /etc/mandos/plugin-runner.conf, the initrd.img
      file must be updated, possibly using the following command:
      
 	# update-initramfs -k all -u
   
   5. On the server computer, start the server by running the command
      For Debian: su -c 'invoke-rc.d mandos start'
-     For Ubuntu: sudo invoke-rc.d mandos start
+     For Ubuntu: sudo service mandos start
      
      At this point, it is possible to verify that the correct password
      will be received by the client by running the command:
@@ -122,12 +130,14 @@
      
      After this, the client computer should be able to reboot without
      needing a password entered on the console, as long as it does not
-     take more than an hour to reboot.
+     take more than five minutes to reboot.
 
 * Further customizations
   
   You may want to tighten or loosen the timeouts in the server
   configuration files; see mandos.conf(5) and mandos-clients.conf(5).
-  If IPsec is not used, it is suggested that a more cryptographically
-  secure checker program is used and configured, since without IPsec
-  ping packets can be faked.
+  If IPsec is not used and SSH is not installed, it is suggested that
+  a more cryptographically secure checker program is used and
+  configured, since, without IPsec, ping packets can be faked.
+
+#+STARTUP: showall

=== modified file 'Makefile'
--- Makefile	2010-10-02 17:23:41 +0000
+++ Makefile	2016-10-29 14:22:26 +0000
@@ -1,16 +1,33 @@
-WARN=-O -Wall -Wformat=2 -Winit-self -Wmissing-include-dirs \
-	-Wswitch-default -Wswitch-enum -Wunused-parameter \
-	-Wstrict-aliasing=1 -Wextra -Wfloat-equal -Wundef -Wshadow \
+WARN=-O -Wall -Wextra -Wdouble-promotion -Wformat=2 -Winit-self \
+	-Wmissing-include-dirs -Wswitch-default -Wswitch-enum \
+	-Wunused -Wuninitialized -Wstrict-overflow=5 \
+	-Wsuggest-attribute=pure -Wsuggest-attribute=const \
+	-Wsuggest-attribute=noreturn -Wfloat-equal -Wundef -Wshadow \
 	-Wunsafe-loop-optimizations -Wpointer-arith \
 	-Wbad-function-cast -Wcast-qual -Wcast-align -Wwrite-strings \
-	-Wconversion -Wstrict-prototypes -Wold-style-definition \
-	-Wpacked -Wnested-externs -Winline -Wvolatile-register-var
-#	-Wunreachable-code 
-#DEBUG=-ggdb3
-# For info about _FORTIFY_SOURCE, see
-# <http://www.kernel.org/doc/man-pages/online/pages/man7/feature_test_macros.7.html>
-# and <http://gcc.gnu.org/ml/gcc-patches/2004-09/msg02055.html>.
+	-Wconversion -Wlogical-op -Waggregate-return \
+	-Wstrict-prototypes -Wold-style-definition \
+	-Wmissing-format-attribute -Wnormalized=nfc -Wpacked \
+	-Wredundant-decls -Wnested-externs -Winline -Wvla \
+	-Wvolatile-register-var -Woverlength-strings
+#DEBUG=-ggdb3 -fsanitize=address 
+# For info about _FORTIFY_SOURCE, see feature_test_macros(7)
+# and <https://gcc.gnu.org/ml/gcc-patches/2004-09/msg02055.html>.
 FORTIFY=-D_FORTIFY_SOURCE=2 -fstack-protector-all -fPIC
+# <https://developerblog.redhat.com/2014/10/16/gcc-undefined-behavior-sanitizer-ubsan/>
+ALL_SANITIZE_OPTIONS:=-fsanitize=leak -fsanitize=undefined \
+        -fsanitize=shift -fsanitize=integer-divide-by-zero \
+        -fsanitize=unreachable -fsanitize=vla-bound -fsanitize=null \
+        -fsanitize=return -fsanitize=signed-integer-overflow \
+        -fsanitize=bounds -fsanitize=alignment \
+        -fsanitize=object-size -fsanitize=float-divide-by-zero \
+        -fsanitize=float-cast-overflow -fsanitize=nonnull-attribute \
+        -fsanitize=returns-nonnull-attribute -fsanitize=bool \
+        -fsanitize=enum
+# Check which sanitizing options can be used
+SANITIZE:=$(foreach option,$(ALL_SANITIZE_OPTIONS),$(shell \
+	echo 'int main(){}' | $(CC) --language=c $(option) /dev/stdin \
+	-o /dev/null >/dev/null 2>&1 && echo $(option)))
 LINK_FORTIFY_LD=-z relro -z now
 LINK_FORTIFY=
 
@@ -20,18 +37,23 @@
 LINK_FORTIFY += -pie
 endif
 #COVERAGE=--coverage
-OPTIMIZE=-Os
-LANGUAGE=-std=gnu99
+OPTIMIZE=-Os -fno-strict-aliasing
+LANGUAGE=-std=gnu11
 htmldir=man
-version=1.2.1
+version=1.7.13
 SED=sed
 
+USER=$(firstword $(subst :, ,$(shell getent passwd _mandos || getent passwd nobody || echo 65534)))
+GROUP=$(firstword $(subst :, ,$(shell getent group _mandos || getent group nogroup || echo 65534)))
+
 ## Use these settings for a traditional /usr/local install
 # PREFIX=$(DESTDIR)/usr/local
 # CONFDIR=$(DESTDIR)/etc/mandos
 # KEYDIR=$(DESTDIR)/etc/mandos/keys
 # MANDIR=$(PREFIX)/man
 # INITRAMFSTOOLS=$(DESTDIR)/etc/initramfs-tools
+# STATEDIR=$(DESTDIR)/var/lib/mandos
+# LIBDIR=$(PREFIX)/lib
 ##
 
 ## These settings are for a package-type install
@@ -40,8 +62,21 @@
 KEYDIR=$(DESTDIR)/etc/keys/mandos
 MANDIR=$(PREFIX)/share/man
 INITRAMFSTOOLS=$(DESTDIR)/usr/share/initramfs-tools
+STATEDIR=$(DESTDIR)/var/lib/mandos
+LIBDIR=$(shell \
+	for d in \
+	"/usr/lib/`dpkg-architecture -qDEB_HOST_MULTIARCH 2>/dev/null`" \
+	"`rpm --eval='%{_libdir}' 2>/dev/null`" /usr/lib; do \
+		if [ -d "$$d" -a "$$d" = "$${d%/}" ]; then \
+			echo "$(DESTDIR)$$d"; \
+			break; \
+		fi; \
+	done)
 ##
 
+SYSTEMD=$(DESTDIR)$(shell pkg-config systemd --variable=systemdsystemunitdir)
+TMPFILES=$(DESTDIR)$(shell pkg-config systemd --variable=tmpfilesdir)
+
 GNUTLS_CFLAGS=$(shell pkg-config --cflags-only-I gnutls)
 GNUTLS_LIBS=$(shell pkg-config --libs gnutls)
 AVAHI_CFLAGS=$(shell pkg-config --cflags-only-I avahi-core)
@@ -49,12 +84,14 @@
 GPGME_CFLAGS=$(shell gpgme-config --cflags; getconf LFS_CFLAGS)
 GPGME_LIBS=$(shell gpgme-config --libs; getconf LFS_LIBS; \
 	getconf LFS_LDFLAGS)
+LIBNL3_CFLAGS=$(shell pkg-config --cflags-only-I libnl-route-3.0)
+LIBNL3_LIBS=$(shell pkg-config --libs libnl-route-3.0)
 
 # Do not change these two
-CFLAGS=$(WARN) $(DEBUG) $(FORTIFY) $(COVERAGE) $(OPTIMIZE) \
-	$(LANGUAGE) $(GNUTLS_CFLAGS) $(AVAHI_CFLAGS) $(GPGME_CFLAGS) \
-	-DVERSION='"$(version)"'
-LDFLAGS=$(COVERAGE) $(LINK_FORTIFY) $(foreach flag,$(LINK_FORTIFY_LD),-Xlinker $(flag))
+CFLAGS+=$(WARN) $(DEBUG) $(FORTIFY) $(SANITIZE) $(COVERAGE) \
+	$(OPTIMIZE) $(LANGUAGE) $(GNUTLS_CFLAGS) $(AVAHI_CFLAGS) \
+	$(GPGME_CFLAGS) -DVERSION='"$(version)"'
+LDFLAGS+=-Xlinker --as-needed $(COVERAGE) $(LINK_FORTIFY) $(foreach flag,$(LINK_FORTIFY_LD),-Xlinker $(flag))
 
 # Commands to format a DocBook <refentry> document into a manual page
 DOCBOOKTOMAN=$(strip cd $(dir $<); xsltproc --nonet --xinclude \
@@ -63,11 +100,12 @@
 	--param make.single.year.ranges		1 \
 	--param man.output.quietly		1 \
 	--param man.authors.section.enabled	0 \
-	 /usr/share/xml/docbook/stylesheet/nwalsh/manpages/docbook.xsl \
+	/usr/share/xml/docbook/stylesheet/nwalsh/manpages/docbook.xsl \
 	$(notdir $<); \
-	$(MANPOST) $(notdir $@))
-# DocBook-to-man post-processing to fix a '\n' escape bug
-MANPOST=$(SED) --in-place --expression='s,\\\\en,\\en,g;s,\\n,\\en,g'
+	if locale --all 2>/dev/null | grep --regexp='^en_US\.utf8$$' \
+	&& type man 2>/dev/null; then LANG=en_US.UTF-8 MANWIDTH=80 \
+	man --warnings --encoding=UTF-8 --local-file $(notdir $@); \
+	fi >/dev/null)
 
 DOCBOOKTOHTML=$(strip xsltproc --nonet --xinclude \
 	--param make.year.ranges		1 \
@@ -85,14 +123,15 @@
 PLUGINS=plugins.d/password-prompt plugins.d/mandos-client \
 	plugins.d/usplash plugins.d/splashy plugins.d/askpass-fifo \
 	plugins.d/plymouth
-CPROGS=plugin-runner $(PLUGINS)
+PLUGIN_HELPERS=plugin-helpers/mandos-client-iprouteadddel
+CPROGS=plugin-runner $(PLUGINS) $(PLUGIN_HELPERS)
 PROGS=mandos mandos-keygen mandos-ctl mandos-monitor $(CPROGS)
 DOCS=mandos.8 mandos-keygen.8 mandos-monitor.8 mandos-ctl.8 \
 	mandos.conf.5 mandos-clients.conf.5 plugin-runner.8mandos \
 	plugins.d/mandos-client.8mandos \
 	plugins.d/password-prompt.8mandos plugins.d/usplash.8mandos \
 	plugins.d/splashy.8mandos plugins.d/askpass-fifo.8mandos \
-	plugins.d/plymouth.8mandos
+	plugins.d/plymouth.8mandos intro.8mandos
 
 htmldocs=$(addsuffix .xhtml,$(DOCS))
 
@@ -119,6 +158,11 @@
 %.8mandos.xhtml: %.xml common.ent legalnotice.xml
 	$(DOCBOOKTOHTML)
 
+intro.8mandos: intro.xml common.ent legalnotice.xml
+	$(DOCBOOKTOMAN)
+intro.8mandos.xhtml: intro.xml common.ent legalnotice.xml
+	$(DOCBOOKTOHTML)
+
 mandos.8: mandos.xml common.ent mandos-options.xml overview.xml \
 		legalnotice.xml
 	$(DOCBOOKTOMAN)
@@ -210,12 +254,18 @@
 		$@)
 
 plugins.d/mandos-client: plugins.d/mandos-client.c
-	$(LINK.c) $(GNUTLS_LIBS) $(AVAHI_LIBS) $(GPGME_LIBS) $(strip\
-		) $(COMMON) $^ $(LOADLIBES) $(LDLIBS) -o $@
-
-.PHONY : all doc html clean distclean run-client run-server install \
-	install-server install-client uninstall uninstall-server \
-	uninstall-client purge purge-server purge-client
+	$(LINK.c) $^ -lrt $(GNUTLS_LIBS) $(AVAHI_LIBS) $(strip\
+		) $(GPGME_LIBS) $(LOADLIBES) $(LDLIBS) -o $@
+
+plugin-helpers/mandos-client-iprouteadddel: plugin-helpers/mandos-client-iprouteadddel.c
+	$(LINK.c) $(LIBNL3_CFLAGS) $^ $(LIBNL3_LIBS) $(strip\
+		) $(LOADLIBES) $(LDLIBS) -o $@
+
+.PHONY : all doc html clean distclean mostlyclean maintainer-clean \
+	check run-client run-server install install-html \
+	install-server install-client-nokey install-client uninstall \
+	uninstall-server uninstall-client purge purge-server \
+	purge-client
 
 clean:
 	-rm --force $(CPROGS) $(objects) $(htmldocs) $(DOCS) core
@@ -223,27 +273,34 @@
 distclean: clean
 mostlyclean: clean
 maintainer-clean: clean
-	-rm --force --recursive keydir confdir
+	-rm --force --recursive keydir confdir statedir
 
 check:	all
 	./mandos --check
+	./mandos-ctl --check
 
 # Run the client with a local config and key
 run-client: all keydir/seckey.txt keydir/pubkey.txt
 	@echo "###################################################################"
 	@echo "# The following error messages are harmless and can be safely     #"
-	@echo "# ignored.  The messages are caused by not running as root, but   #"
-	@echo "# you should NOT run \"make run-client\" as root unless you also    #"
-	@echo "# unpacked and compiled Mandos as root, which is NOT recommended. #"
-	@echo "# From plugin-runner: setuid: Operation not permitted             #"
+	@echo "# ignored:                                                        #"
+	@echo "# From plugin-runner: setgid: Operation not permitted             #"
+	@echo "#                     setuid: Operation not permitted             #"
 	@echo "# From askpass-fifo:  mkfifo: Permission denied                   #"
-	@echo "# From mandos-client: setuid: Operation not permitted             #"
-	@echo "#                     seteuid: Operation not permitted            #"
-	@echo "#                     klogctl: Operation not permitted            #"
+	@echo "# From mandos-client:                                             #"
+	@echo "#             Failed to raise privileges: Operation not permitted #"
+	@echo "#             Warning: network hook \"*\" exited with status *      #"
+	@echo "#                                                                 #"
+	@echo "# (The messages are caused by not running as root, but you should #"
+	@echo "# NOT run \"make run-client\" as root unless you also unpacked and  #"
+	@echo "# compiled Mandos as root, which is also NOT recommended.)        #"
 	@echo "###################################################################"
+# We set GNOME_KEYRING_CONTROL to block pam_gnome_keyring
 	./plugin-runner --plugin-dir=plugins.d \
+		--plugin-helper-dir=plugin-helpers \
 		--config-file=plugin-runner.conf \
-		--options-for=mandos-client:--seckey=keydir/seckey.txt,--pubkey=keydir/pubkey.txt \
+		--options-for=mandos-client:--seckey=keydir/seckey.txt,--pubkey=keydir/pubkey.txt,--network-hook-dir=network-hooks.d \
+		--env-for=mandos-client:GNOME_KEYRING_CONTROL= \
 		$(CLIENTARGS)
 
 # Used by run-client
@@ -252,14 +309,9 @@
 	./mandos-keygen --dir keydir --force
 
 # Run the server with a local config
-run-server: confdir/mandos.conf confdir/clients.conf
-	@echo "#################################################################"
-	@echo "# NOTE: Please IGNORE the error about \"Could not open file      #"
-	@echo "# u'/var/run/mandos.pid'\" -  it is harmless and is caused by    #"
-	@echo "# the server not running as root.  Do NOT run \"make run-server\" #"
-	@echo "# server as root if you didn't also unpack and compile it thus. #"
-	@echo "#################################################################"
-	./mandos --debug --no-dbus --configdir=confdir $(SERVERARGS)
+run-server: confdir/mandos.conf confdir/clients.conf statedir
+	./mandos --debug --no-dbus --configdir=confdir \
+		--statedir=statedir $(SERVERARGS)
 
 # Used by run-server
 confdir/mandos.conf: mandos.conf
@@ -269,7 +321,9 @@
 	install --directory confdir
 	install --mode=u=rw $< $@
 # Add a client password
-	./mandos-keygen --dir keydir --password >> $@
+	./mandos-keygen --dir keydir --password --no-ssh >> $@
+statedir:
+	install --directory statedir
 
 install: install-server install-client-nokey
 
@@ -280,6 +334,16 @@
 
 install-server: doc
 	install --directory $(CONFDIR)
+	if install --directory --mode=u=rwx --owner=$(USER) \
+		--group=$(GROUP) $(STATEDIR); then \
+		:; \
+	elif install --directory --mode=u=rwx $(STATEDIR); then \
+		chown -- $(USER):$(GROUP) $(STATEDIR) || :; \
+	fi
+	if [ "$(TMPFILES)" != "$(DESTDIR)" -a -d "$(TMPFILES)" ]; then \
+		install --mode=u=rw,go=r tmpfiles.d-mandos.conf \
+			$(TMPFILES)/mandos.conf; \
+	fi
 	install --mode=u=rwx,go=rx mandos $(PREFIX)/sbin/mandos
 	install --mode=u=rwx,go=rx --target-directory=$(PREFIX)/sbin \
 		mandos-ctl
@@ -293,6 +357,9 @@
 		$(DESTDIR)/etc/dbus-1/system.d/mandos.conf
 	install --mode=u=rwx,go=rx init.d-mandos \
 		$(DESTDIR)/etc/init.d/mandos
+	if [ "$(SYSTEMD)" != "$(DESTDIR)" -a -d "$(SYSTEMD)" ]; then \
+		install --mode=u=rw,go=r mandos.service $(SYSTEMD); \
+	fi
 	install --mode=u=rw,go=r default-mandos \
 		$(DESTDIR)/etc/default/mandos
 	if [ -z $(DESTDIR) ]; then \
@@ -308,37 +375,46 @@
 		> $(MANDIR)/man5/mandos.conf.5.gz
 	gzip --best --to-stdout mandos-clients.conf.5 \
 		> $(MANDIR)/man5/mandos-clients.conf.5.gz
+	gzip --best --to-stdout intro.8mandos \
+		> $(MANDIR)/man8/intro.8mandos.gz
 
 install-client-nokey: all doc
-	install --directory $(PREFIX)/lib/mandos $(CONFDIR)
+	install --directory $(LIBDIR)/mandos $(CONFDIR)
 	install --directory --mode=u=rwx $(KEYDIR) \
-		$(PREFIX)/lib/mandos/plugins.d
-	if [ "$(CONFDIR)" != "$(PREFIX)/lib/mandos" ]; then \
+		$(LIBDIR)/mandos/plugins.d \
+		$(LIBDIR)/mandos/plugin-helpers
+	if [ "$(CONFDIR)" != "$(LIBDIR)/mandos" ]; then \
 		install --mode=u=rwx \
-			--directory "$(CONFDIR)/plugins.d"; \
+			--directory "$(CONFDIR)/plugins.d" \
+			"$(CONFDIR)/plugin-helpers"; \
 	fi
+	install --mode=u=rwx,go=rx --directory \
+		"$(CONFDIR)/network-hooks.d"
 	install --mode=u=rwx,go=rx \
-		--target-directory=$(PREFIX)/lib/mandos plugin-runner
+		--target-directory=$(LIBDIR)/mandos plugin-runner
 	install --mode=u=rwx,go=rx --target-directory=$(PREFIX)/sbin \
 		mandos-keygen
 	install --mode=u=rwx,go=rx \
-		--target-directory=$(PREFIX)/lib/mandos/plugins.d \
+		--target-directory=$(LIBDIR)/mandos/plugins.d \
 		plugins.d/password-prompt
 	install --mode=u=rwxs,go=rx \
-		--target-directory=$(PREFIX)/lib/mandos/plugins.d \
+		--target-directory=$(LIBDIR)/mandos/plugins.d \
 		plugins.d/mandos-client
 	install --mode=u=rwxs,go=rx \
-		--target-directory=$(PREFIX)/lib/mandos/plugins.d \
+		--target-directory=$(LIBDIR)/mandos/plugins.d \
 		plugins.d/usplash
 	install --mode=u=rwxs,go=rx \
-		--target-directory=$(PREFIX)/lib/mandos/plugins.d \
+		--target-directory=$(LIBDIR)/mandos/plugins.d \
 		plugins.d/splashy
 	install --mode=u=rwxs,go=rx \
-		--target-directory=$(PREFIX)/lib/mandos/plugins.d \
+		--target-directory=$(LIBDIR)/mandos/plugins.d \
 		plugins.d/askpass-fifo
 	install --mode=u=rwxs,go=rx \
-		--target-directory=$(PREFIX)/lib/mandos/plugins.d \
+		--target-directory=$(LIBDIR)/mandos/plugins.d \
 		plugins.d/plymouth
+	install --mode=u=rwx,go=rx \
+		--target-directory=$(LIBDIR)/mandos/plugin-helpers \
+		plugin-helpers/mandos-client-iprouteadddel
 	install initramfs-tools-hook \
 		$(INITRAMFSTOOLS)/hooks/mandos
 	install --mode=u=rw,go=r initramfs-tools-hook-conf \
@@ -389,13 +465,13 @@
 	! grep --regexp='^ *[^ #].*keyscript=[^,=]*/mandos/' \
 		$(DESTDIR)/etc/crypttab
 	-rm --force $(PREFIX)/sbin/mandos-keygen \
-		$(PREFIX)/lib/mandos/plugin-runner \
-		$(PREFIX)/lib/mandos/plugins.d/password-prompt \
-		$(PREFIX)/lib/mandos/plugins.d/mandos-client \
-		$(PREFIX)/lib/mandos/plugins.d/usplash \
-		$(PREFIX)/lib/mandos/plugins.d/splashy \
-		$(PREFIX)/lib/mandos/plugins.d/askpass-fifo \
-		$(PREFIX)/lib/mandos/plugins.d/plymouth \
+		$(LIBDIR)/mandos/plugin-runner \
+		$(LIBDIR)/mandos/plugins.d/password-prompt \
+		$(LIBDIR)/mandos/plugins.d/mandos-client \
+		$(LIBDIR)/mandos/plugins.d/usplash \
+		$(LIBDIR)/mandos/plugins.d/splashy \
+		$(LIBDIR)/mandos/plugins.d/askpass-fifo \
+		$(LIBDIR)/mandos/plugins.d/plymouth \
 		$(INITRAMFSTOOLS)/hooks/mandos \
 		$(INITRAMFSTOOLS)/conf-hooks.d/mandos \
 		$(INITRAMFSTOOLS)/scripts/init-premount/mandos \
@@ -407,8 +483,8 @@
 		$(MANDIR)/man8/splashy.8mandos.gz \
 		$(MANDIR)/man8/askpass-fifo.8mandos.gz \
 		$(MANDIR)/man8/plymouth.8mandos.gz \
-	-rmdir $(PREFIX)/lib/mandos/plugins.d $(CONFDIR)/plugins.d \
-		 $(PREFIX)/lib/mandos $(CONFDIR) $(KEYDIR)
+	-rmdir $(LIBDIR)/mandos/plugins.d $(CONFDIR)/plugins.d \
+		 $(LIBDIR)/mandos $(CONFDIR) $(KEYDIR)
 	update-initramfs -k all -u
 
 purge: purge-server purge-client
@@ -418,6 +494,8 @@
 		$(DESTDIR)/etc/dbus-1/system.d/mandos.conf
 		$(DESTDIR)/etc/default/mandos \
 		$(DESTDIR)/etc/init.d/mandos \
+		$(SYSTEMD)/mandos.service \
+		$(DESTDIR)/run/mandos.pid \
 		$(DESTDIR)/var/run/mandos.pid
 	-rmdir $(CONFDIR)
 

=== modified file 'NEWS'
--- NEWS	2010-10-02 17:23:41 +0000
+++ NEWS	2016-10-08 04:33:04 +0000
@@ -1,6 +1,299 @@
 This NEWS file records noteworthy changes, very tersely.
 See the manual for detailed information.
 
+Version 1.7.13 (2016-10-08)
+* Client
+** Minor bug fix: Don't ask for passphrase or fail when generating
+   keys using GnuPG 2.1 in a chrooted environment.
+
+Version 1.7.12 (2016-10-05)
+* Client
+** Bug fix: Don't crash after exit() when using DH parameters file
+
+Version 1.7.11 (2016-10-01)
+* Client
+** Security fix: Don't compile with AddressSanitizer
+* Server
+** Bug fix: Find GnuTLS library when gnutls28-dev is not installed
+** Bug fix: Include "Expires" and "Last Checker Status" in mandos-ctl
+   verbose output
+** New option for mandos-ctl: --dump-json
+
+Version 1.7.10 (2016-06-23)
+* Client
+** Security fix: restrict permissions of /etc/mandos/plugin-helpers
+* Server
+** Bug fix: Make the --interface flag work with Python 2.7 when "cc"
+   is not installed
+
+Version 1.7.9 (2016-06-22)
+* Client
+** Do not include intro(8mandos) man page
+
+Version 1.7.8 (2016-06-21)
+* Client
+** Include intro(8mandos) man page
+** mandos-keygen: Use ECDSA SSH keys by default
+** Bug fix: Work with GnuPG 2 when booting (Debian bug #819982)
+   by copying /usr/bin/gpg-agent into initramfs
+* Server
+** Bug fix: Work with GnuPG 2 (don't use --no-use-agent option)
+** Bug fix: Make the --interface option work when using Python 2.7
+   by trying harder to find SO_BINDTODEVICE
+
+Version 1.7.7 (2016-03-19)
+* Client
+** Fix bug in Plymouth client, broken since 1.7.2
+
+Version 1.7.6 (2016-03-13)
+* Server
+** Fix bug where stopping server would time out
+** Make server runnable with Python 3
+
+Version 1.7.5 (2016-03-08)
+* Server
+** Fix security restrictions in systemd service file.
+** Work around bug where stopping server would time out
+
+Version 1.7.4 (2016-03-05)
+* Client
+** Bug fix: Tolerate errors from configure_networking (Debian Bug
+   #816513)
+** Compilation: Only use sanitizing options which work with the
+   compiler used when building.  This should fix compilation with GCC
+   4.9 on mips, mipsel, and s390x.
+* Server
+** Add extra security restrictions in systemd service file.
+
+Version 1.7.3 (2016-02-29)
+* Client
+** Bug fix: Remove new type of keyring directory user by GnuPG 2.1.
+** Bug fix: Remove "nonnull" attribute from a function argument, which
+   would otherwise generate a spurious runtime warning.
+
+Version 1.7.2 (2016-02-28)
+* Server
+** Stop using python-gnutls library; it was not updated to GnuTLS 3.3.
+** Bug fix: Only send D-Bus signal ClientRemoved if using D-Bus.
+** Use GnuPG 2 if available.
+* Client
+** Compile with various sanitizing flags.
+
+Version 1.7.1 (2015-10-24)
+* Client
+** Bug fix: Can now really find Mandos server even if the server has
+   an IPv6 address on a network other than the one which the Mandos
+   server is on.
+
+Version 1.7.0 (2015-08-10)
+* Server
+** Bug fix: Handle local Zeroconf service name collisions better.
+** Bug fix: Finally fix "ERROR: Child process vanished" bug.
+** Bug fix: Fix systemd service file to start server correctly.
+** Bug fix: Be compatible with old 2048-bit DSA keys.
+** The D-Bus API now provides the standard D-Bus ObjectManager
+   interface, and deprecates older functionality.  See the DBUS-API
+   file for the currently recommended API.  Note: the original API
+   still works, but is deprecated.
+* Client
+** Can now find Mandos server even if the server has an IPv6 address
+   on a network without IPv6 Router Advertisment (like if the Mandos
+   client itself is the router, or there is an IPv6 router advertising
+   a network other than the one which the Mandos server is on.)
+** Use a better value than 1024 for the default number of DH bits.
+   This better value is either provided by a DH parameters file (see
+   below) or an appropriate number of DH bits is determined based on
+   the PGP key.
+** Bug fix: mandos-keygen now generates correct output for the
+   "Checker" variable even if the SSH server on the Mandos client has
+   multiple SSH key types.
+** Can now use pre-generated Diffie-Hellman parameters from a file.
+
+Version 1.6.9 (2014-10-05)
+* Server
+** Changed to emit standard D-Bus signal when D-Bus properties change.
+   (The old signal is still emitted too, but marked as deprecated.)
+
+Version 1.6.8 (2014-08-06)
+* Client
+** Bug fix: mandos-keygen now generates working SSH checker commands.
+* Server
+** Bug fix: "mandos-monitor" now really redraws screen on Ctrl-L.
+** Now requires Python 2.7.
+
+Version 1.6.7 (2014-07-17)
+* Client
+** Bug fix: Now compatible with GPGME 1.5.0.
+** Bug fix: Fixed minor memory leaks.
+* Server
+** "mandos-monitor" now has verbose logging, toggleable with "v".
+
+Version 1.6.6 (2014-07-13)
+* Client
+** If client host has an SSH server, "mandos-keygen --password" now
+   outputs "checker" option which uses "ssh-keyscan"; this is more
+   secure than the default "fping" checker.
+** Bug fix: allow "." in network hook names, to match documentation.
+** Better error messages.
+* Server
+** New --no-zeroconf option.
+** Bug fix: Fix --servicename option, broken since 1.6.4.
+** Bug fix: Fix --socket option work for --socket=0.
+
+Version 1.6.5 (2014-05-11)
+* Client
+** Work around bug in GnuPG <http://bugs.g10code.com/gnupg/issue1622>
+** Give better error messages when run without sufficient privileges
+** Only warn if workaround for Debian bug #633582 was necessary and
+   failed, not if it failed and was unnecessary.
+
+Version 1.6.4 (2014-02-16)
+* Server
+** Very minor fix to self-test code.
+
+Version 1.6.3 (2014-01-21)
+* Server
+** Add systemd support.
+** For PID file, fall back to /var/run if /run does not exist.
+* Client
+** Moved files from /usr/lib/mandos to whatever the architecture
+   specifies, like /usr/lib/x86_64-linux-gnu/mandos or
+   /usr/lib64/mandos.
+
+Version 1.6.2 (2013-10-24)
+* Server
+** PID file moved from /var/run to /run.
+** Bug fix: Handle long secrets when saving client state.
+** Bug fix: Use more magic in the GnuTLS priority string to handle
+   both old DSA/ELG 2048-bit keys and new RSA/RSA 4096-bit keys.
+* Client
+** mandos-keygen: Bug fix: now generate RSA keys which GnuTLS can use.
+   		  Bug fix: Output passphrase prompts even when
+   		  redirecting standard output.
+
+Version 1.6.1 (2013-10-13)
+* Server
+** All client options for time intervals now also take an RFC 3339
+   duration.  The same for all options to mandos-ctl.
+** Bug fix: Handle fast checkers (like ":") correctly.
+** Bug fix: Don't print output from checkers when running in
+   foreground.
+** Bug fix: Do not fail when client is removed from clients.conf but
+   saved settings remain.
+** Bug fix: mandos-monitor now displays standout (reverse video) again
+   using new version of Urwid.
+** Bug fix: Make boolean options work from the config file again.
+** Bug fix: Make --no-ipv6 work again.
+** New default priority string to be slightly more compatible with
+   older versions of GnuTLS.
+* Client
+** Bug fix: Fix bashism in mandos-keygen.
+** Default key and subkey types are now RSA and RSA, respectively.
+   Also, new default key size is 4096 bits.
+
+Version 1.6.0 (2012-06-18)
+* Server
+** Takes new --foreground option
+** Init script supports new "status" action.
+* Client
+** Now uses all interfaces by default; the --interface option can
+   still be used to restrict it, and the argument to --interface (as
+   well as the $DEVICE environment variable for the network hooks) is
+   now a comma-separated list of interfaces to use.
+
+Version 1.5.5 (2012-06-01)
+* Server
+** Server takes new --socket option
+
+Version 1.5.4 (2012-05-20)
+* Server
+** Bug fix: Regression fix: Make non-zero approval timeout values work.
+** Bug fix: Regression fix: Allow changing the Timeout D-Bus property.
+** Fall back to not bind to an interface if an invalid interface name
+   is given.
+** Removed support for undocumented feature of using plain "%%s" in
+   "checker" client option.
+** Old D-Bus interface are now marked as deprecated.
+** mandos-monitor: Bug fix: show approval timers correctly.
+** mandos-ctl: Show "Extended Timeout" correctly, not as milliseconds.
+
+Version 1.5.3 (2012-01-15)
+* Server
+** Add D-Bus property se.recompile.Client.LastCheckerStatus and use it
+   in mandos-monitor.
+* Client
+** Fix bugs in the example "bridge" network hook.
+
+Version 1.5.2 (2012-01-08)
+* Server
+** Removed D-Bus signal se.recompile.Mandos.NewRequest() added in
+   1.5.0.  It was buggy and was of questionable utility.
+
+Version 1.5.1 (2012-01-01)
+* Server
+** Include intro(8mandos) manual page, missing since migration from
+   README file in version 1.4.0.
+
+Version 1.5.0 (2012-01-01)
+* Client
+** Network hooks.  The Mandos client can now run custom scripts to take
+   up a network interface before the client is run.  Three example
+   scripts are provided: "wireless", "openvpn", and "bridge".
+   To facilitate this, the client now prefers network interfaces which
+   are up (if any) over all other interfaces.
+* Server
+** Persistent state.  Client state is now saved between server
+   restarts.
+** clients.conf file can now contain "enabled" setting for clients.
+** Bug fix: Fix rare crash bug.
+** Bug fix: Send corrent D-Bus type in PropertyChanged for
+   "ApprovalDelay", "ApprovalDuration", "Timeout", and
+   "ExtendedTimeout".
+** mandos-ctl: Bare numbers as arguments are taken to be milliseconds.
+** Bug fix: mandos-ctl --secret option now works.
+** New D-Bus signal: se.recompile.Mandos.NewRequest(s).
+
+Version 1.4.1 (2011-10-15)
+* Server
+** Make D-Bus properties settable again, and handle checkers
+   for disabled clients correctly.
+* Miscellaneous fixes to "pedantic" Lintian warnings
+
+Version 1.4.0 (2011-10-09)
+* README file migrated to manual page intro(8mandos).
+* Client:
+** Fixed warning about "rmdir: Directory not empty".
+* Server:
+** Default values changed: timeout 5 minutes, interval 2 minutes.
+** Clients gets an expiration extension when receiving a password,
+   controlled by new "extended_timeout" setting.
+** New domain name: "fukt.bsnet.se" changes to "recompile.se".  This
+   also affects the D-Bus bus and interface names (old names still
+   work).  Users should start using the new names immediately.
+** New D-Bus Client object properties "Expires" and "ExtendedTimeout";
+   see DBUS-API for details.
+
+Version 1.3.1 (2011-07-27)
+* Client:
+** Client now retries all Mandos servers periodically.
+** Work around Debian bug #633582 - fixes "Permission denied" problem.
+
+Version 1.3.0 (2011-03-08)
+* Server:
+** Updated for Python 2.6.
+* Client:
+** Bug fix: Make the password-prompt plugin not conflict with
+   Plymouth.
+** Bug fix: Bug fix: update initramfs also when purging package.
+
+Version 1.2.3 (2010-10-11)
+* Server:
+** Bug fix: Expose D-Bus API also in non-debug mode.
+
+Version 1.2.2 (2010-10-07)
+* Client:
+** splashy: Minor fix to compile with non-Linux kernels.
+
 Version 1.2.1 (2010-10-02)
 * Server:
 ** mandos-monitor(8): Documentation bug fix: Key for removing client

=== modified file 'README'
--- README	2010-09-26 18:32:58 +0000
+++ README	2016-03-23 07:11:22 +0000
@@ -1,182 +1,11 @@
--*- org -*-
-
-* Mandos
-  - Have your cake and eat it too!
-  
-  You know how it is.  You’ve heard of it happening.  The Man comes
-  and takes away your servers, your friends’ servers, the servers of
-  everybody in the same hosting facility. The servers of their
-  neighbors, and their neighbors’ friends.  The servers of people who
-  owe them money.  And like *that*, they’re gone.  And you doubt
-  you’ll ever see them again.
-  
-  That is why your servers have encrypted root file systems.  However,
-  there’s a downside.  There’s no going around it: rebooting is a
-  pain.  Dragging out that rarely-used keyboard and screen and
-  unraveling cables behind your servers to plug them in to type in
-  that password is messy, especially if you have many servers.  There
-  are some people who do clever things like using serial line consoles
-  and daisy-chain it to the next server, and keep all the servers
-  connected in a ring with serial cables, which will work, if your
-  servers are physically close enough.  There are also other
-  out-of-band management solutions, but with *all* these, you still
-  have to be on hand and manually type in the password at boot time.
-  Otherwise the server just sits there, waiting for a password.
-  
-  Wouldn’t it be great if you could have the security of encrypted
-  root file systems and still have servers that could boot up
-  automatically if there was a short power outage while you were
-  asleep?  That you could reboot at will, without having someone run
-  over to the server to type in the password?
-  
-  Well, with Mandos, you (almost) can!  The gain in convenience will
-  only be offset by a small loss in security.  The setup is as
-  follows:
-  
-  The server will still have its encrypted root file system.  The
-  password to this file system will be stored on another computer
-  (henceforth known as the Mandos server) on the same local network.
-  The password will *not* be stored in plaintext, but encrypted with
-  OpenPGP.  To decrypt this password, a key is needed.  This key (the
-  Mandos client key) will not be stored there, but back on the
-  original server (henceforth known as the Mandos client) in the
-  initial RAM disk image.  Oh, and all network Mandos client/server
-  communications will be encrypted, using TLS (SSL).
-  
-  So, at boot time, the Mandos client will ask for its encrypted data
-  over the network, decrypt it to get the password, use it to decrypt
-  the root file, and continue booting.
-  
-  Now, of course the initial RAM disk image is not on the encrypted
-  root file system, so anyone who had physical access could take the
-  Mandos client computer offline and read the disk with their own
-  tools to get the authentication keys used by a client.  *But*, by
-  then the Mandos server should notice that the original server has
-  been offline for too long, and will no longer give out the encrypted
-  key.  The timing here is the only real weak point, and the method,
-  frequency and timeout of the server’s checking can be adjusted to
-  any desired level of paranoia
-  
-  (The encrypted keys on the Mandos server is on its normal file
-  system, so those are safe, provided the root file system of *that*
-  server is encrypted.)
-
-* FAQ - couldn’t the security be defeated by...
-
-** Grabbing the Mandos client key from the initrd *really quickly*?
-   This, as mentioned above, is the only real weak point.  But if you
-   set the timing values tight enough, this will be really difficult
-   to do.  An attacker would have to physically disassemble the client
-   computer, extract the key from the initial RAM disk image, and then
-   connect to a *still online* Mandos server to get the encrypted key,
-   and do all this *before* the Mandos server timeout kicks in and the
-   Mandos server refuses to give out the key to anyone.
-   
-   Now, as the typical procedure seems to be to barge in and turn off
-   and grab *all* computers, to maybe look at them months later, this
-   is not likely.  If someone does that, the whole system *will* lock
-   itself up completely, since Mandos servers are no longer running.
-   
-   For sophisticated attackers who *could* do the clever thing, *and*
-   had physical access to the server for enough time, it would be
-   simpler to get a key for an encrypted file system by using hardware
-   memory scanners and reading it right off the memory bus.
-
-** Replay attacks?
-   Nope, the network stuff is all done over TLS, which provides
-   protection against that.
-
-** Man-in-the-middle?
-   No.  The server only gives out the passwords to clients which have
-   *in the TLS handshake* proven that they do indeed hold the OpenPGP
-   private key corresponding to that client.
-
-** Physically grabbing the Mandos server computer?
-   You could protect *that* computer the old-fashioned way, with a
-   must-type-in-the-password-at-boot method.  Or you could have two
-   computers be the Mandos server for each other.
-   
-   Multiple Mandos servers can coexist on a network without any
-   trouble.  They do not clash, and clients will try all available
-   servers.  This means that if just one reboots then the other can
-   bring it back up, but if both reboot at the same time they will
-   stay down until someone types in the password on one of them.
-
-** Faking ping replies?
-   The default for the server is to use "fping", the replies to which
-   could be faked to eliminate the timeout.  But this could easily be
-   changed to any shell command, with any security measures you like.
-   It could, for instance, be changed to an SSH command with strict
-   keychecking, which could not be faked.  Or IPsec could be used for
-   the ping packets, making them secure.
-
-* Security Summary
-  So, in summary:  The only weakness in the Mandos system is from
-  people who have:
-  1. The power to come in and physically take your servers, *and*
-  2. The cunning and patience to do it carefully, one at a time, and
-     *quickly*, faking Mandos client/server responses for each one
-     before the timeout.
-  
-  While there are some who may be threatened by people who have *both*
-  these attributes, they do not, probably, constitute the majority.
-  
-  If you *do* face such opponents, you must figure that they could
-  just as well open your servers and read the file system keys right
-  off the memory by running wires to the memory bus.
-  
-  What Mandos is designed to protect against is *not* such determined,
-  focused, and competent attacks, but against the early morning knock
-  on your door and the sudden absence of all the servers in your
-  server room.  Which it does nicely.
-
-* The Plugin System
-  In the early designs, the mandos-client(8mandos) program (which
-  retrieves a password from the Mandos server) also prompted for a
-  password on the terminal, in case a Mandos server could not be
-  found.  Other ways of retrieving a password could easily be
-  envisoned, but this multiplicity of purpose was seen to be too
-  complex to be a viable way to continue.  Instead, the original
-  program was separated into mandos-client(8mandos) and
-  password-prompt(8mandos), and a plugin-runner(8mandos) exist to run
-  them both in parallel, allowing the first successful plugin to
-  provide the password.  This opened up for any number of additional
-  plugins to run, all competing to be the first to find a password and
-  provide it to the plugin runner.
-  
-  Four additional plugins are provided:
-  * plymouth(8mandos)
-    This prompts for a password when using plymouth(8).
-  * usplash(8mandos)
-    This prompts for a password when using usplash(8).
-  * splashy(8mandos)
-    This prompts for a password when using splashy(8).
-  * askpass-fifo(8mandos)
-    To provide compatibility with the "askpass" program from
-    cryptsetup, this plugin listens to the same FIFO as askpass would
-    do.
-  
-  More plugins can easily be written and added by the system
-  administrator; see the section called "WRITING PLUGINS" in
-  plugin-runner(8mandos) to learn the plugin requirements.
-
-* Copyright
-
-    Copyright © 2008-2010 Teddy Hogeborn
-    Copyright © 2008-2010 Björn Påhlsson
-  
-** License:
-   
-   This program is free software: you can redistribute it and/or
-   modify it under the terms of the GNU General Public License as
-   published by the Free Software Foundation, either version 3 of the
-   License, or (at your option) any later version.
-
-   This program is distributed in the hope that it will be useful, but
-   WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   General Public License for more details.
-
-   You should have received a copy of the GNU General Public License
-   along with this program.  If not, see
-   <http://www.gnu.org/licenses/>.
+Please see: https://www.recompile.se/mandos/man/intro.8mandos
+
+This information previously in this file has been moved to the
+intro(8mandos) manual page.  Go to the above URL, or install the
+Mandos server and run this command:
+
+	man 8mandos intro
+
+In short, this is the Mandos system; it allows computers to have
+encrypted root file systems and at the same time be capable of remote
+and/or unattended reboots.

=== modified file 'TODO'
--- TODO	2010-09-26 18:32:58 +0000
+++ TODO	2016-07-03 03:32:28 +0000
@@ -1,134 +1,123 @@
 -*- org -*-
 
-* Use _attribute_((nonnull)) wherever possible.
+* Testing
+** python-nemu
+
+* mandos-applet
 
 * mandos-client
-** TODO [#B] use scandir(3) instead of readdir(3)
-** TODO [#B] Prefix all debug output with "Mandos plugin " + program_invocation_short_name
-** TODO [#B] Retry a server which has a non-definite reply:
-*** A closed connection during the TLS handshake
-*** A TCP timeout
+** TODO A --server option which only adds to the server list.
+   (Unlike --connect, which implicitly disables zeroconf.)
 ** TODO [#B] Use capabilities instead of seteuid().
-** TODO [#A] Retry --connect forever
+   https://forums.grsecurity.net/viewtopic.php?f=7&t=2522
+** TODO [#B] Use getaddrinfo(hints=AI_NUMERICHOST) instead of inet_pton()
+** TODO [#C] Make start_mandos_communication() take "struct server".
+** TODO [#C] --interfaces=regex,eth*,noregex (bridge-utils-interfaces(5))
+** TODO [#A] Detect partial writes to stdout and exit with EX_TEMPFAIL
 
 * splashy
 ** TODO [#B] use scandir(3) instead of readdir(3)
-** TODO [#B] Prefix all debug output with "Mandos plugin " + program_invocation_short_name
+** TODO [#A] Detect partial writes to stdout and exit with EX_TEMPFAIL
 
-* usplash
-** TODO [#A] Make it work again
+* usplash (Deprecated)
+** TODO [#B] Make it work again
 ** TODO [#B] use scandir(3) instead of readdir(3)
-** TODO [#B] Prefix all debug output with "Mandos plugin " + program_invocation_short_name
-** TODO Use [[info:libc:Argz%20Functions][argz_extract]]
+** TODO [#A] Detect partial writes to stdout and exit with EX_TEMPFAIL
 
 * askpass-fifo
-** TODO [#B] Prefix all debug output with "Mandos plugin " + program_invocation_short_name
-** TODO [#B] Drop privileges after opening FIFO.
+** TODO [#A] Detect partial writes to stdout and exit with EX_TEMPFAIL
 
 * password-prompt
-** TODO [#B] Prefix all debug output with "Mandos plugin " + program_invocation_short_name
 ** TODO [#B] lock stdin (with flock()?)
+** TODO [#A] Detect partial writes to stdout and exit with EX_TEMPFAIL
+
+* plymouth
+** TODO [#A] Detect partial writes to stdout and exit with EX_TEMPFAIL
 
 * TODO [#B] passdev
 
 * plugin-runner
-** TODO [#B] use scandir(3) instead of readdir(3)
+** TODO handle printing for errors for plugins
+*** Hook up stderr of plugins, buffer them, and prepend "Mandos Plugin [plugin name]"
 ** TODO [#C] use same file name rules as run-parts(8)
 ** kernel command line option for debug info
-** TODO [#B] Use openat()
+** TODO [#A] Restart plugins which exit with EX_TEMPFAIL
 
 * mandos (server)
+** TODO [#B] --notify-command
+   This would allow the mandos.service to use
+   --notify-command="systemd-notify --pid --ready"
+** TODO [#B] python-systemd
+*** import systemd.daemon; systemd.daemon.notify()
 ** TODO [#B] Log level							  :BUGS:
-** TODO Persistent state						  :BUGS:
-   /var/lib/mandos/*
 *** TODO /etc/mandos/clients.d/*.conf
     Watch this directory and add/remove/update clients?
 ** TODO [#C] config for TXT record
-** TODO Log level option
-   syslogger.setLevel(logging.WARNING)
-   + SetLogLevel D-Bus call
-** TODO Implement --foreground						  :BUGS:
-   [[info:standards:Option%20Table][Table of Long Options]]
-** TODO Implement --socket
-   [[info:standards:Option%20Table][Table of Long Options]]
-** TODO Date+time on console log messages				  :BUGS:
-   Is this the default?
+** TODO Log level dbus option
+   SetLogLevel D-Bus call
 ** TODO [#C] DBusServiceObjectUsingSuper
 ** TODO [#B] Global enable/disable flag
-** TODO [#B] By-client countdown on secrets given
-** TODO [#B] Fix problem with fsck taking a really long time
-   Whenever a client successfully gets a secret it could get a
-   one-time timeout boost to allow for an fsck-incurred delay
-** TODO [#A] Delay before client receives key
-   This would give an operator opportunity to cancel the request if
-   desired.
-** TODO [#A] Client manual approval mode
-   A client needs manual approval on the server before it gets the
-   secret
-** TODO [#B] Support RFC 3339 time duration syntax
-** More D-Bus methods
-*** NeedsApproval(50, True) -> timeout, default approve
-    Default approval is configurable, but True by default
-    + Approve(True) -> approve sending saved
-    + Approve(False) -> Close client connection immediately
-*** NeedsPassword(50) - Timeout, default disapprove
+** TODO [#B] By-client countdown on number of secrets given
+** D-Bus Client method NeedsPassword(50) - Timeout, default disapprove
     + SetPass(u"gazonk", True) -> Approval, persistent
     + Approve(False) -> Close client connection immediately
 ** TODO [#C] python-parsedatetime
-** TODO [#C] systemd/launchd
-   http://0pointer.de/blog/projects/systemd.html
 ** TODO Separate logging logic to own object
-** TODO make clients to a dict!
-** TODO [#A] Limit approval_delay to max gnutls/tls timeout value
+** TODO [#B] Limit approval_delay to max gnutls/tls timeout value
 ** TODO [#B] break the wait on approval_delay if connection dies
 ** TODO Generate Client.runtime_expansions from client options + extra
 ** TODO Allow %%(checker)s as a runtime expansion
-
-* mandos.xml
-** Add mandos contact info in manual pages
+** TODO D-Bus AddClient() method on server object
+** TODO Use org.freedesktop.DBus.Method.NoReply annotation on async methods. :2:
+** TODO Save state periodically to recover better from hard shutdowns
+** TODO CheckerCompleted method, deprecate CheckedOK
+** TODO Secret Service API?
+   https://standards.freedesktop.org/secret-service/
+** TODO Remove D-Bus interfaces with old domain name			  :2:
+** TODO Remove old string_to_delta format				  :2:
+** TODO http://0pointer.de/blog/projects/stateless.html
+*** File in /usr/lib/sysusers.d to create user+group "_mandos"
+** TODO Error handling on error parsing config files
+** TODO init.d script error handling
+** TODO D-Bus server properties; address, port, interface, etc.		  :2:
+** Python 3								  :2:
+*** TODO [#C] In Python 3.3, use shlex.quote() instead of re.escape()
 
 * mandos-ctl
 *** Handle "no D-Bus server" and/or "no Mandos server found" better
-*** [#B] --dump option
-** TODO Support RFC 3339 time duration syntax
+** TODO Remove old string_to_delta format				  :2:
 
 * TODO mandos-dispatch
   Listens for specified D-Bus signals and spawns shell commands with
   arguments.
 
 * mandos-monitor
-** TODO help should be toggable
+** TODO --servicename						       :BUGS:
+** TODO help should be toggleable
 ** Urwid client data displayer
    Better view of client data in the listing
 *** Properties popup
-** Nicer crashes. Stack traces Messes up shell.
-*** Print a nice "We are sorry" message, save stack trace to log.
-** Show timeout countdown for approval
+** Print a nice "We are sorry" message, save stack trace to log.
 
 * mandos-keygen
-** TODO Loop until passwords match when run interactively
 ** TODO "--secfile" option
    Using the "secfile" option instead of "secret"
 ** TODO [#B] "--test" option
    For testing decryption before rebooting.
 
-* Makefile
-** TODO Add "--Xlinker --as-needed"
-   http://udrepper.livejournal.com/19395.html
-** TODO [#C] Implement DEB_BUILD_OPTIONS
-   http://www.debian.org/doc/debian-policy/ch-source.html#s-debianrules-options
-
 * Package
 ** /usr/share/initramfs-tools/hooks/mandos
 *** TODO [#C] use same file name rules as run-parts(8)
 *** TODO [#C] Do not install in initrd.img if configured not to.
     Use "/etc/initramfs-tools/hooksconf.d/mandos"?
-** TODO [#C] /etc/bash_completion.d/mandos
+** TODO [#C] $(pkg-config --variable=completionsdir bash-completion)
    From XML sources directly?
 
 * Side Stuff
-** TODO Locate which packet move the other bin/sh when busy box is deactivated
-** TODO contact owner of packet, and ask them to have that shell static in position regardless of busybox
+** TODO Locate which package moves the other bin/sh when busybox is deactivated
+** TODO contact owner of package, and ask them to have that shell static in position regardless of busybox
+
+* [[http://www.undeadly.org/cgi?action=article&sid=20110530221728][OpenBSD]]
 
 
 #+STARTUP: showall

=== added file 'bugs.xml'
--- bugs.xml	1970-01-01 00:00:00 +0000
+++ bugs.xml	2016-03-05 21:42:56 +0000
@@ -0,0 +1,11 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE legalnotice PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
+	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd">
+<para>
+  Please report bugs to the Mandos development mailing list:
+  <email>mandos-dev@recompile.se</email> (subscription required).
+  Note that this list is public.  The developers can be reached
+  privately at <email>mandos@recompile.se</email> (OpenPGP key
+  fingerprint <literal>153A 37F1 0BBA 0435 987F 2C4A 7223 2973 CA34
+  C2C4</literal> for encrypted mail).
+</para>

=== modified file 'clients.conf'
--- clients.conf	2010-09-12 03:00:40 +0000
+++ clients.conf	2012-06-23 00:58:49 +0000
@@ -4,14 +4,19 @@
 
 # How long until a client is disabled and not be allowed to get the
 # data this server holds.
-;timeout = 1h
+;timeout = PT5M
 
 # How often to run the checker to confirm that a client is still up.
 # Note: a new checker will not be started if an old one is still
 # running.  The server will wait for a checker to complete until the
 # above "timeout" occurs, at which time the client will be disabled,
 # and any running checker killed.
-;interval = 5m
+;interval = PT2M
+
+# Extended timeout is an added timeout that is given once after a
+# password has been sent sucessfully to a client.  This allows for
+# additional delays caused by file system checks and quota checks.
+;extended_timeout = PT15M
 
 # What command to run as "the checker".
 ;checker = fping -q -- %%(host)s
@@ -20,10 +25,13 @@
 ;approved_by_default = True
 
 # How long to wait for approval.
-;approval_delay = 0s
+;approval_delay = PT0S
 
 # How long one approval will last.
-;approval_duration = 1s
+;approval_duration = PT1S
+
+# Whether this client is enabled by default
+;enabled = True
 
 
 ;####
@@ -70,10 +78,10 @@
 ;host = 192.0.2.3
 ;
 ;# Parameters from the [DEFAULT] section can be overridden per client.
-;interval = 5m
+;interval = PT1M
 ;
 ;# This client requires manual approval before it receives its secret.
 ;approved_by_default = False
 ;# Require approval within 30 seconds.
-;approval_delay = 30s
+;approval_delay = PT30S
 ;####

=== modified file 'common.ent'
--- common.ent	2010-10-02 17:23:41 +0000
+++ common.ent	2016-10-08 04:33:04 +0000
@@ -1,3 +1,3 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!-- Edited by Makefile -->
-<!ENTITY version "1.2.1">
+<!ENTITY version "1.7.13">

=== modified file 'dbus-mandos.conf'
--- dbus-mandos.conf	2009-11-09 07:35:16 +0000
+++ dbus-mandos.conf	2011-10-02 19:18:24 +0000
@@ -7,12 +7,18 @@
     <allow own="se.bsnet.fukt.Mandos"/>
     <allow send_destination="se.bsnet.fukt.Mandos"/>
     <allow receive_sender="se.bsnet.fukt.Mandos"/>
+    <allow own="se.recompile.Mandos"/>
+    <allow send_destination="se.recompile.Mandos"/>
+    <allow receive_sender="se.recompile.Mandos"/>
   </policy>
   
   <policy user="root">
     <allow own="se.bsnet.fukt.Mandos"/>
     <allow send_destination="se.bsnet.fukt.Mandos"/>
     <allow receive_sender="se.bsnet.fukt.Mandos"/>
+    <allow own="se.recompile.Mandos"/>
+    <allow send_destination="se.recompile.Mandos"/>
+    <allow receive_sender="se.recompile.Mandos"/>
   </policy>
 
 </busconfig>

=== modified file 'debian/changelog'
--- debian/changelog	2010-10-05 19:03:43 +0000
+++ debian/changelog	2016-10-08 04:33:04 +0000
@@ -1,3 +1,446 @@
+mandos (1.7.13-1) unstable; urgency=medium
+
+  * New upstream release.
+  * Fix "fails to install noninteractively" by using the "%no-protection"
+    statement in the GnuPG batch parameter file. (Closes: #840001)
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Sat, 08 Oct 2016 06:31:07 +0200
+
+mandos (1.7.12-1) unstable; urgency=medium
+
+  * New upstream release.
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Wed, 05 Oct 2016 22:06:55 +0200
+
+mandos (1.7.11-1) unstable; urgency=high
+
+  * New upstream release.
+  * debian/control (Source: mandos/Vcs-Bzr): Change to use HTTPS.
+    (Vcs-Browser): - '' -
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Sat, 01 Oct 2016 16:20:48 +0200
+
+mandos (1.7.10-1) unstable; urgency=high
+
+  * New upstream release.
+  * debian/rules (override_dh_fixperms-arch): Also exclude
+    "etc/mandos/plugin-helpers" from changes by dh_fixperms.
+  * debian/mandos-client.postinst: Fix the permissions of
+    "/etc/mandos/plugin-helpers" for those systems which had a fresh
+    install of an older version.
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Thu, 23 Jun 2016 22:00:29 +0200
+
+mandos (1.7.9-1) unstable; urgency=medium
+
+  * New upstream release.
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Wed, 22 Jun 2016 07:30:12 +0200
+
+mandos (1.7.8-1) unstable; urgency=medium
+
+  * New upstream release.
+  * Fix "bad gpgme_op_decrypt: GPGME: Decryption failed." by copying
+    /usr/bin/gpg-agent into initramfs (Closes: #819982)
+  * debian/control (Homepage): Change URL to use HTTPS.
+    (Standards-Version): Update to 3.9.8.
+  * debian/copyright (Source): Change URL to HTTPS.
+  * debian/mandos-client.README.Debian: Change wording to match updated
+    capabilities.
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Tue, 21 Jun 2016 21:36:10 +0200
+
+mandos (1.7.7-1) unstable; urgency=medium
+
+  * New upstream release.
+  * debian/mandos-client.postinst (configure): If older version, fix
+    permissions on plugin helper directory.  Also fix permissions on
+    plugin helper local override directory (/etc/mandos/plugin-helpers),
+    but only if not listed by "dpkg-statoverride".
+  * debian/rules (override_dh_fixperms-arch): Exclude plugin helper
+    directory from dh_fixperms.
+  * debian/mandos.postinst (configure): Fix state directory permissions,
+    but only if not listed by "dpkg-statoverride".
+  * debian/mandos-client.lintian-overrides: Do not warn about permissions
+    on plugin helper directory.
+  * debian/mandos.dirs (usr/lib/tmpfiles.d): Added.
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Sat, 19 Mar 2016 22:58:49 +0100
+
+mandos (1.7.6-1) unstable; urgency=medium
+
+  * New upstream release.
+  * debian/control (Source: mandos/Build-Depends-Indep): Remove
+    "python-avahi".
+    (Source: mandos/Build-Depends-Indep): Change "python-gi |
+    python-gobject" to "python-gi"; i.e. remove "python-gobject".
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Sun, 13 Mar 2016 22:58:23 +0100
+
+mandos (1.7.5-1) unstable; urgency=high
+
+  * New upstream release.
+  * debian/mandos.postinst (configure): If old version was 1.7.4-1 or
+    1.7.4-1~bpo8+1, fix situation where clients.pickle file is owned by
+    root.
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Tue, 08 Mar 2016 01:09:55 +0100
+
+mandos (1.7.4-1) unstable; urgency=medium
+
+  * New upstream release.
+  * initramfs-tools-script: Fix "Call to configure_network in initramfs
+    script broken due to set -e" by surrounding call by "set +x" and "set
+    -e" (Closes: #816513)
+  * debian/control: (Source: mandos/Build-Depends-Indep): Change
+    "python-gobject | python-gi" to "python-gi | python-gobject"
+    (Package: mandos/Depends): - '' -
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Sat, 05 Mar 2016 23:10:07 +0100
+
+mandos (1.7.3-1) unstable; urgency=medium
+
+  * New upstream release.
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Mon, 29 Feb 2016 22:26:38 +0100
+
+mandos (1.7.2-1) unstable; urgency=medium
+
+  * New upstream release.
+  * Fix "Uses unneeded and obsolete version specific python packages"
+    by removing version-specific dependencies (Closes: #811159)
+  * debian/control (Source: mandos/Build-Depends): Add (>= 3.3.0) to
+    "libgnutls28-dev" and "gnutls-dev".
+    (Source: mandos/Build-Depends-Indep): Remove "python2.7-gnutls",
+    "python2.7", "python2.7-dbus", "python2.7-avahi", and
+    "python2.7-gobject"; replace with "python (>= 2.7), python (<< 3)",
+    "python-dbus", "python-avahi", "python-gobject | python-gi".
+    (Package: mandos/Depends): Remove "python-gnutls" and
+    "python2.7-gnutls", add "libgnutls28-dev (>= 3.3.0) | libgnutls30 (>=
+    3.3.0)".  Add "python (<< 3)".  Remove "python2.7-dbus",
+    "python2.7-avahi", "python2.7-gobject", and "python2.7-urwid".
+    Replace "python-gobject" with "python-gobject | python-gi" and "gnupg
+    (<< 2)" with "gnupg".
+    (Package: mandos-client/Depends): Replace
+    "gnupg (<< 2)" with "gnupg".
+    (Source: mandos/Standards-Version): Change to 3.9.7.
+  * debian/copyright (Copyright): Update copyright year.
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Sun, 28 Feb 2016 16:09:01 +0100
+
+mandos (1.7.1-2) unstable; urgency=medium
+
+  * debian/control (Package: mandos/Depends): Fix "Please drop versioned
+    dependency on initscripts package" by removing initscripts dependency
+    (Closes: #804967)
+  * debian/rules (override_dh_fixperms) Fix "FTBFS when built with
+    dpkg-buildpackage -A (No such file or directory)" by splitting into
+    "override_dh_fixperms-arch" and "override_dh_fixperms-indep".
+    (Closes: #806073)
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Sat, 05 Dec 2015 02:27:40 +0100
+
+mandos (1.7.1-1) unstable; urgency=medium
+
+  * New upstream release.
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Sat, 24 Oct 2015 19:43:40 +0200
+
+mandos (1.7.0-1) unstable; urgency=medium
+
+  * New upstream release.
+  * debian/control (Standards-Version): Updated to "3.9.6".
+    (Build-Depends): Add "libnl-route-3-dev".
+    (Package: mandos-client/Recommends): Added "gnutls-bin | openssl" for
+    the generating of DH parameters.
+  * debian/mandos-client.README.Debian: Update example command line to use
+    new MANDOSPLUGINHELPERDIR environment variable.  Also document the new
+    dhparams.pem file.
+  * debian/mandos-client.postinst: Create DH parameters file.
+  * debian/mandos.prerm: Don't run init script, use only invoke-rc.d.
+  * debian/mandos-client.postinst: Don't use absolute paths to commands.
+  * debian/mandos-client.postrm: Don't use absolute paths to commands.
+    Also remove dhparams.pem file.
+  * debian/copyright (Copyright): Update copyright year.
+  * Upstream changed systemd service file to implicitly be of
+    "Type=dbus". (Closes: #786845)
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Mon, 10 Aug 2015 22:00:29 +0200
+
+mandos (1.6.9-1) unstable; urgency=medium
+
+  * New upstream release.
+  * debian/control (Build-Depends): Fix "still uses GnutLS 2.x" by
+    changing from "libgnutls-dev" to "libgnutls28-dev | gnutls-dev"
+    (Closes: #762349)
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Sun, 05 Oct 2014 22:05:06 +0200
+
+mandos (1.6.8-1) unstable; urgency=medium
+
+  * New upstream release.
+  * debian/control (Source: mandos/Build-Depends-Indep): Since upstream
+    now requires Python 2.7, depend on exactly the python2.7 package and
+    all the Python 2.7 versions of the python modules.
+    (Package: mandos/Depends): - '' - but still depend on python (>=2.7)
+    and the generic versions of the Python modules; this is for mandos-ctl
+    and mandos-monitor, both of which are compatible with Python 3, and
+    use #!/usr/bin/python.
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Wed, 06 Aug 2014 22:55:24 +0200
+
+mandos (1.6.7-1) unstable; urgency=medium
+
+  * New upstream release.
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Thu, 17 Jul 2014 05:22:45 +0200
+
+mandos (1.6.6-1) unstable; urgency=medium
+
+  * New upstream release.
+  * debian/mandos.postinst: Fix typo in comment.
+  * debian/control (mandos/Recommends): Changed to "ssh-client | fping".
+    (mandos-client/Recommends): New; set to "ssh".
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Sun, 13 Jul 2014 22:49:21 +0200
+
+mandos (1.6.5-3) unstable; urgency=medium
+
+  * debian/control (mandos-client/Depends): Add "dpkg-dev (>=1.16.0)";
+    initramfs-tools-hook runs "dpkg-architecture -qDEB_HOST_MULTIARCH".
+    (Closes: #750221)
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Fri, 06 Jun 2014 04:27:15 +0200
+
+mandos (1.6.5-2) unstable; urgency=medium
+
+  * debian/rules (override_dh_auto_test-arch): New; does nothing.  Fixes
+    FTBFS for build-indep.
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Tue, 13 May 2014 08:08:31 +0200
+
+mandos (1.6.5-1) unstable; urgency=medium
+
+  * New upstream release.
+  * debian/copyright: Change year to "2014".
+  * debian/control (Build-Depends, Build-Depends-Indep): Moved build
+    dependencies of "mandos" package to "Build-Depends-Indep".
+  * debian/upstream/signing-key.asc: New; upstream source public key.
+  * debian/control (Standards-Version): Updated to "3.9.5".
+  * debian/control (mandos/Depends): Remove the dependency on
+    "avahi-daemon (>= 0.6.31-3) | systemd-sysv".  It is unnecessary
+    since we have a workaround in debian/mandos.postinst anyway.
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Sun, 11 May 2014 22:16:33 +0200
+
+mandos (1.6.4-1) unstable; urgency=medium
+
+  * New upstream release.
+  * debian/control (Build-Depends): Add Python dependencies to
+                                    successfully run self-tests.
+  * debian/copyright: GPLv3 now has its own license file - use it.
+  * debian/watch: Set PGP signature URL.
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Sun, 16 Feb 2014 14:09:25 +0100
+
+mandos (1.6.3-1) unstable; urgency=low
+
+  * New upstream release.
+  * debian/control (Build-Depends): Added "systemd".
+  * debian/mandos.dirs (lib/systemd/system): New.
+  * debian/mandos-client.README.Debian: Refer to architecture libdir.
+  * debian/control (mandos/Depends): Add "avahi-daemon (>= 0.6.31-3) |
+                                     systemd-sysv".
+  * debian/mandos.postinst: If avahi-daemon is version 0.6.31-2 or older,
+                            edit /etc/init.d script headers Required-Start
+                            and Required-Stop to have "avahi" instead of
+                            "avahi-daemon", before insserv(8) sees it.
+  * debian/mandos-client.lintian-overrides: Libdir changes.
+  * debian/rules (override_dh_fixperms): - '' -
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Tue, 21 Jan 2014 22:01:30 +0100
+
+mandos (1.6.2-1) unstable; urgency=low
+
+  * New upstream release.
+  * debian/compat: Changed to "9".
+  * debian/control (Build-Depends): Changed debhelper version to (>= 9).
+    (Standards-Version): Updated to "3.9.4".
+    (DM-Upload-Allowed): Removed.
+    (mandos/Depends): Add "initscripts (>= 2.88dsf-13.3)" to be able to
+                      use the "/run" directory (for mandos.pid).
+  * debian/copyright (Copyright): Update year.
+  * Fix "Mandos/gnutls fails to establish connection, "an algorithm that
+    is not enabled was negotiated"" fixed by upstream. (Closes: #702120)
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Thu, 24 Oct 2013 22:33:40 +0200
+
+mandos (1.6.1-1) unstable; urgency=low
+
+  * New upstream release.
+  * debian/control (mandos/Depends): No longer depends on
+                                     python-gnupginterface, but does
+                                     depend on gnupg (<< 2).
+    (Build-Depends): Depend on debhelper 8.9.7 for using "override-*-arch"
+                     and "override-*-indep" targets in debian/rules.
+  * debian/mandos-client.README: Update Linux documentation link.
+  * debian/rules: Completely rewritten to use debhelper v7.
+  * initramfs-tools-hook: Bug fix: Make sure the right version of GnuPG is
+    copied into the initramfs image.  Always assume that GPGME is used to
+    avoid searching for it since the path might not be /usr/lib.  Thanks
+    to Félix Sipma <felix+debian@gueux.org> for the initial bug report,
+    and also thanks to Dick Middleton <dick@lingbrae.com> for some more
+    debugging. (Closes:  #721903)
+  * Fix "bashism in /bin/sh script" fixed by upstream. (Closes: #690639)
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Sun, 13 Oct 2013 19:03:23 +0200
+
+mandos (1.6.0-1) unstable; urgency=low
+
+  * New upstream release.
+  * debian/copyright (Copyright): Join the two lines to a single line.
+  * debian/mandos-client.README.Debian: Update to refer to the new
+    location of the example network hooks, and the new feature of using
+    all network interfaces.
+  * debian/mandos-client.docs (network-hooks.d): Removed.
+  * debian/mandos-client.examples (network-hooks.d): New.
+  * debian/rules (binary-common): Added "dh_installexamples".
+    (binary-common/dh_fixperms): Exclude new location of
+    "network-hooks.d".
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Mon, 18 Jun 2012 00:15:23 +0200
+
+mandos (1.5.5-1) unstable; urgency=low
+
+  * New upstream release.
+  * debian/copyright (Format): Updated to
+    "http://www.debian.org/doc/packaging-manuals/copyright-format/1.0/".
+  * debian/control (Build-Depends): Removed "man, locales-all".
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Fri, 01 Jun 2012 20:30:41 +0200
+
+mandos (1.5.4-1) unstable; urgency=low
+
+  * New upstream release.
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Sun, 20 May 2012 15:38:34 +0200
+
+mandos (1.5.3-1.2) unstable; urgency=low
+
+  * Non-maintainer upload.
+  * Set Architecture to linux-any.  (Closes: #647670)
+
+ -- Robert Millan <rmh@debian.org>  Sun, 22 Apr 2012 16:22:01 +0200
+
+mandos (1.5.3-1.1) unstable; urgency=low
+
+  * Non-maintainer upload.
+  * Fix "mandos FTBFS on buildds": add build-dependency on locales-all and
+    pass LC_ALL to dh_auto_build to make sure we have and use the en_US.UTF-8
+    locale for manpage creation.
+    (Closes: #656178)
+
+ -- gregor herrmann <gregoa@debian.org>  Tue, 31 Jan 2012 17:56:05 +0100
+
+mandos (1.5.3-1) unstable; urgency=low
+
+  * New upstream release.
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Sun, 15 Jan 2012 22:05:54 +0100
+
+mandos (1.5.2-1) unstable; urgency=low
+
+  * New upstream release.
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Sun, 08 Jan 2012 11:17:20 +0100
+
+mandos (1.5.1-1) unstable; urgency=low
+
+  * New upstream release.
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Sun, 01 Jan 2012 21:53:31 +0100
+
+mandos (1.5.0-1) unstable; urgency=low
+
+  * New upstream release.
+  * debian/control (mandos-client/Depends): Added "initramfs-tools".
+  * debian/mandos-client.README.Debian: Corrected mail address and adjust
+                                        wording.
+  * debian/rules (binary-common): Exclude new nework-hooks.d directory
+                                  from dh_fixperms.
+  * debian/mandos-client.README.Debian: Document network hook facility.
+  * debian/mandos-client.docs (network-hooks.d): Added.
+  * debian/mandos.dirs (var/lib/mandos): Added.
+  * debian/mandos.postinst: Fix ownership of /var/lib/mandos.
+  * debian/control (mandos/Depends): Added "python-gnupginterface".
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Sun, 01 Jan 2012 05:58:11 +0100
+
+mandos (1.4.1-1) unstable; urgency=low
+
+  * New upstream release.
+  * debian/control (Build-Depends): Added "man".
+  * debian/control (Conflicts): Changed to "Breaks:".
+  * debian/copyright: Updated format.
+  * debian/mandos-client.postinst: Use "set -e" instead of "#!/bin/sh -e".
+  * debian/mandos-client.postrm: - '' -
+  * debian/mandos.postinst: - '' -
+  * debian/mandos.prerm: Consistent magic.
+
+ -- Björn Påhlsson <belorn@fukt.bsnet.se>  Sat, 15 Oct 2011 18:18:52 +0200
+
+mandos (1.4.0-1) unstable; urgency=low
+
+  * New upstream release.
+  * Fix "FTBFS with binutils-gold": Added "-Xlinker --as-needed" to
+    LDFLAGS in Makefile. (Closes: #632145)
+  * Fix "/run transition: uses obsolete /dev/.initramfs": Try both old and
+    new PID file locations. (Closes: #643554)
+  * debian/source/local-options: New; contains "--single-debian-patch".
+  * debian/control (Standards-Version): Upgraded to "3.9.2".
+    (DM-Upload-Allowed): New; set to "yes".
+  * debian/control: Changed domain from "fukt.bsnet.se" to "recompile.se".
+  * debian/copyright: - '' -
+  * debian/mandos-client.README.Debian: - '' -
+  * debian/mandos.README.Debian: - '' -
+  * debian/watch: - '' -
+  * debian/control (mandos/Description): Fix language to placate lintian.
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Sun, 09 Oct 2011 19:15:08 +0200
+
+mandos (1.3.1-1) unstable; urgency=low
+
+  * New upstream release.
+  * Conflict with correct version of dropbear.
+  * New version uses argparse; depend on python (<=2.7) | python-argparse.
+
+ -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Wed, 27 Jul 2011 19:47:17 +0200
+
+mandos (1.3.0-1) unstable; urgency=low
+
+  * New upstream release.
+  * debian/control (mandos): Depend on Python 2.6, remove dependency on
+    python-multiprocessing.
+  (mandos-client): Conflict with dropbear (<< 0.52-5).
+  * debian/mandos-client.postrm (purge): Bug fix: update initramfs also on
+    purge.
+  * debian/mandos-client.lintian-overrides: Added plugins.d/plymouth.
+
+ -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Tue, 08 Mar 2011 20:22:57 +0100
+
+mandos (1.2.3-1) experimental; urgency=low
+
+  * New upstream release.
+
+ -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Mon, 11 Oct 2010 19:37:31 +0200
+
+mandos (1.2.2-1) experimental; urgency=low
+
+  * New upstream release.
+  * plugins.d/splashy.c: Only use ELIBBAD if defined. (Closes: #599256)
+
+ -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Thu, 07 Oct 2010 20:27:54 +0200
+
 mandos (1.2.1-3) experimental; urgency=low
 
   * debian/changelog: Include entry for NMU of version 1.0.14-1.1.

=== modified file 'debian/compat'
--- debian/compat	2008-09-17 00:34:09 +0000
+++ debian/compat	2013-10-20 15:25:09 +0000
@@ -1,1 +1,1 @@
-7
+9

=== modified file 'debian/control'
--- debian/control	2010-10-01 18:40:55 +0000
+++ debian/control	2016-10-30 03:02:49 +0000
@@ -1,24 +1,28 @@
 Source: mandos
 Section: admin
 Priority: extra
-Maintainer: Mandos Maintainers <mandos@fukt.bsnet.se>
-Uploaders: Teddy Hogeborn <teddy@fukt.bsnet.se>,
-	   Björn Påhlsson <belorn@fukt.bsnet.se>
-Build-Depends: debhelper (>= 7), docbook-xml, docbook-xsl,
-	libavahi-core-dev, libgpgme11-dev, libgnutls-dev, xsltproc,
-	pkg-config
-Standards-Version: 3.9.1
-Vcs-Bzr: http://ftp.fukt.bsnet.se/pub/mandos/trunk
-Vcs-Browser: http://bzr.fukt.bsnet.se/loggerhead/mandos/trunk/files
-Homepage: http://www.fukt.bsnet.se/mandos
+Maintainer: Mandos Maintainers <mandos@recompile.se>
+Uploaders: Teddy Hogeborn <teddy@recompile.se>,
+	   Björn Påhlsson <belorn@recompile.se>
+Build-Depends: debhelper (>= 9), docbook-xml, docbook-xsl,
+	libavahi-core-dev, libgpgme11-dev, libgnutls28-dev (>= 3.3.0)
+	| gnutls-dev (>= 3.3.0), xsltproc, pkg-config,
+	libnl-route-3-dev
+Build-Depends-Indep: systemd, python (>= 2.7), python (<< 3),
+	python-dbus, python-gi
+Standards-Version: 3.9.8
+Vcs-Bzr: https://ftp.recompile.se/pub/mandos/trunk
+Vcs-Browser: https://bzr.recompile.se/loggerhead/mandos/trunk/files
+Homepage: https://www.recompile.se/mandos
 
 Package: mandos
 Architecture: all
-Depends: ${misc:Depends}, python (>=2.5), python-gnutls, python-dbus,
-	python-avahi, python-gobject, avahi-daemon, adduser,
-	python-urwid, python (>=2.6) | python-multiprocessing
-Recommends: fping
-Description: a server giving encrypted passwords to Mandos clients
+Depends: ${misc:Depends}, python (>= 2.7), python (<< 3),
+	libgnutls28-dev (>= 3.3.0) | libgnutls30 (>= 3.3.0),
+	python-dbus, python-gi, avahi-daemon, adduser, python-urwid,
+	gnupg2 | gnupg, systemd-sysv | lsb-base (>= 3.0-6)
+Recommends: ssh-client | fping
+Description: server giving encrypted passwords to Mandos clients
  This is the server part of the Mandos system, which allows
  computers to have encrypted root file systems and at the
  same time be capable of remote and/or unattended reboots.
@@ -34,9 +38,11 @@
  whereupon the computers can continue booting normally.
 
 Package: mandos-client
-Architecture: any
+Architecture: linux-any
 Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, cryptsetup,
-	gnupg (<< 2)
+	initramfs-tools, dpkg-dev (>=1.16.0)
+Recommends: ssh, gnutls-bin | openssl
+Breaks: dropbear (<= 0.53.1-1)
 Enhances: cryptsetup
 Description: do unattended reboots with an encrypted root file system
  This is the client part of the Mandos system, which allows

=== modified file 'debian/copyright'
--- debian/copyright	2010-09-26 18:32:58 +0000
+++ debian/copyright	2016-03-23 07:11:22 +0000
@@ -1,12 +1,11 @@
-Format-Specification:
- http://wiki.debian.org/Proposals/CopyrightFormat?action=recall&rev=233
+Format: http://www.debian.org/doc/packaging-manuals/copyright-format/1.0/
 Upstream-Name: Mandos
-Upstream-Maintainer: Mandos Maintainers <mandos@fukt.bsnet.se>
-Upstream-Source: <http://www.fukt.bsnet.se/mandos>
+Upstream-Contact: Mandos <mandos@recompile.se>
+Source: <https://www.recompile.se/mandos>
 
 Files: *
-Copyright: Copyright © 2008-2010 Teddy Hogeborn
-Copyright: Copyright © 2008-2010 Björn Påhlsson
+Copyright: Copyright © 2008-2016 Teddy Hogeborn
+	   Copyright © 2008-2016 Björn Påhlsson
 License: GPL-3+
     This program is free software: you can redistribute it and/or
     modify it under the terms of the GNU General Public License as
@@ -23,4 +22,4 @@
     <http://www.gnu.org/licenses/>.
     .
     On Debian systems, the complete text of the GNU General Public
-    License can be found in "/usr/share/common-licenses/GPL".
+    License can be found in "/usr/share/common-licenses/GPL-3".

=== modified file 'debian/mandos-client.README.Debian'
--- debian/mandos-client.README.Debian	2010-09-27 17:53:53 +0000
+++ debian/mandos-client.README.Debian	2016-06-21 19:47:08 +0000
@@ -1,24 +1,6 @@
-* Choose the Client Network Interface
-  
-  Please make sure that the correct network interface is specified in
-  the DEVICE setting in the "/etc/initramfs-tools/initramfs.conf"
-  file.  If the setting is empty, the interface will be autodetected
-  at boot time, which may not be correct.  *If* the DEVICE setting is
-  changed, it will be necessary to update the initrd image by running
-  the command
-  
-	update-initramfs -k all -u
-  
-  The device can be overridden at boot time on the Linux kernel
-  command line using the sixth colon-separated field of the "ip="
-  option; for exact syntax, read the documentation in the file
-  "/usr/share/doc/linux-doc-*/Documentation/filesystems/nfsroot.txt",
-  available in the "linux-doc-*" package.
-  
-  Note that since this network interface is used in the initial RAM
-  disk environment, the network interface *must* exist at that stage.
-  Thus, the interface can *not* be a pseudo-interface such as "br0" or
-  "tun0"; instead, a real interface (such as "eth0") must be used.
+This file documents the next steps to take after installation of the
+Debian package, and also contain some notes specific to the Debian
+packaging which are not also in the manual.
 
 * Adding a Client Password to the Server
   
@@ -38,7 +20,10 @@
   is possible to verify that the correct password will be received by
   this client by running the command, on the client:
   
-	/usr/lib/mandos/plugins.d/mandos-client \
+	MANDOSPLUGINHELPERDIR=/usr/lib/$(dpkg-architecture \
+	-qDEB_HOST_MULTIARCH)/mandos/plugin-helpers \
+	/usr/lib/$(dpkg-architecture -qDEB_HOST_MULTIARCH \
+	)/mandos/plugins.d/mandos-client \
 		--pubkey=/etc/keys/mandos/pubkey.txt \
 		--seckey=/etc/keys/mandos/seckey.txt; echo
   
@@ -46,6 +31,40 @@
   it, and output it to standard output.  There it can be verified to
   be the correct password, before rebooting.
 
+* Emergency Escape
+  
+  If it ever should be necessary, the Mandos client can be temporarily
+  prevented from running at startup by passing the parameter
+  "mandos=off" to the kernel.
+
+* Specifying a Client Network Interface
+  
+  At boot time the network interfaces to use will by default be
+  automatically detected.  If this should result in incorrect
+  interfaces, edit the DEVICE setting in the
+  "/etc/initramfs-tools/initramfs.conf" file.  (The default setting is
+  empty, meaning it will autodetect the interfaces.)  *If* the DEVICE
+  setting is changed, it will be necessary to update the initrd image
+  by running this command:
+  
+	update-initramfs -k all -u
+  
+  The device can also be overridden at boot time on the Linux kernel
+  command line using the sixth colon-separated field of the "ip="
+  option; for exact syntax, read the documentation in the file
+  "/usr/share/doc/linux-doc-*/Documentation/filesystems/nfs/nfsroot.txt",
+  available in the "linux-doc-*" package.
+  
+  Note that since the network interfaces are used in the initial RAM
+  disk environment, the network interfaces *must* exist at that stage.
+  Thus, an interface can *not* be a pseudo-interface such as "br0" or
+  "tun0"; instead, only real interfaces (such as "eth0") can be used.
+  This can be overcome by writing a "network hook" program to create
+  an interface (see mandos-client(8mandos)) and placing it in
+  "/etc/mandos/network-hooks.d", from where it will be copied into the
+  initial RAM disk.  Example network hook scripts can be found in
+  "/usr/share/doc/mandos-client/examples/network-hooks.d".
+
 * User-Supplied Plugins
   
   Any plugins found in "/etc/mandos/plugins.d" will override and add
@@ -62,25 +81,29 @@
   Mandos client will be the new default way for getting a password for
   the root file system when booting.
 
-* Emergency Escape
-  
-  If it ever should be necessary, the Mandos client can be temporarily
-  prevented from running at startup by passing the parameter
-  "mandos=off" to the kernel.
-
 * Non-local Connection (Not Using ZeroConf)
   
   If the "ip=" kernel command line option is used to specify a
   complete IP address and device name, as noted above, it then becomes
   possible to specify a specific IP address and port to connect to,
   instead of using ZeroConf.  The syntax for doing this is
-  "mandos=connect:<IP_ADDRESS>:<PORT_NUMBER>".
+  "mandos=connect:<IP_ADDRESS>:<PORT_NUMBER>" on the kernel command
+  line.
   
-  For very advanced users, it it possible to specify simply
+  For very advanced users, it is possible to specify simply
   "mandos=connect" on the kernel command line to make the system only
   set up the network (using the data in the "ip=" option) and not pass
   any extra "--connect" options to mandos-client at boot.  For this to
   work, "--options-for=mandos-client:--connect=<ADDRESS>:<PORT>" needs
   to be manually added to the file "/etc/mandos/plugin-runner.conf".
 
- -- Teddy Hogeborn <teddy@fukt.bsnet.se>, Mon, 27 Sep 2010 19:53:21 +0200
+* Diffie-Hellman Parameters
+
+  On installation, a file with Diffie-Hellman parameters,
+  /etc/keys/mandos/dhparams.pem, will be generated and automatically
+  installed into the initital RAM disk image and also used by the
+  Mandos Client on boot.  If different parameters are needed for
+  policy or other reasons, simply replace the existing dhparams.pem
+  file and update the initital RAM disk image.
+
+ -- Teddy Hogeborn <teddy@recompile.se>, Tue, 21 Jun 2016 21:43:49 +0200

=== added file 'debian/mandos-client.examples'
--- debian/mandos-client.examples	1970-01-01 00:00:00 +0000
+++ debian/mandos-client.examples	2012-06-01 21:48:12 +0000
@@ -0,0 +1,1 @@
+network-hooks.d

=== modified file 'debian/mandos-client.lintian-overrides'
--- debian/mandos-client.lintian-overrides	2009-01-18 06:41:57 +0000
+++ debian/mandos-client.lintian-overrides	2016-03-19 04:21:00 +0000
@@ -2,12 +2,14 @@
 #
 mandos-client binary: non-standard-dir-perm etc/keys/mandos/ 0700 != 0755
 
-# The directory /usr/lib/mandos/plugins.d contains setuid binaries
-# which are not meant to be run outside an initial RAM disk
+# The directory /usr/lib/<arch>/mandos/plugins.d contains setuid
+# binaries which are not meant to be run outside an initial RAM disk
 # environment (except for test purposes).  It would be insecure to
 # allow anyone to run them.
 #
-mandos-client binary: non-standard-dir-perm usr/lib/mandos/plugins.d/ 0700 != 0755
+mandos-client binary: non-standard-dir-perm usr/lib/*/mandos/plugins.d/ 0700 != 0755
+# Likewise for helper executables for plugins
+mandos-client binary: non-standard-dir-perm usr/lib/*/mandos/plugin-helpers/ 0700 != 0755
 
 # These binaries must be setuid root, since they need root powers, but
 # are started by plugin-runner(8mandos), which runs all plugins as
@@ -15,13 +17,16 @@
 # system, but in an initial RAM disk environment.  Here they are
 # protected from non-root access by the directory permissions, above.
 #
-mandos-client binary: setuid-binary usr/lib/mandos/plugins.d/mandos-client 4755 root/root
-mandos-client binary: setuid-binary usr/lib/mandos/plugins.d/askpass-fifo 4755 root/root
-mandos-client binary: setuid-binary usr/lib/mandos/plugins.d/splashy 4755 root/root
-mandos-client binary: setuid-binary usr/lib/mandos/plugins.d/usplash 4755 root/root
+mandos-client binary: setuid-binary usr/lib/*/mandos/plugins.d/mandos-client 4755 root/root
+mandos-client binary: setuid-binary usr/lib/*/mandos/plugins.d/askpass-fifo 4755 root/root
+mandos-client binary: setuid-binary usr/lib/*/mandos/plugins.d/splashy 4755 root/root
+mandos-client binary: setuid-binary usr/lib/*/mandos/plugins.d/usplash 4755 root/root
+mandos-client binary: setuid-binary usr/lib/*/mandos/plugins.d/plymouth 4755 root/root
 
 # The directory /etc/mandos/plugins.d can be used by local system
 # administrators to place plugins in, overriding and complementing
-# /usr/lib/mandos/plugins.d, and must be likewise protected.
+# /usr/lib/<arch>/mandos/plugins.d, and must be likewise protected.
 #
 mandos-client binary: non-standard-dir-perm etc/mandos/plugins.d/ 0700 != 0755
+# Likewise for plugin-helpers directory
+mandos-client binary: non-standard-dir-perm etc/mandos/plugin-helpers/ 0700 != 0755

=== modified file 'debian/mandos-client.postinst'
--- debian/mandos-client.postinst	2009-05-24 23:36:15 +0000
+++ debian/mandos-client.postinst	2016-10-09 22:35:41 +0000
@@ -1,4 +1,4 @@
-#!/bin/sh -e
+#!/bin/sh
 # This script can be called in the following ways:
 #
 # After the package was installed:
@@ -15,12 +15,12 @@
 # If prerm fails during replacement due to conflict:
 #       <postinst> abort-remove in-favour <new-package> <version>
 
+set -e
+
 # Update the initial RAM file system image
 update_initramfs()
 {
-    if [ -x /usr/sbin/update-initramfs ]; then
-	update-initramfs -u -k all
-    fi
+    update-initramfs -u -k all
     
     if dpkg --compare-versions "$2" lt-nl "1.0.10-1"; then
         # Make old initrd.img files unreadable too, in case they were
@@ -56,16 +56,52 @@
 	-a -r /etc/keys/mandos/seckey.txt ]; then
 	return 0
     fi
-    if [ -x /usr/sbin/mandos-keygen ]; then
-	mandos-keygen
-    fi
+    mandos-keygen
+    gpg-connect-agent KILLAGENT /bye || :
+}
+
+create_dh_params(){
+    if [ -r /etc/keys/mandos/dhparams.pem ]; then
+	return 0
+    fi
+    # Create a Diffe-Hellman parameters file
+    DHFILE="`mktemp -t mandos-client-dh-parameters.XXXXXXXXXX.pem`"
+    # First try certtool from GnuTLS
+    if ! certtool --generate-dh-params --sec-param high \
+	 --outfile "$DHFILE"; then
+	# Otherwise try OpenSSL
+	if ! openssl genpkey -genparam -algorithm DH -out "$DHFILE" \
+	     -pkeyopt dh_paramgen_prime_len:3072; then
+	    # None of the commands succeded; give up
+	    rm -- "$DHFILE"
+	    return 1
+	fi
+    fi
+    sed --in-place --expression='0,/^-----BEGIN DH PARAMETERS-----$/d' \
+	"$DHFILE"
+    sed --in-place --expression='1i-----BEGIN DH PARAMETERS-----' \
+	    "$DHFILE"
+    cp --archive "$DHFILE" /etc/keys/mandos/dhparams.pem
+    rm -- "$DHFILE"
 }
 
 case "$1" in
     configure)
 	add_mandos_user "$@"
 	create_key "$@"
+	create_dh_params "$@" || :
 	update_initramfs "$@"
+	if dpkg --compare-versions "$2" lt-nl "1.7.10-1"; then
+	    PLUGINHELPERDIR=/usr/lib/$(dpkg-architecture -qDEB_HOST_MULTIARCH 2>/dev/null)/mandos/plugin-helpers
+	    if ! dpkg-statoverride --list "$PLUGINHELPERDIR" \
+		 >/dev/null 2>&1; then
+		chmod u=rwx,go= -- "$PLUGINHELPERDIR"
+	    fi
+	    if ! dpkg-statoverride --list /etc/mandos/plugin-helpers \
+		 >/dev/null 2>&1; then
+		chmod u=rwx,go= -- /etc/mandos/plugin-helpers
+	    fi
+	fi
 	;;
     abort-upgrade|abort-deconfigure|abort-remove)
 	;;

=== modified file 'debian/mandos-client.postrm'
--- debian/mandos-client.postrm	2009-01-18 00:16:57 +0000
+++ debian/mandos-client.postrm	2015-07-27 09:23:56 +0000
@@ -1,4 +1,4 @@
-#!/bin/sh -e
+#!/bin/sh
 # This script can be called in the following ways:
 #
 # After the package was removed:
@@ -26,13 +26,12 @@
 # If preinst fails during upgrade:
 #       <new-postrm> abort-upgrade <old-version>
 
+set -e
 
 # Update the initial RAM file system image
 update_initramfs()
 {
-    if [ -x /usr/sbin/update-initramfs ]; then
-	update-initramfs -u -k all
-    fi
+    update-initramfs -u -k all || :
 }
 
 case "$1" in
@@ -44,7 +43,9 @@
 	shred --remove /etc/keys/mandos/seckey.txt 2>/dev/null || :
 	rm --force /etc/mandos/plugin-runner.conf \
 	    /etc/keys/mandos/pubkey.txt \
-	    /etc/keys/mandos/seckey.txt 2>/dev/null
+	    /etc/keys/mandos/seckey.txt \
+	    /etc/keys/mandos/dhparams.pem 2>/dev/null
+	update_initramfs
 	;;
     upgrade|failed-upgrade|disappear|abort-install|abort-upgrade)
 	;;

=== modified file 'debian/mandos.README.Debian'
--- debian/mandos.README.Debian	2009-09-08 06:28:20 +0000
+++ debian/mandos.README.Debian	2011-10-05 16:00:56 +0000
@@ -1,10 +1,10 @@
 The Mandos server is useless without at least one configured client in
 /etc/mandos/clients.conf.  To create one, install the "mandos-client"
-package on a client computer, and run the command
+package on a client computer, and, on the client, run the command
 
 	# mandos-keygen --password
 
-there to get a config file stanza.  Append the output of that command
-to the file "/etc/mandos/clients.conf" on the Mandos server.
+to get a config file stanza.  Append the output of that command to the
+file "/etc/mandos/clients.conf" on the Mandos server computer.
 
- -- Teddy Hogeborn <teddy@fukt.bsnet.se>, Tue,  8 Sep 2009 06:57:45 +0200
+ -- Teddy Hogeborn <teddy@recompile.se>, Wed,  5 Oct 2011 17:51:22 +0200

=== modified file 'debian/mandos.dirs'
--- debian/mandos.dirs	2010-09-15 17:33:14 +0000
+++ debian/mandos.dirs	2016-03-19 12:10:15 +0000
@@ -4,3 +4,6 @@
 etc/default
 etc/dbus-1/system.d
 usr/sbin
+var/lib/mandos
+lib/systemd/system
+usr/lib/tmpfiles.d

=== modified file 'debian/mandos.postinst'
--- debian/mandos.postinst	2009-05-24 23:28:04 +0000
+++ debian/mandos.postinst	2016-03-19 03:48:56 +0000
@@ -1,4 +1,4 @@
-#!/bin/sh -e
+#!/bin/sh
 # This script can be called in the following ways:
 #
 # After the package was installed:
@@ -15,6 +15,8 @@
 # If prerm fails during replacement due to conflict:
 #       <postinst> abort-remove in-favour <new-package> <version>
 
+set -e
+
 case "$1" in
     configure)
 	# Rename old "mandos" user and group
@@ -32,18 +34,46 @@
 		--home /nonexistent --no-create-home --group \
 		--disabled-password --gecos "Mandos password system" \
 		_mandos
+	elif dpkg --compare-versions "$2" eq 1.7.4-1 \
+		|| dpkg --compare-versions "$2" eq "1.7.4-1~bpo8+1"
+	then
+	    start=no
+	    if ! [ -f /var/lib/mandos/clients.pickle ]; then
+		invoke-rc.d mandos stop
+		start=yes
+	    fi
+	    chown _mandos:_mandos /var/lib/mandos/clients.pickle \
+		  2>/dev/null || :
+	    if [ "$start" = yes ]; then
+		invoke-rc.d mandos start
+	    fi
+	fi
+	if ! dpkg-statoverride --list "/var/lib/mandos" >/dev/null \
+	     2>&1; then
+	    chown _mandos:_mandos /var/lib/mandos
+	    chmod u=rwx,go= /var/lib/mandos
 	fi
 	;;
-
+    
     abort-upgrade|abort-deconfigure|abort-remove)
 	;;
-
+    
     *)
 	echo "$0 called with unknown argument '$1'" 1>&2
 	exit 1
 	;;
 esac
 
+# Avahi version 0.6.31-2 and older provides "avahi" (instead of
+# "avahi-daemon") in its /etc/init.d script header.  To make
+# insserv(8) happy, we edit our /etc/init.d script header to contain
+# the correct string before the code added by dh_installinit calls
+# update.rc-d, which calls insserv.
+avahi_version="`dpkg-query --showformat='${Version}' --show avahi-daemon`"
+if dpkg --compare-versions "$avahi_version" le 0.6.31-2; then
+    sed --in-place --expression='/^### BEGIN INIT INFO$/,/^### END INIT INFO$/s/^\(# Required-\(Stop\|Start\):.*avahi\)-daemon\>/\1/g' /etc/init.d/mandos
+fi
+
 #DEBHELPER#
 
 exit 0

=== modified file 'debian/mandos.prerm'
--- debian/mandos.prerm	2009-01-18 00:16:57 +0000
+++ debian/mandos.prerm	2015-07-12 01:57:54 +0000
@@ -1,4 +1,4 @@
-#! /bin/sh
+#!/bin/sh
 # prerm script for mandos
 #
 # see: dh_installdeb(1)
@@ -17,13 +17,7 @@
 
 case "$1" in
     remove|deconfigure)
-	if [ -x /etc/init.d/mandos ]; then
-		if [ -x /usr/sbin/invoke-rc.d ]; then
-			invoke-rc.d mandos stop
-		else
-			/etc/init.d/mandos stop
-		fi
-	fi
+	invoke-rc.d mandos stop || :
 	;;
     upgrade|failed-upgrade)
         ;;

=== modified file 'debian/rules'
--- debian/rules	2010-09-09 18:16:14 +0000
+++ debian/rules	2016-06-23 19:46:41 +0000
@@ -1,106 +1,35 @@
 #!/usr/bin/make -f
-# Sample debian/rules that uses debhelper.
-#
-# This file was originally written by Joey Hess and Craig Small.
-# As a special exception, when this file is copied by dh-make into a
-# dh-make output file, you may use that output file without restriction.
-# This special exception was added by Craig Small in version 0.37 of dh-make.
-#
-# Modified to make a template file for a multi-binary package with separated
-# build-arch and build-indep targets  by Bill Allombert 2001
-
-# Uncomment this to turn on verbose mode.
-#export DH_VERBOSE=1
-
-# This has to be exported to make some magic below work.
-export DH_OPTIONS
-
-# -pie was broken briefly on the mips and mipsel architectures, see
-# <http://bugs.debian.org/526961>
-BINUTILS_V := $(shell dpkg-query --showformat='$${Version}' \
-			--show binutils)
-ifeq (yes,$(shell dpkg --compare-versions $(BINUTILS_V) lt 2.20-3 \
-		&& dpkg --compare-versions $(BINUTILS_V) ge 2.19.1-1 \
-		&& echo yes))
-  ifneq (,$(strip $(findstring :$(DEB_HOST_ARCH):,:mips:mipsel:) \
-		$(findstring :$(DEB_BUILD_ARCH):,:mips:mipsel:)))
-    BROKEN_PIE := yes
-    export BROKEN_PIE
-  endif
-endif
-
-configure: configure-stamp
-configure-stamp:
-	dh_testdir
-	touch configure-stamp
-
-build: build-arch build-indep
-
-build-arch: build-arch-stamp
-build-arch-stamp: configure-stamp
-	dh_auto_build -- all doc
-	touch $@
-
-build-indep: build-indep-stamp
-build-indep-stamp: configure-stamp
-	dh_auto_build -- doc
-	touch $@
-
-clean:
-	dh_testdir
-	dh_testroot
-	rm -f build-arch-stamp build-indep-stamp configure-stamp
-	dh_auto_clean
-	dh_clean
-
-install: install-indep install-arch
-install-indep:
-	dh_testdir
-	dh_testroot
-	dh_prep
-	dh_installdirs --indep
-	$(MAKE) DESTDIR=$(CURDIR)/debian/mandos install-server
-	dh_lintian
+%:
+	dh $@
+
+override_dh_auto_build-arch:
+	LC_ALL=en_US.utf8 dh_auto_build -- all doc
+
+override_dh_auto_build-indep:
+	LC_ALL=en_US.utf8 dh_auto_build -- doc
+
+override_dh_installinit-indep:
 	dh_installinit --onlyscripts \
 		--update-rcd-params="defaults 25 15"
-	dh_install --indep
-
-install-arch:
-	dh_testdir
-	dh_testroot
-	dh_prep
-	dh_installdirs --same-arch
-	$(MAKE) DESTDIR=$(CURDIR)/debian/mandos-client install-client-nokey
-	dh_lintian
-	dh_install --same-arch
-
-binary-common:
-	dh_testdir
-	dh_testroot
-	dh_installchangelogs
-	dh_installdocs
-	dh_link
-	dh_strip
-	dh_compress
+
+override_dh_auto_install-indep:
+	$(MAKE) DESTDIR=$(CURDIR)/debian/mandos install-server
+
+override_dh_auto_install-arch:
+	$(MAKE) DESTDIR=$(CURDIR)/debian/mandos-client \
+		install-client-nokey
+
+override_dh_fixperms-arch:
 	dh_fixperms --exclude etc/keys/mandos \
-		--exclude etc/mandos/clients.conf \
 		--exclude etc/mandos/plugins.d \
-		--exclude usr/lib/mandos/plugins.d
-	dh_installdeb
-	dh_shlibdeps
-	dh_gencontrol
-	dh_md5sums
-	dh_builddeb
-
-# Build architecture independant packages using the common target.
-binary-indep: build-indep install-indep
-	$(MAKE) -f debian/rules DH_OPTIONS=--indep binary-common
-
-# Build architecture dependant packages using the common target.
-binary-arch: build-arch install-arch
-	$(MAKE) -f debian/rules DH_OPTIONS=--same-arch binary-common
-
-binary: binary-arch binary-indep
-
-.PHONY: build clean binary-indep binary-arch binary install \
-		install-indep install-arch configure
+		--exclude etc/mandos/plugin-helpers \
+		--exclude usr/lib/$(shell dpkg-architecture -qDEB_HOST_MULTIARCH 2>/dev/null)/mandos/plugins.d \
+		--exclude usr/lib/$(shell dpkg-architecture -qDEB_HOST_MULTIARCH 2>/dev/null)/mandos/plugin-helpers \
+		--exclude usr/share/doc/mandos-client/examples/network-hooks.d
+	chmod --recursive g-w -- \
+	"$(CURDIR)/debian/mandos-client/usr/share/doc/mandos-client/examples/network-hooks.d"
+
+override_dh_fixperms-indep:
+	dh_fixperms --exclude etc/mandos/clients.conf
+
+override_dh_auto_test-arch: ;

=== added file 'debian/source/local-options'
--- debian/source/local-options	1970-01-01 00:00:00 +0000
+++ debian/source/local-options	2011-10-08 21:13:46 +0000
@@ -0,0 +1,1 @@
+--single-debian-patch

=== added directory 'debian/upstream'
=== added file 'debian/upstream/signing-key.asc'
--- debian/upstream/signing-key.asc	1970-01-01 00:00:00 +0000
+++ debian/upstream/signing-key.asc	2014-03-28 22:32:21 +0000
@@ -0,0 +1,52 @@
+-----BEGIN PGP PUBLIC KEY BLOCK-----
+Version: GnuPG v1.4.12 (GNU/Linux)
+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+=9Noe
+-----END PGP PUBLIC KEY BLOCK-----

=== modified file 'debian/watch'
--- debian/watch	2010-09-15 17:17:46 +0000
+++ debian/watch	2014-02-16 02:42:42 +0000
@@ -1,2 +1,3 @@
 version=3
-ftp://ftp.fukt.bsnet.se/pub/mandos/mandos[-_]([^\s]+?)(?:\.orig)?\.tar\.(?:gz|bz2|7z|xz)
+opts=pgpsigurlmangle=s/$/.asc/ \
+ ftp://ftp.recompile.se/pub/mandos/mandos[-_]([^\s]+?)(?:\.orig)?\.tar\.(?:gz|bz2|7z|xz)

=== modified file 'init.d-mandos'
--- init.d-mandos	2009-09-16 23:28:39 +0000
+++ init.d-mandos	2016-03-13 00:37:02 +0000
@@ -1,16 +1,16 @@
 #! /bin/sh
 ### BEGIN INIT INFO
 # Provides:          mandos
-# Required-Start:    $remote_fs $syslog avahi
-# Required-Stop:     $remote_fs $syslog avahi
+# Required-Start:    $remote_fs $syslog avahi-daemon
+# Required-Stop:     $remote_fs $syslog avahi-daemon
 # Default-Start:     2 3 4 5
 # Default-Stop:      0 1 6
 # Short-Description: Mandos server
-# Description:       Gives encrypted passwords to Mandos clients
+# Description:       Server of encrypted passwords to Mandos clients
 ### END INIT INFO
 
-# Author: Teddy Hogeborn <teddy@fukt.bsnet.se>
-# Author: Björn Påhlsson <belorn@fukt.bsnet.se>
+# Author: Teddy Hogeborn <teddy@recompile.se>
+# Author: Björn Påhlsson <belorn@recompile.se>
 #
 # Please remove the "Author" lines above and replace them
 # with your own name if you copy and modify this script.
@@ -23,7 +23,11 @@
 NAME=mandos
 DAEMON=/usr/sbin/$NAME
 DAEMON_ARGS=""
-PIDFILE=/var/run/$NAME.pid
+if [ -d /run/. ]; then
+    PIDFILE=/run/$NAME.pid
+else
+    PIDFILE=/var/run/$NAME.pid
+fi
 SCRIPTNAME=/etc/init.d/$NAME
 
 # Exit if the package is not installed
@@ -40,7 +44,8 @@
 . /lib/init/vars.sh
 
 # Define LSB log_* functions.
-# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
+# Depend on lsb-base (>= 3.2-14) to ensure that this file is present
+# and status_of_proc is working.
 . /lib/lsb/init-functions
 
 #
@@ -118,6 +123,9 @@
 		2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
 	esac
 	;;
+  status)
+	status_of_proc "$DAEMON" "$NAME" -p "$PIDFILE" && exit 0 || exit $?
+	;;
   #reload|force-reload)
 	#
 	# If do_reload() is not implemented then leave this commented out
@@ -144,14 +152,14 @@
 		esac
 		;;
 	  *)
-	  	# Failed to stop
+		# Failed to stop
 		log_end_msg 1
 		;;
 	esac
 	;;
   *)
 	#echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
-	echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload}" >&2
+	echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
 	exit 3
 	;;
 esac

=== modified file 'initramfs-tools-hook'
--- initramfs-tools-hook	2010-09-09 18:16:14 +0000
+++ initramfs-tools-hook	2016-06-21 19:13:11 +0000
@@ -3,7 +3,7 @@
 # This script will be run by 'mkinitramfs' when it creates the image.
 # Its job is to decide which files to install, then install them into
 # the staging area, where the initramfs is being created.  This
-# happens when a new 'linux-image' package is installed, or when the
+# happens when a new 'linux-image' package is installed, or when an
 # administrator runs 'update-initramfs' by hand to update an initramfs
 # image.
 
@@ -29,13 +29,15 @@
 
 . /usr/share/initramfs-tools/hook-functions
 
-for d in /usr /usr/local; do
-    if [ -d "$d"/lib/mandos ]; then
-	prefix="$d"
+for d in /usr/lib \
+    "/usr/lib/`dpkg-architecture -qDEB_HOST_MULTIARCH 2>/dev/null`" \
+    "`rpm --eval='%{_libdir}' 2>/dev/null`" /usr/local/lib; do
+    if [ -d "$d"/mandos ]; then
+	libdir="$d"
 	break
     fi
 done
-if [ -z "$prefix" ]; then
+if [ -z "$libdir" ]; then
     # Mandos not found
     exit 1
 fi
@@ -68,20 +70,23 @@
 CONFDIR="/conf/conf.d/mandos"
 MANDOSDIR="/lib/mandos"
 PLUGINDIR="${MANDOSDIR}/plugins.d"
+PLUGINHELPERDIR="${MANDOSDIR}/plugin-helpers"
+HOOKDIR="${MANDOSDIR}/network-hooks.d"
 
 # Make directories
 install --directory --mode=u=rwx,go=rx "${DESTDIR}${CONFDIR}" \
-	"${DESTDIR}${MANDOSDIR}"
+	"${DESTDIR}${MANDOSDIR}" "${DESTDIR}${HOOKDIR}"
 install --owner=${mandos_user} --group=${mandos_group} --directory \
-    --mode=u=rwx "${DESTDIR}${PLUGINDIR}"
+	--mode=u=rwx "${DESTDIR}${PLUGINDIR}" \
+	"${DESTDIR}${PLUGINHELPERDIR}"
 
 # Copy the Mandos plugin runner
-copy_exec "$prefix"/lib/mandos/plugin-runner "${MANDOSDIR}"
+copy_exec "$libdir"/mandos/plugin-runner "${MANDOSDIR}"
 
 # Copy the plugins
 
 # Copy the packaged plugins
-for file in "$prefix"/lib/mandos/plugins.d/*; do
+for file in "$libdir"/mandos/plugins.d/*; do
     base="`basename \"$file\"`"
     # Is this plugin overridden?
     if [ -e "/etc/mandos/plugins.d/$base" ]; then
@@ -95,6 +100,21 @@
     esac
 done
 
+# Copy the packaged plugin helpers
+for file in "$libdir"/mandos/plugin-helpers/*; do
+    base="`basename \"$file\"`"
+    # Is this plugin overridden?
+    if [ -e "/etc/mandos/plugin-helpers/$base" ]; then
+	continue
+    fi
+    case "$base" in
+	*~|.*|\#*\#|*.dpkg-old|*.dpkg-bak|*.dpkg-new|*.dpkg-divert)
+	    : ;;
+	"*") : ;;
+	*) copy_exec "$file" "${PLUGINHELPERDIR}" ;;
+    esac
+done
+
 # Copy any user-supplied plugins
 for file in /etc/mandos/plugins.d/*; do
     base="`basename \"$file\"`"
@@ -106,12 +126,80 @@
     esac
 done
 
-# GPGME needs /usr/bin/gpg
-if [ ! -e "${DESTDIR}/usr/bin/gpg" \
-    -a -n "`ls \"${DESTDIR}\"/usr/lib/libgpgme.so* \
-		2>/dev/null`" ]; then
-    copy_exec /usr/bin/gpg
-fi
+# Copy any user-supplied plugin helpers
+for file in /etc/mandos/plugin-helpers/*; do
+    base="`basename \"$file\"`"
+    case "$base" in
+	*~|.*|\#*\#|*.dpkg-old|*.dpkg-bak|*.dpkg-new|*.dpkg-divert)
+	    : ;;
+	"*") : ;;
+	*) copy_exec "$file" "${PLUGINHELPERDIR}" ;;
+    esac
+done
+
+# Get DEVICE from initramfs.conf and other files
+. /etc/initramfs-tools/initramfs.conf
+for conf in /etc/initramfs-tools/conf.d/*; do
+    if [ -n `basename \"$conf\" | grep '^[[:alnum:]][[:alnum:]\._-]*$' \
+	| grep -v '\.dpkg-.*$'` ]; then
+	[ -f ${conf} ] && . ${conf}
+    fi
+done
+export DEVICE
+
+# Copy network hooks
+for hook in /etc/mandos/network-hooks.d/*; do
+    case "`basename \"$hook\"`" in
+	"*") continue ;;
+	*[!A-Za-z0-9_.-]*) continue ;;
+	*) test -d "$hook" || copy_exec "$hook" "${HOOKDIR}" ;;
+    esac
+    if [ -x "$hook" ]; then
+        # Copy any files needed by the network hook
+	MANDOSNETHOOKDIR=/etc/mandos/network-hooks.d MODE=files \
+	    VERBOSITY=0 "$hook" files | while read file target; do
+	    if [ ! -e "${file}" ]; then
+		echo "WARNING: file ${file} not found, requested by Mandos network hook '${hook##*/}'" >&2
+	    fi
+	    if [ -z "${target}" ]; then
+		copy_exec "$file"
+	    else
+		copy_exec "$file" "$target"
+	    fi
+	done
+        # Copy and load any modules needed by the network hook
+	MANDOSNETHOOKDIR=/etc/mandos/network-hooks.d MODE=modules \
+	    VERBOSITY=0 "$hook" modules | while read module; do
+	    if [ -z "${target}" ]; then
+		force_load "$module"
+	    fi
+	done
+    fi
+done
+
+# GPGME needs GnuPG
+gpg=/usr/bin/gpg
+libgpgme11_version="`dpkg-query --showformat='${Version}' --show libgpgme11`"
+if dpkg --compare-versions "$libgpgme11_version" ge 1.5.0-0.1; then
+    if [ -e /usr/bin/gpgconf ]; then
+	if [ ! -e "${DESTDIR}/usr/bin/gpgconf" ]; then
+	    copy_exec /usr/bin/gpgconf
+	fi
+	gpg="`/usr/bin/gpgconf|sed --quiet --expression='s/^gpg:[^:]*://p'`"
+	gpgagent="`/usr/bin/gpgconf|sed --quiet --expression='s/^gpg-agent:[^:]*://p'`"
+	# Newer versions of GnuPG 2 requires the gpg-agent binary
+	if [ -e "$gpgagent" ] && [ ! -e "${DESTDIR}$gpgagent" ]; then
+	    copy_exec "$gpgagent"
+	fi
+    fi
+elif dpkg --compare-versions "$libgpgme11_version" ge 1.4.1-0.1; then
+    gpg=/usr/bin/gpg2
+fi
+if [ ! -e "${DESTDIR}$gpg" ]; then
+    copy_exec "$gpg"
+fi
+unset gpg
+unset libgpgme11_version
 
 # Config files
 for file in /etc/mandos/plugin-runner.conf; do
@@ -131,15 +219,29 @@
 	"${DESTDIR}${CONFDIR}/plugin-runner.conf"
 fi
 
-# Key files 
+# Key files
 for file in "$keydir"/*; do
     if [ -d "$file" ]; then
 	continue
     fi
-    cp --archive --sparse=always "$file" "${DESTDIR}${CONFDIR}"
-    chown ${mandos_user}:${mandos_group} \
-	"${DESTDIR}${CONFDIR}/`basename \"$file\"`"
+    case "$file" in
+	*~|.*|\#*\#|*.dpkg-old|*.dpkg-bak|*.dpkg-new|*.dpkg-divert)
+	    : ;;
+	"*") : ;;
+	*)
+	    cp --archive --sparse=always "$file" \
+	       "${DESTDIR}${CONFDIR}"
+	    chown ${mandos_user}:${mandos_group} \
+		  "${DESTDIR}${CONFDIR}/`basename \"$file\"`"
+	    ;;
+    esac
 done
+# Use Diffie-Hellman parameters file if available
+if [ -e "${DESTDIR}${CONFDIR}"/dhparams.pem ]; then
+    sed --in-place \
+	--expression="1i--options-for=mandos-client:--dh-params=${CONFDIR}/dhparams.pem" \
+	"${DESTDIR}/${CONFDIR}/plugin-runner.conf"
+fi
 
 # /lib/mandos/plugin-runner will drop priviliges, but needs access to
 # its plugin directory and its config file.  However, since almost all
@@ -169,7 +271,7 @@
 done
 for dir in "${DESTDIR}"/lib* "${DESTDIR}"/usr/lib*; do
     if [ -d "$dir" ]; then
-	find "$dir" \! -perm -u+rw,g+r -prune -or -print0 \
-	    | xargs --null --no-run-if-empty chmod a+rX
+	find "$dir" \! -perm -u+rw,g+r -prune -or \! -type l -print0 \
+	    | xargs --null --no-run-if-empty chmod a+rX --
     fi
 done

=== modified file 'initramfs-tools-script'
--- initramfs-tools-script	2009-09-16 23:28:39 +0000
+++ initramfs-tools-script	2016-03-02 16:45:38 +0000
@@ -94,7 +94,9 @@
 # If we are connecting directly, run "configure_networking" (from
 # /scripts/functions); it needs IPOPTS and DEVICE
 if [ "${connect+set}" = set ]; then
+    set +e			# Required by library functions
     configure_networking
+    set -e
     if [ -n "$connect" ]; then
 	cat <<-EOF >>/conf/conf.d/mandos/plugin-runner.conf
 	
@@ -108,6 +110,7 @@
 
 # Our keyscript
 mandos=/lib/mandos/plugin-runner
+test -x "$mandos"
 
 # parse /conf/conf.d/cryptroot.  Format:
 # target=sda2_crypt,source=/dev/sda2,key=none,keyscript=/foo/bar/baz

=== added file 'initramfs-unpack'
--- initramfs-unpack	1970-01-01 00:00:00 +0000
+++ initramfs-unpack	2013-10-13 15:43:42 +0000
@@ -0,0 +1,67 @@
+#!/bin/bash
+# 
+# Initramfs unpacker - unpacks initramfs images into /tmp
+# 
+# Copyright © 2013 Teddy Hogeborn
+# Copyright © 2013 Björn Påhlsson
+# 
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+#     This program is distributed in the hope that it will be useful,
+#     but WITHOUT ANY WARRANTY; without even the implied warranty of
+#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#     GNU General Public License for more details.
+# 
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see
+# <http://www.gnu.org/licenses/>.
+# 
+# Contact the authors at <mandos@recompile.se>.
+
+cpio="cpio --extract --make-directories --unconditional --preserve-modification-time"
+
+if [ -z "$*" ]; then
+    set -- /boot/initrd.img-*
+fi
+
+for imgfile in "$@"; do
+    if ! [ -f "$imgfile" ]; then
+	echo "Error: Not an existing file: $imgfile" >&2
+	continue
+    fi
+    imgdir="${TMPDIR:-/tmp}/${imgfile##*/}"
+    if [ -d "$imgdir" ]; then
+	rm --recursive -- "$imgdir"
+    fi
+    mkdir --parents "$imgdir"
+    # Does this image contain microcode?
+    if $cpio --quiet --list --file="$imgfile" >/dev/null 2>&1; then
+	# Number of bytes to skip to get to the compressed archive
+	skip=$(($(LANG=C $cpio --io-size=1 --list --file="$imgfile" 2>&1 \
+	    | sed --quiet --expression='s/^\([0-9]\+\) blocks$/\1/p')+8))
+	catimg="dd if=$imgfile bs=$skip skip=1 status=noxfer"
+    else
+	catimg="cat -- $imgfile"
+    fi
+    # Determine the compression method
+    if { $catimg 2>/dev/null | zcat --test >/dev/null 2>&1;
+	    [ ${PIPESTATUS[-1]} -eq 0 ]; }; then
+	decomp="zcat"
+    elif { $catimg 2>/dev/null | bzip2 --test >/dev/null 2>&1;
+	    [ ${PIPESTATUS[-1]} -eq 0 ]; }; then
+	decomp="bzip2 --stdout --decompress"
+    elif { $catimg 2>/dev/null | lzop --test >/dev/null 2>&1;
+	    [ ${PIPESTATUS[-1]} -eq 0 ]; }; then
+	decomp="lzop --stdout --decompress"
+    else
+	echo "Error: Could not determine type of $imgfile" >&2
+	continue
+    fi
+    $catimg 2>/dev/null | $decomp | ( cd -- "$imgdir" && $cpio --quiet )
+    if [ ${PIPESTATUS[-1]} -eq 0 ]; then
+	echo "$imgfile unpacked into $imgdir"
+    fi
+done

=== added file 'intro.xml'
--- intro.xml	1970-01-01 00:00:00 +0000
+++ intro.xml	2016-03-23 07:11:22 +0000
@@ -0,0 +1,435 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
+"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
+<!ENTITY TIMESTAMP "2016-03-22">
+<!ENTITY % common SYSTEM "common.ent">
+%common;
+]>
+
+<refentry xmlns:xi="http://www.w3.org/2001/XInclude">
+   <refentryinfo>
+    <title>Mandos Manual</title>
+    <!-- NWalsh’s docbook scripts use this to generate the footer: -->
+    <productname>Mandos</productname>
+    <productnumber>&version;</productnumber>
+    <date>&TIMESTAMP;</date>
+    <authorgroup>
+      <author>
+	<firstname>Björn</firstname>
+	<surname>Påhlsson</surname>
+	<address>
+	  <email>belorn@recompile.se</email>
+	</address>
+      </author>
+      <author>
+	<firstname>Teddy</firstname>
+	<surname>Hogeborn</surname>
+	<address>
+	  <email>teddy@recompile.se</email>
+	</address>
+      </author>
+    </authorgroup>
+    <copyright>
+      <year>2011</year>
+      <year>2012</year>
+      <year>2013</year>
+      <year>2014</year>
+      <year>2015</year>
+      <year>2016</year>
+      <holder>Teddy Hogeborn</holder>
+      <holder>Björn Påhlsson</holder>
+    </copyright>
+    <xi:include href="legalnotice.xml"/>
+  </refentryinfo>
+  
+  <refmeta>
+    <refentrytitle>intro</refentrytitle>
+    <manvolnum>8mandos</manvolnum>
+  </refmeta>
+  
+  <refnamediv>
+    <refname>intro</refname>
+    <refpurpose>
+      Introduction to the Mandos system
+    </refpurpose>
+  </refnamediv>
+  
+  <refsect1 id="description">
+    <title>DESCRIPTION</title>
+    <para>
+      This is the the Mandos system, which allows computers to have
+      encrypted root file systems and at the same time be capable of
+      remote and/or unattended reboots.
+    </para>
+    <para>
+      The computers run a small client program in the initial RAM disk
+      environment which will communicate with a server over a network.
+      All network communication is encrypted using TLS.  The clients
+      are identified by the server using an OpenPGP key; each client
+      has one unique to it.  The server sends the clients an encrypted
+      password.  The encrypted password is decrypted by the clients
+      using the same OpenPGP key, and the password is then used to
+      unlock the root file system, whereupon the computers can
+      continue booting normally.
+    </para>
+  </refsect1>
+  
+  <refsect1 id="introduction">
+    <title>INTRODUCTION</title>
+    <para>
+      You know how it is.  You’ve heard of it happening.  The Man
+      comes and takes away your servers, your friends’ servers, the
+      servers of everybody in the same hosting facility. The servers
+      of their neighbors, and their neighbors’ friends.  The servers
+      of people who owe them money.  And like
+      <emphasis>that</emphasis>, they’re gone.  And you doubt you’ll
+      ever see them again.
+    </para>
+    <para>
+      That is why your servers have encrypted root file systems.
+      However, there’s a downside.  There’s no going around it:
+      rebooting is a pain.  Dragging out that rarely-used keyboard and
+      screen and unraveling cables behind your servers to plug them in
+      to type in that password is messy, especially if you have many
+      servers.  There are some people who do clever things like using
+      serial line consoles and daisy-chain it to the next server, and
+      keep all the servers connected in a ring with serial cables,
+      which will work, if your servers are physically close enough.
+      There are also other out-of-band management solutions, but with
+      <emphasis>all</emphasis> these, you still have to be on hand and
+      manually type in the password at boot time.  Otherwise the
+      server just sits there, waiting for a password.
+    </para>
+    <para>
+      Wouldn’t it be great if you could have the security of encrypted
+      root file systems and still have servers that could boot up
+      automatically if there was a short power outage while you were
+      asleep?  That you could reboot at will, without having someone
+      run over to the server to type in the password?
+    </para>
+    <para>
+      Well, with Mandos, you (almost) can!  The gain in convenience
+      will only be offset by a small loss in security.  The setup is
+      as follows:
+    </para>
+    <para>
+      The server will still have its encrypted root file system.  The
+      password to this file system will be stored on another computer
+      (henceforth known as the Mandos server) on the same local
+      network.  The password will <emphasis>not</emphasis> be stored
+      in plaintext, but encrypted with OpenPGP.  To decrypt this
+      password, a key is needed.  This key (the Mandos client key)
+      will not be stored there, but back on the original server
+      (henceforth known as the Mandos client) in the initial RAM disk
+      image.  Oh, and all network Mandos client/server communications
+      will be encrypted, using TLS (SSL).
+    </para>
+    <para>
+      So, at boot time, the Mandos client will ask for its encrypted
+      data over the network, decrypt it to get the password, use it to
+      decrypt the root file, and continue booting.
+    </para>
+    <para>
+      Now, of course the initial RAM disk image is not on the
+      encrypted root file system, so anyone who had physical access
+      could take the Mandos client computer offline and read the disk
+      with their own tools to get the authentication keys used by a
+      client.  <emphasis>But</emphasis>, by then the Mandos server
+      should notice that the original server has been offline for too
+      long, and will no longer give out the encrypted key.  The timing
+      here is the only real weak point, and the method, frequency and
+      timeout of the server’s checking can be adjusted to any desired
+      level of paranoia
+    </para>
+    <para>
+      (The encrypted keys on the Mandos server is on its normal file
+      system, so those are safe, provided the root file system of
+      <emphasis>that</emphasis> server is encrypted.)
+    </para>
+  </refsect1>
+  
+  <refsect1 id="faq">
+    <title>FREQUENTLY ASKED QUESTIONS</title>
+    <para>
+      Couldn’t the security be defeated by…
+    </para>
+    <refsect2 id="quick">
+      <title>Grabbing the Mandos client key from the
+      initrd <emphasis>really quickly</emphasis>?</title>
+    <para>
+      This, as mentioned above, is the only real weak point.  But if
+      you set the timing values tight enough, this will be really
+      difficult to do.  An attacker would have to physically
+      disassemble the client computer, extract the key from the
+      initial RAM disk image, and then connect to a <emphasis>still
+      online</emphasis> Mandos server to get the encrypted key, and do
+      all this <emphasis>before</emphasis> the Mandos server timeout
+      kicks in and the Mandos server refuses to give out the key to
+      anyone.
+    </para>
+    <para>
+      Now, as the typical procedure seems to be to barge in and turn
+      off and grab <emphasis>all</emphasis> computers, to maybe look
+      at them months later, this is not likely.  If someone does that,
+      the whole system <emphasis>will</emphasis> lock itself up
+      completely, since Mandos servers are no longer running.
+    </para>
+    <para>
+      For sophisticated attackers who <emphasis>could</emphasis> do
+      the clever thing, <emphasis>and</emphasis> had physical access
+      to the server for enough time, it would be simpler to get a key
+      for an encrypted file system by using hardware memory scanners
+      and reading it right off the memory bus.
+    </para>
+    </refsect2>
+    
+    <refsect2 id="replay">
+      <title>Replay attacks?</title>
+      <para>
+	Nope, the network stuff is all done over TLS, which provides
+	protection against that.
+      </para>
+    </refsect2>
+    
+    <refsect2 id="mitm">
+      <title>Man-in-the-middle?</title>
+      <para>
+	No.  The server only gives out the passwords to clients which
+	have <emphasis>in the TLS handshake</emphasis> proven that
+	they do indeed hold the OpenPGP private key corresponding to
+	that client.
+      </para>
+    </refsect2>
+    
+    <refsect2 id="sniff">
+      <title>How about sniffing the network traffic and decrypting it
+      later by physically grabbing the Mandos client and using its
+      key?</title>
+      <para>
+	We only use <acronym>PFS</acronym> (Perfect Forward Security)
+	key exchange algorithms in TLS, which protects against this.
+      </para>
+    </refsect2>
+    
+    <refsect2 id="physgrab">
+      <title>Physically grabbing the Mandos server computer?</title>
+      <para>
+	You could protect <emphasis>that</emphasis> computer the
+	old-fashioned way, with a must-type-in-the-password-at-boot
+	method.  Or you could have two computers be the Mandos server
+	for each other.
+      </para>
+      <para>
+	Multiple Mandos servers can coexist on a network without any
+	trouble.  They do not clash, and clients will try all
+	available servers.  This means that if just one reboots then
+	the other can bring it back up, but if both reboot at the same
+	time they will stay down until someone types in the password
+	on one of them.
+      </para>
+    </refsect2>
+    
+    <refsect2 id="fakecheck">
+      <title>Faking checker results?</title>
+      <para>
+	If the Mandos client does not have an SSH server, the default
+	is for the Mandos server to use
+	<quote><literal>fping</literal></quote>, the replies to which
+	could be faked to eliminate the timeout.  But this could
+	easily be changed to any shell command, with any security
+	measures you like.  If the Mandos client
+	<emphasis>has</emphasis> an SSH server, the default
+	configuration (as generated by
+	<command>mandos-keygen</command> with the
+	<option>--password</option> option) is for the Mandos server
+	to use an <command>ssh-keyscan</command> command with strict
+	keychecking, which can not be faked.  Alternatively, IPsec
+	could be used for the ping packets, making them secure.
+      </para>
+    </refsect2>
+  </refsect1>
+  
+  <refsect1 id="security">
+    <title>SECURITY</title>
+    <para>
+      So, in summary:  The only weakness in the Mandos system is from
+      people who have:
+    </para>
+    <orderedlist>
+      <listitem>
+	<para>
+	  The power to come in and physically take your servers,
+	  <emphasis>and</emphasis>
+	</para>
+      </listitem>
+      <listitem>
+	<para>
+	  The cunning and patience to do it carefully, one at a time,
+	  and <emphasis>quickly</emphasis>, faking Mandos
+	  client/server responses for each one before the timeout.
+	</para>
+      </listitem>
+    </orderedlist>
+    <para>
+      While there are some who may be threatened by people who have
+      <emphasis>both</emphasis> these attributes, they do not,
+      probably, constitute the majority.
+    </para>
+    <para>
+      If you <emphasis>do</emphasis> face such opponents, you must
+      figure that they could just as well open your servers and read
+      the file system keys right off the memory by running wires to
+      the memory bus.
+    </para>
+    <para>
+      What Mandos is designed to protect against is
+      <emphasis>not</emphasis> such determined, focused, and competent
+      attacks, but against the early morning knock on your door and
+      the sudden absence of all the servers in your server room.
+      Which it does nicely.
+    </para>
+  </refsect1>
+  
+  <refsect1 id="plugins">
+    <title>PLUGINS</title>
+    <para>
+      In the early designs, the
+      <citerefentry><refentrytitle>mandos-client</refentrytitle
+      ><manvolnum>8mandos</manvolnum></citerefentry> program (which
+      retrieves a password from the Mandos server) also prompted for a
+      password on the terminal, in case a Mandos server could not be
+      found.  Other ways of retrieving a password could easily be
+      envisoned, but this multiplicity of purpose was seen to be too
+      complex to be a viable way to continue.  Instead, the original
+      program was separated into <citerefentry><refentrytitle
+      >mandos-client</refentrytitle><manvolnum>8mandos</manvolnum
+      ></citerefentry> and <citerefentry><refentrytitle
+      >password-prompt</refentrytitle><manvolnum>8mandos</manvolnum
+      ></citerefentry>, and a <citerefentry><refentrytitle
+      >plugin-runner</refentrytitle><manvolnum>8mandos</manvolnum
+      ></citerefentry> exist to run them both in parallel, allowing
+      the first successful plugin to provide the password.  This
+      opened up for any number of additional plugins to run, all
+      competing to be the first to find a password and provide it to
+      the plugin runner.
+    </para>
+    <para>
+      Four additional plugins are provided:
+    </para>
+    <variablelist>
+      <varlistentry>
+	<term>
+	  <citerefentry><refentrytitle>plymouth</refentrytitle>
+	  <manvolnum>8mandos</manvolnum></citerefentry>
+	</term>
+	<listitem>
+	  <para>
+	    This prompts for a password when using <citerefentry>
+	    <refentrytitle>plymouth</refentrytitle><manvolnum
+	    >8</manvolnum></citerefentry>.
+	  </para>
+	</listitem>
+      </varlistentry>
+      <varlistentry>
+	<term>
+	  <citerefentry><refentrytitle>usplash</refentrytitle>
+	  <manvolnum>8mandos</manvolnum></citerefentry>
+	</term>
+	<listitem>
+	  <para>
+	    This prompts for a password when using <citerefentry>
+	    <refentrytitle>usplash</refentrytitle><manvolnum
+	    >8</manvolnum></citerefentry>.
+	  </para>
+	</listitem>
+      </varlistentry>
+      <varlistentry>
+	<term>
+	  <citerefentry><refentrytitle>splashy</refentrytitle>
+	  <manvolnum>8mandos</manvolnum></citerefentry>
+	</term>
+	<listitem>
+	  <para>
+	    This prompts for a password when using <citerefentry>
+	    <refentrytitle>splashy</refentrytitle><manvolnum
+	    >8</manvolnum></citerefentry>.
+	  </para>
+	</listitem>
+      </varlistentry>
+      <varlistentry>
+	<term>
+	  <citerefentry><refentrytitle>askpass-fifo</refentrytitle>
+	  <manvolnum>8mandos</manvolnum></citerefentry>
+	</term>
+	<listitem>
+	  <para>
+	    To provide compatibility with the "askpass" program from
+	    cryptsetup, this plugin listens to the same FIFO as
+	    askpass would do.
+	  </para>
+	</listitem>
+      </varlistentry>
+    </variablelist>
+    <para>
+      More plugins can easily be written and added by the system
+      administrator; see the section called "WRITING PLUGINS" in
+      <citerefentry><refentrytitle>plugin-runner</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry> to learn the
+      plugin requirements.
+    </para>
+  </refsect1>
+  
+  <refsect1 id="bugs">
+    <title>BUGS</title>
+    <xi:include href="bugs.xml"/>
+  </refsect1>
+  
+  <refsect1 id="see_also">
+    <title>SEE ALSO</title>
+    <para>
+      <citerefentry><refentrytitle>mandos</refentrytitle>
+      <manvolnum>8</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>mandos.conf</refentrytitle>
+      <manvolnum>5</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>mandos-clients.conf</refentrytitle>
+      <manvolnum>5</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>mandos-ctl</refentrytitle>
+      <manvolnum>8</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>mandos-monitor</refentrytitle>
+      <manvolnum>8</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>plugin-runner</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>mandos-client</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>password-prompt</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>plymouth</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>usplash</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>splashy</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>askpass-fifo</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>mandos-keygen</refentrytitle>
+      <manvolnum>8</manvolnum></citerefentry>
+    </para>
+    <variablelist>
+      <varlistentry>
+	<term>
+	  <ulink url="https://www.recompile.se/mandos">Mandos</ulink>
+	</term>
+	<listitem>
+	  <para>
+	    The Mandos home page.
+	  </para>
+	</listitem>
+      </varlistentry>
+    </variablelist>
+  </refsect1>
+</refentry>
+<!-- Local Variables: -->
+<!-- time-stamp-start: "<!ENTITY TIMESTAMP [\"']" -->
+<!-- time-stamp-end: "[\"']>" -->
+<!-- time-stamp-format: "%:y-%02m-%02d" -->
+<!-- End: -->

=== modified file 'mandos'
--- mandos	2010-10-02 17:23:41 +0000
+++ mandos	2016-10-29 13:44:49 +0000
@@ -1,19 +1,19 @@
 #!/usr/bin/python
 # -*- mode: python; coding: utf-8 -*-
-# 
+#
 # Mandos server - give out binary blobs to connecting clients.
-# 
+#
 # This program is partly derived from an example program for an Avahi
 # service publisher, downloaded from
 # <http://avahi.org/wiki/PythonPublishExample>.  This includes the
 # methods "add", "remove", "server_state_changed",
 # "entry_group_state_changed", "cleanup", and "activate" in the
 # "AvahiService" class, and some lines in "main".
-# 
+#
 # Everything else is
-# Copyright © 2008-2010 Teddy Hogeborn
-# Copyright © 2008-2010 Björn Påhlsson
-# 
+# Copyright © 2008-2016 Teddy Hogeborn
+# Copyright © 2008-2016 Björn Påhlsson
+#
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 # the Free Software Foundation, either version 3 of the License, or
@@ -23,28 +23,34 @@
 #     but WITHOUT ANY WARRANTY; without even the implied warranty of
 #     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 #     GNU General Public License for more details.
-# 
+#
 # You should have received a copy of the GNU General Public License
 # along with this program.  If not, see
 # <http://www.gnu.org/licenses/>.
-# 
-# Contact the authors at <mandos@fukt.bsnet.se>.
-# 
-
-from __future__ import division, with_statement, absolute_import
-
-import SocketServer as socketserver
+#
+# Contact the authors at <mandos@recompile.se>.
+#
+
+from __future__ import (division, absolute_import, print_function,
+                        unicode_literals)
+
+try:
+    from future_builtins import *
+except ImportError:
+    pass
+
+try:
+    import SocketServer as socketserver
+except ImportError:
+    import socketserver
 import socket
-import optparse
+import argparse
 import datetime
 import errno
-import gnutls.crypto
-import gnutls.connection
-import gnutls.errors
-import gnutls.library.functions
-import gnutls.library.constants
-import gnutls.library.types
-import ConfigParser as configparser
+try:
+    import ConfigParser as configparser
+except ImportError:
+    import configparser
 import sys
 import re
 import os
@@ -59,69 +65,265 @@
 import struct
 import fcntl
 import functools
-import cPickle as pickle
+try:
+    import cPickle as pickle
+except ImportError:
+    import pickle
 import multiprocessing
+import types
+import binascii
+import tempfile
+import itertools
+import collections
+import codecs
 
 import dbus
 import dbus.service
-import gobject
-import avahi
+from gi.repository import GLib
 from dbus.mainloop.glib import DBusGMainLoop
 import ctypes
 import ctypes.util
 import xml.dom.minidom
 import inspect
 
+# Try to find the value of SO_BINDTODEVICE:
 try:
+    # This is where SO_BINDTODEVICE is in Python 3.3 (or 3.4?) and
+    # newer, and it is also the most natural place for it:
     SO_BINDTODEVICE = socket.SO_BINDTODEVICE
 except AttributeError:
     try:
+        # This is where SO_BINDTODEVICE was up to and including Python
+        # 2.6, and also 3.2:
         from IN import SO_BINDTODEVICE
     except ImportError:
-        SO_BINDTODEVICE = None
-
-
-version = "1.2.1"
-
-#logger = logging.getLogger(u'mandos')
-logger = logging.Logger(u'mandos')
-syslogger = (logging.handlers.SysLogHandler
-             (facility = logging.handlers.SysLogHandler.LOG_DAEMON,
-              address = "/dev/log"))
-syslogger.setFormatter(logging.Formatter
-                       (u'Mandos [%(process)d]: %(levelname)s:'
-                        u' %(message)s'))
-logger.addHandler(syslogger)
-
-console = logging.StreamHandler()
-console.setFormatter(logging.Formatter(u'%(name)s [%(process)d]:'
-                                       u' %(levelname)s:'
-                                       u' %(message)s'))
-logger.addHandler(console)
+        # In Python 2.7 it seems to have been removed entirely.
+        # Try running the C preprocessor:
+        try:
+            cc = subprocess.Popen(["cc", "--language=c", "-E",
+                                   "/dev/stdin"],
+                                  stdin=subprocess.PIPE,
+                                  stdout=subprocess.PIPE)
+            stdout = cc.communicate(
+                "#include <sys/socket.h>\nSO_BINDTODEVICE\n")[0]
+            SO_BINDTODEVICE = int(stdout.splitlines()[-1])
+        except (OSError, ValueError, IndexError):
+            # No value found
+            SO_BINDTODEVICE = None
+
+if sys.version_info.major == 2:
+    str = unicode
+
+version = "1.7.13"
+stored_state_file = "clients.pickle"
+
+logger = logging.getLogger()
+syslogger = None
+
+try:
+    if_nametoindex = ctypes.cdll.LoadLibrary(
+        ctypes.util.find_library("c")).if_nametoindex
+except (OSError, AttributeError):
+
+    def if_nametoindex(interface):
+        "Get an interface index the hard way, i.e. using fcntl()"
+        SIOCGIFINDEX = 0x8933  # From /usr/include/linux/sockios.h
+        with contextlib.closing(socket.socket()) as s:
+            ifreq = fcntl.ioctl(s, SIOCGIFINDEX,
+                                struct.pack(b"16s16x", interface))
+        interface_index = struct.unpack("I", ifreq[16:20])[0]
+        return interface_index
+
+
+def copy_function(func):
+    """Make a copy of a function"""
+    if sys.version_info.major == 2:
+        return types.FunctionType(func.func_code,
+                                  func.func_globals,
+                                  func.func_name,
+                                  func.func_defaults,
+                                  func.func_closure)
+    else:
+        return types.FunctionType(func.__code__,
+                                  func.__globals__,
+                                  func.__name__,
+                                  func.__defaults__,
+                                  func.__closure__)
+
+
+def initlogger(debug, level=logging.WARNING):
+    """init logger and add loglevel"""
+
+    global syslogger
+    syslogger = (logging.handlers.SysLogHandler(
+        facility=logging.handlers.SysLogHandler.LOG_DAEMON,
+        address="/dev/log"))
+    syslogger.setFormatter(logging.Formatter
+                           ('Mandos [%(process)d]: %(levelname)s:'
+                            ' %(message)s'))
+    logger.addHandler(syslogger)
+
+    if debug:
+        console = logging.StreamHandler()
+        console.setFormatter(logging.Formatter('%(asctime)s %(name)s'
+                                               ' [%(process)d]:'
+                                               ' %(levelname)s:'
+                                               ' %(message)s'))
+        logger.addHandler(console)
+    logger.setLevel(level)
+
+
+class PGPError(Exception):
+    """Exception if encryption/decryption fails"""
+    pass
+
+
+class PGPEngine(object):
+    """A simple class for OpenPGP symmetric encryption & decryption"""
+
+    def __init__(self):
+        self.tempdir = tempfile.mkdtemp(prefix="mandos-")
+        self.gpg = "gpg"
+        try:
+            output = subprocess.check_output(["gpgconf"])
+            for line in output.splitlines():
+                name, text, path = line.split(b":")
+                if name == "gpg":
+                    self.gpg = path
+                    break
+        except OSError as e:
+            if e.errno != errno.ENOENT:
+                raise
+        self.gnupgargs = ['--batch',
+                          '--homedir', self.tempdir,
+                          '--force-mdc',
+                          '--quiet']
+        # Only GPG version 1 has the --no-use-agent option.
+        if self.gpg == "gpg" or self.gpg.endswith("/gpg"):
+            self.gnupgargs.append("--no-use-agent")
+
+    def __enter__(self):
+        return self
+
+    def __exit__(self, exc_type, exc_value, traceback):
+        self._cleanup()
+        return False
+
+    def __del__(self):
+        self._cleanup()
+
+    def _cleanup(self):
+        if self.tempdir is not None:
+            # Delete contents of tempdir
+            for root, dirs, files in os.walk(self.tempdir,
+                                             topdown=False):
+                for filename in files:
+                    os.remove(os.path.join(root, filename))
+                for dirname in dirs:
+                    os.rmdir(os.path.join(root, dirname))
+            # Remove tempdir
+            os.rmdir(self.tempdir)
+            self.tempdir = None
+
+    def password_encode(self, password):
+        # Passphrase can not be empty and can not contain newlines or
+        # NUL bytes.  So we prefix it and hex encode it.
+        encoded = b"mandos" + binascii.hexlify(password)
+        if len(encoded) > 2048:
+            # GnuPG can't handle long passwords, so encode differently
+            encoded = (b"mandos" + password.replace(b"\\", b"\\\\")
+                       .replace(b"\n", b"\\n")
+                       .replace(b"\0", b"\\x00"))
+        return encoded
+
+    def encrypt(self, data, password):
+        passphrase = self.password_encode(password)
+        with tempfile.NamedTemporaryFile(
+                dir=self.tempdir) as passfile:
+            passfile.write(passphrase)
+            passfile.flush()
+            proc = subprocess.Popen([self.gpg, '--symmetric',
+                                     '--passphrase-file',
+                                     passfile.name]
+                                    + self.gnupgargs,
+                                    stdin=subprocess.PIPE,
+                                    stdout=subprocess.PIPE,
+                                    stderr=subprocess.PIPE)
+            ciphertext, err = proc.communicate(input=data)
+        if proc.returncode != 0:
+            raise PGPError(err)
+        return ciphertext
+
+    def decrypt(self, data, password):
+        passphrase = self.password_encode(password)
+        with tempfile.NamedTemporaryFile(
+                dir=self.tempdir) as passfile:
+            passfile.write(passphrase)
+            passfile.flush()
+            proc = subprocess.Popen([self.gpg, '--decrypt',
+                                     '--passphrase-file',
+                                     passfile.name]
+                                    + self.gnupgargs,
+                                    stdin=subprocess.PIPE,
+                                    stdout=subprocess.PIPE,
+                                    stderr=subprocess.PIPE)
+            decrypted_plaintext, err = proc.communicate(input=data)
+        if proc.returncode != 0:
+            raise PGPError(err)
+        return decrypted_plaintext
+
+
+# Pretend that we have an Avahi module
+class Avahi(object):
+    """This isn't so much a class as it is a module-like namespace.
+    It is instantiated once, and simulates having an Avahi module."""
+    IF_UNSPEC = -1               # avahi-common/address.h
+    PROTO_UNSPEC = -1            # avahi-common/address.h
+    PROTO_INET = 0               # avahi-common/address.h
+    PROTO_INET6 = 1              # avahi-common/address.h
+    DBUS_NAME = "org.freedesktop.Avahi"
+    DBUS_INTERFACE_ENTRY_GROUP = DBUS_NAME + ".EntryGroup"
+    DBUS_INTERFACE_SERVER = DBUS_NAME + ".Server"
+    DBUS_PATH_SERVER = "/"
+
+    def string_array_to_txt_array(self, t):
+        return dbus.Array((dbus.ByteArray(s.encode("utf-8"))
+                           for s in t), signature="ay")
+    ENTRY_GROUP_ESTABLISHED = 2  # avahi-common/defs.h
+    ENTRY_GROUP_COLLISION = 3    # avahi-common/defs.h
+    ENTRY_GROUP_FAILURE = 4      # avahi-common/defs.h
+    SERVER_INVALID = 0           # avahi-common/defs.h
+    SERVER_REGISTERING = 1       # avahi-common/defs.h
+    SERVER_RUNNING = 2           # avahi-common/defs.h
+    SERVER_COLLISION = 3         # avahi-common/defs.h
+    SERVER_FAILURE = 4           # avahi-common/defs.h
+avahi = Avahi()
+
 
 class AvahiError(Exception):
     def __init__(self, value, *args, **kwargs):
         self.value = value
-        super(AvahiError, self).__init__(value, *args, **kwargs)
-    def __unicode__(self):
-        return unicode(repr(self.value))
+        return super(AvahiError, self).__init__(value, *args,
+                                                **kwargs)
+
 
 class AvahiServiceError(AvahiError):
     pass
 
+
 class AvahiGroupError(AvahiError):
     pass
 
 
 class AvahiService(object):
     """An Avahi (Zeroconf) service.
-    
+
     Attributes:
     interface: integer; avahi.IF_UNSPEC or an interface index.
                Used to optionally bind to the specified interface.
-    name: string; Example: u'Mandos'
-    type: string; Example: u'_mandos._tcp'.
-                  See <http://www.dns-sd.org/ServiceTypes.html>
+    name: string; Example: 'Mandos'
+    type: string; Example: '_mandos._tcp'.
+     See <https://www.iana.org/assignments/service-names-port-numbers>
     port: integer; what port to announce
     TXT: list of strings; TXT record for the service
     domain: string; Domain to publish on, default to .local if empty.
@@ -133,10 +335,18 @@
     server: D-Bus Server
     bus: dbus.SystemBus()
     """
-    def __init__(self, interface = avahi.IF_UNSPEC, name = None,
-                 servicetype = None, port = None, TXT = None,
-                 domain = u"", host = u"", max_renames = 32768,
-                 protocol = avahi.PROTO_UNSPEC, bus = None):
+
+    def __init__(self,
+                 interface=avahi.IF_UNSPEC,
+                 name=None,
+                 servicetype=None,
+                 port=None,
+                 TXT=None,
+                 domain="",
+                 host="",
+                 max_renames=32768,
+                 protocol=avahi.PROTO_UNSPEC,
+                 bus=None):
         self.interface = interface
         self.name = name
         self.type = servicetype
@@ -150,43 +360,54 @@
         self.group = None       # our entry group
         self.server = None
         self.bus = bus
-    def rename(self):
+        self.entry_group_state_changed_match = None
+
+    def rename(self, remove=True):
         """Derived from the Avahi example code"""
         if self.rename_count >= self.max_renames:
-            logger.critical(u"No suitable Zeroconf service name found"
-                            u" after %i retries, exiting.",
+            logger.critical("No suitable Zeroconf service name found"
+                            " after %i retries, exiting.",
                             self.rename_count)
-            raise AvahiServiceError(u"Too many renames")
-        self.name = unicode(self.server.GetAlternativeServiceName(self.name))
-        logger.info(u"Changing Zeroconf service name to %r ...",
+            raise AvahiServiceError("Too many renames")
+        self.name = str(
+            self.server.GetAlternativeServiceName(self.name))
+        self.rename_count += 1
+        logger.info("Changing Zeroconf service name to %r ...",
                     self.name)
-        syslogger.setFormatter(logging.Formatter
-                               (u'Mandos (%s) [%%(process)d]:'
-                                u' %%(levelname)s: %%(message)s'
-                                % self.name))
-        self.remove()
+        if remove:
+            self.remove()
         try:
             self.add()
-        except dbus.exceptions.DBusException, error:
-            logger.critical(u"DBusException: %s", error)
-            self.cleanup()
-            os._exit(1)
-        self.rename_count += 1
+        except dbus.exceptions.DBusException as error:
+            if (error.get_dbus_name()
+                == "org.freedesktop.Avahi.CollisionError"):
+                logger.info("Local Zeroconf service name collision.")
+                return self.rename(remove=False)
+            else:
+                logger.critical("D-Bus Exception", exc_info=error)
+                self.cleanup()
+                os._exit(1)
+
     def remove(self):
         """Derived from the Avahi example code"""
+        if self.entry_group_state_changed_match is not None:
+            self.entry_group_state_changed_match.remove()
+            self.entry_group_state_changed_match = None
         if self.group is not None:
             self.group.Reset()
+
     def add(self):
         """Derived from the Avahi example code"""
+        self.remove()
         if self.group is None:
             self.group = dbus.Interface(
                 self.bus.get_object(avahi.DBUS_NAME,
                                     self.server.EntryGroupNew()),
                 avahi.DBUS_INTERFACE_ENTRY_GROUP)
-            self.group.connect_to_signal('StateChanged',
-                                         self
-                                         .entry_group_state_changed)
-        logger.debug(u"Adding Zeroconf service '%s' of type '%s' ...",
+        self.entry_group_state_changed_match = (
+            self.group.connect_to_signal(
+                'StateChanged', self.entry_group_state_changed))
+        logger.debug("Adding Zeroconf service '%s' of type '%s' ...",
                      self.name, self.type)
         self.group.AddService(
             self.interface,
@@ -197,65 +418,385 @@
             dbus.UInt16(self.port),
             avahi.string_array_to_txt_array(self.TXT))
         self.group.Commit()
+
     def entry_group_state_changed(self, state, error):
         """Derived from the Avahi example code"""
-        logger.debug(u"Avahi entry group state change: %i", state)
-        
+        logger.debug("Avahi entry group state change: %i", state)
+
         if state == avahi.ENTRY_GROUP_ESTABLISHED:
-            logger.debug(u"Zeroconf service established.")
+            logger.debug("Zeroconf service established.")
         elif state == avahi.ENTRY_GROUP_COLLISION:
-            logger.warning(u"Zeroconf service name collision.")
+            logger.info("Zeroconf service name collision.")
             self.rename()
         elif state == avahi.ENTRY_GROUP_FAILURE:
-            logger.critical(u"Avahi: Error in group state changed %s",
-                            unicode(error))
-            raise AvahiGroupError(u"State changed: %s"
-                                  % unicode(error))
+            logger.critical("Avahi: Error in group state changed %s",
+                            str(error))
+            raise AvahiGroupError("State changed: {!s}".format(error))
+
     def cleanup(self):
         """Derived from the Avahi example code"""
         if self.group is not None:
-            self.group.Free()
+            try:
+                self.group.Free()
+            except (dbus.exceptions.UnknownMethodException,
+                    dbus.exceptions.DBusException):
+                pass
             self.group = None
-    def server_state_changed(self, state):
+        self.remove()
+
+    def server_state_changed(self, state, error=None):
         """Derived from the Avahi example code"""
-        logger.debug(u"Avahi server state change: %i", state)
-        if state == avahi.SERVER_COLLISION:
-            logger.error(u"Zeroconf server name collision")
-            self.remove()
+        logger.debug("Avahi server state change: %i", state)
+        bad_states = {
+            avahi.SERVER_INVALID: "Zeroconf server invalid",
+            avahi.SERVER_REGISTERING: None,
+            avahi.SERVER_COLLISION: "Zeroconf server name collision",
+            avahi.SERVER_FAILURE: "Zeroconf server failure",
+        }
+        if state in bad_states:
+            if bad_states[state] is not None:
+                if error is None:
+                    logger.error(bad_states[state])
+                else:
+                    logger.error(bad_states[state] + ": %r", error)
+            self.cleanup()
         elif state == avahi.SERVER_RUNNING:
-            self.add()
+            try:
+                self.add()
+            except dbus.exceptions.DBusException as error:
+                if (error.get_dbus_name()
+                    == "org.freedesktop.Avahi.CollisionError"):
+                    logger.info("Local Zeroconf service name"
+                                " collision.")
+                    return self.rename(remove=False)
+                else:
+                    logger.critical("D-Bus Exception", exc_info=error)
+                    self.cleanup()
+                    os._exit(1)
+        else:
+            if error is None:
+                logger.debug("Unknown state: %r", state)
+            else:
+                logger.debug("Unknown state: %r: %r", state, error)
+
     def activate(self):
         """Derived from the Avahi example code"""
         if self.server is None:
             self.server = dbus.Interface(
                 self.bus.get_object(avahi.DBUS_NAME,
-                                    avahi.DBUS_PATH_SERVER),
+                                    avahi.DBUS_PATH_SERVER,
+                                    follow_name_owner_changes=True),
                 avahi.DBUS_INTERFACE_SERVER)
-        self.server.connect_to_signal(u"StateChanged",
-                                 self.server_state_changed)
+        self.server.connect_to_signal("StateChanged",
+                                      self.server_state_changed)
         self.server_state_changed(self.server.GetState())
 
 
+class AvahiServiceToSyslog(AvahiService):
+    def rename(self, *args, **kwargs):
+        """Add the new name to the syslog messages"""
+        ret = AvahiService.rename(self, *args, **kwargs)
+        syslogger.setFormatter(logging.Formatter(
+            'Mandos ({}) [%(process)d]: %(levelname)s: %(message)s'
+            .format(self.name)))
+        return ret
+
+
+# Pretend that we have a GnuTLS module
+class GnuTLS(object):
+    """This isn't so much a class as it is a module-like namespace.
+    It is instantiated once, and simulates having a GnuTLS module."""
+
+    library = ctypes.util.find_library("gnutls")
+    if library is None:
+        library = ctypes.util.find_library("gnutls-deb0")
+    _library = ctypes.cdll.LoadLibrary(library)
+    del library
+    _need_version = b"3.3.0"
+
+    def __init__(self):
+        # Need to use "self" here, since this method is called before
+        # the assignment to the "gnutls" global variable happens.
+        if self.check_version(self._need_version) is None:
+            raise self.Error("Needs GnuTLS {} or later"
+                             .format(self._need_version))
+
+    # Unless otherwise indicated, the constants and types below are
+    # all from the gnutls/gnutls.h C header file.
+
+    # Constants
+    E_SUCCESS = 0
+    E_INTERRUPTED = -52
+    E_AGAIN = -28
+    CRT_OPENPGP = 2
+    CLIENT = 2
+    SHUT_RDWR = 0
+    CRD_CERTIFICATE = 1
+    E_NO_CERTIFICATE_FOUND = -49
+    OPENPGP_FMT_RAW = 0         # gnutls/openpgp.h
+
+    # Types
+    class session_int(ctypes.Structure):
+        _fields_ = []
+    session_t = ctypes.POINTER(session_int)
+
+    class certificate_credentials_st(ctypes.Structure):
+        _fields_ = []
+    certificate_credentials_t = ctypes.POINTER(
+        certificate_credentials_st)
+    certificate_type_t = ctypes.c_int
+
+    class datum_t(ctypes.Structure):
+        _fields_ = [('data', ctypes.POINTER(ctypes.c_ubyte)),
+                    ('size', ctypes.c_uint)]
+
+    class openpgp_crt_int(ctypes.Structure):
+        _fields_ = []
+    openpgp_crt_t = ctypes.POINTER(openpgp_crt_int)
+    openpgp_crt_fmt_t = ctypes.c_int  # gnutls/openpgp.h
+    log_func = ctypes.CFUNCTYPE(None, ctypes.c_int, ctypes.c_char_p)
+    credentials_type_t = ctypes.c_int
+    transport_ptr_t = ctypes.c_void_p
+    close_request_t = ctypes.c_int
+
+    # Exceptions
+    class Error(Exception):
+        # We need to use the class name "GnuTLS" here, since this
+        # exception might be raised from within GnuTLS.__init__,
+        # which is called before the assignment to the "gnutls"
+        # global variable has happened.
+        def __init__(self, message=None, code=None, args=()):
+            # Default usage is by a message string, but if a return
+            # code is passed, convert it to a string with
+            # gnutls.strerror()
+            self.code = code
+            if message is None and code is not None:
+                message = GnuTLS.strerror(code)
+            return super(GnuTLS.Error, self).__init__(
+                message, *args)
+
+    class CertificateSecurityError(Error):
+        pass
+
+    # Classes
+    class Credentials(object):
+        def __init__(self):
+            self._c_object = gnutls.certificate_credentials_t()
+            gnutls.certificate_allocate_credentials(
+                ctypes.byref(self._c_object))
+            self.type = gnutls.CRD_CERTIFICATE
+
+        def __del__(self):
+            gnutls.certificate_free_credentials(self._c_object)
+
+    class ClientSession(object):
+        def __init__(self, socket, credentials=None):
+            self._c_object = gnutls.session_t()
+            gnutls.init(ctypes.byref(self._c_object), gnutls.CLIENT)
+            gnutls.set_default_priority(self._c_object)
+            gnutls.transport_set_ptr(self._c_object, socket.fileno())
+            gnutls.handshake_set_private_extensions(self._c_object,
+                                                    True)
+            self.socket = socket
+            if credentials is None:
+                credentials = gnutls.Credentials()
+            gnutls.credentials_set(self._c_object, credentials.type,
+                                   ctypes.cast(credentials._c_object,
+                                               ctypes.c_void_p))
+            self.credentials = credentials
+
+        def __del__(self):
+            gnutls.deinit(self._c_object)
+
+        def handshake(self):
+            return gnutls.handshake(self._c_object)
+
+        def send(self, data):
+            data = bytes(data)
+            data_len = len(data)
+            while data_len > 0:
+                data_len -= gnutls.record_send(self._c_object,
+                                               data[-data_len:],
+                                               data_len)
+
+        def bye(self):
+            return gnutls.bye(self._c_object, gnutls.SHUT_RDWR)
+
+    # Error handling functions
+    def _error_code(result):
+        """A function to raise exceptions on errors, suitable
+        for the 'restype' attribute on ctypes functions"""
+        if result >= 0:
+            return result
+        if result == gnutls.E_NO_CERTIFICATE_FOUND:
+            raise gnutls.CertificateSecurityError(code=result)
+        raise gnutls.Error(code=result)
+
+    def _retry_on_error(result, func, arguments):
+        """A function to retry on some errors, suitable
+        for the 'errcheck' attribute on ctypes functions"""
+        while result < 0:
+            if result not in (gnutls.E_INTERRUPTED, gnutls.E_AGAIN):
+                return _error_code(result)
+            result = func(*arguments)
+        return result
+
+    # Unless otherwise indicated, the function declarations below are
+    # all from the gnutls/gnutls.h C header file.
+
+    # Functions
+    priority_set_direct = _library.gnutls_priority_set_direct
+    priority_set_direct.argtypes = [session_t, ctypes.c_char_p,
+                                    ctypes.POINTER(ctypes.c_char_p)]
+    priority_set_direct.restype = _error_code
+
+    init = _library.gnutls_init
+    init.argtypes = [ctypes.POINTER(session_t), ctypes.c_int]
+    init.restype = _error_code
+
+    set_default_priority = _library.gnutls_set_default_priority
+    set_default_priority.argtypes = [session_t]
+    set_default_priority.restype = _error_code
+
+    record_send = _library.gnutls_record_send
+    record_send.argtypes = [session_t, ctypes.c_void_p,
+                            ctypes.c_size_t]
+    record_send.restype = ctypes.c_ssize_t
+    record_send.errcheck = _retry_on_error
+
+    certificate_allocate_credentials = (
+        _library.gnutls_certificate_allocate_credentials)
+    certificate_allocate_credentials.argtypes = [
+        ctypes.POINTER(certificate_credentials_t)]
+    certificate_allocate_credentials.restype = _error_code
+
+    certificate_free_credentials = (
+        _library.gnutls_certificate_free_credentials)
+    certificate_free_credentials.argtypes = [
+        certificate_credentials_t]
+    certificate_free_credentials.restype = None
+
+    handshake_set_private_extensions = (
+        _library.gnutls_handshake_set_private_extensions)
+    handshake_set_private_extensions.argtypes = [session_t,
+                                                 ctypes.c_int]
+    handshake_set_private_extensions.restype = None
+
+    credentials_set = _library.gnutls_credentials_set
+    credentials_set.argtypes = [session_t, credentials_type_t,
+                                ctypes.c_void_p]
+    credentials_set.restype = _error_code
+
+    strerror = _library.gnutls_strerror
+    strerror.argtypes = [ctypes.c_int]
+    strerror.restype = ctypes.c_char_p
+
+    certificate_type_get = _library.gnutls_certificate_type_get
+    certificate_type_get.argtypes = [session_t]
+    certificate_type_get.restype = _error_code
+
+    certificate_get_peers = _library.gnutls_certificate_get_peers
+    certificate_get_peers.argtypes = [session_t,
+                                      ctypes.POINTER(ctypes.c_uint)]
+    certificate_get_peers.restype = ctypes.POINTER(datum_t)
+
+    global_set_log_level = _library.gnutls_global_set_log_level
+    global_set_log_level.argtypes = [ctypes.c_int]
+    global_set_log_level.restype = None
+
+    global_set_log_function = _library.gnutls_global_set_log_function
+    global_set_log_function.argtypes = [log_func]
+    global_set_log_function.restype = None
+
+    deinit = _library.gnutls_deinit
+    deinit.argtypes = [session_t]
+    deinit.restype = None
+
+    handshake = _library.gnutls_handshake
+    handshake.argtypes = [session_t]
+    handshake.restype = _error_code
+    handshake.errcheck = _retry_on_error
+
+    transport_set_ptr = _library.gnutls_transport_set_ptr
+    transport_set_ptr.argtypes = [session_t, transport_ptr_t]
+    transport_set_ptr.restype = None
+
+    bye = _library.gnutls_bye
+    bye.argtypes = [session_t, close_request_t]
+    bye.restype = _error_code
+    bye.errcheck = _retry_on_error
+
+    check_version = _library.gnutls_check_version
+    check_version.argtypes = [ctypes.c_char_p]
+    check_version.restype = ctypes.c_char_p
+
+    # All the function declarations below are from gnutls/openpgp.h
+
+    openpgp_crt_init = _library.gnutls_openpgp_crt_init
+    openpgp_crt_init.argtypes = [ctypes.POINTER(openpgp_crt_t)]
+    openpgp_crt_init.restype = _error_code
+
+    openpgp_crt_import = _library.gnutls_openpgp_crt_import
+    openpgp_crt_import.argtypes = [openpgp_crt_t,
+                                   ctypes.POINTER(datum_t),
+                                   openpgp_crt_fmt_t]
+    openpgp_crt_import.restype = _error_code
+
+    openpgp_crt_verify_self = _library.gnutls_openpgp_crt_verify_self
+    openpgp_crt_verify_self.argtypes = [openpgp_crt_t, ctypes.c_uint,
+                                        ctypes.POINTER(ctypes.c_uint)]
+    openpgp_crt_verify_self.restype = _error_code
+
+    openpgp_crt_deinit = _library.gnutls_openpgp_crt_deinit
+    openpgp_crt_deinit.argtypes = [openpgp_crt_t]
+    openpgp_crt_deinit.restype = None
+
+    openpgp_crt_get_fingerprint = (
+        _library.gnutls_openpgp_crt_get_fingerprint)
+    openpgp_crt_get_fingerprint.argtypes = [openpgp_crt_t,
+                                            ctypes.c_void_p,
+                                            ctypes.POINTER(
+                                                ctypes.c_size_t)]
+    openpgp_crt_get_fingerprint.restype = _error_code
+
+    # Remove non-public functions
+    del _error_code, _retry_on_error
+# Create the global "gnutls" object, simulating a module
+gnutls = GnuTLS()
+
+
+def call_pipe(connection,       # : multiprocessing.Connection
+              func, *args, **kwargs):
+    """This function is meant to be called by multiprocessing.Process
+
+    This function runs func(*args, **kwargs), and writes the resulting
+    return value on the provided multiprocessing.Connection.
+    """
+    connection.send(func(*args, **kwargs))
+    connection.close()
+
+
 class Client(object):
     """A representation of a client host served by this server.
-    
+
     Attributes:
-    _approved:   bool(); 'None' if not yet approved/disapproved
+    approved:   bool(); 'None' if not yet approved/disapproved
     approval_delay: datetime.timedelta(); Time to wait for approval
     approval_duration: datetime.timedelta(); Duration of one approval
     checker:    subprocess.Popen(); a running checker process used
                                     to see if the client lives.
                                     'None' if no process is running.
-    checker_callback_tag: a gobject event source tag, or None
+    checker_callback_tag: a GLib event source tag, or None
     checker_command: string; External command which is run to check
                      if client lives.  %() expansions are done at
                      runtime with vars(self) as dict, so that for
                      instance %(name)s can be used in the command.
-    checker_initiator_tag: a gobject event source tag, or None
+    checker_initiator_tag: a GLib event source tag, or None
     created:    datetime.datetime(); (UTC) object creation
+    client_structure: Object describing what attributes a client has
+                      and is used for storing the client at exit
     current_checker_command: string; current running checker_command
-    disable_hook:  If set, called by disable() as disable_hook(self)
-    disable_initiator_tag: a gobject event source tag, or None
+    disable_initiator_tag: a GLib event source tag, or None
     enabled:    bool()
     fingerprint: string (40 or 32 hexadecimal digits); used to
                  uniquely identify the client
@@ -263,298 +804,392 @@
     interval:   datetime.timedelta(); How often to start a new checker
     last_approval_request: datetime.datetime(); (UTC) or None
     last_checked_ok: datetime.datetime(); (UTC) or None
-    last_enabled: datetime.datetime(); (UTC)
+    last_checker_status: integer between 0 and 255 reflecting exit
+                         status of last checker. -1 reflects crashed
+                         checker, -2 means no checker completed yet.
+    last_checker_signal: The signal which killed the last checker, if
+                         last_checker_status is -1
+    last_enabled: datetime.datetime(); (UTC) or None
     name:       string; from the config file, used in log messages and
                         D-Bus identifiers
     secret:     bytestring; sent verbatim (over TLS) to client
     timeout:    datetime.timedelta(); How long from last_checked_ok
                                       until this client is disabled
+    extended_timeout:   extra long timeout when secret has been sent
     runtime_expansions: Allowed attributes for runtime expansion.
+    expires:    datetime.datetime(); time (UTC) when a client will be
+                disabled, or None
+    server_settings: The server_settings dict from main()
     """
-    
-    runtime_expansions = (u"approval_delay", u"approval_duration",
-                          u"created", u"enabled", u"fingerprint",
-                          u"host", u"interval", u"last_checked_ok",
-                          u"last_enabled", u"name", u"timeout")
-    
+
+    runtime_expansions = ("approval_delay", "approval_duration",
+                          "created", "enabled", "expires",
+                          "fingerprint", "host", "interval",
+                          "last_approval_request", "last_checked_ok",
+                          "last_enabled", "name", "timeout")
+    client_defaults = {
+        "timeout": "PT5M",
+        "extended_timeout": "PT15M",
+        "interval": "PT2M",
+        "checker": "fping -q -- %%(host)s",
+        "host": "",
+        "approval_delay": "PT0S",
+        "approval_duration": "PT1S",
+        "approved_by_default": "True",
+        "enabled": "True",
+    }
+
     @staticmethod
-    def _timedelta_to_milliseconds(td):
-        "Convert a datetime.timedelta() to milliseconds"
-        return ((td.days * 24 * 60 * 60 * 1000)
-                + (td.seconds * 1000)
-                + (td.microseconds // 1000))
-    
-    def timeout_milliseconds(self):
-        "Return the 'timeout' attribute in milliseconds"
-        return self._timedelta_to_milliseconds(self.timeout)
-    
-    def interval_milliseconds(self):
-        "Return the 'interval' attribute in milliseconds"
-        return self._timedelta_to_milliseconds(self.interval)
-
-    def approval_delay_milliseconds(self):
-        return self._timedelta_to_milliseconds(self.approval_delay)
-    
-    def __init__(self, name = None, disable_hook=None, config=None):
-        """Note: the 'checker' key in 'config' sets the
-        'checker_command' attribute and *not* the 'checker'
-        attribute."""
+    def config_parser(config):
+        """Construct a new dict of client settings of this form:
+        { client_name: {setting_name: value, ...}, ...}
+        with exceptions for any special settings as defined above.
+        NOTE: Must be a pure function. Must return the same result
+        value given the same arguments.
+        """
+        settings = {}
+        for client_name in config.sections():
+            section = dict(config.items(client_name))
+            client = settings[client_name] = {}
+
+            client["host"] = section["host"]
+            # Reformat values from string types to Python types
+            client["approved_by_default"] = config.getboolean(
+                client_name, "approved_by_default")
+            client["enabled"] = config.getboolean(client_name,
+                                                  "enabled")
+
+            # Uppercase and remove spaces from fingerprint for later
+            # comparison purposes with return value from the
+            # fingerprint() function
+            client["fingerprint"] = (section["fingerprint"].upper()
+                                     .replace(" ", ""))
+            if "secret" in section:
+                client["secret"] = codecs.decode(section["secret"]
+                                                 .encode("utf-8"),
+                                                 "base64")
+            elif "secfile" in section:
+                with open(os.path.expanduser(os.path.expandvars
+                                             (section["secfile"])),
+                          "rb") as secfile:
+                    client["secret"] = secfile.read()
+            else:
+                raise TypeError("No secret or secfile for section {}"
+                                .format(section))
+            client["timeout"] = string_to_delta(section["timeout"])
+            client["extended_timeout"] = string_to_delta(
+                section["extended_timeout"])
+            client["interval"] = string_to_delta(section["interval"])
+            client["approval_delay"] = string_to_delta(
+                section["approval_delay"])
+            client["approval_duration"] = string_to_delta(
+                section["approval_duration"])
+            client["checker_command"] = section["checker"]
+            client["last_approval_request"] = None
+            client["last_checked_ok"] = None
+            client["last_checker_status"] = -2
+
+        return settings
+
+    def __init__(self, settings, name=None, server_settings=None):
         self.name = name
-        if config is None:
-            config = {}
-        logger.debug(u"Creating client %r", self.name)
-        # Uppercase and remove spaces from fingerprint for later
-        # comparison purposes with return value from the fingerprint()
-        # function
-        self.fingerprint = (config[u"fingerprint"].upper()
-                            .replace(u" ", u""))
-        logger.debug(u"  Fingerprint: %s", self.fingerprint)
-        if u"secret" in config:
-            self.secret = config[u"secret"].decode(u"base64")
-        elif u"secfile" in config:
-            with open(os.path.expanduser(os.path.expandvars
-                                         (config[u"secfile"])),
-                      "rb") as secfile:
-                self.secret = secfile.read()
+        if server_settings is None:
+            server_settings = {}
+        self.server_settings = server_settings
+        # adding all client settings
+        for setting, value in settings.items():
+            setattr(self, setting, value)
+
+        if self.enabled:
+            if not hasattr(self, "last_enabled"):
+                self.last_enabled = datetime.datetime.utcnow()
+            if not hasattr(self, "expires"):
+                self.expires = (datetime.datetime.utcnow()
+                                + self.timeout)
         else:
-            raise TypeError(u"No secret or secfile for client %s"
-                            % self.name)
-        self.host = config.get(u"host", u"")
-        self.created = datetime.datetime.utcnow()
-        self.enabled = False
-        self.last_approval_request = None
-        self.last_enabled = None
-        self.last_checked_ok = None
-        self.timeout = string_to_delta(config[u"timeout"])
-        self.interval = string_to_delta(config[u"interval"])
-        self.disable_hook = disable_hook
+            self.last_enabled = None
+            self.expires = None
+
+        logger.debug("Creating client %r", self.name)
+        logger.debug("  Fingerprint: %s", self.fingerprint)
+        self.created = settings.get("created",
+                                    datetime.datetime.utcnow())
+
+        # attributes specific for this server instance
         self.checker = None
         self.checker_initiator_tag = None
         self.disable_initiator_tag = None
         self.checker_callback_tag = None
-        self.checker_command = config[u"checker"]
         self.current_checker_command = None
-        self.last_connect = None
-        self._approved = None
-        self.approved_by_default = config.get(u"approved_by_default",
-                                              True)
+        self.approved = None
         self.approvals_pending = 0
-        self.approval_delay = string_to_delta(
-            config[u"approval_delay"])
-        self.approval_duration = string_to_delta(
-            config[u"approval_duration"])
-        self.changedstate = multiprocessing_manager.Condition(multiprocessing_manager.Lock())
-    
+        self.changedstate = multiprocessing_manager.Condition(
+            multiprocessing_manager.Lock())
+        self.client_structure = [attr
+                                 for attr in self.__dict__.keys()
+                                 if not attr.startswith("_")]
+        self.client_structure.append("client_structure")
+
+        for name, t in inspect.getmembers(
+                type(self), lambda obj: isinstance(obj, property)):
+            if not name.startswith("_"):
+                self.client_structure.append(name)
+
+    # Send notice to process children that client state has changed
     def send_changedstate(self):
-        self.changedstate.acquire()
-        self.changedstate.notify_all()
-        self.changedstate.release()
-        
+        with self.changedstate:
+            self.changedstate.notify_all()
+
     def enable(self):
         """Start this client's checker and timeout hooks"""
-        if getattr(self, u"enabled", False):
+        if getattr(self, "enabled", False):
             # Already enabled
             return
-        self.send_changedstate()
+        self.expires = datetime.datetime.utcnow() + self.timeout
+        self.enabled = True
         self.last_enabled = datetime.datetime.utcnow()
+        self.init_checker()
+        self.send_changedstate()
+
+    def disable(self, quiet=True):
+        """Disable this client."""
+        if not getattr(self, "enabled", False):
+            return False
+        if not quiet:
+            logger.info("Disabling client %s", self.name)
+        if getattr(self, "disable_initiator_tag", None) is not None:
+            GLib.source_remove(self.disable_initiator_tag)
+            self.disable_initiator_tag = None
+        self.expires = None
+        if getattr(self, "checker_initiator_tag", None) is not None:
+            GLib.source_remove(self.checker_initiator_tag)
+            self.checker_initiator_tag = None
+        self.stop_checker()
+        self.enabled = False
+        if not quiet:
+            self.send_changedstate()
+        # Do not run this again if called by a GLib.timeout_add
+        return False
+
+    def __del__(self):
+        self.disable()
+
+    def init_checker(self):
         # Schedule a new checker to be started an 'interval' from now,
         # and every interval from then on.
-        self.checker_initiator_tag = (gobject.timeout_add
-                                      (self.interval_milliseconds(),
-                                       self.start_checker))
+        if self.checker_initiator_tag is not None:
+            GLib.source_remove(self.checker_initiator_tag)
+        self.checker_initiator_tag = GLib.timeout_add(
+            int(self.interval.total_seconds() * 1000),
+            self.start_checker)
         # Schedule a disable() when 'timeout' has passed
-        self.disable_initiator_tag = (gobject.timeout_add
-                                   (self.timeout_milliseconds(),
-                                    self.disable))
-        self.enabled = True
+        if self.disable_initiator_tag is not None:
+            GLib.source_remove(self.disable_initiator_tag)
+        self.disable_initiator_tag = GLib.timeout_add(
+            int(self.timeout.total_seconds() * 1000), self.disable)
         # Also start a new checker *right now*.
         self.start_checker()
-    
-    def disable(self, quiet=True):
-        """Disable this client."""
-        if not getattr(self, "enabled", False):
-            return False
-        if not quiet:
-            self.send_changedstate()
-        if not quiet:
-            logger.info(u"Disabling client %s", self.name)
-        if getattr(self, u"disable_initiator_tag", False):
-            gobject.source_remove(self.disable_initiator_tag)
-            self.disable_initiator_tag = None
-        if getattr(self, u"checker_initiator_tag", False):
-            gobject.source_remove(self.checker_initiator_tag)
-            self.checker_initiator_tag = None
-        self.stop_checker()
-        if self.disable_hook:
-            self.disable_hook(self)
-        self.enabled = False
-        # Do not run this again if called by a gobject.timeout_add
-        return False
-    
-    def __del__(self):
-        self.disable_hook = None
-        self.disable()
-    
-    def checker_callback(self, pid, condition, command):
+
+    def checker_callback(self, source, condition, connection,
+                         command):
         """The checker has completed, so take appropriate actions."""
         self.checker_callback_tag = None
         self.checker = None
-        if os.WIFEXITED(condition):
-            exitstatus = os.WEXITSTATUS(condition)
-            if exitstatus == 0:
-                logger.info(u"Checker for %(name)s succeeded",
+        # Read return code from connection (see call_pipe)
+        returncode = connection.recv()
+        connection.close()
+
+        if returncode >= 0:
+            self.last_checker_status = returncode
+            self.last_checker_signal = None
+            if self.last_checker_status == 0:
+                logger.info("Checker for %(name)s succeeded",
                             vars(self))
                 self.checked_ok()
             else:
-                logger.info(u"Checker for %(name)s failed",
-                            vars(self))
+                logger.info("Checker for %(name)s failed", vars(self))
         else:
-            logger.warning(u"Checker for %(name)s crashed?",
+            self.last_checker_status = -1
+            self.last_checker_signal = -returncode
+            logger.warning("Checker for %(name)s crashed?",
                            vars(self))
-    
+        return False
+
     def checked_ok(self):
-        """Bump up the timeout for this client.
-        
-        This should only be called when the client has been seen,
-        alive and well.
-        """
+        """Assert that the client has been seen, alive and well."""
         self.last_checked_ok = datetime.datetime.utcnow()
-        gobject.source_remove(self.disable_initiator_tag)
-        self.disable_initiator_tag = (gobject.timeout_add
-                                      (self.timeout_milliseconds(),
-                                       self.disable))
-    
+        self.last_checker_status = 0
+        self.last_checker_signal = None
+        self.bump_timeout()
+
+    def bump_timeout(self, timeout=None):
+        """Bump up the timeout for this client."""
+        if timeout is None:
+            timeout = self.timeout
+        if self.disable_initiator_tag is not None:
+            GLib.source_remove(self.disable_initiator_tag)
+            self.disable_initiator_tag = None
+        if getattr(self, "enabled", False):
+            self.disable_initiator_tag = GLib.timeout_add(
+                int(timeout.total_seconds() * 1000), self.disable)
+            self.expires = datetime.datetime.utcnow() + timeout
+
     def need_approval(self):
         self.last_approval_request = datetime.datetime.utcnow()
-    
+
     def start_checker(self):
         """Start a new checker subprocess if one is not running.
-        
+
         If a checker already exists, leave it running and do
         nothing."""
         # The reason for not killing a running checker is that if we
-        # did that, then if a checker (for some reason) started
-        # running slowly and taking more than 'interval' time, the
-        # client would inevitably timeout, since no checker would get
-        # a chance to run to completion.  If we instead leave running
+        # did that, and if a checker (for some reason) started running
+        # slowly and taking more than 'interval' time, then the client
+        # would inevitably timeout, since no checker would get a
+        # chance to run to completion.  If we instead leave running
         # checkers alone, the checker would have to take more time
         # than 'timeout' for the client to be disabled, which is as it
         # should be.
-        
-        # If a checker exists, make sure it is not a zombie
-        try:
-            pid, status = os.waitpid(self.checker.pid, os.WNOHANG)
-        except (AttributeError, OSError), error:
-            if (isinstance(error, OSError)
-                and error.errno != errno.ECHILD):
-                raise error
-        else:
-            if pid:
-                logger.warning(u"Checker was a zombie")
-                gobject.source_remove(self.checker_callback_tag)
-                self.checker_callback(pid, status,
-                                      self.current_checker_command)
+
+        if self.checker is not None and not self.checker.is_alive():
+            logger.warning("Checker was not alive; joining")
+            self.checker.join()
+            self.checker = None
         # Start a new checker if needed
         if self.checker is None:
+            # Escape attributes for the shell
+            escaped_attrs = {
+                attr: re.escape(str(getattr(self, attr)))
+                for attr in self.runtime_expansions}
             try:
-                # In case checker_command has exactly one % operator
-                command = self.checker_command % self.host
-            except TypeError:
-                # Escape attributes for the shell
-                escaped_attrs = dict(
-                    (attr,
-                     re.escape(unicode(str(getattr(self, attr, u"")),
-                                       errors=
-                                       u'replace')))
-                    for attr in
-                    self.runtime_expansions)
-
-                try:
-                    command = self.checker_command % escaped_attrs
-                except TypeError, error:
-                    logger.error(u'Could not format string "%s":'
-                                 u' %s', self.checker_command, error)
-                    return True # Try again later
+                command = self.checker_command % escaped_attrs
+            except TypeError as error:
+                logger.error('Could not format string "%s"',
+                             self.checker_command,
+                             exc_info=error)
+                return True     # Try again later
             self.current_checker_command = command
-            try:
-                logger.info(u"Starting checker %r for %s",
-                            command, self.name)
-                # We don't need to redirect stdout and stderr, since
-                # in normal mode, that is already done by daemon(),
-                # and in debug mode we don't want to.  (Stdin is
-                # always replaced by /dev/null.)
-                self.checker = subprocess.Popen(command,
-                                                close_fds=True,
-                                                shell=True, cwd=u"/")
-                self.checker_callback_tag = (gobject.child_watch_add
-                                             (self.checker.pid,
-                                              self.checker_callback,
-                                              data=command))
-                # The checker may have completed before the gobject
-                # watch was added.  Check for this.
-                pid, status = os.waitpid(self.checker.pid, os.WNOHANG)
-                if pid:
-                    gobject.source_remove(self.checker_callback_tag)
-                    self.checker_callback(pid, status, command)
-            except OSError, error:
-                logger.error(u"Failed to start subprocess: %s",
-                             error)
-        # Re-run this periodically if run by gobject.timeout_add
+            logger.info("Starting checker %r for %s", command,
+                        self.name)
+            # We don't need to redirect stdout and stderr, since
+            # in normal mode, that is already done by daemon(),
+            # and in debug mode we don't want to.  (Stdin is
+            # always replaced by /dev/null.)
+            # The exception is when not debugging but nevertheless
+            # running in the foreground; use the previously
+            # created wnull.
+            popen_args = {"close_fds": True,
+                          "shell": True,
+                          "cwd": "/"}
+            if (not self.server_settings["debug"]
+                and self.server_settings["foreground"]):
+                popen_args.update({"stdout": wnull,
+                                   "stderr": wnull})
+            pipe = multiprocessing.Pipe(duplex=False)
+            self.checker = multiprocessing.Process(
+                target=call_pipe,
+                args=(pipe[1], subprocess.call, command),
+                kwargs=popen_args)
+            self.checker.start()
+            self.checker_callback_tag = GLib.io_add_watch(
+                pipe[0].fileno(), GLib.IO_IN,
+                self.checker_callback, pipe[0], command)
+        # Re-run this periodically if run by GLib.timeout_add
         return True
-    
+
     def stop_checker(self):
         """Force the checker process, if any, to stop."""
         if self.checker_callback_tag:
-            gobject.source_remove(self.checker_callback_tag)
+            GLib.source_remove(self.checker_callback_tag)
             self.checker_callback_tag = None
-        if getattr(self, u"checker", None) is None:
+        if getattr(self, "checker", None) is None:
             return
-        logger.debug(u"Stopping checker for %(name)s", vars(self))
-        try:
-            os.kill(self.checker.pid, signal.SIGTERM)
-            #time.sleep(0.5)
-            #if self.checker.poll() is None:
-            #    os.kill(self.checker.pid, signal.SIGKILL)
-        except OSError, error:
-            if error.errno != errno.ESRCH: # No such process
-                raise
+        logger.debug("Stopping checker for %(name)s", vars(self))
+        self.checker.terminate()
         self.checker = None
 
-def dbus_service_property(dbus_interface, signature=u"v",
-                          access=u"readwrite", byte_arrays=False):
+
+def dbus_service_property(dbus_interface,
+                          signature="v",
+                          access="readwrite",
+                          byte_arrays=False):
     """Decorators for marking methods of a DBusObjectWithProperties to
     become properties on the D-Bus.
-    
+
     The decorated method will be called with no arguments by "Get"
     and with one argument by "Set".
-    
+
     The parameters, where they are supported, are the same as
     dbus.service.method, except there is only "signature", since the
     type from Get() and the type sent to Set() is the same.
     """
     # Encoding deeply encoded byte arrays is not supported yet by the
     # "Set" method, so we fail early here:
-    if byte_arrays and signature != u"ay":
-        raise ValueError(u"Byte arrays not supported for non-'ay'"
-                         u" signature %r" % signature)
+    if byte_arrays and signature != "ay":
+        raise ValueError("Byte arrays not supported for non-'ay'"
+                         " signature {!r}".format(signature))
+
     def decorator(func):
         func._dbus_is_property = True
         func._dbus_interface = dbus_interface
         func._dbus_signature = signature
         func._dbus_access = access
         func._dbus_name = func.__name__
-        if func._dbus_name.endswith(u"_dbus_property"):
+        if func._dbus_name.endswith("_dbus_property"):
             func._dbus_name = func._dbus_name[:-14]
-        func._dbus_get_args_options = {u'byte_arrays': byte_arrays }
-        return func
+        func._dbus_get_args_options = {'byte_arrays': byte_arrays}
+        return func
+
+    return decorator
+
+
+def dbus_interface_annotations(dbus_interface):
+    """Decorator for marking functions returning interface annotations
+
+    Usage:
+
+    @dbus_interface_annotations("org.example.Interface")
+    def _foo(self):  # Function name does not matter
+        return {"org.freedesktop.DBus.Deprecated": "true",
+                "org.freedesktop.DBus.Property.EmitsChangedSignal":
+                    "false"}
+    """
+
+    def decorator(func):
+        func._dbus_is_interface = True
+        func._dbus_interface = dbus_interface
+        func._dbus_name = dbus_interface
+        return func
+
+    return decorator
+
+
+def dbus_annotations(annotations):
+    """Decorator to annotate D-Bus methods, signals or properties
+    Usage:
+
+    @dbus_annotations({"org.freedesktop.DBus.Deprecated": "true",
+                       "org.freedesktop.DBus.Property."
+                       "EmitsChangedSignal": "false"})
+    @dbus_service_property("org.example.Interface", signature="b",
+                           access="r")
+    def Property_dbus_property(self):
+        return dbus.Boolean(False)
+
+    See also the DBusObjectWithAnnotations class.
+    """
+
+    def decorator(func):
+        func._dbus_annotations = annotations
+        return func
+
     return decorator
 
 
 class DBusPropertyException(dbus.exceptions.DBusException):
     """A base class for D-Bus property-related exceptions
     """
-    def __unicode__(self):
-        return unicode(str(self))
+    pass
 
 
 class DBusPropertyAccessException(DBusPropertyException):
@@ -569,327 +1204,696 @@
     pass
 
 
-class DBusObjectWithProperties(dbus.service.Object):
+class DBusObjectWithAnnotations(dbus.service.Object):
+    """A D-Bus object with annotations.
+
+    Classes inheriting from this can use the dbus_annotations
+    decorator to add annotations to methods or signals.
+    """
+
+    @staticmethod
+    def _is_dbus_thing(thing):
+        """Returns a function testing if an attribute is a D-Bus thing
+
+        If called like _is_dbus_thing("method") it returns a function
+        suitable for use as predicate to inspect.getmembers().
+        """
+        return lambda obj: getattr(obj, "_dbus_is_{}".format(thing),
+                                   False)
+
+    def _get_all_dbus_things(self, thing):
+        """Returns a generator of (name, attribute) pairs
+        """
+        return ((getattr(athing.__get__(self), "_dbus_name", name),
+                 athing.__get__(self))
+                for cls in self.__class__.__mro__
+                for name, athing in
+                inspect.getmembers(cls, self._is_dbus_thing(thing)))
+
+    @dbus.service.method(dbus.INTROSPECTABLE_IFACE,
+                         out_signature="s",
+                         path_keyword='object_path',
+                         connection_keyword='connection')
+    def Introspect(self, object_path, connection):
+        """Overloading of standard D-Bus method.
+
+        Inserts annotation tags on methods and signals.
+        """
+        xmlstring = dbus.service.Object.Introspect(self, object_path,
+                                                   connection)
+        try:
+            document = xml.dom.minidom.parseString(xmlstring)
+
+            for if_tag in document.getElementsByTagName("interface"):
+                # Add annotation tags
+                for typ in ("method", "signal"):
+                    for tag in if_tag.getElementsByTagName(typ):
+                        annots = dict()
+                        for name, prop in (self.
+                                           _get_all_dbus_things(typ)):
+                            if (name == tag.getAttribute("name")
+                                and prop._dbus_interface
+                                == if_tag.getAttribute("name")):
+                                annots.update(getattr(
+                                    prop, "_dbus_annotations", {}))
+                        for name, value in annots.items():
+                            ann_tag = document.createElement(
+                                "annotation")
+                            ann_tag.setAttribute("name", name)
+                            ann_tag.setAttribute("value", value)
+                            tag.appendChild(ann_tag)
+                # Add interface annotation tags
+                for annotation, value in dict(
+                    itertools.chain.from_iterable(
+                        annotations().items()
+                        for name, annotations
+                        in self._get_all_dbus_things("interface")
+                        if name == if_tag.getAttribute("name")
+                        )).items():
+                    ann_tag = document.createElement("annotation")
+                    ann_tag.setAttribute("name", annotation)
+                    ann_tag.setAttribute("value", value)
+                    if_tag.appendChild(ann_tag)
+                # Fix argument name for the Introspect method itself
+                if (if_tag.getAttribute("name")
+                    == dbus.INTROSPECTABLE_IFACE):
+                    for cn in if_tag.getElementsByTagName("method"):
+                        if cn.getAttribute("name") == "Introspect":
+                            for arg in cn.getElementsByTagName("arg"):
+                                if (arg.getAttribute("direction")
+                                    == "out"):
+                                    arg.setAttribute("name",
+                                                     "xml_data")
+            xmlstring = document.toxml("utf-8")
+            document.unlink()
+        except (AttributeError, xml.dom.DOMException,
+                xml.parsers.expat.ExpatError) as error:
+            logger.error("Failed to override Introspection method",
+                         exc_info=error)
+        return xmlstring
+
+
+class DBusObjectWithProperties(DBusObjectWithAnnotations):
     """A D-Bus object with properties.
 
     Classes inheriting from this can use the dbus_service_property
     decorator to expose methods as D-Bus properties.  It exposes the
     standard Get(), Set(), and GetAll() methods on the D-Bus.
     """
-    
-    @staticmethod
-    def _is_dbus_property(obj):
-        return getattr(obj, u"_dbus_is_property", False)
-    
-    def _get_all_dbus_properties(self):
-        """Returns a generator of (name, attribute) pairs
-        """
-        return ((prop._dbus_name, prop)
-                for name, prop in
-                inspect.getmembers(self, self._is_dbus_property))
-    
+
     def _get_dbus_property(self, interface_name, property_name):
         """Returns a bound method if one exists which is a D-Bus
         property with the specified name and interface.
         """
-        for name in (property_name,
-                     property_name + u"_dbus_property"):
-            prop = getattr(self, name, None)
-            if (prop is None
-                or not self._is_dbus_property(prop)
-                or prop._dbus_name != property_name
-                or (interface_name and prop._dbus_interface
-                    and interface_name != prop._dbus_interface)):
-                continue
-            return prop
+        for cls in self.__class__.__mro__:
+            for name, value in inspect.getmembers(
+                    cls, self._is_dbus_thing("property")):
+                if (value._dbus_name == property_name
+                    and value._dbus_interface == interface_name):
+                    return value.__get__(self)
+
         # No such property
-        raise DBusPropertyNotFound(self.dbus_object_path + u":"
-                                   + interface_name + u"."
-                                   + property_name)
-    
-    @dbus.service.method(dbus.PROPERTIES_IFACE, in_signature=u"ss",
-                         out_signature=u"v")
+        raise DBusPropertyNotFound("{}:{}.{}".format(
+            self.dbus_object_path, interface_name, property_name))
+
+    @classmethod
+    def _get_all_interface_names(cls):
+        """Get a sequence of all interfaces supported by an object"""
+        return (name for name in set(getattr(getattr(x, attr),
+                                             "_dbus_interface", None)
+                                     for x in (inspect.getmro(cls))
+                                     for attr in dir(x))
+                if name is not None)
+
+    @dbus.service.method(dbus.PROPERTIES_IFACE,
+                         in_signature="ss",
+                         out_signature="v")
     def Get(self, interface_name, property_name):
         """Standard D-Bus property Get() method, see D-Bus standard.
         """
         prop = self._get_dbus_property(interface_name, property_name)
-        if prop._dbus_access == u"write":
+        if prop._dbus_access == "write":
             raise DBusPropertyAccessException(property_name)
         value = prop()
-        if not hasattr(value, u"variant_level"):
+        if not hasattr(value, "variant_level"):
             return value
         return type(value)(value, variant_level=value.variant_level+1)
-    
-    @dbus.service.method(dbus.PROPERTIES_IFACE, in_signature=u"ssv")
+
+    @dbus.service.method(dbus.PROPERTIES_IFACE, in_signature="ssv")
     def Set(self, interface_name, property_name, value):
         """Standard D-Bus property Set() method, see D-Bus standard.
         """
         prop = self._get_dbus_property(interface_name, property_name)
-        if prop._dbus_access == u"read":
+        if prop._dbus_access == "read":
             raise DBusPropertyAccessException(property_name)
-        if prop._dbus_get_args_options[u"byte_arrays"]:
+        if prop._dbus_get_args_options["byte_arrays"]:
             # The byte_arrays option is not supported yet on
             # signatures other than "ay".
-            if prop._dbus_signature != u"ay":
-                raise ValueError
-            value = dbus.ByteArray(''.join(unichr(byte)
-                                           for byte in value))
+            if prop._dbus_signature != "ay":
+                raise ValueError("Byte arrays not supported for non-"
+                                 "'ay' signature {!r}"
+                                 .format(prop._dbus_signature))
+            value = dbus.ByteArray(b''.join(chr(byte)
+                                            for byte in value))
         prop(value)
-    
-    @dbus.service.method(dbus.PROPERTIES_IFACE, in_signature=u"s",
-                         out_signature=u"a{sv}")
+
+    @dbus.service.method(dbus.PROPERTIES_IFACE,
+                         in_signature="s",
+                         out_signature="a{sv}")
     def GetAll(self, interface_name):
         """Standard D-Bus property GetAll() method, see D-Bus
         standard.
 
         Note: Will not include properties with access="write".
         """
-        all = {}
-        for name, prop in self._get_all_dbus_properties():
+        properties = {}
+        for name, prop in self._get_all_dbus_things("property"):
             if (interface_name
                 and interface_name != prop._dbus_interface):
                 # Interface non-empty but did not match
                 continue
             # Ignore write-only properties
-            if prop._dbus_access == u"write":
+            if prop._dbus_access == "write":
                 continue
             value = prop()
-            if not hasattr(value, u"variant_level"):
-                all[name] = value
+            if not hasattr(value, "variant_level"):
+                properties[name] = value
                 continue
-            all[name] = type(value)(value, variant_level=
-                                    value.variant_level+1)
-        return dbus.Dictionary(all, signature=u"sv")
-    
+            properties[name] = type(value)(
+                value, variant_level=value.variant_level + 1)
+        return dbus.Dictionary(properties, signature="sv")
+
+    @dbus.service.signal(dbus.PROPERTIES_IFACE, signature="sa{sv}as")
+    def PropertiesChanged(self, interface_name, changed_properties,
+                          invalidated_properties):
+        """Standard D-Bus PropertiesChanged() signal, see D-Bus
+        standard.
+        """
+        pass
+
     @dbus.service.method(dbus.INTROSPECTABLE_IFACE,
-                         out_signature=u"s",
+                         out_signature="s",
                          path_keyword='object_path',
                          connection_keyword='connection')
     def Introspect(self, object_path, connection):
-        """Standard D-Bus method, overloaded to insert property tags.
+        """Overloading of standard D-Bus method.
+
+        Inserts property tags and interface annotation tags.
         """
-        xmlstring = dbus.service.Object.Introspect(self, object_path,
-                                                   connection)
+        xmlstring = DBusObjectWithAnnotations.Introspect(self,
+                                                         object_path,
+                                                         connection)
         try:
             document = xml.dom.minidom.parseString(xmlstring)
+
             def make_tag(document, name, prop):
-                e = document.createElement(u"property")
-                e.setAttribute(u"name", name)
-                e.setAttribute(u"type", prop._dbus_signature)
-                e.setAttribute(u"access", prop._dbus_access)
+                e = document.createElement("property")
+                e.setAttribute("name", name)
+                e.setAttribute("type", prop._dbus_signature)
+                e.setAttribute("access", prop._dbus_access)
                 return e
-            for if_tag in document.getElementsByTagName(u"interface"):
+
+            for if_tag in document.getElementsByTagName("interface"):
+                # Add property tags
                 for tag in (make_tag(document, name, prop)
                             for name, prop
-                            in self._get_all_dbus_properties()
+                            in self._get_all_dbus_things("property")
                             if prop._dbus_interface
-                            == if_tag.getAttribute(u"name")):
+                            == if_tag.getAttribute("name")):
                     if_tag.appendChild(tag)
+                # Add annotation tags for properties
+                for tag in if_tag.getElementsByTagName("property"):
+                    annots = dict()
+                    for name, prop in self._get_all_dbus_things(
+                            "property"):
+                        if (name == tag.getAttribute("name")
+                            and prop._dbus_interface
+                            == if_tag.getAttribute("name")):
+                            annots.update(getattr(
+                                prop, "_dbus_annotations", {}))
+                    for name, value in annots.items():
+                        ann_tag = document.createElement(
+                            "annotation")
+                        ann_tag.setAttribute("name", name)
+                        ann_tag.setAttribute("value", value)
+                        tag.appendChild(ann_tag)
                 # Add the names to the return values for the
                 # "org.freedesktop.DBus.Properties" methods
-                if (if_tag.getAttribute(u"name")
-                    == u"org.freedesktop.DBus.Properties"):
-                    for cn in if_tag.getElementsByTagName(u"method"):
-                        if cn.getAttribute(u"name") == u"Get":
-                            for arg in cn.getElementsByTagName(u"arg"):
-                                if (arg.getAttribute(u"direction")
-                                    == u"out"):
-                                    arg.setAttribute(u"name", u"value")
-                        elif cn.getAttribute(u"name") == u"GetAll":
-                            for arg in cn.getElementsByTagName(u"arg"):
-                                if (arg.getAttribute(u"direction")
-                                    == u"out"):
-                                    arg.setAttribute(u"name", u"props")
-            xmlstring = document.toxml(u"utf-8")
-            document.unlink()
-        except (AttributeError, xml.dom.DOMException,
-                xml.parsers.expat.ExpatError), error:
-            logger.error(u"Failed to override Introspection method",
-                         error)
-        return xmlstring
-
-
+                if (if_tag.getAttribute("name")
+                    == "org.freedesktop.DBus.Properties"):
+                    for cn in if_tag.getElementsByTagName("method"):
+                        if cn.getAttribute("name") == "Get":
+                            for arg in cn.getElementsByTagName("arg"):
+                                if (arg.getAttribute("direction")
+                                    == "out"):
+                                    arg.setAttribute("name", "value")
+                        elif cn.getAttribute("name") == "GetAll":
+                            for arg in cn.getElementsByTagName("arg"):
+                                if (arg.getAttribute("direction")
+                                    == "out"):
+                                    arg.setAttribute("name", "props")
+            xmlstring = document.toxml("utf-8")
+            document.unlink()
+        except (AttributeError, xml.dom.DOMException,
+                xml.parsers.expat.ExpatError) as error:
+            logger.error("Failed to override Introspection method",
+                         exc_info=error)
+        return xmlstring
+
+try:
+    dbus.OBJECT_MANAGER_IFACE
+except AttributeError:
+    dbus.OBJECT_MANAGER_IFACE = "org.freedesktop.DBus.ObjectManager"
+
+
+class DBusObjectWithObjectManager(DBusObjectWithAnnotations):
+    """A D-Bus object with an ObjectManager.
+
+    Classes inheriting from this exposes the standard
+    GetManagedObjects call and the InterfacesAdded and
+    InterfacesRemoved signals on the standard
+    "org.freedesktop.DBus.ObjectManager" interface.
+
+    Note: No signals are sent automatically; they must be sent
+    manually.
+    """
+    @dbus.service.method(dbus.OBJECT_MANAGER_IFACE,
+                         out_signature="a{oa{sa{sv}}}")
+    def GetManagedObjects(self):
+        """This function must be overridden"""
+        raise NotImplementedError()
+
+    @dbus.service.signal(dbus.OBJECT_MANAGER_IFACE,
+                         signature="oa{sa{sv}}")
+    def InterfacesAdded(self, object_path, interfaces_and_properties):
+        pass
+
+    @dbus.service.signal(dbus.OBJECT_MANAGER_IFACE, signature="oas")
+    def InterfacesRemoved(self, object_path, interfaces):
+        pass
+
+    @dbus.service.method(dbus.INTROSPECTABLE_IFACE,
+                         out_signature="s",
+                         path_keyword='object_path',
+                         connection_keyword='connection')
+    def Introspect(self, object_path, connection):
+        """Overloading of standard D-Bus method.
+
+        Override return argument name of GetManagedObjects to be
+        "objpath_interfaces_and_properties"
+        """
+        xmlstring = DBusObjectWithAnnotations.Introspect(self,
+                                                         object_path,
+                                                         connection)
+        try:
+            document = xml.dom.minidom.parseString(xmlstring)
+
+            for if_tag in document.getElementsByTagName("interface"):
+                # Fix argument name for the GetManagedObjects method
+                if (if_tag.getAttribute("name")
+                    == dbus.OBJECT_MANAGER_IFACE):
+                    for cn in if_tag.getElementsByTagName("method"):
+                        if (cn.getAttribute("name")
+                            == "GetManagedObjects"):
+                            for arg in cn.getElementsByTagName("arg"):
+                                if (arg.getAttribute("direction")
+                                    == "out"):
+                                    arg.setAttribute(
+                                        "name",
+                                        "objpath_interfaces"
+                                        "_and_properties")
+            xmlstring = document.toxml("utf-8")
+            document.unlink()
+        except (AttributeError, xml.dom.DOMException,
+                xml.parsers.expat.ExpatError) as error:
+            logger.error("Failed to override Introspection method",
+                         exc_info=error)
+        return xmlstring
+
+
+def datetime_to_dbus(dt, variant_level=0):
+    """Convert a UTC datetime.datetime() to a D-Bus type."""
+    if dt is None:
+        return dbus.String("", variant_level=variant_level)
+    return dbus.String(dt.isoformat(), variant_level=variant_level)
+
+
+def alternate_dbus_interfaces(alt_interface_names, deprecate=True):
+    """A class decorator; applied to a subclass of
+    dbus.service.Object, it will add alternate D-Bus attributes with
+    interface names according to the "alt_interface_names" mapping.
+    Usage:
+
+    @alternate_dbus_interfaces({"org.example.Interface":
+                                    "net.example.AlternateInterface"})
+    class SampleDBusObject(dbus.service.Object):
+        @dbus.service.method("org.example.Interface")
+        def SampleDBusMethod():
+            pass
+
+    The above "SampleDBusMethod" on "SampleDBusObject" will be
+    reachable via two interfaces: "org.example.Interface" and
+    "net.example.AlternateInterface", the latter of which will have
+    its D-Bus annotation "org.freedesktop.DBus.Deprecated" set to
+    "true", unless "deprecate" is passed with a False value.
+
+    This works for methods and signals, and also for D-Bus properties
+    (from DBusObjectWithProperties) and interfaces (from the
+    dbus_interface_annotations decorator).
+    """
+
+    def wrapper(cls):
+        for orig_interface_name, alt_interface_name in (
+                alt_interface_names.items()):
+            attr = {}
+            interface_names = set()
+            # Go though all attributes of the class
+            for attrname, attribute in inspect.getmembers(cls):
+                # Ignore non-D-Bus attributes, and D-Bus attributes
+                # with the wrong interface name
+                if (not hasattr(attribute, "_dbus_interface")
+                    or not attribute._dbus_interface.startswith(
+                        orig_interface_name)):
+                    continue
+                # Create an alternate D-Bus interface name based on
+                # the current name
+                alt_interface = attribute._dbus_interface.replace(
+                    orig_interface_name, alt_interface_name)
+                interface_names.add(alt_interface)
+                # Is this a D-Bus signal?
+                if getattr(attribute, "_dbus_is_signal", False):
+                    # Extract the original non-method undecorated
+                    # function by black magic
+                    if sys.version_info.major == 2:
+                        nonmethod_func = (dict(
+                            zip(attribute.func_code.co_freevars,
+                                attribute.__closure__))
+                                          ["func"].cell_contents)
+                    else:
+                        nonmethod_func = (dict(
+                            zip(attribute.__code__.co_freevars,
+                                attribute.__closure__))
+                                          ["func"].cell_contents)
+                    # Create a new, but exactly alike, function
+                    # object, and decorate it to be a new D-Bus signal
+                    # with the alternate D-Bus interface name
+                    new_function = copy_function(nonmethod_func)
+                    new_function = (dbus.service.signal(
+                        alt_interface,
+                        attribute._dbus_signature)(new_function))
+                    # Copy annotations, if any
+                    try:
+                        new_function._dbus_annotations = dict(
+                            attribute._dbus_annotations)
+                    except AttributeError:
+                        pass
+
+                    # Define a creator of a function to call both the
+                    # original and alternate functions, so both the
+                    # original and alternate signals gets sent when
+                    # the function is called
+                    def fixscope(func1, func2):
+                        """This function is a scope container to pass
+                        func1 and func2 to the "call_both" function
+                        outside of its arguments"""
+
+                        @functools.wraps(func2)
+                        def call_both(*args, **kwargs):
+                            """This function will emit two D-Bus
+                            signals by calling func1 and func2"""
+                            func1(*args, **kwargs)
+                            func2(*args, **kwargs)
+                        # Make wrapper function look like a D-Bus
+                        # signal
+                        for name, attr in inspect.getmembers(func2):
+                            if name.startswith("_dbus_"):
+                                setattr(call_both, name, attr)
+
+                        return call_both
+                    # Create the "call_both" function and add it to
+                    # the class
+                    attr[attrname] = fixscope(attribute, new_function)
+                # Is this a D-Bus method?
+                elif getattr(attribute, "_dbus_is_method", False):
+                    # Create a new, but exactly alike, function
+                    # object.  Decorate it to be a new D-Bus method
+                    # with the alternate D-Bus interface name.  Add it
+                    # to the class.
+                    attr[attrname] = (
+                        dbus.service.method(
+                            alt_interface,
+                            attribute._dbus_in_signature,
+                            attribute._dbus_out_signature)
+                        (copy_function(attribute)))
+                    # Copy annotations, if any
+                    try:
+                        attr[attrname]._dbus_annotations = dict(
+                            attribute._dbus_annotations)
+                    except AttributeError:
+                        pass
+                # Is this a D-Bus property?
+                elif getattr(attribute, "_dbus_is_property", False):
+                    # Create a new, but exactly alike, function
+                    # object, and decorate it to be a new D-Bus
+                    # property with the alternate D-Bus interface
+                    # name.  Add it to the class.
+                    attr[attrname] = (dbus_service_property(
+                        alt_interface, attribute._dbus_signature,
+                        attribute._dbus_access,
+                        attribute._dbus_get_args_options
+                        ["byte_arrays"])
+                                      (copy_function(attribute)))
+                    # Copy annotations, if any
+                    try:
+                        attr[attrname]._dbus_annotations = dict(
+                            attribute._dbus_annotations)
+                    except AttributeError:
+                        pass
+                # Is this a D-Bus interface?
+                elif getattr(attribute, "_dbus_is_interface", False):
+                    # Create a new, but exactly alike, function
+                    # object.  Decorate it to be a new D-Bus interface
+                    # with the alternate D-Bus interface name.  Add it
+                    # to the class.
+                    attr[attrname] = (
+                        dbus_interface_annotations(alt_interface)
+                        (copy_function(attribute)))
+            if deprecate:
+                # Deprecate all alternate interfaces
+                iname = "_AlternateDBusNames_interface_annotation{}"
+                for interface_name in interface_names:
+
+                    @dbus_interface_annotations(interface_name)
+                    def func(self):
+                        return {"org.freedesktop.DBus.Deprecated":
+                                "true"}
+                    # Find an unused name
+                    for aname in (iname.format(i)
+                                  for i in itertools.count()):
+                        if aname not in attr:
+                            attr[aname] = func
+                            break
+            if interface_names:
+                # Replace the class with a new subclass of it with
+                # methods, signals, etc. as created above.
+                if sys.version_info.major == 2:
+                    cls = type(b"{}Alternate".format(cls.__name__),
+                               (cls, ), attr)
+                else:
+                    cls = type("{}Alternate".format(cls.__name__),
+                               (cls, ), attr)
+        return cls
+
+    return wrapper
+
+
+@alternate_dbus_interfaces({"se.recompile.Mandos":
+                            "se.bsnet.fukt.Mandos"})
 class ClientDBus(Client, DBusObjectWithProperties):
     """A Client class using D-Bus
-    
+
     Attributes:
     dbus_object_path: dbus.ObjectPath
     bus: dbus.SystemBus()
     """
-    
+
     runtime_expansions = (Client.runtime_expansions
-                          + (u"dbus_object_path",))
-    
+                          + ("dbus_object_path", ))
+
+    _interface = "se.recompile.Mandos.Client"
+
     # dbus.service.Object doesn't use super(), so we can't either.
-    
-    def __init__(self, bus = None, *args, **kwargs):
-        self._approvals_pending = 0
+
+    def __init__(self, bus=None, *args, **kwargs):
         self.bus = bus
         Client.__init__(self, *args, **kwargs)
         # Only now, when this client is initialized, can it show up on
         # the D-Bus
-        client_object_name = unicode(self.name).translate(
-            {ord(u"."): ord(u"_"),
-             ord(u"-"): ord(u"_")})
-        self.dbus_object_path = (dbus.ObjectPath
-                                 (u"/clients/" + client_object_name))
+        client_object_name = str(self.name).translate(
+            {ord("."): ord("_"),
+             ord("-"): ord("_")})
+        self.dbus_object_path = dbus.ObjectPath(
+            "/clients/" + client_object_name)
         DBusObjectWithProperties.__init__(self, self.bus,
                                           self.dbus_object_path)
-        
-    def _get_approvals_pending(self):
-        return self._approvals_pending
-    def _set_approvals_pending(self, value):
-        old_value = self._approvals_pending
-        self._approvals_pending = value
-        bval = bool(value)
-        if (hasattr(self, "dbus_object_path")
-            and bval is not bool(old_value)):
-            dbus_bool = dbus.Boolean(bval, variant_level=1)
-            self.PropertyChanged(dbus.String(u"ApprovalPending"),
-                                 dbus_bool)
-
-    approvals_pending = property(_get_approvals_pending,
-                                 _set_approvals_pending)
-    del _get_approvals_pending, _set_approvals_pending
-    
-    @staticmethod
-    def _datetime_to_dbus(dt, variant_level=0):
-        """Convert a UTC datetime.datetime() to a D-Bus type."""
-        return dbus.String(dt.isoformat(),
-                           variant_level=variant_level)
-    
-    def enable(self):
-        oldstate = getattr(self, u"enabled", False)
-        r = Client.enable(self)
-        if oldstate != self.enabled:
-            # Emit D-Bus signals
-            self.PropertyChanged(dbus.String(u"Enabled"),
-                                 dbus.Boolean(True, variant_level=1))
-            self.PropertyChanged(
-                dbus.String(u"LastEnabled"),
-                self._datetime_to_dbus(self.last_enabled,
-                                       variant_level=1))
-        return r
-    
-    def disable(self, quiet = False):
-        oldstate = getattr(self, u"enabled", False)
-        r = Client.disable(self, quiet=quiet)
-        if not quiet and oldstate != self.enabled:
-            # Emit D-Bus signal
-            self.PropertyChanged(dbus.String(u"Enabled"),
-                                 dbus.Boolean(False, variant_level=1))
-        return r
-    
+
+    def notifychangeproperty(transform_func, dbus_name,
+                             type_func=lambda x: x,
+                             variant_level=1,
+                             invalidate_only=False,
+                             _interface=_interface):
+        """ Modify a variable so that it's a property which announces
+        its changes to DBus.
+
+        transform_fun: Function that takes a value and a variant_level
+                       and transforms it to a D-Bus type.
+        dbus_name: D-Bus name of the variable
+        type_func: Function that transform the value before sending it
+                   to the D-Bus.  Default: no transform
+        variant_level: D-Bus variant level.  Default: 1
+        """
+        attrname = "_{}".format(dbus_name)
+
+        def setter(self, value):
+            if hasattr(self, "dbus_object_path"):
+                if (not hasattr(self, attrname) or
+                    type_func(getattr(self, attrname, None))
+                    != type_func(value)):
+                    if invalidate_only:
+                        self.PropertiesChanged(
+                            _interface, dbus.Dictionary(),
+                            dbus.Array((dbus_name, )))
+                    else:
+                        dbus_value = transform_func(
+                            type_func(value),
+                            variant_level=variant_level)
+                        self.PropertyChanged(dbus.String(dbus_name),
+                                             dbus_value)
+                        self.PropertiesChanged(
+                            _interface,
+                            dbus.Dictionary({dbus.String(dbus_name):
+                                             dbus_value}),
+                            dbus.Array())
+            setattr(self, attrname, value)
+
+        return property(lambda self: getattr(self, attrname), setter)
+
+    expires = notifychangeproperty(datetime_to_dbus, "Expires")
+    approvals_pending = notifychangeproperty(dbus.Boolean,
+                                             "ApprovalPending",
+                                             type_func=bool)
+    enabled = notifychangeproperty(dbus.Boolean, "Enabled")
+    last_enabled = notifychangeproperty(datetime_to_dbus,
+                                        "LastEnabled")
+    checker = notifychangeproperty(
+        dbus.Boolean, "CheckerRunning",
+        type_func=lambda checker: checker is not None)
+    last_checked_ok = notifychangeproperty(datetime_to_dbus,
+                                           "LastCheckedOK")
+    last_checker_status = notifychangeproperty(dbus.Int16,
+                                               "LastCheckerStatus")
+    last_approval_request = notifychangeproperty(
+        datetime_to_dbus, "LastApprovalRequest")
+    approved_by_default = notifychangeproperty(dbus.Boolean,
+                                               "ApprovedByDefault")
+    approval_delay = notifychangeproperty(
+        dbus.UInt64, "ApprovalDelay",
+        type_func=lambda td: td.total_seconds() * 1000)
+    approval_duration = notifychangeproperty(
+        dbus.UInt64, "ApprovalDuration",
+        type_func=lambda td: td.total_seconds() * 1000)
+    host = notifychangeproperty(dbus.String, "Host")
+    timeout = notifychangeproperty(
+        dbus.UInt64, "Timeout",
+        type_func=lambda td: td.total_seconds() * 1000)
+    extended_timeout = notifychangeproperty(
+        dbus.UInt64, "ExtendedTimeout",
+        type_func=lambda td: td.total_seconds() * 1000)
+    interval = notifychangeproperty(
+        dbus.UInt64, "Interval",
+        type_func=lambda td: td.total_seconds() * 1000)
+    checker_command = notifychangeproperty(dbus.String, "Checker")
+    secret = notifychangeproperty(dbus.ByteArray, "Secret",
+                                  invalidate_only=True)
+
+    del notifychangeproperty
+
     def __del__(self, *args, **kwargs):
         try:
             self.remove_from_connection()
         except LookupError:
             pass
-        if hasattr(DBusObjectWithProperties, u"__del__"):
+        if hasattr(DBusObjectWithProperties, "__del__"):
             DBusObjectWithProperties.__del__(self, *args, **kwargs)
         Client.__del__(self, *args, **kwargs)
-    
-    def checker_callback(self, pid, condition, command,
-                         *args, **kwargs):
-        self.checker_callback_tag = None
-        self.checker = None
-        # Emit D-Bus signal
-        self.PropertyChanged(dbus.String(u"CheckerRunning"),
-                             dbus.Boolean(False, variant_level=1))
-        if os.WIFEXITED(condition):
-            exitstatus = os.WEXITSTATUS(condition)
+
+    def checker_callback(self, source, condition,
+                         connection, command, *args, **kwargs):
+        ret = Client.checker_callback(self, source, condition,
+                                      connection, command, *args,
+                                      **kwargs)
+        exitstatus = self.last_checker_status
+        if exitstatus >= 0:
             # Emit D-Bus signal
             self.CheckerCompleted(dbus.Int16(exitstatus),
-                                  dbus.Int64(condition),
+                                  # This is specific to GNU libC
+                                  dbus.Int64(exitstatus << 8),
                                   dbus.String(command))
         else:
             # Emit D-Bus signal
             self.CheckerCompleted(dbus.Int16(-1),
-                                  dbus.Int64(condition),
+                                  dbus.Int64(
+                                      # This is specific to GNU libC
+                                      (exitstatus << 8)
+                                      | self.last_checker_signal),
                                   dbus.String(command))
-        
-        return Client.checker_callback(self, pid, condition, command,
-                                       *args, **kwargs)
-    
-    def checked_ok(self, *args, **kwargs):
-        r = Client.checked_ok(self, *args, **kwargs)
-        # Emit D-Bus signal
-        self.PropertyChanged(
-            dbus.String(u"LastCheckedOK"),
-            (self._datetime_to_dbus(self.last_checked_ok,
-                                    variant_level=1)))
-        return r
-    
-    def need_approval(self, *args, **kwargs):
-        r = Client.need_approval(self, *args, **kwargs)
-        # Emit D-Bus signal
-        self.PropertyChanged(
-            dbus.String(u"LastApprovalRequest"),
-            (self._datetime_to_dbus(self.last_approval_request,
-                                    variant_level=1)))
-        return r
-    
+        return ret
+
     def start_checker(self, *args, **kwargs):
-        old_checker = self.checker
-        if self.checker is not None:
-            old_checker_pid = self.checker.pid
-        else:
-            old_checker_pid = None
+        old_checker_pid = getattr(self.checker, "pid", None)
         r = Client.start_checker(self, *args, **kwargs)
         # Only if new checker process was started
         if (self.checker is not None
             and old_checker_pid != self.checker.pid):
             # Emit D-Bus signal
             self.CheckerStarted(self.current_checker_command)
-            self.PropertyChanged(
-                dbus.String(u"CheckerRunning"),
-                dbus.Boolean(True, variant_level=1))
-        return r
-    
-    def stop_checker(self, *args, **kwargs):
-        old_checker = getattr(self, u"checker", None)
-        r = Client.stop_checker(self, *args, **kwargs)
-        if (old_checker is not None
-            and getattr(self, u"checker", None) is None):
-            self.PropertyChanged(dbus.String(u"CheckerRunning"),
-                                 dbus.Boolean(False, variant_level=1))
         return r
 
     def _reset_approved(self):
-        self._approved = None
+        self.approved = None
         return False
-    
+
     def approve(self, value=True):
+        self.approved = value
+        GLib.timeout_add(int(self.approval_duration.total_seconds()
+                             * 1000), self._reset_approved)
         self.send_changedstate()
-        self._approved = value
-        gobject.timeout_add(self._timedelta_to_milliseconds
-                            (self.approval_duration),
-                            self._reset_approved)
-    
-    
-    ## D-Bus methods, signals & properties
-    _interface = u"se.bsnet.fukt.Mandos.Client"
-    
-    ## Signals
-    
+
+    #  D-Bus methods, signals & properties
+
+    #  Interfaces
+
+    #  Signals
+
     # CheckerCompleted - signal
-    @dbus.service.signal(_interface, signature=u"nxs")
+    @dbus.service.signal(_interface, signature="nxs")
     def CheckerCompleted(self, exitcode, waitstatus, command):
         "D-Bus signal"
         pass
-    
+
     # CheckerStarted - signal
-    @dbus.service.signal(_interface, signature=u"s")
+    @dbus.service.signal(_interface, signature="s")
     def CheckerStarted(self, command):
         "D-Bus signal"
         pass
-    
+
     # PropertyChanged - signal
-    @dbus.service.signal(_interface, signature=u"sv")
+    @dbus_annotations({"org.freedesktop.DBus.Deprecated": "true"})
+    @dbus.service.signal(_interface, signature="sv")
     def PropertyChanged(self, property, value):
         "D-Bus signal"
         pass
-    
+
     # GotSecret - signal
     @dbus.service.signal(_interface)
     def GotSecret(self):
@@ -898,131 +1902,133 @@
         server to mandos-client
         """
         pass
-    
+
     # Rejected - signal
-    @dbus.service.signal(_interface, signature=u"s")
+    @dbus.service.signal(_interface, signature="s")
     def Rejected(self, reason):
         "D-Bus signal"
         pass
-    
+
     # NeedApproval - signal
-    @dbus.service.signal(_interface, signature=u"tb")
+    @dbus.service.signal(_interface, signature="tb")
     def NeedApproval(self, timeout, default):
         "D-Bus signal"
         return self.need_approval()
-    
-    ## Methods
-    
+
+    #  Methods
+
     # Approve - method
-    @dbus.service.method(_interface, in_signature=u"b")
+    @dbus.service.method(_interface, in_signature="b")
     def Approve(self, value):
         self.approve(value)
-    
+
     # CheckedOK - method
     @dbus.service.method(_interface)
     def CheckedOK(self):
-        return self.checked_ok()
-    
+        self.checked_ok()
+
     # Enable - method
+    @dbus_annotations({"org.freedesktop.DBus.Deprecated": "true"})
     @dbus.service.method(_interface)
     def Enable(self):
         "D-Bus method"
         self.enable()
-    
+
     # StartChecker - method
+    @dbus_annotations({"org.freedesktop.DBus.Deprecated": "true"})
     @dbus.service.method(_interface)
     def StartChecker(self):
         "D-Bus method"
         self.start_checker()
-    
+
     # Disable - method
+    @dbus_annotations({"org.freedesktop.DBus.Deprecated": "true"})
     @dbus.service.method(_interface)
     def Disable(self):
         "D-Bus method"
         self.disable()
-    
+
     # StopChecker - method
+    @dbus_annotations({"org.freedesktop.DBus.Deprecated": "true"})
     @dbus.service.method(_interface)
     def StopChecker(self):
         self.stop_checker()
-    
-    ## Properties
-    
+
+    #  Properties
+
     # ApprovalPending - property
-    @dbus_service_property(_interface, signature=u"b", access=u"read")
+    @dbus_service_property(_interface, signature="b", access="read")
     def ApprovalPending_dbus_property(self):
         return dbus.Boolean(bool(self.approvals_pending))
-    
+
     # ApprovedByDefault - property
-    @dbus_service_property(_interface, signature=u"b",
-                           access=u"readwrite")
+    @dbus_service_property(_interface,
+                           signature="b",
+                           access="readwrite")
     def ApprovedByDefault_dbus_property(self, value=None):
         if value is None:       # get
             return dbus.Boolean(self.approved_by_default)
         self.approved_by_default = bool(value)
-        # Emit D-Bus signal
-        self.PropertyChanged(dbus.String(u"ApprovedByDefault"),
-                             dbus.Boolean(value, variant_level=1))
-    
+
     # ApprovalDelay - property
-    @dbus_service_property(_interface, signature=u"t",
-                           access=u"readwrite")
+    @dbus_service_property(_interface,
+                           signature="t",
+                           access="readwrite")
     def ApprovalDelay_dbus_property(self, value=None):
         if value is None:       # get
-            return dbus.UInt64(self.approval_delay_milliseconds())
+            return dbus.UInt64(self.approval_delay.total_seconds()
+                               * 1000)
         self.approval_delay = datetime.timedelta(0, 0, 0, value)
-        # Emit D-Bus signal
-        self.PropertyChanged(dbus.String(u"ApprovalDelay"),
-                             dbus.UInt64(value, variant_level=1))
-    
+
     # ApprovalDuration - property
-    @dbus_service_property(_interface, signature=u"t",
-                           access=u"readwrite")
+    @dbus_service_property(_interface,
+                           signature="t",
+                           access="readwrite")
     def ApprovalDuration_dbus_property(self, value=None):
         if value is None:       # get
-            return dbus.UInt64(self._timedelta_to_milliseconds(
-                    self.approval_duration))
+            return dbus.UInt64(self.approval_duration.total_seconds()
+                               * 1000)
         self.approval_duration = datetime.timedelta(0, 0, 0, value)
-        # Emit D-Bus signal
-        self.PropertyChanged(dbus.String(u"ApprovalDuration"),
-                             dbus.UInt64(value, variant_level=1))
-    
+
     # Name - property
-    @dbus_service_property(_interface, signature=u"s", access=u"read")
+    @dbus_annotations(
+        {"org.freedesktop.DBus.Property.EmitsChangedSignal": "const"})
+    @dbus_service_property(_interface, signature="s", access="read")
     def Name_dbus_property(self):
         return dbus.String(self.name)
-    
+
     # Fingerprint - property
-    @dbus_service_property(_interface, signature=u"s", access=u"read")
+    @dbus_annotations(
+        {"org.freedesktop.DBus.Property.EmitsChangedSignal": "const"})
+    @dbus_service_property(_interface, signature="s", access="read")
     def Fingerprint_dbus_property(self):
         return dbus.String(self.fingerprint)
-    
+
     # Host - property
-    @dbus_service_property(_interface, signature=u"s",
-                           access=u"readwrite")
+    @dbus_service_property(_interface,
+                           signature="s",
+                           access="readwrite")
     def Host_dbus_property(self, value=None):
         if value is None:       # get
             return dbus.String(self.host)
-        self.host = value
-        # Emit D-Bus signal
-        self.PropertyChanged(dbus.String(u"Host"),
-                             dbus.String(value, variant_level=1))
-    
+        self.host = str(value)
+
     # Created - property
-    @dbus_service_property(_interface, signature=u"s", access=u"read")
+    @dbus_annotations(
+        {"org.freedesktop.DBus.Property.EmitsChangedSignal": "const"})
+    @dbus_service_property(_interface, signature="s", access="read")
     def Created_dbus_property(self):
-        return dbus.String(self._datetime_to_dbus(self.created))
-    
+        return datetime_to_dbus(self.created)
+
     # LastEnabled - property
-    @dbus_service_property(_interface, signature=u"s", access=u"read")
+    @dbus_service_property(_interface, signature="s", access="read")
     def LastEnabled_dbus_property(self):
-        if self.last_enabled is None:
-            return dbus.String(u"")
-        return dbus.String(self._datetime_to_dbus(self.last_enabled))
-    
+        return datetime_to_dbus(self.last_enabled)
+
     # Enabled - property
-    @dbus_service_property(_interface, signature=u"b",
-                           access=u"readwrite")
+    @dbus_service_property(_interface,
+                           signature="b",
+                           access="readwrite")
     def Enabled_dbus_property(self, value=None):
         if value is None:       # get
             return dbus.Boolean(self.enabled)
@@ -1030,89 +2036,97 @@
             self.enable()
         else:
             self.disable()
-    
+
     # LastCheckedOK - property
-    @dbus_service_property(_interface, signature=u"s",
-                           access=u"readwrite")
+    @dbus_service_property(_interface,
+                           signature="s",
+                           access="readwrite")
     def LastCheckedOK_dbus_property(self, value=None):
         if value is not None:
             self.checked_ok()
             return
-        if self.last_checked_ok is None:
-            return dbus.String(u"")
-        return dbus.String(self._datetime_to_dbus(self
-                                                  .last_checked_ok))
-    
+        return datetime_to_dbus(self.last_checked_ok)
+
+    # LastCheckerStatus - property
+    @dbus_service_property(_interface, signature="n", access="read")
+    def LastCheckerStatus_dbus_property(self):
+        return dbus.Int16(self.last_checker_status)
+
+    # Expires - property
+    @dbus_service_property(_interface, signature="s", access="read")
+    def Expires_dbus_property(self):
+        return datetime_to_dbus(self.expires)
+
     # LastApprovalRequest - property
-    @dbus_service_property(_interface, signature=u"s", access=u"read")
+    @dbus_service_property(_interface, signature="s", access="read")
     def LastApprovalRequest_dbus_property(self):
-        if self.last_approval_request is None:
-            return dbus.String(u"")
-        return dbus.String(self.
-                           _datetime_to_dbus(self
-                                             .last_approval_request))
-    
+        return datetime_to_dbus(self.last_approval_request)
+
     # Timeout - property
-    @dbus_service_property(_interface, signature=u"t",
-                           access=u"readwrite")
+    @dbus_service_property(_interface,
+                           signature="t",
+                           access="readwrite")
     def Timeout_dbus_property(self, value=None):
         if value is None:       # get
-            return dbus.UInt64(self.timeout_milliseconds())
+            return dbus.UInt64(self.timeout.total_seconds() * 1000)
+        old_timeout = self.timeout
         self.timeout = datetime.timedelta(0, 0, 0, value)
-        # Emit D-Bus signal
-        self.PropertyChanged(dbus.String(u"Timeout"),
-                             dbus.UInt64(value, variant_level=1))
-        if getattr(self, u"disable_initiator_tag", None) is None:
-            return
-        # Reschedule timeout
-        gobject.source_remove(self.disable_initiator_tag)
-        self.disable_initiator_tag = None
-        time_to_die = (self.
-                       _timedelta_to_milliseconds((self
-                                                   .last_checked_ok
-                                                   + self.timeout)
-                                                  - datetime.datetime
-                                                  .utcnow()))
-        if time_to_die <= 0:
-            # The timeout has passed
-            self.disable()
-        else:
-            self.disable_initiator_tag = (gobject.timeout_add
-                                          (time_to_die, self.disable))
-    
+        # Reschedule disabling
+        if self.enabled:
+            now = datetime.datetime.utcnow()
+            self.expires += self.timeout - old_timeout
+            if self.expires <= now:
+                # The timeout has passed
+                self.disable()
+            else:
+                if (getattr(self, "disable_initiator_tag", None)
+                    is None):
+                    return
+                GLib.source_remove(self.disable_initiator_tag)
+                self.disable_initiator_tag = GLib.timeout_add(
+                    int((self.expires - now).total_seconds() * 1000),
+                    self.disable)
+
+    # ExtendedTimeout - property
+    @dbus_service_property(_interface,
+                           signature="t",
+                           access="readwrite")
+    def ExtendedTimeout_dbus_property(self, value=None):
+        if value is None:       # get
+            return dbus.UInt64(self.extended_timeout.total_seconds()
+                               * 1000)
+        self.extended_timeout = datetime.timedelta(0, 0, 0, value)
+
     # Interval - property
-    @dbus_service_property(_interface, signature=u"t",
-                           access=u"readwrite")
+    @dbus_service_property(_interface,
+                           signature="t",
+                           access="readwrite")
     def Interval_dbus_property(self, value=None):
         if value is None:       # get
-            return dbus.UInt64(self.interval_milliseconds())
+            return dbus.UInt64(self.interval.total_seconds() * 1000)
         self.interval = datetime.timedelta(0, 0, 0, value)
-        # Emit D-Bus signal
-        self.PropertyChanged(dbus.String(u"Interval"),
-                             dbus.UInt64(value, variant_level=1))
-        if getattr(self, u"checker_initiator_tag", None) is None:
+        if getattr(self, "checker_initiator_tag", None) is None:
             return
-        # Reschedule checker run
-        gobject.source_remove(self.checker_initiator_tag)
-        self.checker_initiator_tag = (gobject.timeout_add
-                                      (value, self.start_checker))
-        self.start_checker()    # Start one now, too
+        if self.enabled:
+            # Reschedule checker run
+            GLib.source_remove(self.checker_initiator_tag)
+            self.checker_initiator_tag = GLib.timeout_add(
+                value, self.start_checker)
+            self.start_checker()  # Start one now, too
 
     # Checker - property
-    @dbus_service_property(_interface, signature=u"s",
-                           access=u"readwrite")
+    @dbus_service_property(_interface,
+                           signature="s",
+                           access="readwrite")
     def Checker_dbus_property(self, value=None):
         if value is None:       # get
             return dbus.String(self.checker_command)
-        self.checker_command = value
-        # Emit D-Bus signal
-        self.PropertyChanged(dbus.String(u"Checker"),
-                             dbus.String(self.checker_command,
-                                         variant_level=1))
-    
+        self.checker_command = str(value)
+
     # CheckerRunning - property
-    @dbus_service_property(_interface, signature=u"b",
-                           access=u"readwrite")
+    @dbus_service_property(_interface,
+                           signature="b",
+                           access="readwrite")
     def CheckerRunning_dbus_property(self, value=None):
         if value is None:       # get
             return dbus.Boolean(self.checker is not None)
@@ -1120,18 +2134,26 @@
             self.start_checker()
         else:
             self.stop_checker()
-    
+
     # ObjectPath - property
-    @dbus_service_property(_interface, signature=u"o", access=u"read")
+    @dbus_annotations(
+        {"org.freedesktop.DBus.Property.EmitsChangedSignal": "const",
+         "org.freedesktop.DBus.Deprecated": "true"})
+    @dbus_service_property(_interface, signature="o", access="read")
     def ObjectPath_dbus_property(self):
-        return self.dbus_object_path # is already a dbus.ObjectPath
-    
+        return self.dbus_object_path  # is already a dbus.ObjectPath
+
     # Secret = property
-    @dbus_service_property(_interface, signature=u"ay",
-                           access=u"write", byte_arrays=True)
+    @dbus_annotations(
+        {"org.freedesktop.DBus.Property.EmitsChangedSignal":
+         "invalidates"})
+    @dbus_service_property(_interface,
+                           signature="ay",
+                           access="write",
+                           byte_arrays=True)
     def Secret_dbus_property(self, value):
-        self.secret = str(value)
-    
+        self.secret = bytes(value)
+
     del _interface
 
 
@@ -1140,137 +2162,130 @@
         self._pipe = child_pipe
         self._pipe.send(('init', fpr, address))
         if not self._pipe.recv():
-            raise KeyError()
+            raise KeyError(fpr)
 
     def __getattribute__(self, name):
-        if(name == '_pipe'):
+        if name == '_pipe':
             return super(ProxyClient, self).__getattribute__(name)
         self._pipe.send(('getattr', name))
         data = self._pipe.recv()
         if data[0] == 'data':
             return data[1]
         if data[0] == 'function':
+
             def func(*args, **kwargs):
                 self._pipe.send(('funcall', name, args, kwargs))
                 return self._pipe.recv()[1]
+
             return func
 
     def __setattr__(self, name, value):
-        if(name == '_pipe'):
+        if name == '_pipe':
             return super(ProxyClient, self).__setattr__(name, value)
         self._pipe.send(('setattr', name, value))
 
 
 class ClientHandler(socketserver.BaseRequestHandler, object):
     """A class to handle client connections.
-    
+
     Instantiated once for each connection to handle it.
     Note: This will run in its own forked process."""
-    
+
     def handle(self):
         with contextlib.closing(self.server.child_pipe) as child_pipe:
-            logger.info(u"TCP connection from: %s",
-                        unicode(self.client_address))
-            logger.debug(u"Pipe FD: %d",
+            logger.info("TCP connection from: %s",
+                        str(self.client_address))
+            logger.debug("Pipe FD: %d",
                          self.server.child_pipe.fileno())
 
-            session = (gnutls.connection
-                       .ClientSession(self.request,
-                                      gnutls.connection
-                                      .X509Credentials()))
-
-            # Note: gnutls.connection.X509Credentials is really a
-            # generic GnuTLS certificate credentials object so long as
-            # no X.509 keys are added to it.  Therefore, we can use it
-            # here despite using OpenPGP certificates.
-
-            #priority = u':'.join((u"NONE", u"+VERS-TLS1.1",
-            #                      u"+AES-256-CBC", u"+SHA1",
-            #                      u"+COMP-NULL", u"+CTYPE-OPENPGP",
-            #                      u"+DHE-DSS"))
+            session = gnutls.ClientSession(self.request)
+
+            # priority = ':'.join(("NONE", "+VERS-TLS1.1",
+            #                       "+AES-256-CBC", "+SHA1",
+            #                       "+COMP-NULL", "+CTYPE-OPENPGP",
+            #                       "+DHE-DSS"))
             # Use a fallback default, since this MUST be set.
             priority = self.server.gnutls_priority
             if priority is None:
-                priority = u"NORMAL"
-            (gnutls.library.functions
-             .gnutls_priority_set_direct(session._c_object,
-                                         priority, None))
+                priority = "NORMAL"
+            gnutls.priority_set_direct(session._c_object,
+                                       priority.encode("utf-8"),
+                                       None)
 
             # Start communication using the Mandos protocol
             # Get protocol number
             line = self.request.makefile().readline()
-            logger.debug(u"Protocol version: %r", line)
+            logger.debug("Protocol version: %r", line)
             try:
                 if int(line.strip().split()[0]) > 1:
-                    raise RuntimeError
-            except (ValueError, IndexError, RuntimeError), error:
-                logger.error(u"Unknown protocol version: %s", error)
+                    raise RuntimeError(line)
+            except (ValueError, IndexError, RuntimeError) as error:
+                logger.error("Unknown protocol version: %s", error)
                 return
 
             # Start GnuTLS connection
             try:
                 session.handshake()
-            except gnutls.errors.GNUTLSError, error:
-                logger.warning(u"Handshake failed: %s", error)
+            except gnutls.Error as error:
+                logger.warning("Handshake failed: %s", error)
                 # Do not run session.bye() here: the session is not
                 # established.  Just abandon the request.
                 return
-            logger.debug(u"Handshake succeeded")
+            logger.debug("Handshake succeeded")
 
             approval_required = False
             try:
                 try:
-                    fpr = self.fingerprint(self.peer_certificate
-                                           (session))
-                except (TypeError, gnutls.errors.GNUTLSError), error:
-                    logger.warning(u"Bad certificate: %s", error)
+                    fpr = self.fingerprint(
+                        self.peer_certificate(session))
+                except (TypeError, gnutls.Error) as error:
+                    logger.warning("Bad certificate: %s", error)
                     return
-                logger.debug(u"Fingerprint: %s", fpr)
+                logger.debug("Fingerprint: %s", fpr)
 
                 try:
                     client = ProxyClient(child_pipe, fpr,
                                          self.client_address)
                 except KeyError:
                     return
-                
+
                 if client.approval_delay:
                     delay = client.approval_delay
                     client.approvals_pending += 1
                     approval_required = True
-                
+
                 while True:
                     if not client.enabled:
-                        logger.warning(u"Client %s is disabled",
-                                       client.name)
+                        logger.info("Client %s is disabled",
+                                    client.name)
                         if self.server.use_dbus:
                             # Emit D-Bus signal
-                            client.Rejected("Disabled")                    
+                            client.Rejected("Disabled")
                         return
-                    
-                    if client._approved or not client.approval_delay:
-                        #We are approved or approval is disabled
+
+                    if client.approved or not client.approval_delay:
+                        # We are approved or approval is disabled
                         break
-                    elif client._approved is None:
-                        logger.info(u"Client %s needs approval",
+                    elif client.approved is None:
+                        logger.info("Client %s needs approval",
                                     client.name)
                         if self.server.use_dbus:
                             # Emit D-Bus signal
                             client.NeedApproval(
-                                client.approval_delay_milliseconds(),
-                                client.approved_by_default)
+                                client.approval_delay.total_seconds()
+                                * 1000, client.approved_by_default)
                     else:
-                        logger.warning(u"Client %s was not approved",
+                        logger.warning("Client %s was not approved",
                                        client.name)
                         if self.server.use_dbus:
                             # Emit D-Bus signal
                             client.Rejected("Denied")
                         return
-                    
-                    #wait until timeout or approved
-                    #x = float(client._timedelta_to_milliseconds(delay))
+
+                    # wait until timeout or approved
                     time = datetime.datetime.now()
                     client.changedstate.acquire()
-                    client.changedstate.wait(float(client._timedelta_to_milliseconds(delay) / 1000))
+                    client.changedstate.wait(delay.total_seconds())
                     client.changedstate.release()
                     time2 = datetime.datetime.now()
                     if (time2 - time) >= delay:
@@ -1286,184 +2301,211 @@
                             break
                     else:
                         delay -= time2 - time
-                
-                sent_size = 0
-                while sent_size < len(client.secret):
-                    try:
-                        sent = session.send(client.secret[sent_size:])
-                    except (gnutls.errors.GNUTLSError), error:
-                        logger.warning("gnutls send failed")
-                        return
-                    logger.debug(u"Sent: %d, remaining: %d",
-                                 sent, len(client.secret)
-                                 - (sent_size + sent))
-                    sent_size += sent
-
-                logger.info(u"Sending secret to %s", client.name)
-                # bump the timeout as if seen
-                client.checked_ok()
+
+                try:
+                    session.send(client.secret)
+                except gnutls.Error as error:
+                    logger.warning("gnutls send failed",
+                                   exc_info=error)
+                    return
+
+                logger.info("Sending secret to %s", client.name)
+                # bump the timeout using extended_timeout
+                client.bump_timeout(client.extended_timeout)
                 if self.server.use_dbus:
                     # Emit D-Bus signal
                     client.GotSecret()
-            
+
             finally:
                 if approval_required:
                     client.approvals_pending -= 1
                 try:
                     session.bye()
-                except (gnutls.errors.GNUTLSError), error:
-                    logger.warning("GnuTLS bye failed")
-    
+                except gnutls.Error as error:
+                    logger.warning("GnuTLS bye failed",
+                                   exc_info=error)
+
     @staticmethod
     def peer_certificate(session):
         "Return the peer's OpenPGP certificate as a bytestring"
         # If not an OpenPGP certificate...
-        if (gnutls.library.functions
-            .gnutls_certificate_type_get(session._c_object)
-            != gnutls.library.constants.GNUTLS_CRT_OPENPGP):
-            # ...do the normal thing
-            return session.peer_certificate
+        if (gnutls.certificate_type_get(session._c_object)
+            != gnutls.CRT_OPENPGP):
+            # ...return invalid data
+            return b""
         list_size = ctypes.c_uint(1)
-        cert_list = (gnutls.library.functions
-                     .gnutls_certificate_get_peers
+        cert_list = (gnutls.certificate_get_peers
                      (session._c_object, ctypes.byref(list_size)))
         if not bool(cert_list) and list_size.value != 0:
-            raise gnutls.errors.GNUTLSError(u"error getting peer"
-                                            u" certificate")
+            raise gnutls.Error("error getting peer certificate")
         if list_size.value == 0:
             return None
         cert = cert_list[0]
         return ctypes.string_at(cert.data, cert.size)
-    
+
     @staticmethod
     def fingerprint(openpgp):
         "Convert an OpenPGP bytestring to a hexdigit fingerprint"
         # New GnuTLS "datum" with the OpenPGP public key
-        datum = (gnutls.library.types
-                 .gnutls_datum_t(ctypes.cast(ctypes.c_char_p(openpgp),
-                                             ctypes.POINTER
-                                             (ctypes.c_ubyte)),
-                                 ctypes.c_uint(len(openpgp))))
+        datum = gnutls.datum_t(
+            ctypes.cast(ctypes.c_char_p(openpgp),
+                        ctypes.POINTER(ctypes.c_ubyte)),
+            ctypes.c_uint(len(openpgp)))
         # New empty GnuTLS certificate
-        crt = gnutls.library.types.gnutls_openpgp_crt_t()
-        (gnutls.library.functions
-         .gnutls_openpgp_crt_init(ctypes.byref(crt)))
+        crt = gnutls.openpgp_crt_t()
+        gnutls.openpgp_crt_init(ctypes.byref(crt))
         # Import the OpenPGP public key into the certificate
-        (gnutls.library.functions
-         .gnutls_openpgp_crt_import(crt, ctypes.byref(datum),
-                                    gnutls.library.constants
-                                    .GNUTLS_OPENPGP_FMT_RAW))
+        gnutls.openpgp_crt_import(crt, ctypes.byref(datum),
+                                  gnutls.OPENPGP_FMT_RAW)
         # Verify the self signature in the key
         crtverify = ctypes.c_uint()
-        (gnutls.library.functions
-         .gnutls_openpgp_crt_verify_self(crt, 0,
-                                         ctypes.byref(crtverify)))
+        gnutls.openpgp_crt_verify_self(crt, 0,
+                                       ctypes.byref(crtverify))
         if crtverify.value != 0:
-            gnutls.library.functions.gnutls_openpgp_crt_deinit(crt)
-            raise (gnutls.errors.CertificateSecurityError
-                   (u"Verify failed"))
+            gnutls.openpgp_crt_deinit(crt)
+            raise gnutls.CertificateSecurityError("Verify failed")
         # New buffer for the fingerprint
         buf = ctypes.create_string_buffer(20)
         buf_len = ctypes.c_size_t()
         # Get the fingerprint from the certificate into the buffer
-        (gnutls.library.functions
-         .gnutls_openpgp_crt_get_fingerprint(crt, ctypes.byref(buf),
-                                             ctypes.byref(buf_len)))
+        gnutls.openpgp_crt_get_fingerprint(crt, ctypes.byref(buf),
+                                           ctypes.byref(buf_len))
         # Deinit the certificate
-        gnutls.library.functions.gnutls_openpgp_crt_deinit(crt)
+        gnutls.openpgp_crt_deinit(crt)
         # Convert the buffer to a Python bytestring
         fpr = ctypes.string_at(buf, buf_len.value)
         # Convert the bytestring to hexadecimal notation
-        hex_fpr = u''.join(u"%02X" % ord(char) for char in fpr)
+        hex_fpr = binascii.hexlify(fpr).upper()
         return hex_fpr
 
 
 class MultiprocessingMixIn(object):
     """Like socketserver.ThreadingMixIn, but with multiprocessing"""
+
     def sub_process_main(self, request, address):
         try:
             self.finish_request(request, address)
-        except:
+        except Exception:
             self.handle_error(request, address)
         self.close_request(request)
-            
+
     def process_request(self, request, address):
         """Start a new process to process the request."""
-        multiprocessing.Process(target = self.sub_process_main,
-                                args = (request, address)).start()
+        proc = multiprocessing.Process(target=self.sub_process_main,
+                                       args=(request, address))
+        proc.start()
+        return proc
+
 
 class MultiprocessingMixInWithPipe(MultiprocessingMixIn, object):
     """ adds a pipe to the MixIn """
+
     def process_request(self, request, client_address):
         """Overrides and wraps the original process_request().
-        
+
         This function creates a new pipe in self.pipe
         """
         parent_pipe, self.child_pipe = multiprocessing.Pipe()
 
-        super(MultiprocessingMixInWithPipe,
-              self).process_request(request, client_address)
+        proc = MultiprocessingMixIn.process_request(self, request,
+                                                    client_address)
         self.child_pipe.close()
-        self.add_pipe(parent_pipe)
+        self.add_pipe(parent_pipe, proc)
 
-    def add_pipe(self, parent_pipe):
+    def add_pipe(self, parent_pipe, proc):
         """Dummy function; override as necessary"""
-        pass
+        raise NotImplementedError()
+
 
 class IPv6_TCPServer(MultiprocessingMixInWithPipe,
                      socketserver.TCPServer, object):
     """IPv6-capable TCP server.  Accepts 'None' as address and/or port
-    
+
     Attributes:
         enabled:        Boolean; whether this server is activated yet
         interface:      None or a network interface name (string)
         use_ipv6:       Boolean; to use IPv6 or not
     """
+
     def __init__(self, server_address, RequestHandlerClass,
-                 interface=None, use_ipv6=True):
+                 interface=None,
+                 use_ipv6=True,
+                 socketfd=None):
+        """If socketfd is set, use that file descriptor instead of
+        creating a new one with socket.socket().
+        """
         self.interface = interface
         if use_ipv6:
             self.address_family = socket.AF_INET6
+        if socketfd is not None:
+            # Save the file descriptor
+            self.socketfd = socketfd
+            # Save the original socket.socket() function
+            self.socket_socket = socket.socket
+
+            # To implement --socket, we monkey patch socket.socket.
+            #
+            # (When socketserver.TCPServer is a new-style class, we
+            # could make self.socket into a property instead of monkey
+            # patching socket.socket.)
+            #
+            # Create a one-time-only replacement for socket.socket()
+            @functools.wraps(socket.socket)
+            def socket_wrapper(*args, **kwargs):
+                # Restore original function so subsequent calls are
+                # not affected.
+                socket.socket = self.socket_socket
+                del self.socket_socket
+                # This time only, return a new socket object from the
+                # saved file descriptor.
+                return socket.fromfd(self.socketfd, *args, **kwargs)
+            # Replace socket.socket() function with wrapper
+            socket.socket = socket_wrapper
+        # The socketserver.TCPServer.__init__ will call
+        # socket.socket(), which might be our replacement,
+        # socket_wrapper(), if socketfd was set.
         socketserver.TCPServer.__init__(self, server_address,
                                         RequestHandlerClass)
+
     def server_bind(self):
         """This overrides the normal server_bind() function
         to bind to an interface if one was specified, and also NOT to
         bind to an address or port if they were not specified."""
+        global SO_BINDTODEVICE
         if self.interface is not None:
             if SO_BINDTODEVICE is None:
-                logger.error(u"SO_BINDTODEVICE does not exist;"
-                             u" cannot bind to interface %s",
-                             self.interface)
-            else:
-                try:
-                    self.socket.setsockopt(socket.SOL_SOCKET,
-                                           SO_BINDTODEVICE,
-                                           str(self.interface
-                                               + u'\0'))
-                except socket.error, error:
-                    if error[0] == errno.EPERM:
-                        logger.error(u"No permission to"
-                                     u" bind to interface %s",
-                                     self.interface)
-                    elif error[0] == errno.ENOPROTOOPT:
-                        logger.error(u"SO_BINDTODEVICE not available;"
-                                     u" cannot bind to interface %s",
-                                     self.interface)
-                    else:
-                        raise
+                # Fall back to a hard-coded value which seems to be
+                # common enough.
+                logger.warning("SO_BINDTODEVICE not found, trying 25")
+                SO_BINDTODEVICE = 25
+            try:
+                self.socket.setsockopt(
+                    socket.SOL_SOCKET, SO_BINDTODEVICE,
+                    (self.interface + "\0").encode("utf-8"))
+            except socket.error as error:
+                if error.errno == errno.EPERM:
+                    logger.error("No permission to bind to"
+                                 " interface %s", self.interface)
+                elif error.errno == errno.ENOPROTOOPT:
+                    logger.error("SO_BINDTODEVICE not available;"
+                                 " cannot bind to interface %s",
+                                 self.interface)
+                elif error.errno == errno.ENODEV:
+                    logger.error("Interface %s does not exist,"
+                                 " cannot bind", self.interface)
+                else:
+                    raise
         # Only bind(2) the socket if we really need to.
         if self.server_address[0] or self.server_address[1]:
             if not self.server_address[0]:
                 if self.address_family == socket.AF_INET6:
-                    any_address = u"::" # in6addr_any
+                    any_address = "::"  # in6addr_any
                 else:
-                    any_address = socket.INADDR_ANY
+                    any_address = "0.0.0.0"  # INADDR_ANY
                 self.server_address = (any_address,
                                        self.server_address[1])
             elif not self.server_address[1]:
-                self.server_address = (self.server_address[0],
-                                       0)
+                self.server_address = (self.server_address[0], 0)
 #                 if self.interface:
 #                     self.server_address = (self.server_address[0],
 #                                            0, # port
@@ -1475,102 +2517,111 @@
 
 class MandosServer(IPv6_TCPServer):
     """Mandos server.
-    
+
     Attributes:
         clients:        set of Client objects
         gnutls_priority GnuTLS priority string
         use_dbus:       Boolean; to emit D-Bus signals or not
-    
-    Assumes a gobject.MainLoop event loop.
+
+    Assumes a GLib.MainLoop event loop.
     """
+
     def __init__(self, server_address, RequestHandlerClass,
-                 interface=None, use_ipv6=True, clients=None,
-                 gnutls_priority=None, use_dbus=True):
+                 interface=None,
+                 use_ipv6=True,
+                 clients=None,
+                 gnutls_priority=None,
+                 use_dbus=True,
+                 socketfd=None):
         self.enabled = False
         self.clients = clients
         if self.clients is None:
-            self.clients = set()
+            self.clients = {}
         self.use_dbus = use_dbus
         self.gnutls_priority = gnutls_priority
         IPv6_TCPServer.__init__(self, server_address,
                                 RequestHandlerClass,
-                                interface = interface,
-                                use_ipv6 = use_ipv6)
+                                interface=interface,
+                                use_ipv6=use_ipv6,
+                                socketfd=socketfd)
+
     def server_activate(self):
         if self.enabled:
             return socketserver.TCPServer.server_activate(self)
+
     def enable(self):
         self.enabled = True
-    def add_pipe(self, parent_pipe):
+
+    def add_pipe(self, parent_pipe, proc):
         # Call "handle_ipc" for both data and EOF events
-        gobject.io_add_watch(parent_pipe.fileno(),
-                             gobject.IO_IN | gobject.IO_HUP,
-                             functools.partial(self.handle_ipc,
-                                               parent_pipe = parent_pipe))
-        
-    def handle_ipc(self, source, condition, parent_pipe=None,
+        GLib.io_add_watch(
+            parent_pipe.fileno(),
+            GLib.IO_IN | GLib.IO_HUP,
+            functools.partial(self.handle_ipc,
+                              parent_pipe=parent_pipe,
+                              proc=proc))
+
+    def handle_ipc(self, source, condition,
+                   parent_pipe=None,
+                   proc=None,
                    client_object=None):
-        condition_names = {
-            gobject.IO_IN: u"IN",   # There is data to read.
-            gobject.IO_OUT: u"OUT", # Data can be written (without
-                                    # blocking).
-            gobject.IO_PRI: u"PRI", # There is urgent data to read.
-            gobject.IO_ERR: u"ERR", # Error condition.
-            gobject.IO_HUP: u"HUP"  # Hung up (the connection has been
-                                    # broken, usually for pipes and
-                                    # sockets).
-            }
-        conditions_string = ' | '.join(name
-                                       for cond, name in
-                                       condition_names.iteritems()
-                                       if cond & condition)
-        # error or the other end of multiprocessing.Pipe has closed
-        if condition & (gobject.IO_ERR | condition & gobject.IO_HUP):
+        # error, or the other end of multiprocessing.Pipe has closed
+        if condition & (GLib.IO_ERR | GLib.IO_HUP):
+            # Wait for other process to exit
+            proc.join()
             return False
-        
+
         # Read a request from the child
         request = parent_pipe.recv()
         command = request[0]
-        
+
         if command == 'init':
             fpr = request[1]
             address = request[2]
-            
-            for c in self.clients:
+
+            for c in self.clients.values():
                 if c.fingerprint == fpr:
                     client = c
                     break
             else:
-                logger.warning(u"Client not found for fingerprint: %s, ad"
-                               u"dress: %s", fpr, address)
+                logger.info("Client not found for fingerprint: %s, ad"
+                            "dress: %s", fpr, address)
                 if self.use_dbus:
                     # Emit D-Bus signal
-                    mandos_dbus_service.ClientNotFound(fpr, address[0])
+                    mandos_dbus_service.ClientNotFound(fpr,
+                                                       address[0])
                 parent_pipe.send(False)
                 return False
-            
-            gobject.io_add_watch(parent_pipe.fileno(),
-                                 gobject.IO_IN | gobject.IO_HUP,
-                                 functools.partial(self.handle_ipc,
-                                                   parent_pipe = parent_pipe,
-                                                   client_object = client))
+
+            GLib.io_add_watch(
+                parent_pipe.fileno(),
+                GLib.IO_IN | GLib.IO_HUP,
+                functools.partial(self.handle_ipc,
+                                  parent_pipe=parent_pipe,
+                                  proc=proc,
+                                  client_object=client))
             parent_pipe.send(True)
-            # remove the old hook in favor of the new above hook on same fileno
+            # remove the old hook in favor of the new above hook on
+            # same fileno
             return False
         if command == 'funcall':
             funcname = request[1]
             args = request[2]
             kwargs = request[3]
-            
-            parent_pipe.send(('data', getattr(client_object, funcname)(*args, **kwargs)))
+
+            parent_pipe.send(('data', getattr(client_object,
+                                              funcname)(*args,
+                                                        **kwargs)))
 
         if command == 'getattr':
             attrname = request[1]
-            if callable(client_object.__getattribute__(attrname)):
-                parent_pipe.send(('function',))
+            if isinstance(client_object.__getattribute__(attrname),
+                          collections.Callable):
+                parent_pipe.send(('function', ))
             else:
-                parent_pipe.send(('data', client_object.__getattribute__(attrname)))
-        
+                parent_pipe.send((
+                    'data', client_object.__getattribute__(attrname)))
+
         if command == 'setattr':
             attrname = request[1]
             value = request[2]
@@ -1579,87 +2630,168 @@
         return True
 
 
+def rfc3339_duration_to_delta(duration):
+    """Parse an RFC 3339 "duration" and return a datetime.timedelta
+
+    >>> rfc3339_duration_to_delta("P7D")
+    datetime.timedelta(7)
+    >>> rfc3339_duration_to_delta("PT60S")
+    datetime.timedelta(0, 60)
+    >>> rfc3339_duration_to_delta("PT60M")
+    datetime.timedelta(0, 3600)
+    >>> rfc3339_duration_to_delta("PT24H")
+    datetime.timedelta(1)
+    >>> rfc3339_duration_to_delta("P1W")
+    datetime.timedelta(7)
+    >>> rfc3339_duration_to_delta("PT5M30S")
+    datetime.timedelta(0, 330)
+    >>> rfc3339_duration_to_delta("P1DT3M20S")
+    datetime.timedelta(1, 200)
+    """
+
+    # Parsing an RFC 3339 duration with regular expressions is not
+    # possible - there would have to be multiple places for the same
+    # values, like seconds.  The current code, while more esoteric, is
+    # cleaner without depending on a parsing library.  If Python had a
+    # built-in library for parsing we would use it, but we'd like to
+    # avoid excessive use of external libraries.
+
+    # New type for defining tokens, syntax, and semantics all-in-one
+    Token = collections.namedtuple("Token", (
+        "regexp",  # To match token; if "value" is not None, must have
+                   # a "group" containing digits
+        "value",   # datetime.timedelta or None
+        "followers"))           # Tokens valid after this token
+    # RFC 3339 "duration" tokens, syntax, and semantics; taken from
+    # the "duration" ABNF definition in RFC 3339, Appendix A.
+    token_end = Token(re.compile(r"$"), None, frozenset())
+    token_second = Token(re.compile(r"(\d+)S"),
+                         datetime.timedelta(seconds=1),
+                         frozenset((token_end, )))
+    token_minute = Token(re.compile(r"(\d+)M"),
+                         datetime.timedelta(minutes=1),
+                         frozenset((token_second, token_end)))
+    token_hour = Token(re.compile(r"(\d+)H"),
+                       datetime.timedelta(hours=1),
+                       frozenset((token_minute, token_end)))
+    token_time = Token(re.compile(r"T"),
+                       None,
+                       frozenset((token_hour, token_minute,
+                                  token_second)))
+    token_day = Token(re.compile(r"(\d+)D"),
+                      datetime.timedelta(days=1),
+                      frozenset((token_time, token_end)))
+    token_month = Token(re.compile(r"(\d+)M"),
+                        datetime.timedelta(weeks=4),
+                        frozenset((token_day, token_end)))
+    token_year = Token(re.compile(r"(\d+)Y"),
+                       datetime.timedelta(weeks=52),
+                       frozenset((token_month, token_end)))
+    token_week = Token(re.compile(r"(\d+)W"),
+                       datetime.timedelta(weeks=1),
+                       frozenset((token_end, )))
+    token_duration = Token(re.compile(r"P"), None,
+                           frozenset((token_year, token_month,
+                                      token_day, token_time,
+                                      token_week)))
+    # Define starting values:
+    # Value so far
+    value = datetime.timedelta()
+    found_token = None
+    # Following valid tokens
+    followers = frozenset((token_duration, ))
+    # String left to parse
+    s = duration
+    # Loop until end token is found
+    while found_token is not token_end:
+        # Search for any currently valid tokens
+        for token in followers:
+            match = token.regexp.match(s)
+            if match is not None:
+                # Token found
+                if token.value is not None:
+                    # Value found, parse digits
+                    factor = int(match.group(1), 10)
+                    # Add to value so far
+                    value += factor * token.value
+                # Strip token from string
+                s = token.regexp.sub("", s, 1)
+                # Go to found token
+                found_token = token
+                # Set valid next tokens
+                followers = found_token.followers
+                break
+        else:
+            # No currently valid tokens were found
+            raise ValueError("Invalid RFC 3339 duration: {!r}"
+                             .format(duration))
+    # End token found
+    return value
+
+
 def string_to_delta(interval):
     """Parse a string and return a datetime.timedelta
-    
-    >>> string_to_delta(u'7d')
+
+    >>> string_to_delta('7d')
     datetime.timedelta(7)
-    >>> string_to_delta(u'60s')
+    >>> string_to_delta('60s')
     datetime.timedelta(0, 60)
-    >>> string_to_delta(u'60m')
+    >>> string_to_delta('60m')
     datetime.timedelta(0, 3600)
-    >>> string_to_delta(u'24h')
+    >>> string_to_delta('24h')
     datetime.timedelta(1)
-    >>> string_to_delta(u'1w')
+    >>> string_to_delta('1w')
     datetime.timedelta(7)
-    >>> string_to_delta(u'5m 30s')
+    >>> string_to_delta('5m 30s')
     datetime.timedelta(0, 330)
     """
+
+    try:
+        return rfc3339_duration_to_delta(interval)
+    except ValueError:
+        pass
+
     timevalue = datetime.timedelta(0)
     for s in interval.split():
         try:
-            suffix = unicode(s[-1])
+            suffix = s[-1]
             value = int(s[:-1])
-            if suffix == u"d":
+            if suffix == "d":
                 delta = datetime.timedelta(value)
-            elif suffix == u"s":
+            elif suffix == "s":
                 delta = datetime.timedelta(0, value)
-            elif suffix == u"m":
+            elif suffix == "m":
                 delta = datetime.timedelta(0, 0, 0, 0, value)
-            elif suffix == u"h":
+            elif suffix == "h":
                 delta = datetime.timedelta(0, 0, 0, 0, 0, value)
-            elif suffix == u"w":
+            elif suffix == "w":
                 delta = datetime.timedelta(0, 0, 0, 0, 0, 0, value)
             else:
-                raise ValueError(u"Unknown suffix %r" % suffix)
-        except (ValueError, IndexError), e:
-            raise ValueError(e.message)
+                raise ValueError("Unknown suffix {!r}".format(suffix))
+        except IndexError as e:
+            raise ValueError(*(e.args))
         timevalue += delta
     return timevalue
 
 
-def if_nametoindex(interface):
-    """Call the C function if_nametoindex(), or equivalent
-    
-    Note: This function cannot accept a unicode string."""
-    global if_nametoindex
-    try:
-        if_nametoindex = (ctypes.cdll.LoadLibrary
-                          (ctypes.util.find_library(u"c"))
-                          .if_nametoindex)
-    except (OSError, AttributeError):
-        logger.warning(u"Doing if_nametoindex the hard way")
-        def if_nametoindex(interface):
-            "Get an interface index the hard way, i.e. using fcntl()"
-            SIOCGIFINDEX = 0x8933  # From /usr/include/linux/sockios.h
-            with contextlib.closing(socket.socket()) as s:
-                ifreq = fcntl.ioctl(s, SIOCGIFINDEX,
-                                    struct.pack(str(u"16s16x"),
-                                                interface))
-            interface_index = struct.unpack(str(u"I"),
-                                            ifreq[16:20])[0]
-            return interface_index
-    return if_nametoindex(interface)
-
-
-def daemon(nochdir = False, noclose = False):
+def daemon(nochdir=False, noclose=False):
     """See daemon(3).  Standard BSD Unix function.
-    
+
     This should really exist as os.daemon, but it doesn't (yet)."""
     if os.fork():
         sys.exit()
     os.setsid()
     if not nochdir:
-        os.chdir(u"/")
+        os.chdir("/")
     if os.fork():
         sys.exit()
     if not noclose:
         # Close all standard open file descriptors
-        null = os.open(os.path.devnull, os.O_NOCTTY | os.O_RDWR)
+        null = os.open(os.devnull, os.O_NOCTTY | os.O_RDWR)
         if not stat.S_ISCHR(os.fstat(null).st_mode):
             raise OSError(errno.ENODEV,
-                          u"%s not a character device"
-                          % os.path.devnull)
+                          "{} not a character device"
+                          .format(os.devnull))
         os.dup2(null, sys.stdin.fileno())
         os.dup2(null, sys.stdout.fileno())
         os.dup2(null, sys.stderr.fileno())
@@ -1668,380 +2800,691 @@
 
 
 def main():
-    
+
     ##################################################################
     # Parsing of options, both command line and config file
-    
-    parser = optparse.OptionParser(version = "%%prog %s" % version)
-    parser.add_option("-i", u"--interface", type=u"string",
-                      metavar="IF", help=u"Bind to interface IF")
-    parser.add_option("-a", u"--address", type=u"string",
-                      help=u"Address to listen for requests on")
-    parser.add_option("-p", u"--port", type=u"int",
-                      help=u"Port number to receive requests on")
-    parser.add_option("--check", action=u"store_true",
-                      help=u"Run self-test")
-    parser.add_option("--debug", action=u"store_true",
-                      help=u"Debug mode; run in foreground and log to"
-                      u" terminal")
-    parser.add_option("--debuglevel", type=u"string", metavar="LEVEL",
-                      help=u"Debug level for stdout output")
-    parser.add_option("--priority", type=u"string", help=u"GnuTLS"
-                      u" priority string (see GnuTLS documentation)")
-    parser.add_option("--servicename", type=u"string",
-                      metavar=u"NAME", help=u"Zeroconf service name")
-    parser.add_option("--configdir", type=u"string",
-                      default=u"/etc/mandos", metavar=u"DIR",
-                      help=u"Directory to search for configuration"
-                      u" files")
-    parser.add_option("--no-dbus", action=u"store_false",
-                      dest=u"use_dbus", help=u"Do not provide D-Bus"
-                      u" system bus interface")
-    parser.add_option("--no-ipv6", action=u"store_false",
-                      dest=u"use_ipv6", help=u"Do not use IPv6")
-    options = parser.parse_args()[0]
-    
+
+    parser = argparse.ArgumentParser()
+    parser.add_argument("-v", "--version", action="version",
+                        version="%(prog)s {}".format(version),
+                        help="show version number and exit")
+    parser.add_argument("-i", "--interface", metavar="IF",
+                        help="Bind to interface IF")
+    parser.add_argument("-a", "--address",
+                        help="Address to listen for requests on")
+    parser.add_argument("-p", "--port", type=int,
+                        help="Port number to receive requests on")
+    parser.add_argument("--check", action="store_true",
+                        help="Run self-test")
+    parser.add_argument("--debug", action="store_true",
+                        help="Debug mode; run in foreground and log"
+                        " to terminal", default=None)
+    parser.add_argument("--debuglevel", metavar="LEVEL",
+                        help="Debug level for stdout output")
+    parser.add_argument("--priority", help="GnuTLS"
+                        " priority string (see GnuTLS documentation)")
+    parser.add_argument("--servicename",
+                        metavar="NAME", help="Zeroconf service name")
+    parser.add_argument("--configdir",
+                        default="/etc/mandos", metavar="DIR",
+                        help="Directory to search for configuration"
+                        " files")
+    parser.add_argument("--no-dbus", action="store_false",
+                        dest="use_dbus", help="Do not provide D-Bus"
+                        " system bus interface", default=None)
+    parser.add_argument("--no-ipv6", action="store_false",
+                        dest="use_ipv6", help="Do not use IPv6",
+                        default=None)
+    parser.add_argument("--no-restore", action="store_false",
+                        dest="restore", help="Do not restore stored"
+                        " state", default=None)
+    parser.add_argument("--socket", type=int,
+                        help="Specify a file descriptor to a network"
+                        " socket to use instead of creating one")
+    parser.add_argument("--statedir", metavar="DIR",
+                        help="Directory to save/restore state in")
+    parser.add_argument("--foreground", action="store_true",
+                        help="Run in foreground", default=None)
+    parser.add_argument("--no-zeroconf", action="store_false",
+                        dest="zeroconf", help="Do not use Zeroconf",
+                        default=None)
+
+    options = parser.parse_args()
+
     if options.check:
         import doctest
-        doctest.testmod()
-        sys.exit()
-    
+        fail_count, test_count = doctest.testmod()
+        sys.exit(os.EX_OK if fail_count == 0 else 1)
+
     # Default values for config file for server-global settings
-    server_defaults = { u"interface": u"",
-                        u"address": u"",
-                        u"port": u"",
-                        u"debug": u"False",
-                        u"priority":
-                        u"SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP",
-                        u"servicename": u"Mandos",
-                        u"use_dbus": u"True",
-                        u"use_ipv6": u"True",
-                        u"debuglevel": u"",
-                        }
-    
+    server_defaults = {"interface": "",
+                       "address": "",
+                       "port": "",
+                       "debug": "False",
+                       "priority":
+                       "SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP:!RSA"
+                       ":+SIGN-DSA-SHA256",
+                       "servicename": "Mandos",
+                       "use_dbus": "True",
+                       "use_ipv6": "True",
+                       "debuglevel": "",
+                       "restore": "True",
+                       "socket": "",
+                       "statedir": "/var/lib/mandos",
+                       "foreground": "False",
+                       "zeroconf": "True",
+                       }
+
     # Parse config file for server-global settings
     server_config = configparser.SafeConfigParser(server_defaults)
     del server_defaults
-    server_config.read(os.path.join(options.configdir,
-                                    u"mandos.conf"))
+    server_config.read(os.path.join(options.configdir, "mandos.conf"))
     # Convert the SafeConfigParser object to a dict
     server_settings = server_config.defaults()
     # Use the appropriate methods on the non-string config options
-    for option in (u"debug", u"use_dbus", u"use_ipv6"):
-        server_settings[option] = server_config.getboolean(u"DEFAULT",
+    for option in ("debug", "use_dbus", "use_ipv6", "foreground"):
+        server_settings[option] = server_config.getboolean("DEFAULT",
                                                            option)
     if server_settings["port"]:
-        server_settings["port"] = server_config.getint(u"DEFAULT",
-                                                       u"port")
+        server_settings["port"] = server_config.getint("DEFAULT",
+                                                       "port")
+    if server_settings["socket"]:
+        server_settings["socket"] = server_config.getint("DEFAULT",
+                                                         "socket")
+        # Later, stdin will, and stdout and stderr might, be dup'ed
+        # over with an opened os.devnull.  But we don't want this to
+        # happen with a supplied network socket.
+        if 0 <= server_settings["socket"] <= 2:
+            server_settings["socket"] = os.dup(server_settings
+                                               ["socket"])
     del server_config
-    
+
     # Override the settings from the config file with command line
     # options, if set.
-    for option in (u"interface", u"address", u"port", u"debug",
-                   u"priority", u"servicename", u"configdir",
-                   u"use_dbus", u"use_ipv6", u"debuglevel"):
+    for option in ("interface", "address", "port", "debug",
+                   "priority", "servicename", "configdir", "use_dbus",
+                   "use_ipv6", "debuglevel", "restore", "statedir",
+                   "socket", "foreground", "zeroconf"):
         value = getattr(options, option)
         if value is not None:
             server_settings[option] = value
     del options
     # Force all strings to be unicode
     for option in server_settings.keys():
-        if type(server_settings[option]) is str:
-            server_settings[option] = unicode(server_settings[option])
+        if isinstance(server_settings[option], bytes):
+            server_settings[option] = (server_settings[option]
+                                       .decode("utf-8"))
+    # Force all boolean options to be boolean
+    for option in ("debug", "use_dbus", "use_ipv6", "restore",
+                   "foreground", "zeroconf"):
+        server_settings[option] = bool(server_settings[option])
+    # Debug implies foreground
+    if server_settings["debug"]:
+        server_settings["foreground"] = True
     # Now we have our good server settings in "server_settings"
-    
+
     ##################################################################
-    
+
+    if (not server_settings["zeroconf"]
+        and not (server_settings["port"]
+                 or server_settings["socket"] != "")):
+        parser.error("Needs port or socket to work without Zeroconf")
+
     # For convenience
-    debug = server_settings[u"debug"]
-    debuglevel = server_settings[u"debuglevel"]
-    use_dbus = server_settings[u"use_dbus"]
-    use_ipv6 = server_settings[u"use_ipv6"]
-
-    if server_settings[u"servicename"] != u"Mandos":
-        syslogger.setFormatter(logging.Formatter
-                               (u'Mandos (%s) [%%(process)d]:'
-                                u' %%(levelname)s: %%(message)s'
-                                % server_settings[u"servicename"]))
-    
+    debug = server_settings["debug"]
+    debuglevel = server_settings["debuglevel"]
+    use_dbus = server_settings["use_dbus"]
+    use_ipv6 = server_settings["use_ipv6"]
+    stored_state_path = os.path.join(server_settings["statedir"],
+                                     stored_state_file)
+    foreground = server_settings["foreground"]
+    zeroconf = server_settings["zeroconf"]
+
+    if debug:
+        initlogger(debug, logging.DEBUG)
+    else:
+        if not debuglevel:
+            initlogger(debug)
+        else:
+            level = getattr(logging, debuglevel.upper())
+            initlogger(debug, level)
+
+    if server_settings["servicename"] != "Mandos":
+        syslogger.setFormatter(
+            logging.Formatter('Mandos ({}) [%(process)d]:'
+                              ' %(levelname)s: %(message)s'.format(
+                                  server_settings["servicename"])))
+
     # Parse config file with clients
-    client_defaults = { u"timeout": u"1h",
-                        u"interval": u"5m",
-                        u"checker": u"fping -q -- %%(host)s",
-                        u"host": u"",
-                        u"approval_delay": u"0s",
-                        u"approval_duration": u"1s",
-                        }
-    client_config = configparser.SafeConfigParser(client_defaults)
-    client_config.read(os.path.join(server_settings[u"configdir"],
-                                    u"clients.conf"))
-    
+    client_config = configparser.SafeConfigParser(Client
+                                                  .client_defaults)
+    client_config.read(os.path.join(server_settings["configdir"],
+                                    "clients.conf"))
+
     global mandos_dbus_service
     mandos_dbus_service = None
-    
-    tcp_server = MandosServer((server_settings[u"address"],
-                               server_settings[u"port"]),
-                              ClientHandler,
-                              interface=(server_settings[u"interface"]
-                                         or None),
-                              use_ipv6=use_ipv6,
-                              gnutls_priority=
-                              server_settings[u"priority"],
-                              use_dbus=use_dbus)
-    if not debug:
-        pidfilename = u"/var/run/mandos.pid"
-        try:
-            pidfile = open(pidfilename, u"w")
-        except IOError:
-            logger.error(u"Could not open file %r", pidfilename)
-    
-    try:
-        uid = pwd.getpwnam(u"_mandos").pw_uid
-        gid = pwd.getpwnam(u"_mandos").pw_gid
-    except KeyError:
-        try:
-            uid = pwd.getpwnam(u"mandos").pw_uid
-            gid = pwd.getpwnam(u"mandos").pw_gid
+
+    socketfd = None
+    if server_settings["socket"] != "":
+        socketfd = server_settings["socket"]
+    tcp_server = MandosServer(
+        (server_settings["address"], server_settings["port"]),
+        ClientHandler,
+        interface=(server_settings["interface"] or None),
+        use_ipv6=use_ipv6,
+        gnutls_priority=server_settings["priority"],
+        use_dbus=use_dbus,
+        socketfd=socketfd)
+    if not foreground:
+        pidfilename = "/run/mandos.pid"
+        if not os.path.isdir("/run/."):
+            pidfilename = "/var/run/mandos.pid"
+        pidfile = None
+        try:
+            pidfile = codecs.open(pidfilename, "w", encoding="utf-8")
+        except IOError as e:
+            logger.error("Could not open file %r", pidfilename,
+                         exc_info=e)
+
+    for name, group in (("_mandos", "_mandos"),
+                        ("mandos", "mandos"),
+                        ("nobody", "nogroup")):
+        try:
+            uid = pwd.getpwnam(name).pw_uid
+            gid = pwd.getpwnam(group).pw_gid
+            break
         except KeyError:
-            try:
-                uid = pwd.getpwnam(u"nobody").pw_uid
-                gid = pwd.getpwnam(u"nobody").pw_gid
-            except KeyError:
-                uid = 65534
-                gid = 65534
+            continue
+    else:
+        uid = 65534
+        gid = 65534
     try:
         os.setgid(gid)
         os.setuid(uid)
-    except OSError, error:
-        if error[0] != errno.EPERM:
-            raise error
-    
-    if not debug and not debuglevel:
-        syslogger.setLevel(logging.WARNING)
-        console.setLevel(logging.WARNING)
-    if debuglevel:
-        level = getattr(logging, debuglevel.upper())
-        syslogger.setLevel(level)
-        console.setLevel(level)
+        if debug:
+            logger.debug("Did setuid/setgid to {}:{}".format(uid,
+                                                             gid))
+    except OSError as error:
+        logger.warning("Failed to setuid/setgid to {}:{}: {}"
+                       .format(uid, gid, os.strerror(error.errno)))
+        if error.errno != errno.EPERM:
+            raise
 
     if debug:
         # Enable all possible GnuTLS debugging
-        
+
         # "Use a log level over 10 to enable all debugging options."
         # - GnuTLS manual
-        gnutls.library.functions.gnutls_global_set_log_level(11)
-        
-        @gnutls.library.types.gnutls_log_func
+        gnutls.global_set_log_level(11)
+
+        @gnutls.log_func
         def debug_gnutls(level, string):
-            logger.debug(u"GnuTLS: %s", string[:-1])
-        
-        (gnutls.library.functions
-         .gnutls_global_set_log_function(debug_gnutls))
-        
+            logger.debug("GnuTLS: %s", string[:-1])
+
+        gnutls.global_set_log_function(debug_gnutls)
+
         # Redirect stdin so all checkers get /dev/null
-        null = os.open(os.path.devnull, os.O_NOCTTY | os.O_RDWR)
+        null = os.open(os.devnull, os.O_NOCTTY | os.O_RDWR)
         os.dup2(null, sys.stdin.fileno())
         if null > 2:
             os.close(null)
-    else:
-        # No console logging
-        logger.removeHandler(console)
-    
-    
+
+    # Need to fork before connecting to D-Bus
+    if not foreground:
+        # Close all input and output, do double fork, etc.
+        daemon()
+
+    # multiprocessing will use threads, so before we use GLib we need
+    # to inform GLib that threads will be used.
+    GLib.threads_init()
+
     global main_loop
     # From the Avahi example code
-    DBusGMainLoop(set_as_default=True )
-    main_loop = gobject.MainLoop()
+    DBusGMainLoop(set_as_default=True)
+    main_loop = GLib.MainLoop()
     bus = dbus.SystemBus()
     # End of Avahi example code
     if use_dbus:
         try:
-            bus_name = dbus.service.BusName(u"se.bsnet.fukt.Mandos",
-                                            bus, do_not_queue=True)
-        except dbus.exceptions.NameExistsException, e:
-            logger.error(unicode(e) + u", disabling D-Bus")
+            bus_name = dbus.service.BusName("se.recompile.Mandos",
+                                            bus,
+                                            do_not_queue=True)
+            old_bus_name = dbus.service.BusName(
+                "se.bsnet.fukt.Mandos", bus,
+                do_not_queue=True)
+        except dbus.exceptions.DBusException as e:
+            logger.error("Disabling D-Bus:", exc_info=e)
             use_dbus = False
-            server_settings[u"use_dbus"] = False
+            server_settings["use_dbus"] = False
             tcp_server.use_dbus = False
-    protocol = avahi.PROTO_INET6 if use_ipv6 else avahi.PROTO_INET
-    service = AvahiService(name = server_settings[u"servicename"],
-                           servicetype = u"_mandos._tcp",
-                           protocol = protocol, bus = bus)
-    if server_settings["interface"]:
-        service.interface = (if_nametoindex
-                             (str(server_settings[u"interface"])))
+    if zeroconf:
+        protocol = avahi.PROTO_INET6 if use_ipv6 else avahi.PROTO_INET
+        service = AvahiServiceToSyslog(
+            name=server_settings["servicename"],
+            servicetype="_mandos._tcp",
+            protocol=protocol,
+            bus=bus)
+        if server_settings["interface"]:
+            service.interface = if_nametoindex(
+                server_settings["interface"].encode("utf-8"))
 
-    if not debug:
-        # Close all input and output, do double fork, etc.
-        daemon()
-        
     global multiprocessing_manager
     multiprocessing_manager = multiprocessing.Manager()
-    
+
     client_class = Client
     if use_dbus:
-        client_class = functools.partial(ClientDBus, bus = bus)
-    def client_config_items(config, section):
-        special_settings = {
-            "approved_by_default":
-                lambda: config.getboolean(section,
-                                          "approved_by_default"),
-            }
-        for name, value in config.items(section):
+        client_class = functools.partial(ClientDBus, bus=bus)
+
+    client_settings = Client.config_parser(client_config)
+    old_client_settings = {}
+    clients_data = {}
+
+    # This is used to redirect stdout and stderr for checker processes
+    global wnull
+    wnull = open(os.devnull, "w")  # A writable /dev/null
+    # Only used if server is running in foreground but not in debug
+    # mode
+    if debug or not foreground:
+        wnull.close()
+
+    # Get client data and settings from last running state.
+    if server_settings["restore"]:
+        try:
+            with open(stored_state_path, "rb") as stored_state:
+                if sys.version_info.major == 2:
+                    clients_data, old_client_settings = pickle.load(
+                        stored_state)
+                else:
+                    bytes_clients_data, bytes_old_client_settings = (
+                        pickle.load(stored_state, encoding="bytes"))
+                    #   Fix bytes to strings
+                    #  clients_data
+                    # .keys()
+                    clients_data = {(key.decode("utf-8")
+                                     if isinstance(key, bytes)
+                                     else key): value
+                                    for key, value in
+                                    bytes_clients_data.items()}
+                    del bytes_clients_data
+                    for key in clients_data:
+                        value = {(k.decode("utf-8")
+                                  if isinstance(k, bytes) else k): v
+                                 for k, v in
+                                 clients_data[key].items()}
+                        clients_data[key] = value
+                        # .client_structure
+                        value["client_structure"] = [
+                            (s.decode("utf-8")
+                             if isinstance(s, bytes)
+                             else s) for s in
+                            value["client_structure"]]
+                        # .name & .host
+                        for k in ("name", "host"):
+                            if isinstance(value[k], bytes):
+                                value[k] = value[k].decode("utf-8")
+                    #  old_client_settings
+                    # .keys()
+                    old_client_settings = {
+                        (key.decode("utf-8")
+                         if isinstance(key, bytes)
+                         else key): value
+                        for key, value in
+                        bytes_old_client_settings.items()}
+                    del bytes_old_client_settings
+                    # .host
+                    for value in old_client_settings.values():
+                        if isinstance(value["host"], bytes):
+                            value["host"] = (value["host"]
+                                             .decode("utf-8"))
+            os.remove(stored_state_path)
+        except IOError as e:
+            if e.errno == errno.ENOENT:
+                logger.warning("Could not load persistent state:"
+                               " {}".format(os.strerror(e.errno)))
+            else:
+                logger.critical("Could not load persistent state:",
+                                exc_info=e)
+                raise
+        except EOFError as e:
+            logger.warning("Could not load persistent state: "
+                           "EOFError:",
+                           exc_info=e)
+
+    with PGPEngine() as pgp:
+        for client_name, client in clients_data.items():
+            # Skip removed clients
+            if client_name not in client_settings:
+                continue
+
+            # Decide which value to use after restoring saved state.
+            # We have three different values: Old config file,
+            # new config file, and saved state.
+            # New config value takes precedence if it differs from old
+            # config value, otherwise use saved state.
+            for name, value in client_settings[client_name].items():
+                try:
+                    # For each value in new config, check if it
+                    # differs from the old config value (Except for
+                    # the "secret" attribute)
+                    if (name != "secret"
+                        and (value !=
+                             old_client_settings[client_name][name])):
+                        client[name] = value
+                except KeyError:
+                    pass
+
+            # Clients who has passed its expire date can still be
+            # enabled if its last checker was successful.  A Client
+            # whose checker succeeded before we stored its state is
+            # assumed to have successfully run all checkers during
+            # downtime.
+            if client["enabled"]:
+                if datetime.datetime.utcnow() >= client["expires"]:
+                    if not client["last_checked_ok"]:
+                        logger.warning(
+                            "disabling client {} - Client never "
+                            "performed a successful checker".format(
+                                client_name))
+                        client["enabled"] = False
+                    elif client["last_checker_status"] != 0:
+                        logger.warning(
+                            "disabling client {} - Client last"
+                            " checker failed with error code"
+                            " {}".format(
+                                client_name,
+                                client["last_checker_status"]))
+                        client["enabled"] = False
+                    else:
+                        client["expires"] = (
+                            datetime.datetime.utcnow()
+                            + client["timeout"])
+                        logger.debug("Last checker succeeded,"
+                                     " keeping {} enabled".format(
+                                         client_name))
             try:
-                yield (name, special_settings[name]())
-            except KeyError:
-                yield (name, value)
-    
-    tcp_server.clients.update(set(
-            client_class(name = section,
-                         config= dict(client_config_items(
-                        client_config, section)))
-            for section in client_config.sections()))
+                client["secret"] = pgp.decrypt(
+                    client["encrypted_secret"],
+                    client_settings[client_name]["secret"])
+            except PGPError:
+                # If decryption fails, we use secret from new settings
+                logger.debug("Failed to decrypt {} old secret".format(
+                    client_name))
+                client["secret"] = (client_settings[client_name]
+                                    ["secret"])
+
+    # Add/remove clients based on new changes made to config
+    for client_name in (set(old_client_settings)
+                        - set(client_settings)):
+        del clients_data[client_name]
+    for client_name in (set(client_settings)
+                        - set(old_client_settings)):
+        clients_data[client_name] = client_settings[client_name]
+
+    # Create all client objects
+    for client_name, client in clients_data.items():
+        tcp_server.clients[client_name] = client_class(
+            name=client_name,
+            settings=client,
+            server_settings=server_settings)
+
     if not tcp_server.clients:
-        logger.warning(u"No clients defined")
-        
-    if not debug:
-        try:
-            with pidfile:
-                pid = os.getpid()
-                pidfile.write(str(pid) + "\n")
-            del pidfile
-        except IOError:
-            logger.error(u"Could not write to file %r with PID %d",
-                         pidfilename, pid)
-        except NameError:
-            # "pidfile" was never created
-            pass
+        logger.warning("No clients defined")
+
+    if not foreground:
+        if pidfile is not None:
+            pid = os.getpid()
+            try:
+                with pidfile:
+                    print(pid, file=pidfile)
+            except IOError:
+                logger.error("Could not write to file %r with PID %d",
+                             pidfilename, pid)
+        del pidfile
         del pidfilename
-        
-        signal.signal(signal.SIGINT, signal.SIG_IGN)
-
-    signal.signal(signal.SIGHUP, lambda signum, frame: sys.exit())
-    signal.signal(signal.SIGTERM, lambda signum, frame: sys.exit())
-    
+
+    for termsig in (signal.SIGHUP, signal.SIGTERM):
+        GLib.unix_signal_add(GLib.PRIORITY_HIGH, termsig,
+                             lambda: main_loop.quit() and False)
+
     if use_dbus:
-        class MandosDBusService(dbus.service.Object):
+
+        @alternate_dbus_interfaces(
+            {"se.recompile.Mandos": "se.bsnet.fukt.Mandos"})
+        class MandosDBusService(DBusObjectWithObjectManager):
             """A D-Bus proxy object"""
+
             def __init__(self):
-                dbus.service.Object.__init__(self, bus, u"/")
-            _interface = u"se.bsnet.fukt.Mandos"
-            
-            @dbus.service.signal(_interface, signature=u"o")
+                dbus.service.Object.__init__(self, bus, "/")
+
+            _interface = "se.recompile.Mandos"
+
+            @dbus.service.signal(_interface, signature="o")
             def ClientAdded(self, objpath):
                 "D-Bus signal"
                 pass
-            
-            @dbus.service.signal(_interface, signature=u"ss")
+
+            @dbus.service.signal(_interface, signature="ss")
             def ClientNotFound(self, fingerprint, address):
                 "D-Bus signal"
                 pass
-            
-            @dbus.service.signal(_interface, signature=u"os")
+
+            @dbus_annotations({"org.freedesktop.DBus.Deprecated":
+                               "true"})
+            @dbus.service.signal(_interface, signature="os")
             def ClientRemoved(self, objpath, name):
                 "D-Bus signal"
                 pass
-            
-            @dbus.service.method(_interface, out_signature=u"ao")
+
+            @dbus_annotations({"org.freedesktop.DBus.Deprecated":
+                               "true"})
+            @dbus.service.method(_interface, out_signature="ao")
             def GetAllClients(self):
                 "D-Bus method"
-                return dbus.Array(c.dbus_object_path
-                                  for c in tcp_server.clients)
-            
+                return dbus.Array(c.dbus_object_path for c in
+                                  tcp_server.clients.values())
+
+            @dbus_annotations({"org.freedesktop.DBus.Deprecated":
+                               "true"})
             @dbus.service.method(_interface,
-                                 out_signature=u"a{oa{sv}}")
+                                 out_signature="a{oa{sv}}")
             def GetAllClientsWithProperties(self):
                 "D-Bus method"
                 return dbus.Dictionary(
-                    ((c.dbus_object_path, c.GetAll(u""))
-                     for c in tcp_server.clients),
-                    signature=u"oa{sv}")
-            
-            @dbus.service.method(_interface, in_signature=u"o")
+                    {c.dbus_object_path: c.GetAll(
+                        "se.recompile.Mandos.Client")
+                     for c in tcp_server.clients.values()},
+                    signature="oa{sv}")
+
+            @dbus.service.method(_interface, in_signature="o")
             def RemoveClient(self, object_path):
                 "D-Bus method"
-                for c in tcp_server.clients:
+                for c in tcp_server.clients.values():
                     if c.dbus_object_path == object_path:
-                        tcp_server.clients.remove(c)
+                        del tcp_server.clients[c.name]
                         c.remove_from_connection()
-                        # Don't signal anything except ClientRemoved
+                        # Don't signal the disabling
                         c.disable(quiet=True)
-                        # Emit D-Bus signal
-                        self.ClientRemoved(object_path, c.name)
+                        # Emit D-Bus signal for removal
+                        self.client_removed_signal(c)
                         return
                 raise KeyError(object_path)
-            
+
             del _interface
-        
+
+            @dbus.service.method(dbus.OBJECT_MANAGER_IFACE,
+                                 out_signature="a{oa{sa{sv}}}")
+            def GetManagedObjects(self):
+                """D-Bus method"""
+                return dbus.Dictionary(
+                    {client.dbus_object_path:
+                     dbus.Dictionary(
+                         {interface: client.GetAll(interface)
+                          for interface in
+                          client._get_all_interface_names()})
+                     for client in tcp_server.clients.values()})
+
+            def client_added_signal(self, client):
+                """Send the new standard signal and the old signal"""
+                if use_dbus:
+                    # New standard signal
+                    self.InterfacesAdded(
+                        client.dbus_object_path,
+                        dbus.Dictionary(
+                            {interface: client.GetAll(interface)
+                             for interface in
+                             client._get_all_interface_names()}))
+                    # Old signal
+                    self.ClientAdded(client.dbus_object_path)
+
+            def client_removed_signal(self, client):
+                """Send the new standard signal and the old signal"""
+                if use_dbus:
+                    # New standard signal
+                    self.InterfacesRemoved(
+                        client.dbus_object_path,
+                        client._get_all_interface_names())
+                    # Old signal
+                    self.ClientRemoved(client.dbus_object_path,
+                                       client.name)
+
         mandos_dbus_service = MandosDBusService()
-    
+
+    # Save modules to variables to exempt the modules from being
+    # unloaded before the function registered with atexit() is run.
+    mp = multiprocessing
+    wn = wnull
+
     def cleanup():
         "Cleanup function; run on exit"
-        service.cleanup()
-        
+        if zeroconf:
+            service.cleanup()
+
+        mp.active_children()
+        wn.close()
+        if not (tcp_server.clients or client_settings):
+            return
+
+        # Store client before exiting. Secrets are encrypted with key
+        # based on what config file has. If config file is
+        # removed/edited, old secret will thus be unrecovable.
+        clients = {}
+        with PGPEngine() as pgp:
+            for client in tcp_server.clients.values():
+                key = client_settings[client.name]["secret"]
+                client.encrypted_secret = pgp.encrypt(client.secret,
+                                                      key)
+                client_dict = {}
+
+                # A list of attributes that can not be pickled
+                # + secret.
+                exclude = {"bus", "changedstate", "secret",
+                           "checker", "server_settings"}
+                for name, typ in inspect.getmembers(dbus.service
+                                                    .Object):
+                    exclude.add(name)
+
+                client_dict["encrypted_secret"] = (client
+                                                   .encrypted_secret)
+                for attr in client.client_structure:
+                    if attr not in exclude:
+                        client_dict[attr] = getattr(client, attr)
+
+                clients[client.name] = client_dict
+                del client_settings[client.name]["secret"]
+
+        try:
+            with tempfile.NamedTemporaryFile(
+                    mode='wb',
+                    suffix=".pickle",
+                    prefix='clients-',
+                    dir=os.path.dirname(stored_state_path),
+                    delete=False) as stored_state:
+                pickle.dump((clients, client_settings), stored_state,
+                            protocol=2)
+                tempname = stored_state.name
+            os.rename(tempname, stored_state_path)
+        except (IOError, OSError) as e:
+            if not debug:
+                try:
+                    os.remove(tempname)
+                except NameError:
+                    pass
+            if e.errno in (errno.ENOENT, errno.EACCES, errno.EEXIST):
+                logger.warning("Could not save persistent state: {}"
+                               .format(os.strerror(e.errno)))
+            else:
+                logger.warning("Could not save persistent state:",
+                               exc_info=e)
+                raise
+
+        # Delete all clients, and settings from config
         while tcp_server.clients:
-            client = tcp_server.clients.pop()
+            name, client = tcp_server.clients.popitem()
             if use_dbus:
                 client.remove_from_connection()
-            client.disable_hook = None
-            # Don't signal anything except ClientRemoved
+            # Don't signal the disabling
             client.disable(quiet=True)
+            # Emit D-Bus signal for removal
             if use_dbus:
-                # Emit D-Bus signal
-                mandos_dbus_service.ClientRemoved(client.dbus_object_path,
-                                                  client.name)
-    
+                mandos_dbus_service.client_removed_signal(client)
+        client_settings.clear()
+
     atexit.register(cleanup)
-    
-    for client in tcp_server.clients:
+
+    for client in tcp_server.clients.values():
         if use_dbus:
-            # Emit D-Bus signal
-            mandos_dbus_service.ClientAdded(client.dbus_object_path)
-        client.enable()
-    
+            # Emit D-Bus signal for adding
+            mandos_dbus_service.client_added_signal(client)
+        # Need to initiate checking of clients
+        if client.enabled:
+            client.init_checker()
+
     tcp_server.enable()
     tcp_server.server_activate()
-    
+
     # Find out what port we got
-    service.port = tcp_server.socket.getsockname()[1]
+    if zeroconf:
+        service.port = tcp_server.socket.getsockname()[1]
     if use_ipv6:
-        logger.info(u"Now listening on address %r, port %d,"
-                    " flowinfo %d, scope_id %d"
-                    % tcp_server.socket.getsockname())
+        logger.info("Now listening on address %r, port %d,"
+                    " flowinfo %d, scope_id %d",
+                    *tcp_server.socket.getsockname())
     else:                       # IPv4
-        logger.info(u"Now listening on address %r, port %d"
-                    % tcp_server.socket.getsockname())
-    
-    #service.interface = tcp_server.socket.getsockname()[3]
-    
+        logger.info("Now listening on address %r, port %d",
+                    *tcp_server.socket.getsockname())
+
+    # service.interface = tcp_server.socket.getsockname()[3]
+
     try:
-        # From the Avahi example code
-        try:
-            service.activate()
-        except dbus.exceptions.DBusException, error:
-            logger.critical(u"DBusException: %s", error)
-            cleanup()
-            sys.exit(1)
-        # End of Avahi example code
-        
-        gobject.io_add_watch(tcp_server.fileno(), gobject.IO_IN,
-                             lambda *args, **kwargs:
-                             (tcp_server.handle_request
-                              (*args[2:], **kwargs) or True))
-        
-        logger.debug(u"Starting main loop")
+        if zeroconf:
+            # From the Avahi example code
+            try:
+                service.activate()
+            except dbus.exceptions.DBusException as error:
+                logger.critical("D-Bus Exception", exc_info=error)
+                cleanup()
+                sys.exit(1)
+            # End of Avahi example code
+
+        GLib.io_add_watch(tcp_server.fileno(), GLib.IO_IN,
+                          lambda *args, **kwargs:
+                          (tcp_server.handle_request
+                           (*args[2:], **kwargs) or True))
+
+        logger.debug("Starting main loop")
         main_loop.run()
-    except AvahiError, error:
-        logger.critical(u"AvahiError: %s", error)
+    except AvahiError as error:
+        logger.critical("Avahi Error", exc_info=error)
         cleanup()
         sys.exit(1)
     except KeyboardInterrupt:
         if debug:
-            print >> sys.stderr
-        logger.debug(u"Server received KeyboardInterrupt")
-    logger.debug(u"Server exiting")
+            print("", file=sys.stderr)
+        logger.debug("Server received KeyboardInterrupt")
+    logger.debug("Server exiting")
     # Must run before the D-Bus bus name gets deregistered
     cleanup()
 
+
 if __name__ == '__main__':
     main()

=== modified file 'mandos-clients.conf.xml'
--- mandos-clients.conf.xml	2010-09-27 18:57:12 +0000
+++ mandos-clients.conf.xml	2016-06-23 19:19:33 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY CONFNAME "mandos-clients.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/clients.conf</filename>">
-<!ENTITY TIMESTAMP "2010-09-26">
+<!ENTITY TIMESTAMP "2016-06-23">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -20,14 +20,14 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@fukt.bsnet.se</email>
+	  <email>belorn@recompile.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@fukt.bsnet.se</email>
+	  <email>teddy@recompile.se</email>
 	</address>
       </author>
     </authorgroup>
@@ -35,6 +35,12 @@
       <year>2008</year>
       <year>2009</year>
       <year>2010</year>
+      <year>2011</year>
+      <year>2012</year>
+      <year>2013</year>
+      <year>2014</year>
+      <year>2015</year>
+      <year>2016</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -64,8 +70,13 @@
       ><refentrytitle>mandos</refentrytitle>
       <manvolnum>8</manvolnum></citerefentry>, read by it at startup.
       The file needs to list all clients that should be able to use
-      the service.  All clients listed will be regarded as enabled,
-      even if a client was disabled in a previous run of the server.
+      the service.  The settings in this file can be overridden by
+      runtime changes to the server, which it saves across restarts.
+      (See the section called <quote>PERSISTENT STATE</quote> in
+      <citerefentry><refentrytitle>mandos</refentrytitle><manvolnum
+      >8</manvolnum></citerefentry>.)  However, any <emphasis
+      >changes</emphasis> to this file (including adding and removing
+      clients) will, at startup, override changes done during runtime.
     </para>
     <para>
       The format starts with a <literal>[<replaceable>section
@@ -110,7 +121,7 @@
 	  <para>
 	    How long to wait for external approval before resorting to
 	    use the <option>approved_by_default</option> value.  The
-	    default is <quote>0s</quote>, i.e. not to wait.
+	    default is <quote>PT0S</quote>, i.e. not to wait.
 	  </para>
 	  <para>
 	    The format of <replaceable>TIME</replaceable> is the same
@@ -160,17 +171,23 @@
 	    This option is <emphasis>optional</emphasis>.
 	  </para>
 	  <para>
-	    This option allows you to override the default shell
-	    command that the server will use to check if the client is
-	    still up.  Any output of the command will be ignored, only
-	    the exit code is checked:  If the exit code of the command
-	    is zero, the client is considered up.  The command will be
-	    run using <quote><command><filename>/bin/sh</filename>
+	    This option overrides the default shell command that the
+	    server will use to check if the client is still up.  Any
+	    output of the command will be ignored, only the exit code
+	    is checked:  If the exit code of the command is zero, the
+	    client is considered up.  The command will be run using
+	    <quote><command><filename>/bin/sh</filename>
 	    <option>-c</option></command></quote>, so
 	    <varname>PATH</varname> will be searched.  The default
 	    value for the checker command is <quote><literal
 	    ><command>fping</command> <option>-q</option> <option
-	    >--</option> %%(host)s</literal></quote>.
+	    >--</option> %%(host)s</literal></quote>.  Note that
+	    <command>mandos-keygen</command>, when generating output
+	    to be inserted into this file, normally looks for an SSH
+	    server on the Mandos client, and, if it find one, outputs
+	    a <option>checker</option> option to check for the
+	    client’s key fingerprint – this is more secure against
+	    spoofing.
 	  </para>
 	  <para>
 	    In addition to normal start time expansion, this option
@@ -181,6 +198,29 @@
       </varlistentry>
       
       <varlistentry>
+	<term><option>extended_timeout<literal> = </literal><replaceable
+	>TIME</replaceable></option></term>
+	<listitem>
+	  <para>
+	    This option is <emphasis>optional</emphasis>.
+	  </para>
+	  <para>
+	    Extended timeout is an added timeout that is given once
+	    after a password has been sent successfully to a client.
+	    The timeout is by default longer than the normal timeout,
+	    and is used for handling the extra long downtime while a
+	    machine is booting up.  Time to take into consideration
+	    when changing this value is file system checks and quota
+	    checks.  The default value is 15 minutes.
+	  </para>
+	  <para>
+	    The format of <replaceable>TIME</replaceable> is the same
+	    as for <varname>timeout</varname> below.
+	  </para>
+	</listitem>
+      </varlistentry>
+      
+      <varlistentry>
 	<term><option>fingerprint<literal> = </literal
 	><replaceable>HEXSTRING</replaceable></option></term>
 	<listitem>
@@ -190,7 +230,7 @@
 	  <para>
 	    This option sets the OpenPGP fingerprint that identifies
 	    the public key that clients authenticate themselves with
-	    through TLS.  The string needs to be in hexidecimal form,
+	    through TLS.  The string needs to be in hexadecimal form,
 	    but spaces or upper/lower case are not significant.
 	  </para>
 	</listitem>
@@ -228,7 +268,7 @@
 	    will wait for a checker to complete until the below
 	    <quote><varname>timeout</varname></quote> occurs, at which
 	    time the client will be disabled, and any running checker
-	    killed.  The default interval is 5 minutes.
+	    killed.  The default interval is 2 minutes.
 	  </para>
 	  <para>
 	    The format of <replaceable>TIME</replaceable> is the same
@@ -298,23 +338,33 @@
 	    This option is <emphasis>optional</emphasis>.
 	  </para>
 	  <para>
-	    The timeout is how long the server will wait (for either a
-	    successful checker run or a client receiving its secret)
-	    until a client is disabled and not allowed to get the data
-	    this server holds.  By default Mandos will use 1 hour.
-	  </para>
-	  <para>
-	    The <replaceable>TIME</replaceable> is specified as a
-	    space-separated number of values, each of which is a
-	    number and a one-character suffix.  The suffix must be one
-	    of <quote>d</quote>, <quote>s</quote>, <quote>m</quote>,
-	    <quote>h</quote>, and <quote>w</quote> for days, seconds,
-	    minutes, hours, and weeks, respectively.  The values are
-	    added together to give the total time value, so all of
-	    <quote><literal>330s</literal></quote>,
-	    <quote><literal>110s 110s 110s</literal></quote>, and
-	    <quote><literal>5m 30s</literal></quote> will give a value
-	    of five minutes and thirty seconds.
+	    The timeout is how long the server will wait, after a
+	    successful checker run, until a client is disabled and not
+	    allowed to get the data this server holds.  By default
+	    Mandos will use 5 minutes.  See also the
+	    <option>extended_timeout</option> option.
+	  </para>
+	  <para>
+	    The <replaceable>TIME</replaceable> is specified as an RFC
+	    3339 duration; for example
+	    <quote><literal>P1Y2M3DT4H5M6S</literal></quote> meaning
+	    one year, two months, three days, four hours, five
+	    minutes, and six seconds.  Some values can be omitted, see
+	    RFC 3339 Appendix A for details.
+	  </para>
+	</listitem>
+      </varlistentry>
+      
+      <varlistentry>
+	<term><option>enabled<literal> = </literal>{ <literal
+	>1</literal> | <literal>yes</literal> |	<literal>true</literal
+	> | <literal >on</literal> | <literal>0</literal> | <literal
+	>no</literal> | <literal>false</literal> | <literal
+	>off</literal> }</option></term>
+	<listitem>
+	  <para>
+	    Whether this client should be enabled by default.  The
+	    default is <quote>true</quote>.
 	  </para>
 	</listitem>
       </varlistentry>
@@ -364,6 +414,7 @@
 	<quote><literal>approval_duration</literal></quote>,
 	<quote><literal>created</literal></quote>,
 	<quote><literal>enabled</literal></quote>,
+	<quote><literal>expires</literal></quote>,
 	<quote><literal>fingerprint</literal></quote>,
 	<quote><literal>host</literal></quote>,
 	<quote><literal>interval</literal></quote>,
@@ -412,6 +463,7 @@
       <literal>%(<replaceable>foo</replaceable>)s</literal> is
       obscure.
     </para>
+    <xi:include href="bugs.xml"/>
   </refsect1>
   
   <refsect1 id="example">
@@ -419,8 +471,8 @@
     <informalexample>
       <programlisting>
 [DEFAULT]
-timeout = 1h
-interval = 5m
+timeout = PT5M
+interval = PT2M
 checker = fping -q -- %%(host)s
 
 # Client "foo"
@@ -443,15 +495,15 @@
         4T2zw4dxS5NswXWU0sVEXxjs6PYxuIiCTL7vdpx8QjBkrPWDrAbcMyBr2O
         QlnHIvPzEArRQLo=
 host = foo.example.org
-interval = 1m
+interval = PT1M
 
 # Client "bar"
 [bar]
 fingerprint = 3e393aeaefb84c7e89e2f547b3a107558fca3a27
 secfile = /etc/mandos/bar-secret
-timeout = 15m
+timeout = PT15M
 approved_by_default = False
-approval_delay = 30s
+approval_delay = PT30S
       </programlisting>
     </informalexample>
   </refsect1>
@@ -459,13 +511,31 @@
   <refsect1 id="see_also">
     <title>SEE ALSO</title>
     <para>
+      <citerefentry><refentrytitle>intro</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>mandos-keygen</refentrytitle>
       <manvolnum>8</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>mandos.conf</refentrytitle>
       <manvolnum>5</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>mandos</refentrytitle>
+      <manvolnum>8</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>fping</refentrytitle>
       <manvolnum>8</manvolnum></citerefentry>
     </para>
+    <variablelist>
+      <varlistentry>
+	<term>
+	  RFC 3339: <citetitle>Date and Time on the Internet:
+	  Timestamps</citetitle>
+	</term>
+      <listitem>
+	<para>
+	  The time intervals are in the "duration" format, as
+	  specified in ABNF in Appendix A of RFC 3339.
+	</para>
+      </listitem>
+      </varlistentry>
+    </variablelist>
   </refsect1>
 </refentry>
 <!-- Local Variables: -->

=== modified file 'mandos-ctl'
--- mandos-ctl	2010-10-02 17:23:41 +0000
+++ mandos-ctl	2016-10-08 04:33:04 +0000
@@ -1,11 +1,11 @@
 #!/usr/bin/python
 # -*- mode: python; coding: utf-8 -*-
-# 
+#
 # Mandos Monitor - Control and monitor the Mandos server
-# 
-# Copyright © 2008-2010 Teddy Hogeborn
-# Copyright © 2008-2010 Björn Påhlsson
-# 
+#
+# Copyright © 2008-2016 Teddy Hogeborn
+# Copyright © 2008-2016 Björn Påhlsson
+#
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 # the Free Software Foundation, either version 3 of the License, or
@@ -15,64 +15,181 @@
 #     but WITHOUT ANY WARRANTY; without even the implied warranty of
 #     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 #     GNU General Public License for more details.
-# 
+#
 # You should have received a copy of the GNU General Public License
-# along with this program.  If not, see <http://www.gnu.org/licenses/>.
-# 
-# Contact the authors at <mandos@fukt.bsnet.se>.
-# 
-
-from __future__ import division
+# along with this program.  If not, see
+# <http://www.gnu.org/licenses/>.
+#
+# Contact the authors at <mandos@recompile.se>.
+#
+
+from __future__ import (division, absolute_import, print_function,
+                        unicode_literals)
+
+try:
+    from future_builtins import *
+except ImportError:
+    pass
+
 import sys
-import dbus
-from optparse import OptionParser
+import argparse
 import locale
 import datetime
 import re
 import os
-
-locale.setlocale(locale.LC_ALL, u'')
+import collections
+import doctest
+import json
+
+import dbus
+
+if sys.version_info.major == 2:
+    str = unicode
+
+locale.setlocale(locale.LC_ALL, "")
 
 tablewords = {
-    'Name': u'Name',
-    'Enabled': u'Enabled',
-    'Timeout': u'Timeout',
-    'LastCheckedOK': u'Last Successful Check',
-    'LastApprovalRequest': u'Last Approval Request',
-    'Created': u'Created',
-    'Interval': u'Interval',
-    'Host': u'Host',
-    'Fingerprint': u'Fingerprint',
-    'CheckerRunning': u'Check Is Running',
-    'LastEnabled': u'Last Enabled',
-    'ApprovalPending': u'Approval Is Pending',
-    'ApprovedByDefault': u'Approved By Default',
-    'ApprovalDelay': u"Approval Delay",
-    'ApprovalDuration': u"Approval Duration",
-    'Checker': u'Checker',
-    }
-defaultkeywords = ('Name', 'Enabled', 'Timeout', 'LastCheckedOK')
-domain = 'se.bsnet.fukt'
-busname = domain + '.Mandos'
-server_path = '/'
-server_interface = domain + '.Mandos'
-client_interface = domain + '.Mandos.Client'
-version = "1.2.1"
-
-def timedelta_to_milliseconds(td):
-    "Convert a datetime.timedelta object to milliseconds"
-    return ((td.days * 24 * 60 * 60 * 1000)
-            + (td.seconds * 1000)
-            + (td.microseconds // 1000))
+    "Name": "Name",
+    "Enabled": "Enabled",
+    "Timeout": "Timeout",
+    "LastCheckedOK": "Last Successful Check",
+    "LastApprovalRequest": "Last Approval Request",
+    "Created": "Created",
+    "Interval": "Interval",
+    "Host": "Host",
+    "Fingerprint": "Fingerprint",
+    "CheckerRunning": "Check Is Running",
+    "LastEnabled": "Last Enabled",
+    "ApprovalPending": "Approval Is Pending",
+    "ApprovedByDefault": "Approved By Default",
+    "ApprovalDelay": "Approval Delay",
+    "ApprovalDuration": "Approval Duration",
+    "Checker": "Checker",
+    "ExtendedTimeout": "Extended Timeout",
+    "Expires": "Expires",
+    "LastCheckerStatus": "Last Checker Status",
+}
+defaultkeywords = ("Name", "Enabled", "Timeout", "LastCheckedOK")
+domain = "se.recompile"
+busname = domain + ".Mandos"
+server_path = "/"
+server_interface = domain + ".Mandos"
+client_interface = domain + ".Mandos.Client"
+version = "1.7.13"
+
+
+try:
+    dbus.OBJECT_MANAGER_IFACE
+except AttributeError:
+    dbus.OBJECT_MANAGER_IFACE = "org.freedesktop.DBus.ObjectManager"
+
 
 def milliseconds_to_string(ms):
     td = datetime.timedelta(0, 0, 0, ms)
-    return (u"%(days)s%(hours)02d:%(minutes)02d:%(seconds)02d"
-            % { "days": "%dT" % td.days if td.days else "",
-                "hours": td.seconds // 3600,
-                "minutes": (td.seconds % 3600) // 60,
-                "seconds": td.seconds % 60,
-                })
+    return ("{days}{hours:02}:{minutes:02}:{seconds:02}"
+            .format(days="{}T".format(td.days) if td.days else "",
+                    hours=td.seconds // 3600,
+                    minutes=(td.seconds % 3600) // 60,
+                    seconds=td.seconds % 60))
+
+
+def rfc3339_duration_to_delta(duration):
+    """Parse an RFC 3339 "duration" and return a datetime.timedelta
+
+    >>> rfc3339_duration_to_delta("P7D")
+    datetime.timedelta(7)
+    >>> rfc3339_duration_to_delta("PT60S")
+    datetime.timedelta(0, 60)
+    >>> rfc3339_duration_to_delta("PT60M")
+    datetime.timedelta(0, 3600)
+    >>> rfc3339_duration_to_delta("PT24H")
+    datetime.timedelta(1)
+    >>> rfc3339_duration_to_delta("P1W")
+    datetime.timedelta(7)
+    >>> rfc3339_duration_to_delta("PT5M30S")
+    datetime.timedelta(0, 330)
+    >>> rfc3339_duration_to_delta("P1DT3M20S")
+    datetime.timedelta(1, 200)
+    """
+
+    # Parsing an RFC 3339 duration with regular expressions is not
+    # possible - there would have to be multiple places for the same
+    # values, like seconds.  The current code, while more esoteric, is
+    # cleaner without depending on a parsing library.  If Python had a
+    # built-in library for parsing we would use it, but we'd like to
+    # avoid excessive use of external libraries.
+
+    # New type for defining tokens, syntax, and semantics all-in-one
+    Token = collections.namedtuple("Token", (
+        "regexp",  # To match token; if "value" is not None, must have
+                   # a "group" containing digits
+        "value",   # datetime.timedelta or None
+        "followers"))           # Tokens valid after this token
+    # RFC 3339 "duration" tokens, syntax, and semantics; taken from
+    # the "duration" ABNF definition in RFC 3339, Appendix A.
+    token_end = Token(re.compile(r"$"), None, frozenset())
+    token_second = Token(re.compile(r"(\d+)S"),
+                         datetime.timedelta(seconds=1),
+                         frozenset((token_end, )))
+    token_minute = Token(re.compile(r"(\d+)M"),
+                         datetime.timedelta(minutes=1),
+                         frozenset((token_second, token_end)))
+    token_hour = Token(re.compile(r"(\d+)H"),
+                       datetime.timedelta(hours=1),
+                       frozenset((token_minute, token_end)))
+    token_time = Token(re.compile(r"T"),
+                       None,
+                       frozenset((token_hour, token_minute,
+                                  token_second)))
+    token_day = Token(re.compile(r"(\d+)D"),
+                      datetime.timedelta(days=1),
+                      frozenset((token_time, token_end)))
+    token_month = Token(re.compile(r"(\d+)M"),
+                        datetime.timedelta(weeks=4),
+                        frozenset((token_day, token_end)))
+    token_year = Token(re.compile(r"(\d+)Y"),
+                       datetime.timedelta(weeks=52),
+                       frozenset((token_month, token_end)))
+    token_week = Token(re.compile(r"(\d+)W"),
+                       datetime.timedelta(weeks=1),
+                       frozenset((token_end, )))
+    token_duration = Token(re.compile(r"P"), None,
+                           frozenset((token_year, token_month,
+                                      token_day, token_time,
+                                      token_week)))
+    # Define starting values:
+    # Value so far
+    value = datetime.timedelta()
+    found_token = None
+    # Following valid tokens
+    followers = frozenset((token_duration, ))
+    # String left to parse
+    s = duration
+    # Loop until end token is found
+    while found_token is not token_end:
+        # Search for any currently valid tokens
+        for token in followers:
+            match = token.regexp.match(s)
+            if match is not None:
+                # Token found
+                if token.value is not None:
+                    # Value found, parse digits
+                    factor = int(match.group(1), 10)
+                    # Add to value so far
+                    value += factor * token.value
+                # Strip token from string
+                s = token.regexp.sub("", s, 1)
+                # Go to found token
+                found_token = token
+                # Set valid next tokens
+                followers = found_token.followers
+                break
+        else:
+            # No currently valid tokens were found
+            raise ValueError("Invalid RFC 3339 duration: {!r}"
+                             .format(duration))
+    # End token found
+    return value
 
 
 def string_to_delta(interval):
@@ -86,57 +203,59 @@
     datetime.timedelta(0, 3600)
     >>> string_to_delta('24h')
     datetime.timedelta(1)
-    >>> string_to_delta(u'1w')
+    >>> string_to_delta('1w')
     datetime.timedelta(7)
     >>> string_to_delta('5m 30s')
     datetime.timedelta(0, 330)
     """
-    timevalue = datetime.timedelta(0)
-    regexp = re.compile("\d+[dsmhw]")
-    
-    for s in regexp.findall(interval):
-        try:
-            suffix = unicode(s[-1])
-            value = int(s[:-1])
-            if suffix == u"d":
-                delta = datetime.timedelta(value)
-            elif suffix == u"s":
-                delta = datetime.timedelta(0, value)
-            elif suffix == u"m":
-                delta = datetime.timedelta(0, 0, 0, 0, value)
-            elif suffix == u"h":
-                delta = datetime.timedelta(0, 0, 0, 0, 0, value)
-            elif suffix == u"w":
-                delta = datetime.timedelta(0, 0, 0, 0, 0, 0, value)
-            else:
-                raise ValueError
-        except (ValueError, IndexError):
-            raise ValueError
-        timevalue += delta
-    return timevalue
+
+    try:
+        return rfc3339_duration_to_delta(interval)
+    except ValueError:
+        pass
+
+    value = datetime.timedelta(0)
+    regexp = re.compile(r"(\d+)([dsmhw]?)")
+
+    for num, suffix in regexp.findall(interval):
+        if suffix == "d":
+            value += datetime.timedelta(int(num))
+        elif suffix == "s":
+            value += datetime.timedelta(0, int(num))
+        elif suffix == "m":
+            value += datetime.timedelta(0, 0, 0, 0, int(num))
+        elif suffix == "h":
+            value += datetime.timedelta(0, 0, 0, 0, 0, int(num))
+        elif suffix == "w":
+            value += datetime.timedelta(0, 0, 0, 0, 0, 0, int(num))
+        elif suffix == "":
+            value += datetime.timedelta(0, 0, 0, int(num))
+    return value
+
 
 def print_clients(clients, keywords):
     def valuetostring(value, keyword):
         if type(value) is dbus.Boolean:
-            return u"Yes" if value else u"No"
-        if keyword in (u"Timeout", u"Interval", u"ApprovalDelay",
-                       u"ApprovalDuration"):
+            return "Yes" if value else "No"
+        if keyword in ("Timeout", "Interval", "ApprovalDelay",
+                       "ApprovalDuration", "ExtendedTimeout"):
             return milliseconds_to_string(value)
-        return unicode(value)
-    
+        return str(value)
+
     # Create format string to print table rows
-    format_string = u' '.join(u'%%-%ds' %
-                              max(len(tablewords[key]),
-                                  max(len(valuetostring(client[key],
-                                                        key))
-                                      for client in
-                                      clients))
-                              for key in keywords)
+    format_string = " ".join("{{{key}:{width}}}".format(
+        width=max(len(tablewords[key]),
+                  max(len(valuetostring(client[key], key))
+                      for client in clients)),
+        key=key)
+                             for key in keywords)
     # Print header line
-    print format_string % tuple(tablewords[key] for key in keywords)
+    print(format_string.format(**tablewords))
     for client in clients:
-        print format_string % tuple(valuetostring(client[key], key)
-                                    for key in keywords)
+        print(format_string
+              .format(**{key: valuetostring(client[key], key)
+                         for key in keywords}))
+
 
 def has_actions(options):
     return any((options.enable,
@@ -148,6 +267,7 @@
                 options.remove,
                 options.checker is not None,
                 options.timeout is not None,
+                options.extended_timeout is not None,
                 options.interval is not None,
                 options.approved_by_default is not None,
                 options.approval_delay is not None,
@@ -156,182 +276,221 @@
                 options.secret is not None,
                 options.approve,
                 options.deny))
-        
+
+
 def main():
-	parser = OptionParser(version = "%%prog %s" % version)
-	parser.add_option("-a", "--all", action="store_true",
-	                  help="Select all clients")
-	parser.add_option("-v", "--verbose", action="store_true",
-	                  help="Print all fields")
-	parser.add_option("-e", "--enable", action="store_true",
-	                  help="Enable client")
-	parser.add_option("-d", "--disable", action="store_true",
-	                  help="disable client")
-	parser.add_option("-b", "--bump-timeout", action="store_true",
-	                  help="Bump timeout for client")
-	parser.add_option("--start-checker", action="store_true",
-	                  help="Start checker for client")
-	parser.add_option("--stop-checker", action="store_true",
-	                  help="Stop checker for client")
-	parser.add_option("-V", "--is-enabled", action="store_true",
-	                  help="Check if client is enabled")
-	parser.add_option("-r", "--remove", action="store_true",
-	                  help="Remove client")
-	parser.add_option("-c", "--checker", type="string",
-	                  help="Set checker command for client")
-	parser.add_option("-t", "--timeout", type="string",
-	                  help="Set timeout for client")
-	parser.add_option("-i", "--interval", type="string",
-	                  help="Set checker interval for client")
-        parser.add_option("--approve-by-default", action="store_true",
-                          dest=u"approved_by_default",
-                          help="Set client to be approved by default")
-        parser.add_option("--deny-by-default", action="store_false",
-                          dest=u"approved_by_default",
-                          help="Set client to be denied by default")
-        parser.add_option("--approval-delay", type="string",
-                          help="Set delay before client approve/deny")
-        parser.add_option("--approval-duration", type="string",
-                          help="Set duration of one client approval")
-	parser.add_option("-H", "--host", type="string",
-	                  help="Set host for client")
-	parser.add_option("-s", "--secret", type="string",
-	                  help="Set password blob (file) for client")
-	parser.add_option("-A", "--approve", action="store_true",
-	                  help="Approve any current client request")
-	parser.add_option("-D", "--deny", action="store_true",
-	                  help="Deny any current client request")
-	options, client_names = parser.parse_args()
-        
-        if has_actions(options) and not client_names and not options.all:
-            parser.error('Options require clients names or --all.')
-        if options.verbose and has_actions(options):
-            parser.error('--verbose can only be used alone or with'
-                         ' --all.')
-        if options.all and not has_actions(options):
-            parser.error('--all requires an action.')
-        
-        try:
-            bus = dbus.SystemBus()
-            mandos_dbus_objc = bus.get_object(busname, server_path)
-        except dbus.exceptions.DBusException:
-            print >> sys.stderr, "Could not connect to Mandos server"
-            sys.exit(1)
-    
-        mandos_serv = dbus.Interface(mandos_dbus_objc,
-                                     dbus_interface = server_interface)
-
-        #block stderr since dbus library prints to stderr
-        null = os.open(os.path.devnull, os.O_RDWR)
-        stderrcopy = os.dup(sys.stderr.fileno())
-        os.dup2(null, sys.stderr.fileno())
-        os.close(null)
-        try:
-            try:
-                mandos_clients = mandos_serv.GetAllClientsWithProperties()
-            finally:
-                #restore stderr
-                os.dup2(stderrcopy, sys.stderr.fileno())
-                os.close(stderrcopy)
-        except dbus.exceptions.DBusException, e:
-            print >> sys.stderr, "Access denied: Accessing mandos server through dbus."
-            sys.exit(1)
-            
-	# Compile dict of (clients: properties) to process
-	clients={}
-        
-        if options.all or not client_names:
-            clients = dict((bus.get_object(busname, path), properties)
-                           for path, properties in
-                           mandos_clients.iteritems())
-        else:
-            for name in client_names:
-                for path, client in mandos_clients.iteritems():
-                    if client['Name'] == name:
-                        client_objc = bus.get_object(busname, path)
-                        clients[client_objc] = client
-                        break
+    parser = argparse.ArgumentParser()
+    parser.add_argument("--version", action="version",
+                        version="%(prog)s {}".format(version),
+                        help="show version number and exit")
+    parser.add_argument("-a", "--all", action="store_true",
+                        help="Select all clients")
+    parser.add_argument("-v", "--verbose", action="store_true",
+                        help="Print all fields")
+    parser.add_argument("-j", "--dump-json", action="store_true",
+                        help="Dump client data in JSON format")
+    parser.add_argument("-e", "--enable", action="store_true",
+                        help="Enable client")
+    parser.add_argument("-d", "--disable", action="store_true",
+                        help="disable client")
+    parser.add_argument("-b", "--bump-timeout", action="store_true",
+                        help="Bump timeout for client")
+    parser.add_argument("--start-checker", action="store_true",
+                        help="Start checker for client")
+    parser.add_argument("--stop-checker", action="store_true",
+                        help="Stop checker for client")
+    parser.add_argument("-V", "--is-enabled", action="store_true",
+                        help="Check if client is enabled")
+    parser.add_argument("-r", "--remove", action="store_true",
+                        help="Remove client")
+    parser.add_argument("-c", "--checker",
+                        help="Set checker command for client")
+    parser.add_argument("-t", "--timeout",
+                        help="Set timeout for client")
+    parser.add_argument("--extended-timeout",
+                        help="Set extended timeout for client")
+    parser.add_argument("-i", "--interval",
+                        help="Set checker interval for client")
+    parser.add_argument("--approve-by-default", action="store_true",
+                        default=None, dest="approved_by_default",
+                        help="Set client to be approved by default")
+    parser.add_argument("--deny-by-default", action="store_false",
+                        dest="approved_by_default",
+                        help="Set client to be denied by default")
+    parser.add_argument("--approval-delay",
+                        help="Set delay before client approve/deny")
+    parser.add_argument("--approval-duration",
+                        help="Set duration of one client approval")
+    parser.add_argument("-H", "--host", help="Set host for client")
+    parser.add_argument("-s", "--secret",
+                        type=argparse.FileType(mode="rb"),
+                        help="Set password blob (file) for client")
+    parser.add_argument("-A", "--approve", action="store_true",
+                        help="Approve any current client request")
+    parser.add_argument("-D", "--deny", action="store_true",
+                        help="Deny any current client request")
+    parser.add_argument("--check", action="store_true",
+                        help="Run self-test")
+    parser.add_argument("client", nargs="*", help="Client name")
+    options = parser.parse_args()
+
+    if has_actions(options) and not (options.client or options.all):
+        parser.error("Options require clients names or --all.")
+    if options.verbose and has_actions(options):
+        parser.error("--verbose can only be used alone.")
+    if options.dump_json and (options.verbose
+                              or has_actions(options)):
+        parser.error("--dump-json can only be used alone.")
+    if options.all and not has_actions(options):
+        parser.error("--all requires an action.")
+
+    if options.check:
+        fail_count, test_count = doctest.testmod()
+        sys.exit(os.EX_OK if fail_count == 0 else 1)
+
+    try:
+        bus = dbus.SystemBus()
+        mandos_dbus_objc = bus.get_object(busname, server_path)
+    except dbus.exceptions.DBusException:
+        print("Could not connect to Mandos server", file=sys.stderr)
+        sys.exit(1)
+
+    mandos_serv = dbus.Interface(mandos_dbus_objc,
+                                 dbus_interface=server_interface)
+    mandos_serv_object_manager = dbus.Interface(
+        mandos_dbus_objc, dbus_interface=dbus.OBJECT_MANAGER_IFACE)
+
+    # block stderr since dbus library prints to stderr
+    null = os.open(os.path.devnull, os.O_RDWR)
+    stderrcopy = os.dup(sys.stderr.fileno())
+    os.dup2(null, sys.stderr.fileno())
+    os.close(null)
+    try:
+        try:
+            mandos_clients = {path: ifs_and_props[client_interface]
+                              for path, ifs_and_props in
+                              mandos_serv_object_manager
+                              .GetManagedObjects().items()
+                              if client_interface in ifs_and_props}
+        finally:
+            # restore stderr
+            os.dup2(stderrcopy, sys.stderr.fileno())
+            os.close(stderrcopy)
+    except dbus.exceptions.DBusException as e:
+        print("Access denied: "
+              "Accessing mandos server through D-Bus: {}".format(e),
+              file=sys.stderr)
+        sys.exit(1)
+
+    # Compile dict of (clients: properties) to process
+    clients = {}
+
+    if options.all or not options.client:
+        clients = {bus.get_object(busname, path): properties
+                   for path, properties in mandos_clients.items()}
+    else:
+        for name in options.client:
+            for path, client in mandos_clients.items():
+                if client["Name"] == name:
+                    client_objc = bus.get_object(busname, path)
+                    clients[client_objc] = client
+                    break
+            else:
+                print("Client not found on server: {!r}"
+                      .format(name), file=sys.stderr)
+                sys.exit(1)
+
+    if not has_actions(options) and clients:
+        if options.verbose or options.dump_json:
+            keywords = ("Name", "Enabled", "Timeout", "LastCheckedOK",
+                        "Created", "Interval", "Host", "Fingerprint",
+                        "CheckerRunning", "LastEnabled",
+                        "ApprovalPending", "ApprovedByDefault",
+                        "LastApprovalRequest", "ApprovalDelay",
+                        "ApprovalDuration", "Checker",
+                        "ExtendedTimeout", "Expires",
+                        "LastCheckerStatus")
+        else:
+            keywords = defaultkeywords
+
+        if options.dump_json:
+            json.dump({client["Name"]: {key:
+                                        bool(client[key])
+                                        if isinstance(client[key],
+                                                      dbus.Boolean)
+                                        else client[key]
+                                        for key in keywords}
+                       for client in clients.values()},
+                      fp=sys.stdout, indent=4,
+                      separators=(',', ': '))
+            print()
+        else:
+            print_clients(clients.values(), keywords)
+    else:
+        # Process each client in the list by all selected options
+        for client in clients:
+
+            def set_client_prop(prop, value):
+                """Set a Client D-Bus property"""
+                client.Set(client_interface, prop, value,
+                           dbus_interface=dbus.PROPERTIES_IFACE)
+
+            def set_client_prop_ms(prop, value):
+                """Set a Client D-Bus property, converted
+                from a string to milliseconds."""
+                set_client_prop(prop,
+                                string_to_delta(value).total_seconds()
+                                * 1000)
+
+            if options.remove:
+                mandos_serv.RemoveClient(client.__dbus_object_path__)
+            if options.enable:
+                set_client_prop("Enabled", dbus.Boolean(True))
+            if options.disable:
+                set_client_prop("Enabled", dbus.Boolean(False))
+            if options.bump_timeout:
+                set_client_prop("LastCheckedOK", "")
+            if options.start_checker:
+                set_client_prop("CheckerRunning", dbus.Boolean(True))
+            if options.stop_checker:
+                set_client_prop("CheckerRunning", dbus.Boolean(False))
+            if options.is_enabled:
+                if client.Get(client_interface, "Enabled",
+                              dbus_interface=dbus.PROPERTIES_IFACE):
+                    sys.exit(0)
                 else:
-                    print >> sys.stderr, "Client not found on server: %r" % name
                     sys.exit(1)
-            
-	if not has_actions(options) and clients:
-	    if options.verbose:
-	        keywords = ('Name', 'Enabled', 'Timeout',
-                            'LastCheckedOK', 'Created', 'Interval',
-                            'Host', 'Fingerprint', 'CheckerRunning',
-                            'LastEnabled', 'ApprovalPending',
-                            'ApprovedByDefault',
-                            'LastApprovalRequest', 'ApprovalDelay',
-                            'ApprovalDuration', 'Checker')
-            else:
-                keywords = defaultkeywords
-            
-	    print_clients(clients.values(), keywords)
-        else:
-            # Process each client in the list by all selected options
-            for client in clients:
-                if options.remove:
-                    mandos_serv.RemoveClient(client.__dbus_object_path__)
-                if options.enable:
-                    client.Enable(dbus_interface=client_interface)
-                if options.disable:
-                    client.Disable(dbus_interface=client_interface)
-                if options.bump_timeout:
-                    client.CheckedOK(dbus_interface=client_interface)
-                if options.start_checker:
-                    client.StartChecker(dbus_interface=client_interface)
-                if options.stop_checker:
-                    client.StopChecker(dbus_interface=client_interface)
-                if options.is_enabled:
-                    sys.exit(0 if client.Get(client_interface,
-                                             u"Enabled",
-                                             dbus_interface=dbus.PROPERTIES_IFACE)
-                             else 1)
-                if options.checker:
-                    client.Set(client_interface, u"Checker", options.checker,
-                               dbus_interface=dbus.PROPERTIES_IFACE)
-                if options.host:
-                    client.Set(client_interface, u"Host", options.host,
-                               dbus_interface=dbus.PROPERTIES_IFACE)
-                if options.interval:
-                    client.Set(client_interface, u"Interval",
-                               timedelta_to_milliseconds
-                               (string_to_delta(options.interval)),
-                               dbus_interface=dbus.PROPERTIES_IFACE)
-                if options.approval_delay:
-                    client.Set(client_interface, u"ApprovalDelay",
-                               timedelta_to_milliseconds
-                               (string_to_delta(options.
-                                                approval_delay)),
-                               dbus_interface=dbus.PROPERTIES_IFACE)
-                if options.approval_duration:
-                    client.Set(client_interface, u"ApprovalDuration",
-                               timedelta_to_milliseconds
-                               (string_to_delta(options.
-                                                approval_duration)),
-                               dbus_interface=dbus.PROPERTIES_IFACE)
-                if options.timeout:
-                    client.Set(client_interface, u"Timeout",
-                               timedelta_to_milliseconds
-                               (string_to_delta(options.timeout)),
-                               dbus_interface=dbus.PROPERTIES_IFACE)
-                if options.secret:
-                    client.Set(client_interface, u"Secret",
-                               dbus.ByteArray(open(options.secret,
-                                                   u'rb').read()),
-                               dbus_interface=dbus.PROPERTIES_IFACE)
-                if options.approved_by_default is not None:
-                    client.Set(client_interface, u"ApprovedByDefault",
-                               dbus.Boolean(options
-                                            .approved_by_default),
-                               dbus_interface=dbus.PROPERTIES_IFACE)
-                if options.approve:
-                    client.Approve(dbus.Boolean(True),
-                                   dbus_interface=client_interface)
-                elif options.deny:
-                    client.Approve(dbus.Boolean(False),
-                                   dbus_interface=client_interface)
-
-if __name__ == '__main__':
+            if options.checker is not None:
+                set_client_prop("Checker", options.checker)
+            if options.host is not None:
+                set_client_prop("Host", options.host)
+            if options.interval is not None:
+                set_client_prop_ms("Interval", options.interval)
+            if options.approval_delay is not None:
+                set_client_prop_ms("ApprovalDelay",
+                                   options.approval_delay)
+            if options.approval_duration is not None:
+                set_client_prop_ms("ApprovalDuration",
+                                   options.approval_duration)
+            if options.timeout is not None:
+                set_client_prop_ms("Timeout", options.timeout)
+            if options.extended_timeout is not None:
+                set_client_prop_ms("ExtendedTimeout",
+                                   options.extended_timeout)
+            if options.secret is not None:
+                set_client_prop("Secret",
+                                dbus.ByteArray(options.secret.read()))
+            if options.approved_by_default is not None:
+                set_client_prop("ApprovedByDefault",
+                                dbus.Boolean(options
+                                             .approved_by_default))
+            if options.approve:
+                client.Approve(dbus.Boolean(True),
+                               dbus_interface=client_interface)
+            elif options.deny:
+                client.Approve(dbus.Boolean(False),
+                               dbus_interface=client_interface)
+
+
+if __name__ == "__main__":
     main()

=== modified file 'mandos-ctl.xml'
--- mandos-ctl.xml	2010-09-25 23:52:17 +0000
+++ mandos-ctl.xml	2016-06-27 20:21:50 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-ctl">
-<!ENTITY TIMESTAMP "2010-09-26">
+<!ENTITY TIMESTAMP "2016-06-27">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -19,19 +19,25 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@fukt.bsnet.se</email>
+	  <email>belorn@recompile.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@fukt.bsnet.se</email>
+	  <email>teddy@recompile.se</email>
 	</address>
       </author>
     </authorgroup>
     <copyright>
       <year>2010</year>
+      <year>2011</year>
+      <year>2012</year>
+      <year>2013</year>
+      <year>2014</year>
+      <year>2015</year>
+      <year>2016</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -46,104 +52,111 @@
   <refnamediv>
     <refname><command>&COMMANDNAME;</command></refname>
     <refpurpose>
-      Control the operation of the Mandos server
+      Control or query the operation of the Mandos server
     </refpurpose>
   </refnamediv>
   
   <refsynopsisdiv>
     <cmdsynopsis>
       <command>&COMMANDNAME;</command>
-      <group>
-	<arg choice="plain"><option>--enable</option></arg>
-	<arg choice="plain"><option>-e</option></arg>
-	<sbr/>
-	<arg choice="plain"><option>--disable</option></arg>
-	<arg choice="plain"><option>-d</option></arg>
-      </group>
-      <sbr/>
-      <group>
-	<arg choice="plain"><option>--bump-timeout</option></arg>
-	<arg choice="plain"><option>-b</option></arg>
-      </group>
-      <sbr/>
-      <group>
-	<arg choice="plain"><option>--start-checker</option></arg>
-      </group>
-      <sbr/>
-      <group>
-	<arg choice="plain"><option>--stop-checker</option></arg>
-      </group>
-      <sbr/>
-      <group>
-	<arg choice="plain"><option>--remove</option></arg>
-	<arg choice="plain"><option>-r</option></arg>
-      </group>
-      <sbr/>
-      <group>
-	<arg choice="plain"><option>--checker
-	<replaceable>COMMAND</replaceable></option></arg>
-	<arg choice="plain"><option>-c
-	<replaceable>COMMAND</replaceable></option></arg>
-      </group>
-      <sbr/>
-      <group>
-	<arg choice="plain"><option>--timeout
-	<replaceable>TIME</replaceable></option></arg>
-	<arg choice="plain"><option>-t
-	<replaceable>TIME</replaceable></option></arg>
-      </group>
-      <sbr/>
-      <group>
-	<arg choice="plain"><option>--interval
-	<replaceable>TIME</replaceable></option></arg>
-	<arg choice="plain"><option>-i
-	<replaceable>TIME</replaceable></option></arg>
-      </group>
-      <sbr/>
-      <group>
-	<arg choice="plain"><option>--approve-by-default</option
-        ></arg>
-	<sbr/>
-	<arg choice="plain"><option>--deny-by-default</option></arg>
-      </group>
-      <sbr/>
-      <group>
-	<arg choice="plain"><option>--approval-delay
-	<replaceable>TIME</replaceable></option></arg>
-      </group>
-      <sbr/>
-      <group>
-	<arg choice="plain"><option>--approval-duration
-	<replaceable>TIME</replaceable></option></arg>
-      </group>
-      <sbr/>
-      <group>
-	<arg choice="plain"><option>--interval
-	<replaceable>TIME</replaceable></option></arg>
-	<arg choice="plain"><option>-i
-	<replaceable>TIME</replaceable></option></arg>
-      </group>
-      <sbr/>
-      <group>
-	<arg choice="plain"><option>--host
-	<replaceable>STRING</replaceable></option></arg>
-	<arg choice="plain"><option>-H
-	<replaceable>STRING</replaceable></option></arg>
-      </group>
-      <sbr/>
-      <group>
-	<arg choice="plain"><option>--secret
-	<replaceable>FILENAME</replaceable></option></arg>
-	<arg choice="plain"><option>-s
-	<replaceable>FILENAME</replaceable></option></arg>
-      </group>
-      <sbr/>
-      <group>
-	<arg choice="plain"><option>--approve</option></arg>
-	<arg choice="plain"><option>-A</option></arg>
-	<sbr/>
-	<arg choice="plain"><option>--deny</option></arg>
-	<arg choice="plain"><option>-D</option></arg>
+      <group choice="req">
+	<group>
+	  <arg choice="plain"><option>--enable</option></arg>
+	  <arg choice="plain"><option>-e</option></arg>
+	  <sbr/>
+	  <arg choice="plain"><option>--disable</option></arg>
+	  <arg choice="plain"><option>-d</option></arg>
+	</group>
+	<sbr/>
+	<group>
+	  <arg choice="plain"><option>--bump-timeout</option></arg>
+	  <arg choice="plain"><option>-b</option></arg>
+	</group>
+	<sbr/>
+	<group>
+	  <arg choice="plain"><option>--start-checker</option></arg>
+	</group>
+	<sbr/>
+	<group>
+	  <arg choice="plain"><option>--stop-checker</option></arg>
+	</group>
+	<sbr/>
+	<group>
+	  <arg choice="plain"><option>--remove</option></arg>
+	  <arg choice="plain"><option>-r</option></arg>
+	</group>
+	<sbr/>
+	<group>
+	  <arg choice="plain"><option>--checker
+	  <replaceable>COMMAND</replaceable></option></arg>
+	  <arg choice="plain"><option>-c
+	  <replaceable>COMMAND</replaceable></option></arg>
+	</group>
+	<sbr/>
+	<group>
+	  <arg choice="plain"><option>--timeout
+	  <replaceable>TIME</replaceable></option></arg>
+	  <arg choice="plain"><option>-t
+	  <replaceable>TIME</replaceable></option></arg>
+	</group>
+	<sbr/>
+	<group>
+	  <arg choice="plain"><option>--extended-timeout
+	  <replaceable>TIME</replaceable></option></arg>
+	</group>
+	<sbr/>
+	<group>
+	  <arg choice="plain"><option>--interval
+	  <replaceable>TIME</replaceable></option></arg>
+	  <arg choice="plain"><option>-i
+	  <replaceable>TIME</replaceable></option></arg>
+	</group>
+	<sbr/>
+	<group>
+	  <arg choice="plain"><option>--approve-by-default</option
+          ></arg>
+	  <sbr/>
+	  <arg choice="plain"><option>--deny-by-default</option></arg>
+	</group>
+	<sbr/>
+	<group>
+	  <arg choice="plain"><option>--approval-delay
+	  <replaceable>TIME</replaceable></option></arg>
+	</group>
+	<sbr/>
+	<group>
+	  <arg choice="plain"><option>--approval-duration
+	  <replaceable>TIME</replaceable></option></arg>
+	</group>
+	<sbr/>
+	<group>
+	  <arg choice="plain"><option>--interval
+	  <replaceable>TIME</replaceable></option></arg>
+	  <arg choice="plain"><option>-i
+	  <replaceable>TIME</replaceable></option></arg>
+	</group>
+	<sbr/>
+	<group>
+	  <arg choice="plain"><option>--host
+	  <replaceable>STRING</replaceable></option></arg>
+	  <arg choice="plain"><option>-H
+	  <replaceable>STRING</replaceable></option></arg>
+	</group>
+	<sbr/>
+	<group>
+	  <arg choice="plain"><option>--secret
+	  <replaceable>FILENAME</replaceable></option></arg>
+	  <arg choice="plain"><option>-s
+	  <replaceable>FILENAME</replaceable></option></arg>
+	</group>
+	<sbr/>
+	<group>
+	  <arg choice="plain"><option>--approve</option></arg>
+	  <arg choice="plain"><option>-A</option></arg>
+	  <sbr/>
+	  <arg choice="plain"><option>--deny</option></arg>
+	  <arg choice="plain"><option>-D</option></arg>
+	</group>
       </group>
       <sbr/>
       <group choice="req">
@@ -157,8 +170,11 @@
     <cmdsynopsis>
       <command>&COMMANDNAME;</command>
       <group>
-	<arg choice="plain"><option>--verbose</option></arg>
-	<arg choice="plain"><option>-v</option></arg>
+	  <arg choice="plain"><option>--verbose</option></arg>
+	  <arg choice="plain"><option>-v</option></arg>
+	  <sbr/>
+	  <arg choice="plain"><option>--dump-json</option></arg>
+	  <arg choice="plain"><option>-j</option></arg>
       </group>
       <group>
 	<arg rep='repeat' choice='plain'>
@@ -188,14 +204,19 @@
 	<arg choice="plain"><option>-v</option></arg>
       </group>
     </cmdsynopsis>
+    <cmdsynopsis>
+      <command>&COMMANDNAME;</command>
+      <arg choice="plain"><option>--check</option></arg>
+    </cmdsynopsis>
   </refsynopsisdiv>
   
   <refsect1 id="description">
     <title>DESCRIPTION</title>
     <para>
-      <command>&COMMANDNAME;</command> is a program to control the
-      operation of the Mandos server <citerefentry><refentrytitle
-      >mandos</refentrytitle><manvolnum>8</manvolnum></citerefentry>.
+      <command>&COMMANDNAME;</command> is a program to control or
+      query the operation of the Mandos server
+      <citerefentry><refentrytitle>mandos</refentrytitle><manvolnum
+      >8</manvolnum></citerefentry>.
     </para>
     <para>
       This program can be used to change client settings, approve or
@@ -317,6 +338,19 @@
 	  </para>
 	</listitem>
       </varlistentry>
+
+      <varlistentry>
+	<term><option>--extended-timeout
+	<replaceable>TIME</replaceable></option></term>
+	<listitem>
+	  <para>
+	    Set the <varname>extended_timeout</varname> option of the
+	    specified client(s); see <citerefentry><refentrytitle
+	    >mandos-clients.conf</refentrytitle><manvolnum
+	    >5</manvolnum></citerefentry>.
+	  </para>
+	</listitem>
+      </varlistentry>
       
       <varlistentry>
 	<term><option>--interval
@@ -446,6 +480,16 @@
       </varlistentry>
       
       <varlistentry>
+	<term><option>--dump-json</option></term>
+	<term><option>-j</option></term>
+	<listitem>
+	  <para>
+	    Dump client settings as JSON to standard output.
+	  </para>
+	</listitem>
+      </varlistentry>
+      
+      <varlistentry>
 	<term><option>--is-enabled</option></term>
 	<term><option>-V</option></term>
 	<listitem>
@@ -456,6 +500,15 @@
 	</listitem>
       </varlistentry>
       
+      <varlistentry>
+	<term><option>--check</option></term>
+	<listitem>
+	  <para>
+	    Run self-tests.  This includes any unit tests, etc.
+	  </para>
+	</listitem>
+      </varlistentry>
+      
     </variablelist>
   </refsect1>
   
@@ -477,11 +530,10 @@
     </para>
   </refsect1>
   
-<!--   <refsect1 id="bugs"> -->
-<!--     <title>BUGS</title> -->
-<!--     <para> -->
-<!--     </para> -->
-<!--   </refsect1> -->
+  <refsect1 id="bugs">
+    <title>BUGS</title>
+    <xi:include href="bugs.xml"/>
+  </refsect1>
   
   <refsect1 id="example">
     <title>EXAMPLE</title>
@@ -553,6 +605,8 @@
   <refsect1 id="see_also">
     <title>SEE ALSO</title>
     <para>
+      <citerefentry><refentrytitle>intro</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>mandos</refentrytitle>
       <manvolnum>8</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>mandos-clients.conf</refentrytitle>

=== modified file 'mandos-keygen'
--- mandos-keygen	2010-10-02 17:23:41 +0000
+++ mandos-keygen	2016-10-08 04:33:04 +0000
@@ -2,8 +2,8 @@
 # 
 # Mandos key generator - create a new OpenPGP key for a Mandos client
 # 
-# Copyright © 2008-2010 Teddy Hogeborn
-# Copyright © 2008-2010 Björn Påhlsson
+# Copyright © 2008-2016 Teddy Hogeborn
+# Copyright © 2008-2016 Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -18,21 +18,22 @@
 # You should have received a copy of the GNU General Public License
 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
 # 
-# Contact the authors at <mandos@fukt.bsnet.se>.
+# Contact the authors at <mandos@recompile.se>.
 # 
 
-VERSION="1.2.1"
+VERSION="1.7.13"
 
 KEYDIR="/etc/keys/mandos"
-KEYTYPE=DSA
-KEYLENGTH=2048
-SUBKEYTYPE=ELG-E
-SUBKEYLENGTH=2048
+KEYTYPE=RSA
+KEYLENGTH=4096
+SUBKEYTYPE=RSA
+SUBKEYLENGTH=4096
 KEYNAME="`hostname --fqdn 2>/dev/null || hostname`"
 KEYEMAIL=""
-KEYCOMMENT="Mandos client key"
+KEYCOMMENT=""
 KEYEXPIRE=0
 FORCE=no
+SSH=yes
 KEYCOMMENT_ORIG="$KEYCOMMENT"
 mode=keygen
 
@@ -41,12 +42,12 @@
 fi
 
 # Parse options
-TEMP=`getopt --options vhpF:d:t:l:s:L:n:e:c:x:f \
-    --longoptions version,help,password,passfile:,dir:,type:,length:,subtype:,sublength:,name:,email:,comment:,expire:,force \
+TEMP=`getopt --options vhpF:d:t:l:s:L:n:e:c:x:fS \
+    --longoptions version,help,password,passfile:,dir:,type:,length:,subtype:,sublength:,name:,email:,comment:,expire:,force,no-ssh \
     --name "$0" -- "$@"`
 
 help(){
-basename="`basename $0`"
+basename="`basename "$0"`"
 cat <<EOF
 Usage: $basename [ -v | --version ]
        $basename [ -h | --help ]
@@ -60,19 +61,18 @@
   -v, --version         Show program's version number and exit
   -h, --help            Show this help message and exit
   -d DIR, --dir DIR     Target directory for key files
-  -t TYPE, --type TYPE  Key type.  Default is DSA.
+  -t TYPE, --type TYPE  Key type.  Default is RSA.
   -l BITS, --length BITS
-                        Key length in bits.  Default is 2048.
+                        Key length in bits.  Default is 4096.
   -s TYPE, --subtype TYPE
-                        Subkey type.  Default is ELG-E.
+                        Subkey type.  Default is RSA.
   -L BITS, --sublength BITS
-                        Subkey length in bits.  Default is 2048.
+                        Subkey length in bits.  Default is 4096.
   -n NAME, --name NAME  Name of key.  Default is the FQDN.
   -e ADDRESS, --email ADDRESS
                         Email address of key.  Default is empty.
   -c TEXT, --comment TEXT
-                        Comment field for key.  The default value is
-                        "Mandos client key".
+                        Comment field for key.  The default is empty.
   -x TIME, --expire TIME
                         Key expire time.  Default is no expiration.
                         See gpg(1) for syntax.
@@ -86,6 +86,7 @@
                         Encrypt a password from FILE using the key in
                         the key directory.  All options other than
                         --dir and --name are ignored.
+  -S, --no-ssh          Don't get SSH key or set "checker" option.
 EOF
 }
 
@@ -104,6 +105,7 @@
 	-c|--comment) KEYCOMMENT="$2"; shift 2;;
 	-x|--expire) KEYEXPIRE="$2"; shift 2;;
 	-f|--force) FORCE=yes; shift;;
+	-S|--no-ssh) SSH=no; shift;;
 	-v|--version) echo "$0 $VERSION"; exit;;
 	-h|--help) help; exit;;
 	--) shift; break;;
@@ -111,7 +113,7 @@
     esac
 done
 if [ "$#" -gt 0 ]; then
-    echo "Unknown arguments: '$@'" >&2
+    echo "Unknown arguments: '$*'" >&2
     exit 1
 fi
 
@@ -189,10 +191,10 @@
 trap "
 set +e; \
 test -n \"$SECFILE\" && shred --remove \"$SECFILE\"; \
-shred --remove \"$RINGDIR\"/sec*;
+shred --remove \"$RINGDIR\"/sec* 2>/dev/null;
 test -n \"$BATCHFILE\" && rm --force \"$BATCHFILE\"; \
 rm --recursive --force \"$RINGDIR\";
-stty echo; \
+tty --quiet && stty echo; \
 " EXIT
 
 set -e
@@ -204,10 +206,10 @@
     cat >"$BATCHFILE" <<-EOF
 	Key-Type: $KEYTYPE
 	Key-Length: $KEYLENGTH
-	#Key-Usage: encrypt,sign,auth
+	Key-Usage: sign,auth
 	Subkey-Type: $SUBKEYTYPE
 	Subkey-Length: $SUBKEYLENGTH
-	#Subkey-Usage: encrypt,sign,auth
+	Subkey-Usage: encrypt
 	Name-Real: $KEYNAME
 	$KEYCOMMENTLINE
 	$KEYEMAILLINE
@@ -216,6 +218,7 @@
 	#Handle: <no-spaces>
 	#%pubring pubring.gpg
 	#%secring secring.gpg
+	%no-protection
 	%commit
 	EOF
     
@@ -229,6 +232,11 @@
 	date
     fi
     
+    # Make sure trustdb.gpg exists;
+    # this is a workaround for Debian bug #737128
+    gpg --quiet --batch --no-tty --no-options --enable-dsa2 \
+	--homedir "$RINGDIR" \
+	--import-ownertrust < /dev/null
     # Generate a new key in the key rings
     gpg --quiet --batch --no-tty --no-options --enable-dsa2 \
 	--homedir "$RINGDIR" --trust-model always \
@@ -270,6 +278,29 @@
 fi
 
 if [ "$mode" = password ]; then
+    
+    # Make SSH be 0 or 1
+    case "$SSH" in
+	[Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]) SSH=1;;
+	[Nn][Oo]|[Ff][Aa][Ll][Ss][Ee]|*) SSH=0;;
+    esac
+    
+    if [ $SSH -eq 1 ]; then
+	for ssh_keytype in ecdsa-sha2-nistp256 ed25519 rsa; do
+	    set +e
+	    ssh_fingerprint="`ssh-keyscan -t $ssh_keytype localhost 2>/dev/null`"
+	    set -e
+	    if [ $? -ne 0 ]; then
+		ssh_fingerprint=""
+		continue
+	    fi
+	    if [ -n "$ssh_fingerprint" ]; then
+		ssh_fingerprint="${ssh_fingerprint#localhost }"
+		break
+	    fi
+	done
+    fi
+    
     # Import key into temporary key rings
     gpg --quiet --batch --no-tty --no-options --enable-dsa2 \
 	--homedir "$RINGDIR" --trust-model always --armor \
@@ -280,7 +311,7 @@
     
     # Get fingerprint of key
     FINGERPRINT="`gpg --quiet --batch --no-tty --no-options \
-	--enable-dsa2 --homedir \"$RINGDIR\" --trust-model always \
+	--enable-dsa2 --homedir "$RINGDIR" --trust-model always \
 	--fingerprint --with-colons \
 	| sed --quiet \
 	--expression='/^fpr:/{s/^fpr:.*:\\([0-9A-Z]*\\):\$/\\1/p;q}'`"
@@ -289,31 +320,39 @@
     
     FILECOMMENT="Encrypted password for a Mandos client"
     
-    if [ -n "$PASSFILE" ]; then
-	cat "$PASSFILE"
-    else
-	stty -echo
-	echo -n "Enter passphrase: " >&2
-	first="$(head --lines=1 | tr --delete '\n')"
-	echo >&2
-	echo -n "Repeat passphrase: " >&2
-	second="$(head --lines=1 | tr --delete '\n')"
-	echo >&2
-	stty echo
-	if [ "$first" != "$second" ]; then
-	    echo "Passphrase mismatch" >&2
-	    touch "$RINGDIR"/mismatch
+    while [ ! -s "$SECFILE" ]; do
+	if [ -n "$PASSFILE" ]; then
+	    cat "$PASSFILE"
 	else
-	    echo -n "$first"
+	    tty --quiet && stty -echo
+	    echo -n "Enter passphrase: " >/dev/tty
+	    read first
+	    tty --quiet && echo >&2
+	    echo -n "Repeat passphrase: " >/dev/tty
+	    read second
+	    if tty --quiet; then
+		echo >&2
+		stty echo
+	    fi
+	    if [ "$first" != "$second" ]; then
+		echo "Passphrase mismatch" >&2
+		touch "$RINGDIR"/mismatch
+	    else
+		echo -n "$first"
+	    fi
+	fi | gpg --quiet --batch --no-tty --no-options --enable-dsa2 \
+	    --homedir "$RINGDIR" --trust-model always --armor \
+	    --encrypt --sign --recipient "$FINGERPRINT" --comment \
+	    "$FILECOMMENT" > "$SECFILE"
+	if [ -e "$RINGDIR"/mismatch ]; then
+	    rm --force "$RINGDIR"/mismatch
+	    if tty --quiet; then
+		> "$SECFILE"
+	    else
+		exit 1
+	    fi
 	fi
-    fi | gpg --quiet --batch --no-tty --no-options --enable-dsa2 \
-	--homedir "$RINGDIR" --trust-model always --armor --encrypt \
-	--sign --recipient "$FINGERPRINT" --comment "$FILECOMMENT" \
-	> "$SECFILE"
-    if [ -e "$RINGDIR"/mismatch ]; then
-	rm --force "$RINGDIR"/mismatch
-	exit 1
-    fi
+    done
     
     cat <<-EOF
 	[$KEYNAME]
@@ -330,6 +369,10 @@
 		/^[^-]/s/^/    /p
 	    }
 	}' < "$SECFILE"
+    if [ -n "$ssh_fingerprint" ]; then
+	echo 'checker = ssh-keyscan -t '"$ssh_keytype"' %%(host)s 2>/dev/null | grep --fixed-strings --line-regexp --quiet --regexp=%%(host)s" %(ssh_fingerprint)s"'
+	echo "ssh_fingerprint = ${ssh_fingerprint}"
+    fi
 fi
 
 trap - EXIT
@@ -340,5 +383,5 @@
     shred --remove "$SECFILE"
 fi
 # Remove the key rings
-shred --remove "$RINGDIR"/sec*
+shred --remove "$RINGDIR"/sec* 2>/dev/null
 rm --recursive --force "$RINGDIR"

=== modified file 'mandos-keygen.xml'
--- mandos-keygen.xml	2009-01-04 21:54:55 +0000
+++ mandos-keygen.xml	2016-03-05 21:42:56 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-keygen">
-<!ENTITY TIMESTAMP "2009-01-04">
+<!ENTITY TIMESTAMP "2016-03-05">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -19,20 +19,27 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@fukt.bsnet.se</email>
+	  <email>belorn@recompile.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@fukt.bsnet.se</email>
+	  <email>teddy@recompile.se</email>
 	</address>
       </author>
     </authorgroup>
     <copyright>
       <year>2008</year>
       <year>2009</year>
+      <year>2010</year>
+      <year>2011</year>
+      <year>2012</year>
+      <year>2013</year>
+      <year>2014</year>
+      <year>2015</year>
+      <year>2016</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -117,7 +124,10 @@
 	<replaceable>TIME</replaceable></option></arg>
       </group>
       <sbr/>
-      <arg><option>--force</option></arg>
+      <group>
+	<arg choice="plain"><option>--force</option></arg>
+	<arg choice="plain"><option>-f</option></arg>
+      </group>
     </cmdsynopsis>
     <cmdsynopsis>
       <command>&COMMANDNAME;</command>
@@ -143,6 +153,10 @@
 	<arg choice="plain"><option>-n
 	<replaceable>NAME</replaceable></option></arg>
       </group>
+      <group>
+	<arg choice="plain"><option>--no-ssh</option></arg>
+	<arg choice="plain"><option>-S</option></arg>
+      </group>
     </cmdsynopsis>
     <cmdsynopsis>
       <command>&COMMANDNAME;</command>
@@ -213,7 +227,7 @@
 	<listitem>
 	  <para>
 	    Target directory for key files.  Default is
-	    <filename>/etc/mandos</filename>.
+	    <filename class="directory">/etc/mandos</filename>.
 	  </para>
 	</listitem>
       </varlistentry>
@@ -225,7 +239,7 @@
 	<replaceable>TYPE</replaceable></option></term>
 	<listitem>
 	  <para>
-	    Key type.  Default is <quote>DSA</quote>.
+	    Key type.  Default is <quote>RSA</quote>.
 	  </para>
 	</listitem>
       </varlistentry>
@@ -237,7 +251,7 @@
 	<replaceable>BITS</replaceable></option></term>
 	<listitem>
 	  <para>
-	    Key length in bits.  Default is 2048.
+	    Key length in bits.  Default is 4096.
 	  </para>
 	</listitem>
       </varlistentry>
@@ -249,7 +263,7 @@
 	<replaceable>KEYTYPE</replaceable></option></term>
 	<listitem>
 	  <para>
-	    Subkey type.  Default is <quote>ELG-E</quote> (Elgamal
+	    Subkey type.  Default is <quote>RSA</quote> (Elgamal
 	    encryption-only).
 	  </para>
 	</listitem>
@@ -262,7 +276,7 @@
 	<replaceable>BITS</replaceable></option></term>
 	<listitem>
 	  <para>
-	    Subkey length in bits.  Default is 2048.
+	    Subkey length in bits.  Default is 4096.
 	  </para>
 	</listitem>
       </varlistentry>
@@ -286,8 +300,7 @@
 	<replaceable>TEXT</replaceable></option></term>
 	<listitem>
 	  <para>
-	    Comment field for key.  The default value is
-	    <quote><literal>Mandos client key</literal></quote>.
+	    Comment field for key.  Default is empty.
 	  </para>
 	</listitem>
       </varlistentry>
@@ -345,6 +358,22 @@
 	  </para>
 	</listitem>
       </varlistentry>
+      <varlistentry>
+	<term><option>--no-ssh</option></term>
+	<term><option>-S</option></term>
+	<listitem>
+	  <para>
+	    When <option>--password</option> or
+	    <option>--passfile</option> is given, this option will
+	    prevent <command>&COMMANDNAME;</command> from calling
+	    <command>ssh-keyscan</command> to get an SSH fingerprint
+	    for this host and, if successful, output suitable config
+	    options to use this fingerprint as a
+	    <option>checker</option> option in the output.  This is
+	    otherwise the default behavior.
+	  </para>
+	</listitem>
+      </varlistentry>
     </variablelist>
   </refsect1>
   
@@ -410,7 +439,7 @@
 	</listitem>
       </varlistentry>
       <varlistentry>
-	<term><filename>/tmp</filename></term>
+	<term><filename class="directory">/tmp</filename></term>
 	<listitem>
 	  <para>
 	    Temporary files will be written here if
@@ -421,11 +450,10 @@
     </variablelist>
   </refsect1>
   
-<!--   <refsect1 id="bugs"> -->
-<!--     <title>BUGS</title> -->
-<!--     <para> -->
-<!--     </para> -->
-<!--   </refsect1> -->
+  <refsect1 id="bugs">
+    <title>BUGS</title>
+    <xi:include href="bugs.xml"/>
+  </refsect1>
   
   <refsect1 id="example">
     <title>EXAMPLE</title>
@@ -451,9 +479,9 @@
     </informalexample>
     <informalexample>
       <para>
-	Prompt for a password, encrypt it with the key in
-	<filename>/etc/mandos</filename> and output a section suitable
-	for <filename>clients.conf</filename>.
+	Prompt for a password, encrypt it with the key in <filename
+	class="directory">/etc/mandos</filename> and output a section
+	suitable for <filename>clients.conf</filename>.
       </para>
       <para>
 	<userinput>&COMMANDNAME; --password</userinput>
@@ -492,6 +520,8 @@
   <refsect1 id="see_also">
     <title>SEE ALSO</title>
     <para>
+      <citerefentry><refentrytitle>intro</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>gpg</refentrytitle>
       <manvolnum>1</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>mandos-clients.conf</refentrytitle>
@@ -499,7 +529,9 @@
       <citerefentry><refentrytitle>mandos</refentrytitle>
       <manvolnum>8</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>mandos-client</refentrytitle>
-      <manvolnum>8mandos</manvolnum></citerefentry>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>ssh-keyscan</refentrytitle>
+      <manvolnum>1</manvolnum></citerefentry>
     </para>
   </refsect1>
   

=== modified file 'mandos-monitor'
--- mandos-monitor	2010-10-02 17:23:41 +0000
+++ mandos-monitor	2016-10-08 04:33:04 +0000
@@ -1,11 +1,11 @@
 #!/usr/bin/python
 # -*- mode: python; coding: utf-8 -*-
-# 
+#
 # Mandos Monitor - Control and monitor the Mandos server
-# 
-# Copyright © 2009,2010 Teddy Hogeborn
-# Copyright © 2009,2010 Björn Påhlsson
-# 
+#
+# Copyright © 2009-2016 Teddy Hogeborn
+# Copyright © 2009-2016 Björn Påhlsson
+#
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 # the Free Software Foundation, either version 3 of the License, or
@@ -15,18 +15,23 @@
 #     but WITHOUT ANY WARRANTY; without even the implied warranty of
 #     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 #     GNU General Public License for more details.
-# 
+#
 # You should have received a copy of the GNU General Public License
-# along with this program.  If not, see <http://www.gnu.org/licenses/>.
-# 
-# Contact the authors at <mandos@fukt.bsnet.se>.
-# 
+# along with this program.  If not, see
+# <http://www.gnu.org/licenses/>.
+#
+# Contact the authors at <mandos@recompile.se>.
+#
 
-from __future__ import division, absolute_import, with_statement
+from __future__ import (division, absolute_import, print_function,
+                        unicode_literals)
+try:
+    from future_builtins import *
+except ImportError:
+    pass
 
 import sys
 import os
-import signal
 
 import datetime
 
@@ -34,85 +39,89 @@
 import urwid
 
 from dbus.mainloop.glib import DBusGMainLoop
-import gobject
+from gi.repository import GLib
 
 import dbus
 
-import UserList
-
 import locale
 
-locale.setlocale(locale.LC_ALL, u'')
-
 import logging
+
+if sys.version_info.major == 2:
+    str = unicode
+
+locale.setlocale(locale.LC_ALL, '')
+
 logging.getLogger('dbus.proxies').setLevel(logging.CRITICAL)
 
 # Some useful constants
-domain = 'se.bsnet.fukt'
+domain = 'se.recompile'
 server_interface = domain + '.Mandos'
 client_interface = domain + '.Mandos.Client'
-version = "1.2.1"
-
-# Always run in monochrome mode
-urwid.curses_display.curses.has_colors = lambda : False
-
-# Urwid doesn't support blinking, but we want it.  Since we have no
-# use for underline on its own, we make underline also always blink.
-urwid.curses_display.curses.A_UNDERLINE |= (
-    urwid.curses_display.curses.A_BLINK)
+version = "1.7.13"
+
+try:
+    dbus.OBJECT_MANAGER_IFACE
+except AttributeError:
+    dbus.OBJECT_MANAGER_IFACE = "org.freedesktop.DBus.ObjectManager"
+
 
 def isoformat_to_datetime(iso):
     "Parse an ISO 8601 date string to a datetime.datetime()"
     if not iso:
         return None
-    d, t = iso.split(u"T", 1)
-    year, month, day = d.split(u"-", 2)
-    hour, minute, second = t.split(u":", 2)
+    d, t = iso.split("T", 1)
+    year, month, day = d.split("-", 2)
+    hour, minute, second = t.split(":", 2)
     second, fraction = divmod(float(second), 1)
     return datetime.datetime(int(year),
                              int(month),
                              int(day),
                              int(hour),
                              int(minute),
-                             int(second),           # Whole seconds
-                             int(fraction*1000000)) # Microseconds
+                             int(second),            # Whole seconds
+                             int(fraction*1000000))  # Microseconds
+
 
 class MandosClientPropertyCache(object):
     """This wraps a Mandos Client D-Bus proxy object, caches the
     properties and calls a hook function when any of them are
     changed.
     """
-    def __init__(self, proxy_object=None, *args, **kwargs):
-        self.proxy = proxy_object # Mandos Client proxy object
-        
-        self.properties = dict()
-        self.proxy.connect_to_signal(u"PropertyChanged",
-                                     self.property_changed,
-                                     client_interface,
-                                     byte_arrays=True)
-        
-        self.properties.update(
-            self.proxy.GetAll(client_interface,
-                              dbus_interface = dbus.PROPERTIES_IFACE))
-
-        #XXX This break good super behaviour!
-#        super(MandosClientPropertyCache, self).__init__(
-#            *args, **kwargs)
-    
-    def property_changed(self, property=None, value=None):
-        """This is called whenever we get a PropertyChanged signal
-        It updates the changed property in the "properties" dict.
+    def __init__(self, proxy_object=None, properties=None, **kwargs):
+        self.proxy = proxy_object  # Mandos Client proxy object
+        self.properties = dict() if properties is None else properties
+        self.property_changed_match = (
+            self.proxy.connect_to_signal("PropertiesChanged",
+                                         self.properties_changed,
+                                         dbus.PROPERTIES_IFACE,
+                                         byte_arrays=True))
+
+        if properties is None:
+            self.properties.update(self.proxy.GetAll(
+                client_interface,
+                dbus_interface=dbus.PROPERTIES_IFACE))
+
+        super(MandosClientPropertyCache, self).__init__(**kwargs)
+
+    def properties_changed(self, interface, properties, invalidated):
+        """This is called whenever we get a PropertiesChanged signal
+        It updates the changed properties in the "properties" dict.
         """
         # Update properties dict with new value
-        self.properties[property] = value
+        if interface == client_interface:
+            self.properties.update(properties)
+
+    def delete(self):
+        self.property_changed_match.remove()
 
 
 class MandosClientWidget(urwid.FlowWidget, MandosClientPropertyCache):
     """A Mandos Client which is visible on the screen.
     """
-    
+
     def __init__(self, server_proxy_object=None, update_hook=None,
-                 delete_hook=None, logger=None, *args, **kwargs):
+                 delete_hook=None, logger=None, **kwargs):
         # Called on update
         self.update_hook = update_hook
         # Called on delete
@@ -121,208 +130,169 @@
         self.server_proxy_object = server_proxy_object
         # Logger
         self.logger = logger
-        
+
         self._update_timer_callback_tag = None
-        self._update_timer_callback_lock = 0
-        self.last_checker_failed = False
-        
+
         # The widget shown normally
-        self._text_widget = urwid.Text(u"")
+        self._text_widget = urwid.Text("")
         # The widget shown when we have focus
-        self._focus_text_widget = urwid.Text(u"")
-        super(MandosClientWidget, self).__init__(
-            update_hook=update_hook, delete_hook=delete_hook,
-            *args, **kwargs)
+        self._focus_text_widget = urwid.Text("")
+        super(MandosClientWidget, self).__init__(**kwargs)
         self.update()
         self.opened = False
-        
-        last_checked_ok = isoformat_to_datetime(self.properties
-                                                [u"LastCheckedOK"])
-        if last_checked_ok is None:
-            self.last_checker_failed = True
-        else:
-            self.last_checker_failed = ((datetime.datetime.utcnow()
-                                         - last_checked_ok)
-                                        > datetime.timedelta
-                                        (milliseconds=
-                                         self.properties
-                                         [u"Interval"]))
-        
-        if self.last_checker_failed:
-            self.using_timer(True)
-        
-        if self.need_approval:
-            self.using_timer(True)
-        
-        self.proxy.connect_to_signal(u"CheckerCompleted",
-                                     self.checker_completed,
-                                     client_interface,
-                                     byte_arrays=True)
-        self.proxy.connect_to_signal(u"CheckerStarted",
-                                     self.checker_started,
-                                     client_interface,
-                                     byte_arrays=True)
-        self.proxy.connect_to_signal(u"GotSecret",
-                                     self.got_secret,
-                                     client_interface,
-                                     byte_arrays=True)
-        self.proxy.connect_to_signal(u"NeedApproval",
-                                     self.need_approval,
-                                     client_interface,
-                                     byte_arrays=True)
-        self.proxy.connect_to_signal(u"Rejected",
-                                     self.rejected,
-                                     client_interface,
-                                     byte_arrays=True)
-    
-    def property_changed(self, property=None, value=None):
-        super(self, MandosClientWidget).property_changed(property,
-                                                         value)
-        if property == u"ApprovalPending":
-            using_timer(bool(value))
-        
+
+        self.match_objects = (
+            self.proxy.connect_to_signal("CheckerCompleted",
+                                         self.checker_completed,
+                                         client_interface,
+                                         byte_arrays=True),
+            self.proxy.connect_to_signal("CheckerStarted",
+                                         self.checker_started,
+                                         client_interface,
+                                         byte_arrays=True),
+            self.proxy.connect_to_signal("GotSecret",
+                                         self.got_secret,
+                                         client_interface,
+                                         byte_arrays=True),
+            self.proxy.connect_to_signal("NeedApproval",
+                                         self.need_approval,
+                                         client_interface,
+                                         byte_arrays=True),
+            self.proxy.connect_to_signal("Rejected",
+                                         self.rejected,
+                                         client_interface,
+                                         byte_arrays=True))
+        self.logger('Created client {}'
+                    .format(self.properties["Name"]), level=0)
+
     def using_timer(self, flag):
         """Call this method with True or False when timer should be
         activated or deactivated.
         """
-        old = self._update_timer_callback_lock
-        if flag:
-            self._update_timer_callback_lock += 1
-        else:
-            self._update_timer_callback_lock -= 1
-        if old == 0 and self._update_timer_callback_lock:
-            self._update_timer_callback_tag = (gobject.timeout_add
+        if flag and self._update_timer_callback_tag is None:
+            # Will update the shown timer value every second
+            self._update_timer_callback_tag = (GLib.timeout_add
                                                (1000,
                                                 self.update_timer))
-        elif old and self._update_timer_callback_lock == 0:
-            gobject.source_remove(self._update_timer_callback_tag)
+        elif not (flag or self._update_timer_callback_tag is None):
+            GLib.source_remove(self._update_timer_callback_tag)
             self._update_timer_callback_tag = None
-    
+
     def checker_completed(self, exitstatus, condition, command):
         if exitstatus == 0:
-            if self.last_checker_failed:
-                self.last_checker_failed = False
-                self.using_timer(False)
-            #self.logger(u'Checker for client %s (command "%s")'
-            #            u' was successful'
-            #            % (self.properties[u"Name"], command))
+            self.logger('Checker for client {} (command "{}")'
+                        ' succeeded'.format(self.properties["Name"],
+                                            command), level=0)
             self.update()
             return
         # Checker failed
-        if not self.last_checker_failed:
-            self.last_checker_failed = True
-            self.using_timer(True)
         if os.WIFEXITED(condition):
-            self.logger(u'Checker for client %s (command "%s")'
-                        u' failed with exit code %s'
-                        % (self.properties[u"Name"], command,
-                           os.WEXITSTATUS(condition)))
+            self.logger('Checker for client {} (command "{}") failed'
+                        ' with exit code {}'
+                        .format(self.properties["Name"], command,
+                                os.WEXITSTATUS(condition)))
         elif os.WIFSIGNALED(condition):
-            self.logger(u'Checker for client %s (command "%s")'
-                        u' was killed by signal %s'
-                        % (self.properties[u"Name"], command,
-                           os.WTERMSIG(condition)))
-        elif os.WCOREDUMP(condition):
-            self.logger(u'Checker for client %s (command "%s")'
-                        u' dumped core'
-                        % (self.properties[u"Name"], command))
-        else:
-            self.logger(u'Checker for client %s completed'
-                        u' mysteriously')
+            self.logger('Checker for client {} (command "{}") was'
+                        ' killed by signal {}'
+                        .format(self.properties["Name"], command,
+                                os.WTERMSIG(condition)))
         self.update()
-    
+
     def checker_started(self, command):
-        #self.logger(u'Client %s started checker "%s"'
-        #            % (self.properties[u"Name"], unicode(command)))
-        pass
-    
+        """Server signals that a checker started."""
+        self.logger('Client {} started checker "{}"'
+                    .format(self.properties["Name"],
+                            command), level=0)
+
     def got_secret(self):
-        self.last_checker_failed = False
-        self.logger(u'Client %s received its secret'
-                    % self.properties[u"Name"])
-    
+        self.logger('Client {} received its secret'
+                    .format(self.properties["Name"]))
+
     def need_approval(self, timeout, default):
         if not default:
-            message = u'Client %s needs approval within %s seconds'
+            message = 'Client {} needs approval within {} seconds'
         else:
-            message = u'Client %s will get its secret in %s seconds'
-        self.logger(message
-                    % (self.properties[u"Name"], timeout/1000))
-        self.using_timer(True)
-    
+            message = 'Client {} will get its secret in {} seconds'
+        self.logger(message.format(self.properties["Name"],
+                                   timeout/1000))
+
     def rejected(self, reason):
-        self.logger(u'Client %s was rejected; reason: %s'
-                    % (self.properties[u"Name"], reason))
-    
+        self.logger('Client {} was rejected; reason: {}'
+                    .format(self.properties["Name"], reason))
+
     def selectable(self):
         """Make this a "selectable" widget.
         This overrides the method from urwid.FlowWidget."""
         return True
-    
-    def rows(self, (maxcol,), focus=False):
+
+    def rows(self, maxcolrow, focus=False):
         """How many rows this widget will occupy might depend on
         whether we have focus or not.
         This overrides the method from urwid.FlowWidget"""
-        return self.current_widget(focus).rows((maxcol,), focus=focus)
-    
+        return self.current_widget(focus).rows(maxcolrow, focus=focus)
+
     def current_widget(self, focus=False):
         if focus or self.opened:
             return self._focus_widget
         return self._widget
-    
+
     def update(self):
         "Called when what is visible on the screen should be updated."
         # How to add standout mode to a style
-        with_standout = { u"normal": u"standout",
-                          u"bold": u"bold-standout",
-                          u"underline-blink":
-                              u"underline-blink-standout",
-                          u"bold-underline-blink":
-                              u"bold-underline-blink-standout",
-                          }
+        with_standout = {"normal": "standout",
+                         "bold": "bold-standout",
+                         "underline-blink":
+                         "underline-blink-standout",
+                         "bold-underline-blink":
+                         "bold-underline-blink-standout",
+                         }
 
         # Rebuild focus and non-focus widgets using current properties
 
         # Base part of a client. Name!
-        base = (u'%(name)s: '
-                      % {u"name": self.properties[u"Name"]})
-        if not self.properties[u"Enabled"]:
-            message = u"DISABLED"
-        elif self.properties[u"ApprovalPending"]:
-            timeout = datetime.timedelta(milliseconds
-                                         = self.properties
-                                         [u"ApprovalDelay"])
+        base = '{name}: '.format(name=self.properties["Name"])
+        if not self.properties["Enabled"]:
+            message = "DISABLED"
+            self.using_timer(False)
+        elif self.properties["ApprovalPending"]:
+            timeout = datetime.timedelta(
+                milliseconds=self.properties["ApprovalDelay"])
             last_approval_request = isoformat_to_datetime(
-                self.properties[u"LastApprovalRequest"])
+                self.properties["LastApprovalRequest"])
             if last_approval_request is not None:
-                timer = timeout - (datetime.datetime.utcnow()
-                                   - last_approval_request)
+                timer = max(timeout - (datetime.datetime.utcnow()
+                                       - last_approval_request),
+                            datetime.timedelta())
             else:
                 timer = datetime.timedelta()
-            if self.properties[u"ApprovedByDefault"]:
-                message = u"Approval in %s. (d)eny?"
-            else:
-                message = u"Denial in %s. (a)pprove?"
-            message = message % unicode(timer).rsplit(".", 1)[0]
-        elif self.last_checker_failed:
-            timeout = datetime.timedelta(milliseconds
-                                         = self.properties
-                                         [u"Timeout"])
-            last_ok = isoformat_to_datetime(
-                max((self.properties[u"LastCheckedOK"]
-                     or self.properties[u"Created"]),
-                    self.properties[u"LastEnabled"]))
-            timer = timeout - (datetime.datetime.utcnow() - last_ok)
-            message = (u'A checker has failed! Time until client'
-                       u' gets disabled: %s'
-                           % unicode(timer).rsplit(".", 1)[0])
+            if self.properties["ApprovedByDefault"]:
+                message = "Approval in {}. (d)eny?"
+            else:
+                message = "Denial in {}. (a)pprove?"
+            message = message.format(str(timer).rsplit(".", 1)[0])
+            self.using_timer(True)
+        elif self.properties["LastCheckerStatus"] != 0:
+            # When checker has failed, show timer until client expires
+            expires = self.properties["Expires"]
+            if expires == "":
+                timer = datetime.timedelta(0)
+            else:
+                expires = (datetime.datetime.strptime
+                           (expires, '%Y-%m-%dT%H:%M:%S.%f'))
+                timer = max(expires - datetime.datetime.utcnow(),
+                            datetime.timedelta())
+            message = ('A checker has failed! Time until client'
+                       ' gets disabled: {}'
+                       .format(str(timer).rsplit(".", 1)[0]))
+            self.using_timer(True)
         else:
-            message = u"enabled"
-        self._text = "%s%s" % (base, message)
-            
+            message = "enabled"
+            self.using_timer(False)
+        self._text = "{}{}".format(base, message)
+
         if not urwid.supports_unicode():
             self._text = self._text.encode("ascii", "replace")
-        textlist = [(u"normal", self._text)]
+        textlist = [("normal", self._text)]
         self._text_widget.set_text(textlist)
         self._focus_text_widget.set_text([(with_standout[text[0]],
                                            text[1])
@@ -335,66 +305,84 @@
         # Run update hook, if any
         if self.update_hook is not None:
             self.update_hook()
-    
+
     def update_timer(self):
-        "called by gobject"
+        """called by GLib. Will indefinitely loop until
+        GLib.source_remove() on tag is called
+        """
         self.update()
         return True             # Keep calling this
-    
-    def delete(self):
+
+    def delete(self, **kwargs):
         if self._update_timer_callback_tag is not None:
-            gobject.source_remove(self._update_timer_callback_tag)
+            GLib.source_remove(self._update_timer_callback_tag)
             self._update_timer_callback_tag = None
+        for match in self.match_objects:
+            match.remove()
+        self.match_objects = ()
         if self.delete_hook is not None:
             self.delete_hook(self)
-    
-    def render(self, (maxcol,), focus=False):
+        return super(MandosClientWidget, self).delete(**kwargs)
+
+    def render(self, maxcolrow, focus=False):
         """Render differently if we have focus.
         This overrides the method from urwid.FlowWidget"""
-        return self.current_widget(focus).render((maxcol,),
+        return self.current_widget(focus).render(maxcolrow,
                                                  focus=focus)
-    
-    def keypress(self, (maxcol,), key):
+
+    def keypress(self, maxcolrow, key):
         """Handle keys.
         This overrides the method from urwid.FlowWidget"""
-        if key == u"+":
-            self.proxy.Enable(dbus_interface = client_interface)
-        elif key == u"-":
-            self.proxy.Disable(dbus_interface = client_interface)
-        elif key == u"a":
+        if key == "+":
+            self.proxy.Set(client_interface, "Enabled",
+                           dbus.Boolean(True), ignore_reply=True,
+                           dbus_interface=dbus.PROPERTIES_IFACE)
+        elif key == "-":
+            self.proxy.Set(client_interface, "Enabled", False,
+                           ignore_reply=True,
+                           dbus_interface=dbus.PROPERTIES_IFACE)
+        elif key == "a":
             self.proxy.Approve(dbus.Boolean(True, variant_level=1),
-                               dbus_interface = client_interface)
-        elif key == u"d":
+                               dbus_interface=client_interface,
+                               ignore_reply=True)
+        elif key == "d":
             self.proxy.Approve(dbus.Boolean(False, variant_level=1),
-                                  dbus_interface = client_interface)
-        elif key == u"R" or key == u"_" or key == u"ctrl k":
+                               dbus_interface=client_interface,
+                               ignore_reply=True)
+        elif key == "R" or key == "_" or key == "ctrl k":
             self.server_proxy_object.RemoveClient(self.proxy
-                                                  .object_path)
-        elif key == u"s":
-            self.proxy.StartChecker(dbus_interface = client_interface)
-        elif key == u"S":
-            self.proxy.StopChecker(dbus_interface = client_interface)
-        elif key == u"C":
-            self.proxy.CheckedOK(dbus_interface = client_interface)
+                                                  .object_path,
+                                                  ignore_reply=True)
+        elif key == "s":
+            self.proxy.Set(client_interface, "CheckerRunning",
+                           dbus.Boolean(True), ignore_reply=True,
+                           dbus_interface=dbus.PROPERTIES_IFACE)
+        elif key == "S":
+            self.proxy.Set(client_interface, "CheckerRunning",
+                           dbus.Boolean(False), ignore_reply=True,
+                           dbus_interface=dbus.PROPERTIES_IFACE)
+        elif key == "C":
+            self.proxy.CheckedOK(dbus_interface=client_interface,
+                                 ignore_reply=True)
         # xxx
-#         elif key == u"p" or key == "=":
+#         elif key == "p" or key == "=":
 #             self.proxy.pause()
-#         elif key == u"u" or key == ":":
+#         elif key == "u" or key == ":":
 #             self.proxy.unpause()
-#         elif key == u"RET":
+#         elif key == "RET":
 #             self.open()
         else:
             return key
-    
-    def property_changed(self, property=None, value=None,
-                         *args, **kwargs):
-        """Call self.update() if old value is not new value.
+
+    def properties_changed(self, interface, properties, invalidated):
+        """Call self.update() if any properties changed.
         This overrides the method from MandosClientPropertyCache"""
-        property_name = unicode(property)
-        old_value = self.properties.get(property_name)
-        super(MandosClientWidget, self).property_changed(
-            property=property, value=value, *args, **kwargs)
-        if self.properties.get(property_name) != old_value:
+        old_values = {key: self.properties.get(key)
+                      for key in properties.keys()}
+        super(MandosClientWidget, self).properties_changed(
+            interface, properties, invalidated)
+        if any(old_values[key] != self.properties.get(key)
+               for key in old_values):
             self.update()
 
 
@@ -403,10 +391,10 @@
     "down" key presses, thus not allowing any containing widgets to
     use them as an excuse to shift focus away from this widget.
     """
-    def keypress(self, (maxcol, maxrow), key):
-        ret = super(ConstrainedListBox, self).keypress((maxcol,
-                                                        maxrow), key)
-        if ret in (u"up", u"down"):
+    def keypress(self, *args, **kwargs):
+        ret = (super(ConstrainedListBox, self)
+               .keypress(*args, **kwargs))
+        if ret in ("up", "down"):
             return
         return ret
 
@@ -415,308 +403,331 @@
     """This is the entire user interface - the whole screen
     with boxes, lists of client widgets, etc.
     """
-    def __init__(self, max_log_length=1000):
+    def __init__(self, max_log_length=1000, log_level=1):
         DBusGMainLoop(set_as_default=True)
-        
+
         self.screen = urwid.curses_display.Screen()
-        
+
         self.screen.register_palette((
-                (u"normal",
-                 u"default", u"default", None),
-                (u"bold",
-                 u"default", u"default", u"bold"),
-                (u"underline-blink",
-                 u"default", u"default", u"underline"),
-                (u"standout",
-                 u"default", u"default", u"standout"),
-                (u"bold-underline-blink",
-                 u"default", u"default", (u"bold", u"underline")),
-                (u"bold-standout",
-                 u"default", u"default", (u"bold", u"standout")),
-                (u"underline-blink-standout",
-                 u"default", u"default", (u"underline", u"standout")),
-                (u"bold-underline-blink-standout",
-                 u"default", u"default", (u"bold", u"underline",
-                                          u"standout")),
+                ("normal",
+                 "default", "default", None),
+                ("bold",
+                 "bold", "default", "bold"),
+                ("underline-blink",
+                 "underline,blink", "default", "underline,blink"),
+                ("standout",
+                 "standout", "default", "standout"),
+                ("bold-underline-blink",
+                 "bold,underline,blink", "default",
+                 "bold,underline,blink"),
+                ("bold-standout",
+                 "bold,standout", "default", "bold,standout"),
+                ("underline-blink-standout",
+                 "underline,blink,standout", "default",
+                 "underline,blink,standout"),
+                ("bold-underline-blink-standout",
+                 "bold,underline,blink,standout", "default",
+                 "bold,underline,blink,standout"),
                 ))
-        
+
         if urwid.supports_unicode():
-            self.divider = u"─" # \u2500
-            #self.divider = u"━" # \u2501
+            self.divider = "─"  # \u2500
         else:
-            #self.divider = u"-" # \u002d
-            self.divider = u"_" # \u005f
-        
+            self.divider = "_"  # \u005f
+
         self.screen.start()
-        
+
         self.size = self.screen.get_cols_rows()
-        
+
         self.clients = urwid.SimpleListWalker([])
         self.clients_dict = {}
-        
+
         # We will add Text widgets to this list
         self.log = []
         self.max_log_length = max_log_length
-        
+
+        self.log_level = log_level
+
         # We keep a reference to the log widget so we can remove it
         # from the ListWalker without it getting destroyed
         self.logbox = ConstrainedListBox(self.log)
-        
+
         # This keeps track of whether self.uilist currently has
         # self.logbox in it or not
         self.log_visible = True
-        self.log_wrap = u"any"
-        
+        self.log_wrap = "any"
+
         self.rebuild()
-        self.log_message_raw((u"bold",
-                              u"Mandos Monitor version " + version))
-        self.log_message_raw((u"bold",
-                              u"q: Quit  ?: Help"))
-        
+        self.log_message_raw(("bold",
+                              "Mandos Monitor version " + version))
+        self.log_message_raw(("bold",
+                              "q: Quit  ?: Help"))
+
         self.busname = domain + '.Mandos'
-        self.main_loop = gobject.MainLoop()
-        self.bus = dbus.SystemBus()
-        mandos_dbus_objc = self.bus.get_object(
-            self.busname, u"/", follow_name_owner_changes=True)
-        self.mandos_serv = dbus.Interface(mandos_dbus_objc,
-                                          dbus_interface
-                                          = server_interface)
-        try:
-            mandos_clients = (self.mandos_serv
-                              .GetAllClientsWithProperties())
-        except dbus.exceptions.DBusException:
-            mandos_clients = dbus.Dictionary()
-        
-        (self.mandos_serv
-         .connect_to_signal(u"ClientRemoved",
-                            self.find_and_remove_client,
-                            dbus_interface=server_interface,
-                            byte_arrays=True))
-        (self.mandos_serv
-         .connect_to_signal(u"ClientAdded",
-                            self.add_new_client,
-                            dbus_interface=server_interface,
-                            byte_arrays=True))
-        (self.mandos_serv
-         .connect_to_signal(u"ClientNotFound",
-                            self.client_not_found,
-                            dbus_interface=server_interface,
-                            byte_arrays=True))
-        for path, client in mandos_clients.iteritems():
-            client_proxy_object = self.bus.get_object(self.busname,
-                                                      path)
-            self.add_client(MandosClientWidget(server_proxy_object
-                                               =self.mandos_serv,
-                                               proxy_object
-                                               =client_proxy_object,
-                                               properties=client,
-                                               update_hook
-                                               =self.refresh,
-                                               delete_hook
-                                               =self.remove_client,
-                                               logger
-                                               =self.log_message),
-                            path=path)
-    
+        self.main_loop = GLib.MainLoop()
+
     def client_not_found(self, fingerprint, address):
-        self.log_message((u"Client with address %s and fingerprint %s"
-                          u" could not be found" % (address,
-                                                    fingerprint)))
-    
+        self.log_message("Client with address {} and fingerprint {}"
+                         " could not be found"
+                         .format(address, fingerprint))
+
     def rebuild(self):
         """This rebuilds the User Interface.
         Call this when the widget layout needs to change"""
         self.uilist = []
-        #self.uilist.append(urwid.ListBox(self.clients))
+        # self.uilist.append(urwid.ListBox(self.clients))
         self.uilist.append(urwid.Frame(ConstrainedListBox(self.
                                                           clients),
-                                       #header=urwid.Divider(),
+                                       # header=urwid.Divider(),
                                        header=None,
-                                       footer=
-                                       urwid.Divider(div_char=
-                                                     self.divider)))
+                                       footer=urwid.Divider(
+                                           div_char=self.divider)))
         if self.log_visible:
             self.uilist.append(self.logbox)
-            pass
         self.topwidget = urwid.Pile(self.uilist)
-    
-    def log_message(self, message):
+
+    def log_message(self, message, level=1):
+        """Log message formatted with timestamp"""
+        if level < self.log_level:
+            return
         timestamp = datetime.datetime.now().isoformat()
-        self.log_message_raw(timestamp + u": " + message)
-    
-    def log_message_raw(self, markup):
+        self.log_message_raw("{}: {}".format(timestamp, message),
+                             level=level)
+
+    def log_message_raw(self, markup, level=1):
         """Add a log message to the log buffer."""
+        if level < self.log_level:
+            return
         self.log.append(urwid.Text(markup, wrap=self.log_wrap))
-        if (self.max_log_length
-            and len(self.log) > self.max_log_length):
-            del self.log[0:len(self.log)-self.max_log_length-1]
+        if self.max_log_length:
+            if len(self.log) > self.max_log_length:
+                del self.log[0:len(self.log)-self.max_log_length-1]
         self.logbox.set_focus(len(self.logbox.body.contents),
-                              coming_from=u"above")
+                              coming_from="above")
         self.refresh()
-    
+
     def toggle_log_display(self):
         """Toggle visibility of the log buffer."""
         self.log_visible = not self.log_visible
         self.rebuild()
-        #self.log_message(u"Log visibility changed to: "
-        #                 + unicode(self.log_visible))
-    
+        self.log_message("Log visibility changed to: {}"
+                         .format(self.log_visible), level=0)
+
     def change_log_display(self):
         """Change type of log display.
         Currently, this toggles wrapping of text lines."""
-        if self.log_wrap == u"clip":
-            self.log_wrap = u"any"
+        if self.log_wrap == "clip":
+            self.log_wrap = "any"
         else:
-            self.log_wrap = u"clip"
+            self.log_wrap = "clip"
         for textwidget in self.log:
             textwidget.set_wrap_mode(self.log_wrap)
-        #self.log_message(u"Wrap mode: " + self.log_wrap)
-    
-    def find_and_remove_client(self, path, name):
-        """Find an client from its object path and remove it.
-        
-        This is connected to the ClientRemoved signal from the
+        self.log_message("Wrap mode: {}".format(self.log_wrap),
+                         level=0)
+
+    def find_and_remove_client(self, path, interfaces):
+        """Find a client by its object path and remove it.
+
+        This is connected to the InterfacesRemoved signal from the
         Mandos server object."""
+        if client_interface not in interfaces:
+            # Not a Mandos client object; ignore
+            return
         try:
             client = self.clients_dict[path]
         except KeyError:
             # not found?
-            return
-        self.remove_client(client, path)
-    
-    def add_new_client(self, path):
+            self.log_message("Unknown client {!r} removed"
+                             .format(path))
+            return
+        client.delete()
+
+    def add_new_client(self, path, ifs_and_props):
+        """Find a client by its object path and remove it.
+
+        This is connected to the InterfacesAdded signal from the
+        Mandos server object.
+        """
+        if client_interface not in ifs_and_props:
+            # Not a Mandos client object; ignore
+            return
         client_proxy_object = self.bus.get_object(self.busname, path)
-        self.add_client(MandosClientWidget(server_proxy_object
-                                           =self.mandos_serv,
-                                           proxy_object
-                                           =client_proxy_object,
-                                           update_hook
-                                           =self.refresh,
-                                           delete_hook
-                                           =self.remove_client,
-                                           logger
-                                           =self.log_message),
+        self.add_client(MandosClientWidget(
+            server_proxy_object=self.mandos_serv,
+            proxy_object=client_proxy_object,
+            update_hook=self.refresh,
+            delete_hook=self.remove_client,
+            logger=self.log_message,
+            properties=dict(ifs_and_props[client_interface])),
                         path=path)
-    
+
     def add_client(self, client, path=None):
         self.clients.append(client)
         if path is None:
             path = client.proxy.object_path
         self.clients_dict[path] = client
-        self.clients.sort(None, lambda c: c.properties[u"Name"])
+        self.clients.sort(key=lambda c: c.properties["Name"])
         self.refresh()
-    
+
     def remove_client(self, client, path=None):
         self.clients.remove(client)
         if path is None:
             path = client.proxy.object_path
         del self.clients_dict[path]
-        if not self.clients_dict:
-            # Work around bug in Urwid 0.9.8.3 - if a SimpleListWalker
-            # is completely emptied, we need to recreate it.
-            self.clients = urwid.SimpleListWalker([])
-            self.rebuild()
         self.refresh()
-    
+
     def refresh(self):
         """Redraw the screen"""
         canvas = self.topwidget.render(self.size, focus=True)
         self.screen.draw_screen(self.size, canvas)
-    
+
     def run(self):
         """Start the main loop and exit when it's done."""
+        self.bus = dbus.SystemBus()
+        mandos_dbus_objc = self.bus.get_object(
+            self.busname, "/", follow_name_owner_changes=True)
+        self.mandos_serv = dbus.Interface(
+            mandos_dbus_objc, dbus_interface=server_interface)
+        try:
+            mandos_clients = (self.mandos_serv
+                              .GetAllClientsWithProperties())
+            if not mandos_clients:
+                self.log_message_raw(("bold",
+                                      "Note: Server has no clients."))
+        except dbus.exceptions.DBusException:
+            self.log_message_raw(("bold",
+                                  "Note: No Mandos server running."))
+            mandos_clients = dbus.Dictionary()
+
+        (self.mandos_serv
+         .connect_to_signal("InterfacesRemoved",
+                            self.find_and_remove_client,
+                            dbus_interface=dbus.OBJECT_MANAGER_IFACE,
+                            byte_arrays=True))
+        (self.mandos_serv
+         .connect_to_signal("InterfacesAdded",
+                            self.add_new_client,
+                            dbus_interface=dbus.OBJECT_MANAGER_IFACE,
+                            byte_arrays=True))
+        (self.mandos_serv
+         .connect_to_signal("ClientNotFound",
+                            self.client_not_found,
+                            dbus_interface=server_interface,
+                            byte_arrays=True))
+        for path, client in mandos_clients.items():
+            client_proxy_object = self.bus.get_object(self.busname,
+                                                      path)
+            self.add_client(MandosClientWidget(
+                server_proxy_object=self.mandos_serv,
+                proxy_object=client_proxy_object,
+                properties=client,
+                update_hook=self.refresh,
+                delete_hook=self.remove_client,
+                logger=self.log_message),
+                            path=path)
+
         self.refresh()
-        self._input_callback_tag = (gobject.io_add_watch
+        self._input_callback_tag = (GLib.io_add_watch
                                     (sys.stdin.fileno(),
-                                     gobject.IO_IN,
+                                     GLib.IO_IN,
                                      self.process_input))
         self.main_loop.run()
         # Main loop has finished, we should close everything now
-        gobject.source_remove(self._input_callback_tag)
+        GLib.source_remove(self._input_callback_tag)
         self.screen.stop()
-    
+
     def stop(self):
         self.main_loop.quit()
-    
+
     def process_input(self, source, condition):
         keys = self.screen.get_input()
-        translations = { u"ctrl n": u"down",      # Emacs
-                         u"ctrl p": u"up",        # Emacs
-                         u"ctrl v": u"page down", # Emacs
-                         u"meta v": u"page up",   # Emacs
-                         u" ": u"page down",      # less
-                         u"f": u"page down",      # less
-                         u"b": u"page up",        # less
-                         u"j": u"down",           # vi
-                         u"k": u"up",             # vi
-                         }
+        translations = {"ctrl n": "down",       # Emacs
+                        "ctrl p": "up",         # Emacs
+                        "ctrl v": "page down",  # Emacs
+                        "meta v": "page up",    # Emacs
+                        " ": "page down",       # less
+                        "f": "page down",       # less
+                        "b": "page up",         # less
+                        "j": "down",            # vi
+                        "k": "up",              # vi
+                        }
         for key in keys:
             try:
                 key = translations[key]
             except KeyError:    # :-)
                 pass
-            
-            if key == u"q" or key == u"Q":
+
+            if key == "q" or key == "Q":
                 self.stop()
                 break
-            elif key == u"window resize":
+            elif key == "window resize":
                 self.size = self.screen.get_cols_rows()
                 self.refresh()
-            elif key == u"\f":  # Ctrl-L
+            elif key == "ctrl l":
+                self.screen.clear()
                 self.refresh()
-            elif key == u"l" or key == u"D":
+            elif key == "l" or key == "D":
                 self.toggle_log_display()
                 self.refresh()
-            elif key == u"w" or key == u"i":
+            elif key == "w" or key == "i":
                 self.change_log_display()
                 self.refresh()
-            elif key == u"?" or key == u"f1" or key == u"esc":
+            elif key == "?" or key == "f1" or key == "esc":
                 if not self.log_visible:
                     self.log_visible = True
                     self.rebuild()
-                self.log_message_raw((u"bold",
-                                      u"  ".
-                                      join((u"q: Quit",
-                                            u"?: Help",
-                                            u"l: Log window toggle",
-                                            u"TAB: Switch window",
-                                            u"w: Wrap (log)"))))
-                self.log_message_raw((u"bold",
-                                      u"  "
-                                      .join((u"Clients:",
-                                             u"+: Enable",
-                                             u"-: Disable",
-                                             u"R: Remove",
-                                             u"s: Start new checker",
-                                             u"S: Stop checker",
-                                             u"C: Checker OK",
-                                             u"a: Approve",
-                                             u"d: Deny"))))
+                self.log_message_raw(("bold",
+                                      "  ".
+                                      join(("q: Quit",
+                                            "?: Help",
+                                            "l: Log window toggle",
+                                            "TAB: Switch window",
+                                            "w: Wrap (log lines)",
+                                            "v: Toggle verbose log",
+                                            ))))
+                self.log_message_raw(("bold",
+                                      "  "
+                                      .join(("Clients:",
+                                             "+: Enable",
+                                             "-: Disable",
+                                             "R: Remove",
+                                             "s: Start new checker",
+                                             "S: Stop checker",
+                                             "C: Checker OK",
+                                             "a: Approve",
+                                             "d: Deny"))))
                 self.refresh()
-            elif key == u"tab":
+            elif key == "tab":
                 if self.topwidget.get_focus() is self.logbox:
                     self.topwidget.set_focus(0)
                 else:
                     self.topwidget.set_focus(self.logbox)
                 self.refresh()
-            #elif (key == u"end" or key == u"meta >" or key == u"G"
-            #      or key == u">"):
-            #    pass            # xxx end-of-buffer
-            #elif (key == u"home" or key == u"meta <" or key == u"g"
-            #      or key == u"<"):
-            #    pass            # xxx beginning-of-buffer
-            #elif key == u"ctrl e" or key == u"$":
-            #    pass            # xxx move-end-of-line
-            #elif key == u"ctrl a" or key == u"^":
-            #    pass            # xxx move-beginning-of-line
-            #elif key == u"ctrl b" or key == u"meta (" or key == u"h":
-            #    pass            # xxx left
-            #elif key == u"ctrl f" or key == u"meta )" or key == u"l":
-            #    pass            # xxx right
-            #elif key == u"a":
-            #    pass            # scroll up log
-            #elif key == u"z":
-            #    pass            # scroll down log
+            elif key == "v":
+                if self.log_level == 0:
+                    self.log_level = 1
+                    self.log_message("Verbose mode: Off")
+                else:
+                    self.log_level = 0
+                    self.log_message("Verbose mode: On")
+            # elif (key == "end" or key == "meta >" or key == "G"
+            #       or key == ">"):
+            #     pass            # xxx end-of-buffer
+            # elif (key == "home" or key == "meta <" or key == "g"
+            #       or key == "<"):
+            #     pass            # xxx beginning-of-buffer
+            # elif key == "ctrl e" or key == "$":
+            #     pass            # xxx move-end-of-line
+            # elif key == "ctrl a" or key == "^":
+            #     pass            # xxx move-beginning-of-line
+            # elif key == "ctrl b" or key == "meta (" or key == "h":
+            #     pass            # xxx left
+            # elif key == "ctrl f" or key == "meta )" or key == "l":
+            #     pass            # xxx right
+            # elif key == "a":
+            #     pass            # scroll up log
+            # elif key == "z":
+            #     pass            # scroll down log
             elif self.topwidget.selectable():
                 self.topwidget.keypress(self.size, key)
                 self.refresh()
@@ -727,7 +738,7 @@
     ui.run()
 except KeyboardInterrupt:
     ui.screen.stop()
-except Exception, e:
-    ui.log_message(unicode(e))
+except Exception as e:
+    ui.log_message(str(e))
     ui.screen.stop()
     raise

=== modified file 'mandos-monitor.xml'
--- mandos-monitor.xml	2010-09-30 06:24:20 +0000
+++ mandos-monitor.xml	2016-03-05 21:46:00 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-monitor">
-<!ENTITY TIMESTAMP "2010-09-14">
+<!ENTITY TIMESTAMP "2016-03-05">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -19,19 +19,25 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@fukt.bsnet.se</email>
+	  <email>belorn@recompile.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@fukt.bsnet.se</email>
+	  <email>teddy@recompile.se</email>
 	</address>
       </author>
     </authorgroup>
     <copyright>
       <year>2010</year>
+      <year>2011</year>
+      <year>2012</year>
+      <year>2013</year>
+      <year>2014</year>
+      <year>2015</year>
+      <year>2016</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -127,6 +133,10 @@
 	<entry>Toggle log window line wrap</entry>
       </row>
       <row>
+	<entry>v</entry>
+	<entry>Toggle verbose logging</entry>
+      </row>
+      <row>
 	<entry>Up, Ctrl-P, k</entry>
 	<entry>Move up a line</entry>
       </row>
@@ -189,9 +199,10 @@
     <title>BUGS</title>
     <para>
       This program can currently only be used to monitor and control a
-      Mandos server with the default D-Bus service name of
-      <quote>Mandos</quote>.
+      Mandos server with the default D-Bus bus name of
+      <quote>se.recompile.Mandos</quote>.
     </para>
+    <xi:include href="bugs.xml"/>
   </refsect1>
   
   <refsect1 id="example">
@@ -218,6 +229,8 @@
   <refsect1 id="see_also">
     <title>SEE ALSO</title>
     <para>
+      <citerefentry><refentrytitle>intro</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>mandos</refentrytitle>
       <manvolnum>8</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>mandos-ctl</refentrytitle>

=== modified file 'mandos-options.xml'
--- mandos-options.xml	2009-02-13 05:38:21 +0000
+++ mandos-options.xml	2015-07-20 03:03:33 +0000
@@ -49,12 +49,15 @@
   <para id="priority">
     GnuTLS priority string for the <acronym>TLS</acronym> handshake.
     The default is <quote><literal
-    >SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP</literal></quote>.  See
-    <citerefentry><refentrytitle>gnutls_priority_init</refentrytitle>
+    >SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP:!RSA</literal>
+    <literal>:+SIGN-DSA-SHA256</literal></quote>.
+    See <citerefentry><refentrytitle
+    >gnutls_priority_init</refentrytitle>
     <manvolnum>3</manvolnum></citerefentry> for the syntax.
     <emphasis>Warning</emphasis>: changing this may make the
     <acronym>TLS</acronym> handshake fail, making server-client
-    communication impossible.
+    communication impossible.  Changing this option may also make the
+    network traffic decryptable by an attacker.
   </para>
   
   <para id="servicename">
@@ -86,4 +89,35 @@
     advanced users should consider changing this option</emphasis>.
   </para>
   
+  <para id="restore">
+    This option controls whether the server will restore its state
+    from the last time it ran.  Default is to restore last state.
+  </para>
+  
+  <para id="statedir">
+    Directory to save (and restore) state in.  Default is
+    <quote><filename
+    class="directory">/var/lib/mandos</filename></quote>.
+  </para>
+  
+  <para id="socket">
+    If this option is used, the server will not create a new network
+    socket, but will instead use the supplied file descriptor.  By
+    default, the server will create a new network socket.
+  </para>
+  
+  <para id="foreground">
+    This option will make the server run in the foreground and not
+    write a PID file.  The default is to <emphasis>not</emphasis> run
+    in the foreground, except in <option>debug</option> mode, which
+    implies this option.
+  </para>
+  
+  <para id="zeroconf">
+    This option controls whether the server will announce its
+    existence using Zeroconf.  Default is to use Zeroconf.  If
+    Zeroconf is not used, a <option>port</option> number or a
+    <option>socket</option> is required.
+  </para>
+  
 </section>

=== modified file 'mandos.conf'
--- mandos.conf	2009-02-13 05:38:21 +0000
+++ mandos.conf	2015-07-20 03:03:33 +0000
@@ -4,32 +4,26 @@
 # These are the default values for the server, uncomment and change
 # them if needed.
 
-
 # If "interface" is set, the server will only listen to a specific
 # network interface.
 ;interface = 
 
-
 # If "address" is set, the server will only listen to a specific
 # address.  This must currently be an IPv6 address; an IPv4 address
 # can be specified using the "::FFFF:192.0.2.3" syntax.  Also, if this
 # is a link-local address, an interface should be set above.
 ;address =
 
-
 # If "port" is set, the server to bind to that port. By default, the
 # server will listen to an arbitrary port.
 ;port = 
 
-
 # If "debug" is true, the server will run in the foreground and print
 # a lot of debugging information.
 ;debug = False
 
-
 # GnuTLS priority for the TLS handshake.  See gnutls_priority_init(3).
-;priority = SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP
-
+;priority = SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP:!RSA:+SIGN-DSA-SHA256
 
 # Zeroconf service name.  You need to change this if you for some
 # reason want to run more than one server on the same *host*.
@@ -42,3 +36,18 @@
 
 # Whether to use IPv6.  (Changing this is NOT recommended.)
 ;use_ipv6 = True
+
+# Whether to restore saved state on startup
+;restore = True
+
+# The directory where state is saved
+;statedir = /var/lib/mandos
+
+# Whether to run in the foreground
+;foreground = False
+
+# File descriptor number to use for network socket
+;socket = 
+
+# Whether to use ZeroConf; if false, requires port or socket
+;zeroconf = True

=== modified file 'mandos.conf.xml'
--- mandos.conf.xml	2009-02-25 01:14:29 +0000
+++ mandos.conf.xml	2016-03-05 21:42:56 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY CONFNAME "mandos.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/mandos.conf</filename>">
-<!ENTITY TIMESTAMP "2009-02-25">
+<!ENTITY TIMESTAMP "2016-03-05">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -20,20 +20,27 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@fukt.bsnet.se</email>
+	  <email>belorn@recompile.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@fukt.bsnet.se</email>
+	  <email>teddy@recompile.se</email>
 	</address>
       </author>
     </authorgroup>
     <copyright>
       <year>2008</year>
       <year>2009</year>
+      <year>2010</year>
+      <year>2011</year>
+      <year>2012</year>
+      <year>2013</year>
+      <year>2014</year>
+      <year>2015</year>
+      <year>2016</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -153,6 +160,33 @@
 	</listitem>
       </varlistentry>
       
+      <varlistentry>
+	<term><option>restore<literal> = </literal>{ <literal
+	  >1</literal> | <literal>yes</literal> | <literal
+	  >true</literal> | <literal>on</literal> | <literal
+	  >0</literal> | <literal>no</literal> | <literal
+	  >false</literal> | <literal>off</literal> }</option></term>
+	<listitem>
+	  <xi:include href="mandos-options.xml" xpointer="restore"/>
+	</listitem>
+      </varlistentry>
+      
+      <varlistentry>
+	<term><option>statedir<literal> = </literal><replaceable
+	>DIRECTORY</replaceable></option></term>
+	<listitem>
+	  <xi:include href="mandos-options.xml" xpointer="statedir"/>
+	</listitem>
+      </varlistentry>
+      
+      <varlistentry>
+	<term><option>socket<literal> = </literal><replaceable
+	>NUMBER</replaceable></option></term>
+	<listitem>
+	  <xi:include href="mandos-options.xml" xpointer="socket"/>
+	</listitem>
+      </varlistentry>
+      
     </variablelist>
   </refsect1>
   
@@ -170,6 +204,7 @@
       built-in module <systemitem class="library">ConfigParser</systemitem>
       requires it.
     </para>
+    <xi:include href="bugs.xml"/>
   </refsect1>
   
   <refsect1 id="example">
@@ -192,11 +227,13 @@
 interface = eth0
 address = fe80::aede:48ff:fe71:f6f2
 port = 1025
-debug = true
-priority = SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP
+debug = True
+priority = SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP:!RSA
 servicename = Daena
 use_dbus = False
 use_ipv6 = True
+restore = True
+statedir = /var/lib/mandos
       </programlisting>
     </informalexample>
   </refsect1>
@@ -204,6 +241,8 @@
   <refsect1 id="see_also">
     <title>SEE ALSO</title>
     <para>
+      <citerefentry><refentrytitle>intro</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>gnutls_priority_init</refentrytitle
       ><manvolnum>3</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>mandos</refentrytitle>

=== modified file 'mandos.lsm'
--- mandos.lsm	2010-10-02 17:23:41 +0000
+++ mandos.lsm	2016-10-08 04:33:04 +0000
@@ -1,22 +1,23 @@
 Begin4
 Title:		Mandos
-Version:	1.2.1
-Entered-date:	2010-10-02
+Version:	1.7.13
+Entered-date:	2016-10-08
 Description:	The Mandos system allows computers to have encrypted
-root file systems and at the same time be capable of remote and/or
-unattended reboots.
+		root file systems and at the same time be capable of
+		remote and/or unattended reboots.
 Keywords:	boot, encryption, luks, cryptsetup, network, openpgp,
-tls, dm-crypt
-Author:		teddy@fukt.bsnet.se (Teddy Hogeborn),
-		belorn@fukt.bsnet.se (Björn Påhlsson)
-Maintained-by:	teddy@fukt.bsnet.se (Teddy Hogeborn),
-		belorn@fukt.bsnet.se (Björn Påhlsson)
-Primary-site: http://www.fukt.bsnet.se/mandos
-	      130K mandos_1.2.1.orig.tar.gz
-Alternate-site: ftp://ftp.fukt.bsnet.se/pub/mandos
-		130K mandos_1.2.1.orig.tar.gz
-Platforms:	Requires GCC, GNU libC, Avahi, GnuPG, Python 2.5, and
-various other libraries.  While made for Debian GNU/Linux, it is
-probably portable to other distributions, but not other Unixes.
-Copying-policy: GNU General Public License version 3.0 or later
+		tls, dm-crypt
+Author:		teddy@recompile.se (Teddy Hogeborn),
+		belorn@recompile.se (Björn Påhlsson)
+Maintained-by:	teddy@recompile.se (Teddy Hogeborn),
+		belorn@recompile.se (Björn Påhlsson)
+Primary-site:	https://www.recompile.se/mandos
+		173K mandos_1.7.13.orig.tar.gz
+Alternate-site:	ftp://ftp.recompile.se/pub/mandos
+		173K mandos_1.7.13.orig.tar.gz
+Platforms:	Requires GCC, GNU libC, Avahi, GnuPG, Python 2.7, and
+		various other libraries.  While made for Debian
+		GNU/Linux, it is probably portable to other
+		distributions, but not other Unixes.
+Copying-policy:	GNU General Public License version 3.0 or later
 End

=== added file 'mandos.service'
--- mandos.service	1970-01-01 00:00:00 +0000
+++ mandos.service	2016-03-13 00:37:02 +0000
@@ -0,0 +1,33 @@
+[Unit]
+Description=Server of encrypted passwords to Mandos clients
+Documentation=man:intro(8mandos) man:mandos(8)
+## If the server is configured to listen to a specific IP or network
+## interface, it may be necessary to change "network.target" to
+## "network-online.target".
+After=network.target
+## If the server is configured to not use ZeroConf, these two lines
+## become unnecessary and should be removed or commented out.
+After=avahi-daemon.service
+RequisiteOverridable=avahi-daemon.service
+
+[Service]
+## If the server's D-Bus interface is disabled, the "BusName" setting
+## should be removed or commented out.
+BusName=se.recompile.Mandos
+ExecStart=/usr/sbin/mandos --foreground
+Restart=always
+KillMode=mixed
+## Using socket activation won't work, because systemd always does
+## bind() on the socket, and also won't announce the ZeroConf service.
+#ExecStart=/usr/sbin/mandos --foreground --socket=0
+#StandardInput=socket
+# Restrict what the Mandos daemon can do.  Note that this also affects
+# "checker" programs!
+PrivateTmp=yes
+PrivateDevices=yes
+ProtectSystem=full
+ProtectHome=yes
+CapabilityBoundingSet=CAP_KILL CAP_SETGID CAP_SETUID CAP_DAC_OVERRIDE CAP_NET_RAW
+
+[Install]
+WantedBy=multi-user.target

=== modified file 'mandos.xml'
--- mandos.xml	2010-09-27 17:39:03 +0000
+++ mandos.xml	2016-07-03 03:32:28 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos">
-<!ENTITY TIMESTAMP "2010-09-26">
+<!ENTITY TIMESTAMP "2016-07-03">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -19,14 +19,14 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@fukt.bsnet.se</email>
+	  <email>belorn@recompile.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@fukt.bsnet.se</email>
+	  <email>teddy@recompile.se</email>
 	</address>
       </author>
     </authorgroup>
@@ -34,6 +34,12 @@
       <year>2008</year>
       <year>2009</year>
       <year>2010</year>
+      <year>2011</year>
+      <year>2012</year>
+      <year>2013</year>
+      <year>2014</year>
+      <year>2015</year>
+      <year>2016</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -93,6 +99,18 @@
       <arg><option>--no-dbus</option></arg>
       <sbr/>
       <arg><option>--no-ipv6</option></arg>
+      <sbr/>
+      <arg><option>--no-restore</option></arg>
+      <sbr/>
+      <arg><option>--statedir
+      <replaceable>DIRECTORY</replaceable></option></arg>
+      <sbr/>
+      <arg><option>--socket
+      <replaceable>FD</replaceable></option></arg>
+      <sbr/>
+      <arg><option>--foreground</option></arg>
+      <sbr/>
+      <arg><option>--no-zeroconf</option></arg>
     </cmdsynopsis>
     <cmdsynopsis>
       <command>&COMMANDNAME;</command>
@@ -116,14 +134,16 @@
     <para>
       <command>&COMMANDNAME;</command> is a server daemon which
       handles incoming request for passwords for a pre-defined list of
-      client host computers.  The Mandos server uses Zeroconf to
-      announce itself on the local network, and uses TLS to
-      communicate securely with and to authenticate the clients.  The
-      Mandos server uses IPv6 to allow Mandos clients to use IPv6
-      link-local addresses, since the clients will probably not have
-      any other addresses configured (see <xref linkend="overview"/>).
-      Any authenticated client is then given the stored pre-encrypted
-      password for that specific client.
+      client host computers. For an introduction, see
+      <citerefentry><refentrytitle>intro</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>. The Mandos server
+      uses Zeroconf to announce itself on the local network, and uses
+      TLS to communicate securely with and to authenticate the
+      clients.  The Mandos server uses IPv6 to allow Mandos clients to
+      use IPv6 link-local addresses, since the clients will probably
+      not have any other addresses configured (see <xref
+      linkend="overview"/>).  Any authenticated client is then given
+      the stored pre-encrypted password for that specific client.
     </para>
   </refsect1>
   
@@ -272,6 +292,48 @@
 	  <xi:include href="mandos-options.xml" xpointer="ipv6"/>
 	</listitem>
       </varlistentry>
+      
+      <varlistentry>
+	<term><option>--no-restore</option></term>
+	<listitem>
+	  <xi:include href="mandos-options.xml" xpointer="restore"/>
+	  <para>
+	    See also <xref linkend="persistent_state"/>.
+	  </para>
+	</listitem>
+      </varlistentry>
+      
+      <varlistentry>
+	<term><option>--statedir
+	<replaceable>DIRECTORY</replaceable></option></term>
+	<listitem>
+	  <xi:include href="mandos-options.xml" xpointer="statedir"/>
+	</listitem>
+      </varlistentry>
+      
+      <varlistentry>
+	<term><option>--socket
+	<replaceable>FD</replaceable></option></term>
+	<listitem>
+	  <xi:include href="mandos-options.xml" xpointer="socket"/>
+	</listitem>
+      </varlistentry>
+      
+      <varlistentry>
+	<term><option>--foreground</option></term>
+	<listitem>
+	  <xi:include href="mandos-options.xml"
+		      xpointer="foreground"/>
+	</listitem>
+      </varlistentry>
+      
+      <varlistentry>
+	<term><option>--no-zeroconf</option></term>
+	<listitem>
+	  <xi:include href="mandos-options.xml" xpointer="zeroconf"/>
+	</listitem>
+      </varlistentry>
+      
     </variablelist>
   </refsect1>
   
@@ -351,12 +413,10 @@
       for some time, the client is assumed to be compromised and is no
       longer eligible to receive the encrypted password.  (Manual
       intervention is required to re-enable a client.)  The timeout,
-      checker program, and interval between checks can be configured
-      both globally and per client; see <citerefentry>
-      <refentrytitle>mandos-clients.conf</refentrytitle>
-      <manvolnum>5</manvolnum></citerefentry>.  A client successfully
-      receiving its password will also be treated as a successful
-      checker run.
+      extended timeout, checker program, and interval between checks
+      can be configured both globally and per client; see
+      <citerefentry><refentrytitle>mandos-clients.conf</refentrytitle>
+      <manvolnum>5</manvolnum></citerefentry>.
     </para>
   </refsect1>
   
@@ -384,12 +444,24 @@
     <title>LOGGING</title>
     <para>
       The server will send log message with various severity levels to
-      <filename>/dev/log</filename>.  With the
+      <filename class="devicefile">/dev/log</filename>.  With the
       <option>--debug</option> option, it will log even more messages,
       and also show them on the console.
     </para>
   </refsect1>
   
+  <refsect1 id="persistent_state">
+    <title>PERSISTENT STATE</title>
+    <para>
+      Client settings, initially read from
+      <filename>clients.conf</filename>, are persistent across
+      restarts, and run-time changes will override settings in
+      <filename>clients.conf</filename>.  However, if a setting is
+      <emphasis>changed</emphasis> (or a client added, or removed) in
+      <filename>clients.conf</filename>, this will take precedence.
+    </para>
+  </refsect1>
+  
   <refsect1 id="dbus_interface">
     <title>D-BUS INTERFACE</title>
     <para>
@@ -457,16 +529,31 @@
 	</listitem>
       </varlistentry>
       <varlistentry>
-	<term><filename>/var/run/mandos.pid</filename></term>
+	<term><filename>/run/mandos.pid</filename></term>
 	<listitem>
 	  <para>
 	    The file containing the process id of the
 	    <command>&COMMANDNAME;</command> process started last.
-	  </para>
-	</listitem>
-      </varlistentry>
-      <varlistentry>
-	<term><filename>/dev/log</filename></term>
+	    <emphasis >Note:</emphasis> If the <filename
+	    class="directory">/run</filename> directory does not
+	    exist, <filename>/var/run/mandos.pid</filename> will be
+	    used instead.
+	  </para>
+	</listitem>
+      </varlistentry>
+      <varlistentry>
+	<term><filename
+	class="directory">/var/lib/mandos</filename></term>
+	<listitem>
+	  <para>
+	    Directory where persistent state will be saved.  Change
+	    this with the <option>--statedir</option> option.  See
+	    also the <option>--no-restore</option> option.
+	  </para>
+	</listitem>
+      </varlistentry>
+      <varlistentry>
+	<term><filename class="devicefile">/dev/log</filename></term>
 	<listitem>
 	  <para>
 	    The Unix domain socket to where local syslog messages are
@@ -495,23 +582,13 @@
       backtrace.  This could be considered a feature.
     </para>
     <para>
-      Currently, if a client is disabled due to having timed out, the
-      server does not record this fact onto permanent storage.  This
-      has some security implications, see <xref linkend="clients"/>.
-    </para>
-    <para>
       There is no fine-grained control over logging and debug output.
     </para>
     <para>
-      Debug mode is conflated with running in the foreground.
-    </para>
-    <para>
-      The console log messages do not show a time stamp.
-    </para>
-    <para>
       This server does not check the expire time of clients’ OpenPGP
       keys.
     </para>
+    <xi:include href="bugs.xml"/>
   </refsect1>
   
   <refsect1 id="example">
@@ -527,9 +604,9 @@
     <informalexample>
       <para>
 	Run the server in debug mode, read configuration files from
-	the <filename>~/mandos</filename> directory, and use the
-	Zeroconf service name <quote>Test</quote> to not collide with
-	any other official Mandos server on this host:
+	the <filename class="directory">~/mandos</filename> directory,
+	and use the Zeroconf service name <quote>Test</quote> to not
+	collide with any other official Mandos server on this host:
       </para>
       <para>
 
@@ -584,21 +661,6 @@
 	compromised if they are gone for too long.
       </para>
       <para>
-	If a client is compromised, its downtime should be duly noted
-	by the server which would therefore disable the client.  But
-	if the server was ever restarted, it would re-read its client
-	list from its configuration file and again regard all clients
-	therein as enabled, and hence eligible to receive their
-	passwords.  Therefore, be careful when restarting servers if
-	it is suspected that a client has, in fact, been compromised
-	by parties who may now be running a fake Mandos client with
-	the keys from the non-encrypted initial <acronym>RAM</acronym>
-	image of the client host.  What should be done in that case
-	(if restarting the server program really is necessary) is to
-	stop the server program, edit the configuration file to omit
-	any suspect clients, and restart the server program.
-      </para>
-      <para>
 	For more details on client-side security, see
 	<citerefentry><refentrytitle>mandos-client</refentrytitle>
 	<manvolnum>8mandos</manvolnum></citerefentry>.
@@ -609,15 +671,16 @@
   <refsect1 id="see_also">
     <title>SEE ALSO</title>
     <para>
-      <citerefentry>
-	<refentrytitle>mandos-clients.conf</refentrytitle>
-	<manvolnum>5</manvolnum></citerefentry>, <citerefentry>
-	<refentrytitle>mandos.conf</refentrytitle>
-	<manvolnum>5</manvolnum></citerefentry>, <citerefentry>
-	<refentrytitle>mandos-client</refentrytitle>
-	<manvolnum>8mandos</manvolnum></citerefentry>, <citerefentry>
-	<refentrytitle>sh</refentrytitle><manvolnum>1</manvolnum>
-      </citerefentry>
+      <citerefentry><refentrytitle>intro</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>mandos-clients.conf</refentrytitle>
+      <manvolnum>5</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>mandos.conf</refentrytitle>
+      <manvolnum>5</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>mandos-client</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>sh</refentrytitle>
+      <manvolnum>1</manvolnum></citerefentry>
     </para>
     <variablelist>
       <varlistentry>
@@ -644,8 +707,7 @@
       </varlistentry>
       <varlistentry>
 	<term>
-	  <ulink url="http://www.gnu.org/software/gnutls/"
-	  >GnuTLS</ulink>
+	  <ulink url="https://gnutls.org/">GnuTLS</ulink>
 	</term>
       <listitem>
 	<para>
@@ -689,12 +751,12 @@
       </varlistentry>
       <varlistentry>
 	<term>
-	  RFC 4346: <citetitle>The Transport Layer Security (TLS)
-	  Protocol Version 1.1</citetitle>
+	  RFC 5246: <citetitle>The Transport Layer Security (TLS)
+	  Protocol Version 1.2</citetitle>
 	</term>
       <listitem>
 	<para>
-	  TLS 1.1 is the protocol implemented by GnuTLS.
+	  TLS 1.2 is the protocol implemented by GnuTLS.
 	</para>
       </listitem>
       </varlistentry>
@@ -710,8 +772,8 @@
       </varlistentry>
       <varlistentry>
 	<term>
-	  RFC 5081: <citetitle>Using OpenPGP Keys for Transport Layer
-	  Security</citetitle>
+	  RFC 6091: <citetitle>Using OpenPGP Keys for Transport Layer
+	  Security (TLS) Authentication</citetitle>
 	</term>
       <listitem>
 	<para>

=== added directory 'network-hooks.d'
=== added file 'network-hooks.d/bridge'
--- network-hooks.d/bridge	1970-01-01 00:00:00 +0000
+++ network-hooks.d/bridge	2012-06-13 22:06:57 +0000
@@ -0,0 +1,93 @@
+#!/bin/sh
+#
+# This is an example of a Mandos client network hook.  This hook
+# brings up a bridge interface as specified in a separate
+# configuration file.  To be used, this file and any needed
+# configuration file(s) should be copied into the
+# /etc/mandos/network-hooks.d directory.
+# 
+# Copyright © 2012 Teddy Hogeborn
+# Copyright © 2012 Björn Påhlsson
+# 
+# Copying and distribution of this file, with or without modification,
+# are permitted in any medium without royalty provided the copyright
+# notice and this notice are preserved.  This file is offered as-is,
+# without any warranty.
+
+set -e
+
+CONFIG="$MANDOSNETHOOKDIR/bridge.conf"
+
+addrtoif(){
+    grep -liFe "$1" /sys/class/net/*/address \
+	| sed -e 's,.*/\([^/]*\)/[^/]*,\1,' -e "/^${BRIDGE}\$/d"
+}
+
+# Read config file, which must set "BRIDGE", "PORT_ADDRESSES", and
+# optionally "IPADDRS" and "ROUTES".
+if [ -e "$CONFIG" ]; then
+    . "$CONFIG"
+fi
+
+if [ -z "$BRIDGE" -o -z "$PORT_ADDRESSES" ]; then
+    exit
+fi
+
+if [ -n "$DEVICE" ]; then
+    case "$DEVICE" in
+	*,"$BRIDGE"|*,"$BRIDGE",*|"$BRIDGE",*|"$BRIDGE") :;;
+	*) exit;;
+    esac
+fi
+
+brctl="/sbin/brctl"
+for b in "$brctl" /usr/sbin/brctl; do
+    if [ -e "$b" ]; then
+	brctl="$b"
+	break
+    fi
+done
+
+do_start(){
+    "$brctl" addbr "$BRIDGE"
+    for address in $PORT_ADDRESSES; do
+	interface=`addrtoif "$address"`
+	"$brctl" addif "$BRIDGE" "$interface"
+	ip link set dev "$interface" up
+    done
+    ip link set dev "$BRIDGE" up
+    sleep "${DELAY%%.*}"
+    if [ -n "$IPADDRS" ]; then
+        for ipaddr in $IPADDRS; do
+	    ip addr add "$ipaddr" dev "$BRIDGE"
+	done
+    fi
+    if [ -n "$ROUTES" ]; then
+        for route in $ROUTES; do
+	    ip route add "$route" dev "$BRIDGE"
+	done
+    fi
+}
+
+do_stop(){
+    ip link set dev "$BRIDGE" down
+    for address in $PORT_ADDRESSES; do
+	interface=`addrtoif "$address"`
+	ip link set dev "$interface" down
+	"$brctl" delif "$BRIDGE" "$interface"
+    done
+    "$brctl" delbr "$BRIDGE"
+}
+
+case "${MODE:-$1}" in
+    start|stop)
+	do_"${MODE:-$1}"
+	;;
+    files)
+	echo /bin/ip
+	echo "$brctl"
+	;;
+    modules)
+	echo bridge
+	;;
+esac

=== added file 'network-hooks.d/bridge.conf'
--- network-hooks.d/bridge.conf	1970-01-01 00:00:00 +0000
+++ network-hooks.d/bridge.conf	2011-12-31 13:25:58 +0000
@@ -0,0 +1,11 @@
+## Required
+
+#BRIDGE=br0
+
+#PORT_ADDRESSES="00:11:22:33:44:55 11:22:33:44:55:66"
+
+## Optional
+
+#IPADDRS="192.0.2.3/24 2001:DB8::aede:48ff:fe71:f6f2/32"
+
+#ROUTES="192.0.2.0/24 2001:DB8::/32"

=== added file 'network-hooks.d/openvpn'
--- network-hooks.d/openvpn	1970-01-01 00:00:00 +0000
+++ network-hooks.d/openvpn	2012-06-13 22:06:57 +0000
@@ -0,0 +1,66 @@
+#!/bin/sh
+#
+# This is an example of a Mandos client network hook.  This hook
+# brings up an OpenVPN interface as specified in a separate
+# configuration file.  To be used, this file and any needed
+# configuration file(s) should be copied into the
+# /etc/mandos/network-hooks.d directory.
+# 
+# Copyright © 2012 Teddy Hogeborn
+# Copyright © 2012 Björn Påhlsson
+# 
+# Copying and distribution of this file, with or without modification,
+# are permitted in any medium without royalty provided the copyright
+# notice and this notice are preserved.  This file is offered as-is,
+# without any warranty.
+
+set -e
+
+CONFIG="openvpn.conf"
+
+# Extract the "dev" setting from the config file
+VPNDEVICE=`sed -n -e 's/[[:space:]]#.*//' \
+    -e 's/^[[:space:]]*dev[[:space:]]\+//p' \
+    "$MANDOSNETHOOKDIR/$CONFIG"`
+
+PIDFILE=/run/openvpn-mandos.pid
+
+# Exit if no device set in config
+if [ -z "$VPNDEVICE" ]; then
+    exit
+fi
+
+# Exit if DEVICE is set and it doesn't match the VPN interface
+if [ -n "$DEVICE" ]; then
+    case "$DEVICE" in
+	*,"$VPNDEVICE"*|"$VPNDEVICE"*) :;;
+	*) exit;;
+    esac
+fi
+
+openvpn=/usr/sbin/openvpn
+
+do_start(){
+    "$openvpn" --cd "$MANDOSNETHOOKDIR" --daemon 'openvpn(Mandos)' \
+	--writepid "$PIDFILE" --config "$CONFIG"
+     sleep "$DELAY"
+}
+
+do_stop(){
+    PID="`cat \"$PIDFILE\"`"
+    if [ "$PID" -gt 0 ]; then
+	kill "$PID"
+    fi
+}
+
+case "${MODE:-$1}" in
+    start|stop)
+	do_"${MODE:-$1}"
+	;;
+    files)
+	echo "$openvpn"
+	;;
+    modules)
+	echo tun
+	;;
+esac

=== added file 'network-hooks.d/openvpn.conf'
--- network-hooks.d/openvpn.conf	1970-01-01 00:00:00 +0000
+++ network-hooks.d/openvpn.conf	2011-12-02 16:52:50 +0000
@@ -0,0 +1,19 @@
+# Sample OpenVPN configuration file
+# Uncomment and change - see openvpn(8)
+
+# Network device.
+#dev tun
+
+# Our remote peer
+#remote 192.0.2.3
+#float 192.0.2.3
+#port 1194
+
+# VPN endpoints
+#ifconfig 10.1.0.1 10.1.0.2
+
+# A pre-shared static key
+#secret openvpn.key
+
+# Cipher
+#cipher AES-128-CBC

=== added file 'network-hooks.d/wireless'
--- network-hooks.d/wireless	1970-01-01 00:00:00 +0000
+++ network-hooks.d/wireless	2012-06-13 22:06:57 +0000
@@ -0,0 +1,165 @@
+#!/bin/sh
+#
+# This is an example of a Mandos client network hook.  This hook
+# brings up a wireless interface as specified in a separate
+# configuration file.  To be used, this file and any needed
+# configuration file(s) should be copied into the
+# /etc/mandos/network-hooks.d directory.
+# 
+# Copyright © 2012 Teddy Hogeborn
+# Copyright © 2012 Björn Påhlsson
+# 
+# Copying and distribution of this file, with or without modification,
+# are permitted in any medium without royalty provided the copyright
+# notice and this notice are preserved.  This file is offered as-is,
+# without any warranty.
+
+set -e
+
+RUNDIR="/run"
+CTRL="$RUNDIR/wpa_supplicant-global"
+CTRLDIR="$RUNDIR/wpa_supplicant"
+PIDFILE="$RUNDIR/wpa_supplicant-mandos.pid"
+
+CONFIG="$MANDOSNETHOOKDIR/wireless.conf"
+
+addrtoif(){
+    grep -liFe "$1" /sys/class/net/*/address \
+	| sed -e 's,.*/\([^/]*\)/[^/]*,\1,'
+}
+
+# Read config file
+if [ -e "$CONFIG" ]; then
+    . "$CONFIG"
+else
+    exit
+fi
+
+ifkeys=`sed -n -e 's/^ADDRESS_\([^=]*\)=.*/\1/p' "$CONFIG" | sort -u`
+
+# Exit if DEVICE is set and is not any of the wireless interfaces
+if [ -n "$DEVICE" ]; then
+    while :; do
+	for KEY in $ifkeys; do
+	    ADDRESS=`eval 'echo "$ADDRESS_'"$KEY"\"`
+	    INTERFACE=`addrtoif "$ADDRESS"`
+	    
+	    case "$DEVICE" in
+		*,"$INTERFACE"|*,"$INTERFACE",*|"$INTERFACE",*|"$INTERFACE")
+		    break 2;;
+	    esac
+	done
+	exit
+    done
+fi
+
+wpa_supplicant=/sbin/wpa_supplicant
+wpa_cli=/sbin/wpa_cli
+ip=/bin/ip
+
+# Used by the wpa_interface_* functions in the wireless.conf file
+wpa_cli_set(){
+    case "$1" in
+        ssid|psk) arg="\"$2\"" ;;
+        *) arg="$2" ;;
+    esac
+    "$wpa_cli" -p "$CTRLDIR" -i "$INTERFACE" set_network "$NETWORK" \
+	"$1" "$arg" 2>&1 | sed -e '/^OK$/d'
+}
+
+if [ $VERBOSITY -gt 0 ]; then
+    WPAS_OPTIONS="-d $WPAS_OPTIONS"
+fi
+if [ -n "$PIDFILE" ]; then
+    WPAS_OPTIONS="-P$PIDFILE $WPAS_OPTIONS"
+fi
+
+do_start(){
+    mkdir -m u=rwx,go= -p "$CTRLDIR"
+    "$wpa_supplicant" -B -g "$CTRL" -p "$CTRLDIR" $WPAS_OPTIONS
+    for KEY in $ifkeys; do
+	ADDRESS=`eval 'echo "$ADDRESS_'"$KEY"\"`
+	INTERFACE=`addrtoif "$ADDRESS"`
+	DRIVER=`eval 'echo "$WPA_DRIVER_'"$KEY"\"`
+	IFDELAY=`eval 'echo "$DELAY_'"$KEY"\"`
+	"$wpa_cli" -g "$CTRL" interface_add "$INTERFACE" "" \
+	    "${DRIVER:-wext}" "$CTRLDIR" > /dev/null \
+	    | sed -e '/^OK$/d'
+        NETWORK=`"$wpa_cli" -p "$CTRLDIR" -i "$INTERFACE" add_network`
+	eval wpa_interface_"$KEY"
+	"$wpa_cli" -p "$CTRLDIR" -i "$INTERFACE" enable_network \
+	    "$NETWORK" | sed -e '/^OK$/d'
+	sleep "${IFDELAY:-$DELAY}" &
+	sleep=$!
+	while :; do
+	    kill -0 $sleep 2>/dev/null || break
+	    STATE=`"$wpa_cli" -p "$CTRLDIR" -i "$INTERFACE" status \
+		| sed -n -e 's/^wpa_state=//p'`
+	    if [ "$STATE" = COMPLETED ]; then
+		while :; do
+		    kill -0 $sleep 2>/dev/null || break 2
+		    UP=`cat /sys/class/net/"$INTERFACE"/operstate`
+		    if [ "$UP" = up ]; then
+			kill $sleep 2>/dev/null
+			break 2
+		    fi
+		    sleep 1
+		done
+	    fi
+	    sleep 1
+	done &
+	wait $sleep || :
+	IPADDRS=`eval 'echo "$IPADDRS_'"$KEY"\"`
+	if [ -n "$IPADDRS" ]; then
+	    if [ "$IPADDRS" = dhcp ]; then
+		ipconfig -c dhcp -d "$INTERFACE" || :
+		#dhclient "$INTERFACE"
+	    else
+		for ipaddr in $IPADDRS; do
+		    "$ip" addr add "$ipaddr" dev "$INTERFACE"
+		done
+	    fi
+	fi
+	ROUTES=`eval 'echo "$ROUTES_'"$KEY"\"`
+	if [ -n "$ROUTES" ]; then
+	    for route in $ROUTES; do
+		"$ip" route add "$route" dev "$INTERFACE"
+	    done
+	fi
+    done
+}
+
+do_stop(){
+    "$wpa_cli" -g "$CTRL" terminate 2>&1 | sed -e '/^OK$/d'
+    for KEY in $ifkeys; do
+	ADDRESS=`eval 'echo "$ADDRESS_'"$KEY"\"`
+	INTERFACE=`addrtoif "$ADDRESS"`
+	"$ip" addr show scope global permanent dev "$INTERFACE" \
+	    | while read type addr rest; do
+		case "$type" in
+		    inet|inet6)
+			"$ip" addr del "$addr" dev "$INTERFACE"
+			;;
+		esac
+	    done
+	"$ip" link set dev "$INTERFACE" down
+    done
+}
+
+case "${MODE:-$1}" in
+    start|stop)
+	do_"${MODE:-$1}"
+	;;
+    files)
+	echo "$wpa_supplicant"
+	echo "$wpa_cli"
+	echo "$ip"
+	;;
+    modules)
+	if [ "$IPADDRS" = dhcp ]; then
+	    echo af_packet
+	fi
+	sed -n -e 's/#.*$//' -e 's/[ 	]*$//' \
+	    -e 's/^MODULE_[^=]\+=//p' "$CONFIG"
+	;;
+esac

=== added file 'network-hooks.d/wireless.conf'
--- network-hooks.d/wireless.conf	1970-01-01 00:00:00 +0000
+++ network-hooks.d/wireless.conf	2011-12-31 13:25:58 +0000
@@ -0,0 +1,23 @@
+# Extra options for wpa_supplicant, if any
+#WPAS_OPTIONS=""
+
+# wlan0
+ADDRESS_0=00:11:22:33:44:55
+MODULE_0=ath9k
+#WPA_DRIVER_0=wext
+wpa_interface_0(){
+    # Use this format to set simple things:
+    wpa_cli_set ssid home
+    wpa_cli_set psk "secret passphrase"
+    # Use this format to do more complex things with wpa_cli:
+    #"$wpa_cli" -p "$CTRLDIR" -i "$INTERFACE" bssid "$NETWORK" 00:11:22:33:44:55
+    #"$wpa_cli" -g "$CTRL" ping
+}
+#DELAY_0=10
+IPADDRS_0=dhcp
+#IPADDRS_0="192.0.2.3/24 2001:DB8::aede:48ff:fe71:f6f2/32"
+#ROUTES_0="192.0.2.0/24 2001:DB8::/32"
+
+#ADDRESS_1=11:22:33:44:55:66
+#MODULE_1=...
+#...

=== added directory 'plugin-helpers'
=== added file 'plugin-helpers/mandos-client-iprouteadddel.c'
--- plugin-helpers/mandos-client-iprouteadddel.c	1970-01-01 00:00:00 +0000
+++ plugin-helpers/mandos-client-iprouteadddel.c	2016-02-28 14:22:10 +0000
@@ -0,0 +1,282 @@
+/*  -*- coding: utf-8 -*- */
+/* 
+ * iprouteadddel - Add or delete direct route to a local IP address
+ * 
+ * Copyright © 2015-2016 Teddy Hogeborn
+ * Copyright © 2015-2016 Björn Påhlsson
+ * 
+ * This program is free software: you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation, either version 3 of the
+ * License, or (at your option) any later version.
+ * 
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ * 
+ * You should have received a copy of the GNU General Public License
+ * along with this program.  If not, see
+ * <http://www.gnu.org/licenses/>.
+ * 
+ * Contact the authors at <mandos@recompile.se>.
+ */
+
+#define _GNU_SOURCE		/* asprintf(),
+				   program_invocation_short_name */
+#include <stdbool.h>		/* bool, false, true */
+#include <stdio.h>		/* fprintf(), stderr, FILE, vfprintf */
+#include <errno.h>		/* program_invocation_short_name,
+				   errno, perror(), EINVAL, ENOMEM */
+#include <stdarg.h>		/* va_list, va_start */
+#include <stdlib.h> 		/* EXIT_SUCCESS */
+#include <argp.h>		/* struct argp_option, error_t, struct
+				   argp_state, ARGP_KEY_ARG,
+				   argp_usage(), ARGP_KEY_END,
+				   ARGP_ERR_UNKNOWN, struct argp,
+				   argp_parse() */
+#include <sysexits.h>		/* EX_USAGE, EX_OSERR */
+#include <netinet/ip.h>		/* sa_family_t, AF_INET6, AF_INET */
+#include <inttypes.h>		/* PRIdMAX, intmax_t */
+
+#include <netlink/netlink.h>	/* struct nl_addr, nl_addr_parse(),
+				   nl_geterror(),
+				   nl_addr_get_family(),
+				   nl_addr_put() */
+#include <netlink/route/route.h> /* struct rtnl_route,
+				    struct rtnl_nexthop,
+				    rtnl_route_alloc(),
+				    rtnl_route_set_family(),
+				    rtnl_route_set_protocol(),
+				    RTPROT_BOOT,
+				    rtnl_route_set_scope(),
+				    RT_SCOPE_LINK,
+				    rtnl_route_set_type(),
+				    RTN_UNICAST,
+				    rtnl_route_set_dst(),
+				    rtnl_route_set_table(),
+				    RT_TABLE_MAIN,
+				    rtnl_route_nh_alloc(),
+				    rtnl_route_nh_set_ifindex(),
+				    rtnl_route_add_nexthop(),
+				    rtnl_route_add(),
+				    rtnl_route_delete(),
+				    rtnl_route_put(),
+				    rtnl_route_nh_free() */
+#include <netlink/socket.h>	/* struct nl_sock, nl_socket_alloc(),
+				   nl_connect(), nl_socket_free() */
+#include <netlink/route/link.h>	/* rtnl_link_get_kernel(),
+				   rtnl_link_get_ifindex(),
+				   rtnl_link_put() */
+
+bool debug = false;
+const char *argp_program_version = "mandos-client-iprouteadddel " VERSION;
+const char *argp_program_bug_address = "<mandos@recompile.se>";
+
+/* Function to use when printing errors */
+void perror_plus(const char *print_text){
+  int e = errno;
+  fprintf(stderr, "Mandos plugin helper %s: ",
+	  program_invocation_short_name);
+  errno = e;
+  perror(print_text);
+}
+
+__attribute__((format (gnu_printf, 2, 3), nonnull))
+int fprintf_plus(FILE *stream, const char *format, ...){
+  va_list ap;
+  va_start (ap, format);
+  
+  fprintf(stream, "Mandos plugin helper %s: ",
+	  program_invocation_short_name);
+  return vfprintf(stream, format, ap);
+}
+
+int main(int argc, char *argv[]){
+  int ret;
+  int exitcode = EXIT_SUCCESS;
+  struct arguments {
+    bool add;			/* true: add, false: delete */
+    char *address;		/* IP address as string */
+    struct nl_addr *nl_addr;	/* Netlink IP address */
+    char *interface;		/* interface name */
+  } arguments = { .add = true, .address = NULL, .interface = NULL };
+  struct argp_option options[] = {
+    { .name = "debug", .key = 128,
+      .doc = "Debug mode" },
+    { .name = NULL }
+  };
+  struct rtnl_route *route = NULL;
+  struct rtnl_nexthop *nexthop = NULL;
+  struct nl_sock *sk = NULL;
+  
+  error_t parse_opt(int key, char *arg, struct argp_state *state){
+    int lret;
+    errno = 0;
+    switch(key){
+    case 128:			/* --debug */
+      debug = true;
+      break;
+    case ARGP_KEY_ARG:
+      switch(state->arg_num){
+      case 0:
+	if(strcasecmp(arg, "add") == 0){
+	  ((struct arguments *)(state->input))->add = true;
+	} else if(strcasecmp(arg, "delete") == 0){
+	  ((struct arguments *)(state->input))->add = false;
+	} else {
+	  fprintf_plus(stderr, "Unrecognized command: %s\n", arg);
+	  argp_usage(state);
+	}
+	break;
+      case 1:
+	((struct arguments *)(state->input))->address = arg;
+	lret = nl_addr_parse(arg, AF_UNSPEC, &(((struct arguments *)
+						(state->input))
+					       ->nl_addr));
+	if(lret != 0){
+	  fprintf_plus(stderr, "Failed to parse address %s: %s\n",
+		       arg, nl_geterror(lret));
+	  argp_usage(state);
+	}
+	break;
+      case 2:
+	((struct arguments *)(state->input))->interface = arg;
+	break;
+      default:
+	argp_usage(state);
+      }
+      break;
+    case ARGP_KEY_END:
+      if(state->arg_num < 3){
+	argp_usage(state);
+      }
+      break;
+    default:
+      return ARGP_ERR_UNKNOWN;
+    }
+    return errno;
+  }
+  
+  struct argp argp = { .options = options, .parser = parse_opt,
+		       .args_doc = "[ add | delete ] ADDRESS INTERFACE",
+		       .doc = "Mandos client helper -- Add or delete"
+		       " local route to IP address on interface" };
+  
+  ret = argp_parse(&argp, argc, argv, ARGP_IN_ORDER, 0, &arguments);
+  switch(ret){
+  case 0:
+    break;
+  case EINVAL:
+    exit(EX_USAGE);
+  case ENOMEM:
+  default:
+    errno = ret;
+    perror_plus("argp_parse");
+    exitcode = EX_OSERR;
+    goto end;
+  }
+  /* Get netlink socket */
+  sk = nl_socket_alloc();
+  if(sk == NULL){
+    fprintf_plus(stderr, "Failed to allocate netlink socket: %s\n",
+		 nl_geterror(ret));
+    exitcode = EX_OSERR;
+    goto end;
+  }
+  /* Connect socket to netlink */
+  ret = nl_connect(sk, NETLINK_ROUTE);
+  if(ret < 0){
+    fprintf_plus(stderr, "Failed to connect socket to netlink: %s\n",
+		 nl_geterror(ret));
+    exitcode = EX_OSERR;
+    goto end;
+  }
+  /* Get link object of specified interface */
+  struct rtnl_link *link = NULL;
+  ret = rtnl_link_get_kernel(sk, 0, arguments.interface, &link);
+  if(ret < 0){
+    fprintf_plus(stderr, "Failed to use interface %s: %s\n",
+		 arguments.interface, nl_geterror(ret));
+    exitcode = EX_OSERR;
+    goto end;
+  }
+  /* Get netlink route object */
+  route = rtnl_route_alloc();
+  if(route == NULL){
+    fprintf_plus(stderr, "Failed to get netlink route:\n");
+    exitcode = EX_OSERR;
+    goto end;
+  }
+  /* Get address family of specified address */
+  sa_family_t af = (sa_family_t)nl_addr_get_family(arguments.nl_addr);
+  if(debug){
+    fprintf_plus(stderr, "Address family of %s is %s (%" PRIdMAX
+		 ")\n", arguments.address,
+		 af == AF_INET6 ? "AF_INET6" :
+		 ( af == AF_INET ? "AF_INET" : "UNKNOWN"),
+		 (intmax_t)af);
+  }
+  /* Set route parameters: */
+  rtnl_route_set_family(route, (uint8_t)af);   /* Address family */
+  rtnl_route_set_protocol(route, RTPROT_BOOT); /* protocol - see
+						  ip-route(8) */
+  rtnl_route_set_scope(route, RT_SCOPE_LINK); /* link scope */
+  rtnl_route_set_type(route, RTN_UNICAST);    /* normal unicast
+						 address route */
+  rtnl_route_set_dst(route, arguments.nl_addr); /* Destination
+						   address */
+  rtnl_route_set_table(route, RT_TABLE_MAIN); /* "main" routing
+						 table */
+  /* Create nexthop */
+  nexthop = rtnl_route_nh_alloc();
+  if(nexthop == NULL){
+    fprintf_plus(stderr, "Failed to get netlink route nexthop\n");
+    exitcode = EX_OSERR;
+    goto end;
+  }
+  /* Get index number of specified interface */
+  int ifindex = rtnl_link_get_ifindex(link);
+  if(debug){
+    fprintf_plus(stderr, "ifindex of %s is %d\n", arguments.interface,
+		 ifindex);
+  }
+  /* Set interface index number on nexthop object */
+  rtnl_route_nh_set_ifindex(nexthop, ifindex);
+  /* Set route tu use nexthop object */
+  rtnl_route_add_nexthop(route, nexthop);
+  /* Add or delete route? */
+  if(arguments.add){
+    ret = rtnl_route_add(sk, route, NLM_F_EXCL);
+  } else {
+    ret = rtnl_route_delete(sk, route, 0);
+  }
+  if(ret < 0){
+     fprintf_plus(stderr, "Failed to %s route: %s\n",
+		  arguments.add ? "add" : "delete",
+		  nl_geterror(ret));
+    exitcode = EX_OSERR;
+    goto end;
+  }
+ end:
+  /* Deallocate route */
+  if(route){
+    rtnl_route_put(route);
+  } else if(nexthop) {
+    /* Deallocate route nexthop */
+    rtnl_route_nh_free(nexthop);
+  }
+  /* Deallocate parsed address */
+  if(arguments.nl_addr){
+    nl_addr_put(arguments.nl_addr);
+  }
+  /* Deallocate link struct */
+  if(link){
+    rtnl_link_put(link);
+  }
+  /* Deallocate netlink socket struct */
+   if(sk){
+    nl_socket_free(sk);
+  }
+  return exitcode;
+}

=== modified file 'plugin-runner.c'
--- plugin-runner.c	2010-09-26 21:27:28 +0000
+++ plugin-runner.c	2016-07-03 03:32:28 +0000
@@ -2,8 +2,8 @@
 /*
  * Mandos plugin runner - Run Mandos plugins
  *
- * Copyright © 2008-2010 Teddy Hogeborn
- * Copyright © 2008-2010 Björn Påhlsson
+ * Copyright © 2008-2016 Teddy Hogeborn
+ * Copyright © 2008-2016 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -19,42 +19,40 @@
  * along with this program.  If not, see
  * <http://www.gnu.org/licenses/>.
  * 
- * Contact the authors at <mandos@fukt.bsnet.se>.
+ * Contact the authors at <mandos@recompile.se>.
  */
 
 #define _GNU_SOURCE		/* TEMP_FAILURE_RETRY(), getline(),
-				   asprintf(), O_CLOEXEC */
+				   O_CLOEXEC, pipe2() */
 #include <stddef.h>		/* size_t, NULL */
 #include <stdlib.h>		/* malloc(), exit(), EXIT_SUCCESS,
 				   realloc() */
 #include <stdbool.h>		/* bool, true, false */
 #include <stdio.h>		/* fileno(), fprintf(),
-				   stderr, STDOUT_FILENO */
-#include <sys/types.h>	        /* DIR, fdopendir(), stat(), struct
-				   stat, waitpid(), WIFEXITED(),
-				   WEXITSTATUS(), wait(), pid_t,
-				   uid_t, gid_t, getuid(), getgid(),
-				   dirfd() */
+				   stderr, STDOUT_FILENO, fclose() */
+#include <sys/types.h>	        /* fstat(), struct stat, waitpid(),
+				   WIFEXITED(), WEXITSTATUS(), wait(),
+				   pid_t, uid_t, gid_t, getuid(),
+				   getgid() */
 #include <sys/select.h>		/* fd_set, select(), FD_ZERO(),
 				   FD_SET(), FD_ISSET(), FD_CLR */
 #include <sys/wait.h>		/* wait(), waitpid(), WIFEXITED(),
-				   WEXITSTATUS(), WTERMSIG(),
-				   WCOREDUMP() */
-#include <sys/stat.h>		/* struct stat, stat(), S_ISREG() */
+				   WEXITSTATUS(), WTERMSIG() */
+#include <sys/stat.h>		/* struct stat, fstat(), S_ISREG() */
 #include <iso646.h>		/* and, or, not */
-#include <dirent.h>		/* DIR, struct dirent, fdopendir(),
-				   readdir(), closedir(), dirfd() */
-#include <unistd.h>		/* struct stat, stat(), S_ISREG(),
-				   fcntl(), setuid(), setgid(),
-				   F_GETFD, F_SETFD, FD_CLOEXEC,
-				   access(), pipe(), fork(), close()
-				   dup2(), STDOUT_FILENO, _exit(),
-				   execv(), write(), read(),
-				   close() */
+#include <dirent.h>		/* struct dirent, scandirat() */
+#include <unistd.h>		/* fcntl(), F_GETFD, F_SETFD,
+				   FD_CLOEXEC, write(), STDOUT_FILENO,
+				   struct stat, fstat(), close(),
+				   setgid(), setuid(), S_ISREG(),
+				   faccessat() pipe2(), fork(),
+				   _exit(), dup2(), fexecve(), read()
+				*/
 #include <fcntl.h>		/* fcntl(), F_GETFD, F_SETFD,
-				   FD_CLOEXEC */
-#include <string.h>		/* strsep, strlen(), asprintf(),
-				   strsignal(), strcmp(), strncmp() */
+				   FD_CLOEXEC, openat(), scandirat(),
+				   pipe2() */
+#include <string.h>		/* strsep, strlen(), strsignal(),
+				   strcmp(), strncmp() */
 #include <errno.h>		/* errno */
 #include <argp.h>		/* struct argp_option, struct
 				   argp_state, struct argp,
@@ -72,14 +70,16 @@
 				   EX_CONFIG, EX_UNAVAILABLE, EX_OK */
 #include <errno.h> 		/* errno */
 #include <error.h>		/* error() */
+#include <fnmatch.h>		/* fnmatch() */
 
 #define BUFFER_SIZE 256
 
 #define PDIR "/lib/mandos/plugins.d"
+#define PHDIR "/lib/mandos/plugin-helpers"
 #define AFILE "/conf/conf.d/mandos/plugin-runner.conf"
 
 const char *argp_program_version = "plugin-runner " VERSION;
-const char *argp_program_bug_address = "<mandos@fukt.bsnet.se>";
+const char *argp_program_bug_address = "<mandos@recompile.se>";
 
 typedef struct plugin{
   char *name;			/* can be NULL or any plugin name */
@@ -105,6 +105,7 @@
 
 /* Gets an existing plugin based on name,
    or if none is found, creates a new one */
+__attribute__((warn_unused_result))
 static plugin *getplugin(char *name){
   /* Check for existing plugin with that name */
   for(plugin *p = plugin_list; p != NULL; p = p->next){
@@ -171,17 +172,20 @@
 }
 
 /* Helper function for add_argument and add_environment */
+__attribute__((nonnull, warn_unused_result))
 static bool add_to_char_array(const char *new, char ***array,
 			      int *len){
   /* Resize the pointed-to array to hold one more pointer */
+  char **new_array = NULL;
   do {
-    *array = realloc(*array, sizeof(char *)
-		     * (size_t) ((*len) + 2));
-  } while(*array == NULL and errno == EINTR);
+    new_array = realloc(*array, sizeof(char *)
+			* (size_t) ((*len) + 2));
+  } while(new_array == NULL and errno == EINTR);
   /* Malloc check */
-  if(*array == NULL){
+  if(new_array == NULL){
     return false;
   }
+  *array = new_array;
   /* Make a copy of the new string */
   char *copy;
   do {
@@ -199,6 +203,7 @@
 }
 
 /* Add to a plugin's argument vector */
+__attribute__((nonnull(2), warn_unused_result))
 static bool add_argument(plugin *p, const char *arg){
   if(p == NULL){
     return false;
@@ -207,6 +212,7 @@
 }
 
 /* Add to a plugin's environment */
+__attribute__((nonnull(2), warn_unused_result))
 static bool add_environment(plugin *p, const char *def, bool replace){
   if(p == NULL){
     return false;
@@ -214,19 +220,19 @@
   /* namelen = length of name of environment variable */
   size_t namelen = (size_t)(strchrnul(def, '=') - def);
   /* Search for this environment variable */
-  for(char **e = p->environ; *e != NULL; e++){
-    if(strncmp(*e, def, namelen + 1) == 0){
+  for(char **envdef = p->environ; *envdef != NULL; envdef++){
+    if(strncmp(*envdef, def, namelen + 1) == 0){
       /* It already exists */
       if(replace){
-	char *new;
+	char *new_envdef;
 	do {
-	  new = realloc(*e, strlen(def) + 1);
-	} while(new == NULL and errno == EINTR);
-	if(new == NULL){
+	  new_envdef = realloc(*envdef, strlen(def) + 1);
+	} while(new_envdef == NULL and errno == EINTR);
+	if(new_envdef == NULL){
 	  return false;
 	}
-	*e = new;
-	strcpy(*e, def);
+	*envdef = new_envdef;
+	strcpy(*envdef, def);
       }
       return true;
     }
@@ -234,11 +240,13 @@
   return add_to_char_array(def, &(p->environ), &(p->envc));
 }
 
+#ifndef O_CLOEXEC
 /*
  * Based on the example in the GNU LibC manual chapter 13.13 "File
  * Descriptor Flags".
  | [[info:libc:Descriptor%20Flags][File Descriptor Flags]] |
  */
+__attribute__((warn_unused_result))
 static int set_cloexec_flag(int fd){
   int ret = (int)TEMP_FAILURE_RETRY(fcntl(fd, F_GETFD, 0));
   /* If reading the flags failed, return error indication now. */
@@ -249,6 +257,7 @@
   return (int)TEMP_FAILURE_RETRY(fcntl(fd, F_SETFD,
 				       ret | FD_CLOEXEC));
 }
+#endif	/* not O_CLOEXEC */
 
 
 /* Mark processes as completed when they exit, and save their exit
@@ -286,6 +295,7 @@
 }
 
 /* Prints out a password to stdout */
+__attribute__((nonnull, warn_unused_result))
 static bool print_out_password(const char *buffer, size_t length){
   ssize_t ret;
   for(size_t written = 0; written < length; written += (size_t)ret){
@@ -299,6 +309,7 @@
 }
 
 /* Removes and free a plugin from the plugin list */
+__attribute__((nonnull))
 static void free_plugin(plugin *plugin_node){
   
   for(char **arg = plugin_node->argv; *arg != NULL; arg++){
@@ -336,11 +347,10 @@
 
 int main(int argc, char *argv[]){
   char *plugindir = NULL;
+  char *pluginhelperdir = NULL;
   char *argfile = NULL;
   FILE *conffp;
-  size_t d_name_len;
-  DIR *dir = NULL;
-  struct dirent *dirst;
+  struct dirent **direntries = NULL;
   struct stat st;
   fd_set rfds_all;
   int ret, maxfd = 0;
@@ -354,6 +364,7 @@
 				      .sa_flags = SA_NOCLDSTOP };
   char **custom_argv = NULL;
   int custom_argc = 0;
+  int dir_fd = -1;
   
   /* Establish a signal handler */
   sigemptyset(&sigchld_action.sa_mask);
@@ -404,6 +415,10 @@
       .doc = "Group ID the plugins will run as", .group = 3 },
     { .name = "debug", .key = 132,
       .doc = "Debug mode", .group = 4 },
+    { .name = "plugin-helper-dir", .key = 133,
+      .arg = "DIRECTORY",
+      .doc = "Specify a different plugin helper directory",
+      .group = 2 },
     /*
      * These reproduce what we would get without ARGP_NO_HELP
      */
@@ -416,11 +431,12 @@
     { .name = NULL }
   };
   
+  __attribute__((nonnull(3)))
   error_t parse_opt(int key, char *arg, struct argp_state *state){
     errno = 0;
     switch(key){
       char *tmp;
-      intmax_t tmpmax;
+      intmax_t tmp_id;
     case 'g': 			/* --global-options */
       {
 	char *plugin_option;
@@ -429,10 +445,13 @@
 	    break;
 	  }
 	}
+	errno = 0;
       }
       break;
     case 'G':			/* --global-env */
-      add_environment(getplugin(NULL), arg, true);
+      if(add_environment(getplugin(NULL), arg, true)){
+	errno = 0;
+      }
       break;
     case 'o':			/* --options-for */
       {
@@ -455,6 +474,7 @@
 	    break;
 	  }
 	}
+	errno = 0;
       }
       break;
     case 'E':			/* --env-for */
@@ -472,7 +492,9 @@
 	  errno = EINVAL;
 	  break;
 	}
-	add_environment(getplugin(arg), envdef, true);
+	if(add_environment(getplugin(arg), envdef, true)){
+	  errno = 0;
+	}
       }
       break;
     case 'd':			/* --disable */
@@ -480,6 +502,7 @@
 	plugin *p = getplugin(arg);
 	if(p != NULL){
 	  p->disabled = true;
+	  errno = 0;
 	}
       }
       break;
@@ -488,39 +511,52 @@
 	plugin *p = getplugin(arg);
 	if(p != NULL){
 	  p->disabled = false;
+	  errno = 0;
 	}
       }
       break;
     case 128:			/* --plugin-dir */
       free(plugindir);
       plugindir = strdup(arg);
+      if(plugindir != NULL){
+	errno = 0;
+      }
       break;
     case 129:			/* --config-file */
       /* This is already done by parse_opt_config_file() */
       break;
     case 130:			/* --userid */
-      tmpmax = strtoimax(arg, &tmp, 10);
+      tmp_id = strtoimax(arg, &tmp, 10);
       if(errno != 0 or tmp == arg or *tmp != '\0'
-	 or tmpmax != (uid_t)tmpmax){
+	 or tmp_id != (uid_t)tmp_id){
 	argp_error(state, "Bad user ID number: \"%s\", using %"
 		   PRIdMAX, arg, (intmax_t)uid);
 	break;
       }
-      uid = (uid_t)tmpmax;
+      uid = (uid_t)tmp_id;
+      errno = 0;
       break;
     case 131:			/* --groupid */
-      tmpmax = strtoimax(arg, &tmp, 10);
+      tmp_id = strtoimax(arg, &tmp, 10);
       if(errno != 0 or tmp == arg or *tmp != '\0'
-	 or tmpmax != (gid_t)tmpmax){
+	 or tmp_id != (gid_t)tmp_id){
 	argp_error(state, "Bad group ID number: \"%s\", using %"
 		   PRIdMAX, arg, (intmax_t)gid);
 	break;
       }
-      gid = (gid_t)tmpmax;
+      gid = (gid_t)tmp_id;
+      errno = 0;
       break;
     case 132:			/* --debug */
       debug = true;
       break;
+    case 133:			/* --plugin-helper-dir */
+      free(pluginhelperdir);
+      pluginhelperdir = strdup(arg);
+      if(pluginhelperdir != NULL){
+	errno = 0;
+      }
+      break;
       /*
        * These reproduce what we would get without ARGP_NO_HELP
        */
@@ -570,10 +606,14 @@
     case 129:			/* --config-file */
       free(argfile);
       argfile = strdup(arg);
+      if(argfile != NULL){
+	errno = 0;
+      }
       break;
     case 130:			/* --userid */
     case 131:			/* --groupid */
     case 132:			/* --debug */
+    case 133:			/* --plugin-helper-dir */
     case '?':			/* --help */
     case -3:			/* --usage */
     case 'V':			/* --version */
@@ -658,13 +698,18 @@
 	}
 	
 	custom_argc += 1;
-	custom_argv = realloc(custom_argv, sizeof(char *)
-			      * ((unsigned int) custom_argc + 1));
-	if(custom_argv == NULL){
-	  error(0, errno, "realloc");
-	  exitstatus = EX_OSERR;
-	  free(org_line);
-	  goto fallback;
+	{
+	  char **new_argv = realloc(custom_argv, sizeof(char *)
+				    * ((size_t)custom_argc + 1));
+	  if(new_argv == NULL){
+	    error(0, errno, "realloc");
+	    exitstatus = EX_OSERR;
+	    free(new_arg);
+	    free(org_line);
+	    goto fallback;
+	  } else {
+	    custom_argv = new_argv;
+	  }
 	}
 	custom_argv[custom_argc-1] = new_arg;
 	custom_argv[custom_argc] = NULL;
@@ -728,6 +773,24 @@
     goto fallback;
   }
   
+  {
+    char *pluginhelperenv;
+    bool bret = true;
+    ret = asprintf(&pluginhelperenv, "MANDOSPLUGINHELPERDIR=%s",
+		   pluginhelperdir != NULL ? pluginhelperdir : PHDIR);
+    if(ret != -1){
+      bret = add_environment(getplugin(NULL), pluginhelperenv, true);
+    }
+    if(ret == -1 or not bret){
+      error(0, errno, "Failed to set MANDOSPLUGINHELPERDIR"
+	    " environment variable to \"%s\" for all plugins\n",
+	    pluginhelperdir != NULL ? pluginhelperdir : PHDIR);
+    }
+    if(ret != -1){
+      free(pluginhelperenv);
+    }
+  }
+  
   if(debug){
     for(plugin *p = plugin_list; p != NULL; p=p->next){
       fprintf(stderr, "Plugin: %s has %d arguments\n",
@@ -742,8 +805,32 @@
     }
   }
   
-  /* Strip permissions down to nobody */
-  setgid(gid);
+  if(getuid() == 0){
+    /* Work around Debian bug #633582:
+       <https://bugs.debian.org/633582> */
+    int plugindir_fd = open(/* plugindir or */ PDIR, O_RDONLY);
+    if(plugindir_fd == -1){
+      if(errno != ENOENT){
+	error(0, errno, "open(\"" PDIR "\")");
+      }
+    } else {
+      ret = (int)TEMP_FAILURE_RETRY(fstat(plugindir_fd, &st));
+      if(ret == -1){
+	error(0, errno, "fstat");
+      } else {
+	if(S_ISDIR(st.st_mode) and st.st_uid == 0 and st.st_gid == 0){
+	  ret = fchown(plugindir_fd, uid, gid);
+	  if(ret == -1){
+	    error(0, errno, "fchown");
+	  }
+	}
+      }
+      close(plugindir_fd);
+    }
+  }
+  
+  /* Lower permissions */
+  ret = setgid(gid);
   if(ret == -1){
     error(0, errno, "setgid");
   }
@@ -754,24 +841,13 @@
   
   /* Open plugin directory with close_on_exec flag */
   {
-    int dir_fd = -1;
-    if(plugindir == NULL){
-      dir_fd = open(PDIR, O_RDONLY |
-#ifdef O_CLOEXEC
-		    O_CLOEXEC
-#else  /* not O_CLOEXEC */
-		    0
-#endif	/* not O_CLOEXEC */
-		    );
-    } else {
-      dir_fd = open(plugindir, O_RDONLY |
-#ifdef O_CLOEXEC
-		    O_CLOEXEC
-#else  /* not O_CLOEXEC */
-		    0
-#endif	/* not O_CLOEXEC */
-		    );
-    }
+    dir_fd = open(plugindir != NULL ? plugindir : PDIR, O_RDONLY |
+#ifdef O_CLOEXEC
+		  O_CLOEXEC
+#else  /* not O_CLOEXEC */
+		  0
+#endif	/* not O_CLOEXEC */
+		  );
     if(dir_fd == -1){
       error(0, errno, "Could not open plugin dir");
       exitstatus = EX_UNAVAILABLE;
@@ -783,129 +859,94 @@
     ret = set_cloexec_flag(dir_fd);
     if(ret < 0){
       error(0, errno, "set_cloexec_flag");
-      TEMP_FAILURE_RETRY(close(dir_fd));
       exitstatus = EX_OSERR;
       goto fallback;
     }
 #endif	/* O_CLOEXEC */
-    
-    dir = fdopendir(dir_fd);
-    if(dir == NULL){
-      error(0, errno, "Could not open plugin dir");
-      TEMP_FAILURE_RETRY(close(dir_fd));
-      exitstatus = EX_OSERR;
-      goto fallback;
+  }
+  
+  int good_name(const struct dirent * const dirent){
+    const char * const patterns[] = { ".*", "#*#", "*~", "*.dpkg-new",
+				      "*.dpkg-old", "*.dpkg-bak",
+				      "*.dpkg-divert", NULL };
+#ifdef __GNUC__
+#pragma GCC diagnostic push
+#pragma GCC diagnostic ignored "-Wcast-qual"
+#endif
+    for(const char **pat = (const char **)patterns;
+	*pat != NULL; pat++){
+#ifdef __GNUC__
+#pragma GCC diagnostic pop
+#endif
+      if(fnmatch(*pat, dirent->d_name, FNM_FILE_NAME | FNM_PERIOD)
+	 != FNM_NOMATCH){
+	if(debug){
+	    fprintf(stderr, "Ignoring plugin dir entry \"%s\""
+		    " matching pattern %s\n", dirent->d_name, *pat);
+	}
+	return 0;
+      }
     }
+    return 1;
+  }
+  
+  int numplugins = scandirat(dir_fd, ".", &direntries, good_name,
+			     alphasort);
+  if(numplugins == -1){
+    error(0, errno, "Could not scan plugin dir");
+    direntries = NULL;
+    exitstatus = EX_OSERR;
+    goto fallback;
   }
   
   FD_ZERO(&rfds_all);
   
   /* Read and execute any executable in the plugin directory*/
-  while(true){
-    do {
-      dirst = readdir(dir);
-    } while(dirst == NULL and errno == EINTR);
-    
-    /* All directory entries have been processed */
-    if(dirst == NULL){
-      if(errno == EBADF){
-	error(0, errno, "readdir");
-	exitstatus = EX_IOERR;
-	goto fallback;
-      }
-      break;
-    }
-    
-    d_name_len = strlen(dirst->d_name);
-    
-    /* Ignore dotfiles, backup files and other junk */
-    {
-      bool bad_name = false;
-      
-      const char const *bad_prefixes[] = { ".", "#", NULL };
-      
-      const char const *bad_suffixes[] = { "~", "#", ".dpkg-new",
-					   ".dpkg-old",
-					   ".dpkg-bak",
-					   ".dpkg-divert", NULL };
-      for(const char **pre = bad_prefixes; *pre != NULL; pre++){
-	size_t pre_len = strlen(*pre);
-	if((d_name_len >= pre_len)
-	   and strncmp((dirst->d_name), *pre, pre_len) == 0){
-	  if(debug){
-	    fprintf(stderr, "Ignoring plugin dir entry \"%s\""
-		    " with bad prefix %s\n", dirst->d_name, *pre);
-	  }
-	  bad_name = true;
-	  break;
-	}
-      }
-      if(bad_name){
-	continue;
-      }
-      for(const char **suf = bad_suffixes; *suf != NULL; suf++){
-	size_t suf_len = strlen(*suf);
-	if((d_name_len >= suf_len)
-	   and (strcmp((dirst->d_name) + d_name_len-suf_len, *suf)
-		== 0)){
-	  if(debug){
-	    fprintf(stderr, "Ignoring plugin dir entry \"%s\""
-		    " with bad suffix %s\n", dirst->d_name, *suf);
-	  }
-	  bad_name = true;
-	  break;
-	}
-      }
-      
-      if(bad_name){
-	continue;
-      }
-    }
-    
-    char *filename;
-    if(plugindir == NULL){
-      ret = (int)TEMP_FAILURE_RETRY(asprintf(&filename, PDIR "/%s",
-					     dirst->d_name));
-    } else {
-      ret = (int)TEMP_FAILURE_RETRY(asprintf(&filename, "%s/%s",
-					     plugindir,
-					     dirst->d_name));
-    }
-    if(ret < 0){
-      error(0, errno, "asprintf");
+  for(int i = 0; i < numplugins; i++){
+    
+    int plugin_fd = openat(dir_fd, direntries[i]->d_name, O_RDONLY);
+    if(plugin_fd == -1){
+      error(0, errno, "Could not open plugin");
+      free(direntries[i]);
       continue;
     }
-    
-    ret = (int)TEMP_FAILURE_RETRY(stat(filename, &st));
+    ret = (int)TEMP_FAILURE_RETRY(fstat(plugin_fd, &st));
     if(ret == -1){
       error(0, errno, "stat");
-      free(filename);
+      close(plugin_fd);
+      free(direntries[i]);
       continue;
     }
     
     /* Ignore non-executable files */
     if(not S_ISREG(st.st_mode)
-       or (TEMP_FAILURE_RETRY(access(filename, X_OK)) != 0)){
+       or (TEMP_FAILURE_RETRY(faccessat(dir_fd, direntries[i]->d_name,
+					X_OK, 0)) != 0)){
       if(debug){
-	fprintf(stderr, "Ignoring plugin dir entry \"%s\""
-		" with bad type or mode\n", filename);
+	fprintf(stderr, "Ignoring plugin dir entry \"%s/%s\""
+		" with bad type or mode\n",
+		plugindir != NULL ? plugindir : PDIR,
+		direntries[i]->d_name);
       }
-      free(filename);
+      close(plugin_fd);
+      free(direntries[i]);
       continue;
     }
     
-    plugin *p = getplugin(dirst->d_name);
+    plugin *p = getplugin(direntries[i]->d_name);
     if(p == NULL){
       error(0, errno, "getplugin");
-      free(filename);
+      close(plugin_fd);
+      free(direntries[i]);
       continue;
     }
     if(p->disabled){
       if(debug){
 	fprintf(stderr, "Ignoring disabled plugin \"%s\"\n",
-		dirst->d_name);
+		direntries[i]->d_name);
       }
-      free(filename);
+      close(plugin_fd);
+      free(direntries[i]);
       continue;
     }
     {
@@ -925,9 +966,8 @@
 	}
       }
     }
-    /* If this plugin has any environment variables, we will call
-       using execve and need to duplicate the environment from this
-       process, too. */
+    /* If this plugin has any environment variables, we need to
+       duplicate the environment from this process, too. */
     if(p->environ[0] != NULL){
       for(char **e = environ; *e != NULL; e++){
 	if(not add_environment(p, *e, false)){
@@ -937,25 +977,47 @@
     }
     
     int pipefd[2];
+#ifndef O_CLOEXEC
     ret = (int)TEMP_FAILURE_RETRY(pipe(pipefd));
+#else  /* O_CLOEXEC */
+    ret = (int)TEMP_FAILURE_RETRY(pipe2(pipefd, O_CLOEXEC));
+#endif	/* O_CLOEXEC */
     if(ret == -1){
       error(0, errno, "pipe");
       exitstatus = EX_OSERR;
-      goto fallback;
-    }
+      free(direntries[i]);
+      goto fallback;
+    }
+    if(pipefd[0] >= FD_SETSIZE){
+      fprintf(stderr, "pipe()[0] (%d) >= FD_SETSIZE (%d)", pipefd[0],
+	      FD_SETSIZE);
+      close(pipefd[0]);
+      close(pipefd[1]);
+      exitstatus = EX_OSERR;
+      free(direntries[i]);
+      goto fallback;
+    }
+#ifndef O_CLOEXEC
     /* Ask OS to automatic close the pipe on exec */
     ret = set_cloexec_flag(pipefd[0]);
     if(ret < 0){
       error(0, errno, "set_cloexec_flag");
+      close(pipefd[0]);
+      close(pipefd[1]);
       exitstatus = EX_OSERR;
+      free(direntries[i]);
       goto fallback;
     }
     ret = set_cloexec_flag(pipefd[1]);
     if(ret < 0){
       error(0, errno, "set_cloexec_flag");
+      close(pipefd[0]);
+      close(pipefd[1]);
       exitstatus = EX_OSERR;
+      free(direntries[i]);
       goto fallback;
     }
+#endif	/* not O_CLOEXEC */
     /* Block SIGCHLD until process is safely in process list */
     ret = (int)TEMP_FAILURE_RETRY(sigprocmask(SIG_BLOCK,
 					      &sigchld_action.sa_mask,
@@ -963,6 +1025,7 @@
     if(ret < 0){
       error(0, errno, "sigprocmask");
       exitstatus = EX_OSERR;
+      free(direntries[i]);
       goto fallback;
     }
     /* Starting a new process to be watched */
@@ -972,7 +1035,12 @@
     } while(pid == -1 and errno == EINTR);
     if(pid == -1){
       error(0, errno, "fork");
+      TEMP_FAILURE_RETRY(sigprocmask(SIG_UNBLOCK,
+				     &sigchld_action.sa_mask, NULL));
+      close(pipefd[0]);
+      close(pipefd[1]);
       exitstatus = EX_OSERR;
+      free(direntries[i]);
       goto fallback;
     }
     if(pid == 0){
@@ -994,29 +1062,19 @@
 	_exit(EX_OSERR);
       }
       
-      if(dirfd(dir) < 0){
-	/* If dir has no file descriptor, we could not set FD_CLOEXEC
-	   above and must now close it manually here. */
-	closedir(dir);
-      }
-      if(p->environ[0] == NULL){
-	if(execv(filename, p->argv) < 0){
-	  error(0, errno, "execv for %s", filename);
-	  _exit(EX_OSERR);
-	}
-      } else {
-	if(execve(filename, p->argv, p->environ) < 0){
-	  error(0, errno, "execve for %s", filename);
-	  _exit(EX_OSERR);
-	}
+      if(fexecve(plugin_fd, p->argv,
+		(p->environ[0] != NULL) ? p->environ : environ) < 0){
+	error(0, errno, "fexecve for %s/%s",
+	      plugindir != NULL ? plugindir : PDIR,
+	      direntries[i]->d_name);
+	_exit(EX_OSERR);
       }
       /* no return */
     }
     /* Parent process */
-    TEMP_FAILURE_RETRY(close(pipefd[1])); /* Close unused write end of
-					     pipe */
-    free(filename);
-    plugin *new_plugin = getplugin(dirst->d_name);
+    close(pipefd[1]);		/* Close unused write end of pipe */
+    close(plugin_fd);
+    plugin *new_plugin = getplugin(direntries[i]->d_name);
     if(new_plugin == NULL){
       error(0, errno, "getplugin");
       ret = (int)(TEMP_FAILURE_RETRY
@@ -1026,8 +1084,10 @@
         error(0, errno, "sigprocmask");
       }
       exitstatus = EX_OSERR;
+      free(direntries[i]);
       goto fallback;
     }
+    free(direntries[i]);
     
     new_plugin->pid = pid;
     new_plugin->fd = pipefd[0];
@@ -1043,16 +1103,17 @@
       goto fallback;
     }
     
-    FD_SET(new_plugin->fd, &rfds_all); /* Spurious warning from
-					  -Wconversion */
+    FD_SET(new_plugin->fd, &rfds_all);
     
     if(maxfd < new_plugin->fd){
       maxfd = new_plugin->fd;
     }
   }
   
-  TEMP_FAILURE_RETRY(closedir(dir));
-  dir = NULL;
+  free(direntries);
+  direntries = NULL;
+  close(dir_fd);
+  dir_fd = -1;
   free_plugin(getplugin(NULL));
   
   for(plugin *p = plugin_list; p != NULL; p = p->next){
@@ -1097,15 +1158,11 @@
 		      (intmax_t) (proc->pid),
 		      WTERMSIG(proc->status),
 		      strsignal(WTERMSIG(proc->status)));
-	    } else if(WCOREDUMP(proc->status)){
-	      fprintf(stderr, "Plugin %s [%" PRIdMAX "] dumped"
-		      " core\n", proc->name, (intmax_t) (proc->pid));
 	    }
 	  }
 	  
 	  /* Remove the plugin */
-	  FD_CLR(proc->fd, &rfds_all); /* Spurious warning from
-					  -Wconversion */
+	  FD_CLR(proc->fd, &rfds_all);
 	  
 	  /* Block signal while modifying process_list */
 	  ret = (int)TEMP_FAILURE_RETRY(sigprocmask
@@ -1151,22 +1208,21 @@
       }
       
       /* This process has not completed.  Does it have any output? */
-      if(proc->eof or not FD_ISSET(proc->fd, &rfds)){ /* Spurious
-							 warning from
-							 -Wconversion */
+      if(proc->eof or not FD_ISSET(proc->fd, &rfds)){
 	/* This process had nothing to say at this time */
 	proc = proc->next;
 	continue;
       }
       /* Before reading, make the process' data buffer large enough */
       if(proc->buffer_length + BUFFER_SIZE > proc->buffer_size){
-	proc->buffer = realloc(proc->buffer, proc->buffer_size
-			       + (size_t) BUFFER_SIZE);
-	if(proc->buffer == NULL){
+	char *new_buffer = realloc(proc->buffer, proc->buffer_size
+				   + (size_t) BUFFER_SIZE);
+	if(new_buffer == NULL){
 	  error(0, errno, "malloc");
 	  exitstatus = EX_OSERR;
 	  goto fallback;
 	}
+	proc->buffer = new_buffer;
 	proc->buffer_size += BUFFER_SIZE;
       }
       /* Read from the process */
@@ -1225,8 +1281,10 @@
     free(custom_argv);
   }
   
-  if(dir != NULL){
-    closedir(dir);
+  free(direntries);
+  
+  if(dir_fd != -1){
+    close(dir_fd);
   }
   
   /* Kill the processes */
@@ -1252,6 +1310,7 @@
   free_plugin_list();
   
   free(plugindir);
+  free(pluginhelperdir);
   free(argfile);
   
   return exitstatus;

=== modified file 'plugin-runner.xml'
--- plugin-runner.xml	2009-01-18 06:41:57 +0000
+++ plugin-runner.xml	2016-03-17 21:18:37 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "plugin-runner">
-<!ENTITY TIMESTAMP "2009-01-17">
+<!ENTITY TIMESTAMP "2016-03-17">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -19,20 +19,27 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@fukt.bsnet.se</email>
+	  <email>belorn@recompile.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@fukt.bsnet.se</email>
+	  <email>teddy@recompile.se</email>
 	</address>
       </author>
     </authorgroup>
     <copyright>
       <year>2008</year>
       <year>2009</year>
+      <year>2010</year>
+      <year>2011</year>
+      <year>2012</year>
+      <year>2013</year>
+      <year>2014</year>
+      <year>2015</year>
+      <year>2016</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -113,6 +120,9 @@
       <arg><option>--plugin-dir=<replaceable
       >DIRECTORY</replaceable></option></arg>
       <sbr/>
+      <arg><option>--plugin-helper-dir=<replaceable
+      >DIRECTORY</replaceable></option></arg>
+      <sbr/>
       <arg><option>--config-file=<replaceable
       >FILE</replaceable></option></arg>
       <sbr/>
@@ -260,7 +270,7 @@
 	    Disable the plugin named
 	    <replaceable>PLUGIN</replaceable>.  The plugin will not be
 	    started.
-	  </para>	
+	  </para>
 	</listitem>
       </varlistentry>
       
@@ -319,6 +329,21 @@
       </varlistentry>
       
       <varlistentry>
+	<term><option>--plugin-helper-dir
+	<replaceable>DIRECTORY</replaceable></option></term>
+	<listitem>
+	  <para>
+	    Specify a different plugin helper directory.  The default
+	    is <filename>/lib/mandos/plugin-helpers</filename>, which
+	    will exist in the initial <acronym>RAM</acronym> disk
+	    environment.  (This will simply be passed to all plugins
+	    via the <envar>MANDOSPLUGINHELPERDIR</envar> environment
+	    variable.  See <xref linkend="writing_plugins"/>)
+	  </para>
+	</listitem>
+      </varlistentry>
+      
+      <varlistentry>
 	<term><option>--config-file
 	<replaceable>FILE</replaceable></option></term>
 	<listitem>
@@ -425,7 +450,11 @@
       <para>
 	The plugin will run in the initial RAM disk environment, so
 	care must be taken not to depend on any files or running
-	services not available there.
+	services not available there.  Any helper executables required
+	by the plugin (which are not in the <envar>PATH</envar>) can
+	be placed in the plugin helper directory, the name of which
+	will be made available to the plugin via the
+	<envar>MANDOSPLUGINHELPERDIR</envar> environment variable.
       </para>
       <para>
 	The plugin must exit cleanly and free all allocated resources
@@ -474,7 +503,9 @@
       only passes on its environment to all the plugins.  The
       environment passed to plugins can be modified using the
       <option>--global-env</option> and <option>--env-for</option>
-      options.
+      options.  Also, the <option>--plugin-helper-dir</option> option
+      will affect the environment variable
+      <envar>MANDOSPLUGINHELPERDIR</envar> for the plugins.
     </para>
   </refsect1>
   
@@ -513,6 +544,26 @@
 	    </para>
 	  </listitem>
 	</varlistentry>
+	<varlistentry>
+	  <term><filename class="directory"
+	  >/lib/mandos/plugins.d</filename></term>
+	  <listitem>
+	    <para>
+	      The default plugin directory; can be changed by the
+	      <option>--plugin-dir</option> option.
+	    </para>
+	  </listitem>
+	</varlistentry>
+	<varlistentry>
+	  <term><filename class="directory"
+	  >/lib/mandos/plugin-helpers</filename></term>
+	  <listitem>
+	    <para>
+	      The default plugin helper directory; can be changed by
+	      the <option>--plugin-helper-dir</option> option.
+	    </para>
+	  </listitem>
+	</varlistentry>
       </variablelist>
     </para>
   </refsect1>
@@ -523,6 +574,7 @@
       The <option>--config-file</option> option is ignored when
       specified from within a configuration file.
     </para>
+    <xi:include href="bugs.xml"/>
   </refsect1>
   
   <refsect1 id="examples">
@@ -571,15 +623,16 @@
     </informalexample>
     <informalexample>
       <para>
-	Run plugins from a different directory, read a different
-	configuration file, and add two options to the
+	Read a different configuration file, run plugins from a
+	different directory, specify an alternate plugin helper
+	directory and add two options to the
 	<citerefentry><refentrytitle >mandos-client</refentrytitle>
 	<manvolnum>8mandos</manvolnum></citerefentry> plugin:
       </para>
       <para>
 
 <!-- do not wrap this line -->
-<userinput>cd /etc/keys/mandos; &COMMANDNAME;  --config-file=/etc/mandos/plugin-runner.conf --plugin-dir /usr/lib/mandos/plugins.d --options-for=mandos-client:--pubkey=pubkey.txt,--seckey=seckey.txt</userinput>
+<userinput>cd /etc/keys/mandos; &COMMANDNAME;  --config-file=/etc/mandos/plugin-runner.conf --plugin-dir /usr/lib/x86_64-linux-gnu/mandos/plugins.d --plugin-helper-dir /usr/lib/x86_64-linux-gnu/mandos/plugin-helpers --options-for=mandos-client:--pubkey=pubkey.txt,--seckey=seckey.txt</userinput>
 
       </para>
     </informalexample>
@@ -617,6 +670,8 @@
   <refsect1 id="see_also">
     <title>SEE ALSO</title>
     <para>
+      <citerefentry><refentrytitle>intro</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>cryptsetup</refentrytitle>
       <manvolnum>8</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>crypttab</refentrytitle>

=== modified file 'plugins.d/askpass-fifo.c'
--- plugins.d/askpass-fifo.c	2010-09-26 18:32:58 +0000
+++ plugins.d/askpass-fifo.c	2016-02-28 14:22:10 +0000
@@ -2,8 +2,8 @@
 /*
  * Askpass-FIFO - Read a password from a FIFO and output it
  * 
- * Copyright © 2008-2010 Teddy Hogeborn
- * Copyright © 2008-2010 Björn Påhlsson
+ * Copyright © 2008-2016 Teddy Hogeborn
+ * Copyright © 2008-2016 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -19,11 +19,11 @@
  * along with this program.  If not, see
  * <http://www.gnu.org/licenses/>.
  * 
- * Contact the authors at <mandos@fukt.bsnet.se>.
+ * Contact the authors at <mandos@recompile.se>.
  */
 
 #define _GNU_SOURCE		/* TEMP_FAILURE_RETRY() */
-#include <sys/types.h>		/* ssize_t */
+#include <sys/types.h>		/* uid_t, gid_t, ssize_t */
 #include <sys/stat.h>		/* mkfifo(), S_IRUSR, S_IWUSR */
 #include <iso646.h>		/* and */
 #include <errno.h>		/* errno, EACCES, ENOTDIR, ELOOP,
@@ -32,6 +32,8 @@
 				   ENFILE, ENOMEM, EBADF, EINVAL, EIO,
 				   EISDIR, EFBIG */
 #include <error.h>		/* error() */
+#include <stdio.h>		/* fprintf(), vfprintf(),
+				   vasprintf() */
 #include <stdlib.h>		/* EXIT_FAILURE, NULL, size_t, free(),
 				   realloc(), EXIT_SUCCESS */
 #include <fcntl.h>		/* open(), O_RDONLY */
@@ -39,31 +41,62 @@
 				   STDOUT_FILENO */
 #include <sysexits.h>		/* EX_OSERR, EX_OSFILE,
 				   EX_UNAVAILABLE, EX_IOERR */
-
+#include <string.h> 		/* strerror() */
+#include <stdarg.h>		/* va_list, va_start(), ... */
+
+uid_t uid = 65534;
+gid_t gid = 65534;
+
+/* Function to use when printing errors */
+__attribute__((format (gnu_printf, 3, 4)))
+void error_plus(int status, int errnum, const char *formatstring,
+		...){
+  va_list ap;
+  char *text;
+  int ret;
+  
+  va_start(ap, formatstring);
+  ret = vasprintf(&text, formatstring, ap);
+  if(ret == -1){
+    fprintf(stderr, "Mandos plugin %s: ",
+	    program_invocation_short_name);
+    vfprintf(stderr, formatstring, ap);
+    fprintf(stderr, ": ");
+    fprintf(stderr, "%s\n", strerror(errnum));
+    error(status, errno, "vasprintf while printing error");
+    return;
+  }
+  fprintf(stderr, "Mandos plugin ");
+  error(status, errnum, "%s", text);
+  free(text);
+}
 
 int main(__attribute__((unused))int argc,
 	 __attribute__((unused))char **argv){
   int ret = 0;
   ssize_t sret;
   
+  uid = getuid();
+  gid = getgid();
+  
   /* Create FIFO */
   const char passfifo[] = "/lib/cryptsetup/passfifo";
   ret = mkfifo(passfifo, S_IRUSR | S_IWUSR);
   if(ret == -1){
     int e = errno;
-    error(0, errno, "mkfifo");
     switch(e){
     case EACCES:
     case ENOTDIR:
     case ELOOP:
-      return EX_OSFILE;
+      error_plus(EX_OSFILE, errno, "mkfifo");
     case ENAMETOOLONG:
     case ENOSPC:
     case EROFS:
     default:
-      return EX_OSERR;
+      error_plus(EX_OSERR, errno, "mkfifo");
     case ENOENT:
-      return EX_UNAVAILABLE;	/* no "/lib/cryptsetup"? */
+      /* no "/lib/cryptsetup"? */
+      error_plus(EX_UNAVAILABLE, errno, "mkfifo");
     case EEXIST:
       break;			/* not an error */
     }
@@ -73,7 +106,7 @@
   int fifo_fd = open(passfifo, O_RDONLY);
   if(fifo_fd == -1){
     int e = errno;
-    error(0, errno, "open");
+    error_plus(0, errno, "open");
     switch(e){
     case EACCES:
     case ENOENT:
@@ -91,6 +124,16 @@
     }
   }
   
+  /* Lower group privileges  */
+  if(setgid(gid) == -1){
+    error_plus(0, errno, "setgid");
+  }
+  
+  /* Lower user privileges */
+  if(setuid(uid) == -1){
+    error_plus(0, errno, "setuid");
+  }
+  
   /* Read from FIFO */
   char *buf = NULL;
   size_t buf_len = 0;
@@ -101,7 +144,7 @@
       if(buf_len + blocksize > buf_allocated){
 	char *tmp = realloc(buf, buf_allocated + blocksize);
 	if(tmp == NULL){
-	  error(0, errno, "realloc");
+	  error_plus(0, errno, "realloc");
 	  free(buf);
 	  return EX_OSERR;
 	}
@@ -113,7 +156,7 @@
 	int e = errno;
 	free(buf);
 	errno = e;
-	error(0, errno, "read");
+	error_plus(0, errno, "read");
 	switch(e){
 	case EBADF:
 	case EFAULT:
@@ -141,7 +184,7 @@
       int e = errno;
       free(buf);
       errno = e;
-      error(0, errno, "write");
+      error_plus(0, errno, "write");
       switch(e){
       case EBADF:
       case EFAULT:
@@ -161,7 +204,7 @@
   ret = close(STDOUT_FILENO);
   if(ret == -1){
     int e = errno;
-    error(0, errno, "close");
+    error_plus(0, errno, "close");
     switch(e){
     case EBADF:
       return EX_OSFILE;

=== modified file 'plugins.d/askpass-fifo.xml'
--- plugins.d/askpass-fifo.xml	2009-01-04 21:54:55 +0000
+++ plugins.d/askpass-fifo.xml	2016-03-05 21:42:56 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "askpass-fifo">
-<!ENTITY TIMESTAMP "2009-01-04">
+<!ENTITY TIMESTAMP "2016-03-05">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -19,24 +19,30 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@fukt.bsnet.se</email>
+	  <email>belorn@recompile.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@fukt.bsnet.se</email>
+	  <email>teddy@recompile.se</email>
 	</address>
       </author>
     </authorgroup>
     <copyright>
       <year>2008</year>
       <year>2009</year>
+      <year>2010</year>
+      <year>2011</year>
+      <year>2012</year>
+      <year>2013</year>
+      <year>2014</year>
+      <year>2015</year>
+      <year>2016</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
-    <xi:include href="../legalnotice.xml"/>
   </refentryinfo>
   
   <refmeta>
@@ -111,6 +117,11 @@
     </variablelist>
   </refsect1>
   
+  <refsect1 id="bugs">
+    <title>BUGS</title>
+    <xi:include href="../bugs.xml"/>
+  </refsect1>
+  
   <refsect1 id="example">
     <title>EXAMPLE</title>
     <para>
@@ -148,6 +159,8 @@
   <refsect1 id="see_also">
     <title>SEE ALSO</title>
     <para>
+      <citerefentry><refentrytitle>intro</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>fifo</refentrytitle>
       <manvolnum>7</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>plugin-runner</refentrytitle>

=== modified file 'plugins.d/mandos-client.c'
--- plugins.d/mandos-client.c	2010-09-26 21:27:28 +0000
+++ plugins.d/mandos-client.c	2016-10-05 19:56:40 +0000
@@ -9,8 +9,8 @@
  * "browse_callback", and parts of "main".
  * 
  * Everything else is
- * Copyright © 2008-2010 Teddy Hogeborn
- * Copyright © 2008-2010 Björn Påhlsson
+ * Copyright © 2008-2016 Teddy Hogeborn
+ * Copyright © 2008-2016 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -26,43 +26,49 @@
  * along with this program.  If not, see
  * <http://www.gnu.org/licenses/>.
  * 
- * Contact the authors at <mandos@fukt.bsnet.se>.
+ * Contact the authors at <mandos@recompile.se>.
  */
 
 /* Needed by GPGME, specifically gpgme_data_seek() */
 #ifndef _LARGEFILE_SOURCE
 #define _LARGEFILE_SOURCE
-#endif
+#endif	/* not _LARGEFILE_SOURCE */
 #ifndef _FILE_OFFSET_BITS
 #define _FILE_OFFSET_BITS 64
-#endif
+#endif	/* not _FILE_OFFSET_BITS */
 
 #define _GNU_SOURCE		/* TEMP_FAILURE_RETRY(), asprintf() */
 
 #include <stdio.h>		/* fprintf(), stderr, fwrite(),
-				   stdout, ferror(), remove() */
-#include <stdint.h> 		/* uint16_t, uint32_t */
+				   stdout, ferror() */
+#include <stdint.h> 		/* uint16_t, uint32_t, intptr_t */
 #include <stddef.h>		/* NULL, size_t, ssize_t */
 #include <stdlib.h> 		/* free(), EXIT_SUCCESS, srand(),
 				   strtof(), abort() */
 #include <stdbool.h>		/* bool, false, true */
-#include <string.h>		/* memset(), strcmp(), strlen(),
-				   strerror(), asprintf(), strcpy() */
+#include <string.h>		/* strcmp(), strlen(), strerror(),
+				   asprintf(), strncpy(), strsignal()
+				*/
 #include <sys/ioctl.h>		/* ioctl */
 #include <sys/types.h>		/* socket(), inet_pton(), sockaddr,
 				   sockaddr_in6, PF_INET6,
 				   SOCK_STREAM, uid_t, gid_t, open(),
 				   opendir(), DIR */
-#include <sys/stat.h>		/* open() */
+#include <sys/stat.h>		/* open(), S_ISREG */
 #include <sys/socket.h>		/* socket(), struct sockaddr_in6,
-				   inet_pton(), connect() */
-#include <fcntl.h>		/* open() */
+				   inet_pton(), connect(),
+				   getnameinfo() */
+#include <fcntl.h>		/* open(), unlinkat(), AT_REMOVEDIR */
 #include <dirent.h>		/* opendir(), struct dirent, readdir()
 				 */
 #include <inttypes.h>		/* PRIu16, PRIdMAX, intmax_t,
 				   strtoimax() */
-#include <assert.h>		/* assert() */
-#include <errno.h>		/* perror(), errno */
+#include <errno.h>		/* perror(), errno, EINTR, EINVAL,
+				   EAI_SYSTEM, ENETUNREACH,
+				   EHOSTUNREACH, ECONNREFUSED, EPROTO,
+				   EIO, ENOENT, ENXIO, ENOMEM, EISDIR,
+				   ENOTEMPTY,
+				   program_invocation_short_name */
 #include <time.h>		/* nanosleep(), time(), sleep() */
 #include <net/if.h>		/* ioctl, ifreq, SIOCGIFFLAGS, IFF_UP,
 				   SIOCSIFFLAGS, if_indextoname(),
@@ -72,8 +78,9 @@
 				*/
 #include <unistd.h>		/* close(), SEEK_SET, off_t, write(),
 				   getuid(), getgid(), seteuid(),
-				   setgid(), pause() */
-#include <arpa/inet.h>		/* inet_pton(), htons */
+				   setgid(), pause(), _exit(),
+				   unlinkat() */
+#include <arpa/inet.h>		/* inet_pton(), htons() */
 #include <iso646.h>		/* not, or, and */
 #include <argp.h>		/* struct argp_option, error_t, struct
 				   argp_state, struct argp,
@@ -84,6 +91,15 @@
 				   raise() */
 #include <sysexits.h>		/* EX_OSERR, EX_USAGE, EX_UNAVAILABLE,
 				   EX_NOHOST, EX_IOERR, EX_PROTOCOL */
+#include <sys/wait.h>		/* waitpid(), WIFEXITED(),
+				   WEXITSTATUS(), WTERMSIG() */
+#include <grp.h>		/* setgroups() */
+#include <argz.h>		/* argz_add_sep(), argz_next(),
+				   argz_delete(), argz_append(),
+				   argz_stringify(), argz_add(),
+				   argz_count() */
+#include <netdb.h>		/* getnameinfo(), NI_NUMERICHOST,
+				   EAI_SYSTEM, gai_strerror() */
 
 #ifdef __linux__
 #include <sys/klog.h> 		/* klogctl() */
@@ -107,8 +123,8 @@
 				   init_gnutls_session(),
 				   GNUTLS_* */
 #include <gnutls/openpgp.h>
-			  /* gnutls_certificate_set_openpgp_key_file(),
-				   GNUTLS_OPENPGP_FMT_BASE64 */
+			 /* gnutls_certificate_set_openpgp_key_file(),
+			    GNUTLS_OPENPGP_FMT_BASE64 */
 
 /* GPGME */
 #include <gpgme.h> 		/* All GPGME types, constants and
@@ -122,113 +138,204 @@
 #define PATHDIR "/conf/conf.d/mandos"
 #define SECKEY "seckey.txt"
 #define PUBKEY "pubkey.txt"
+#define HOOKDIR "/lib/mandos/network-hooks.d"
 
 bool debug = false;
 static const char mandos_protocol_version[] = "1";
 const char *argp_program_version = "mandos-client " VERSION;
-const char *argp_program_bug_address = "<mandos@fukt.bsnet.se>";
+const char *argp_program_bug_address = "<mandos@recompile.se>";
 static const char sys_class_net[] = "/sys/class/net";
 char *connect_to = NULL;
+const char *hookdir = HOOKDIR;
+int hookdir_fd = -1;
+uid_t uid = 65534;
+gid_t gid = 65534;
+
+/* Doubly linked list that need to be circularly linked when used */
+typedef struct server{
+  const char *ip;
+  in_port_t port;
+  AvahiIfIndex if_index;
+  int af;
+  struct timespec last_seen;
+  struct server *next;
+  struct server *prev;
+} server;
 
 /* Used for passing in values through the Avahi callback functions */
 typedef struct {
-  AvahiSimplePoll *simple_poll;
   AvahiServer *server;
   gnutls_certificate_credentials_t cred;
   unsigned int dh_bits;
   gnutls_dh_params_t dh_params;
   const char *priority;
   gpgme_ctx_t ctx;
+  server *current_server;
+  char *interfaces;
+  size_t interfaces_size;
 } mandos_context;
 
-/* global context so signal handler can reach it*/
-mandos_context mc = { .simple_poll = NULL, .server = NULL,
-		      .dh_bits = 1024, .priority = "SECURE256"
-		      ":!CTYPE-X.509:+CTYPE-OPENPGP" };
+/* global so signal handler can reach it*/
+AvahiSimplePoll *simple_poll;
 
 sig_atomic_t quit_now = 0;
 int signal_received = 0;
 
+/* Function to use when printing errors */
+void perror_plus(const char *print_text){
+  int e = errno;
+  fprintf(stderr, "Mandos plugin %s: ",
+	  program_invocation_short_name);
+  errno = e;
+  perror(print_text);
+}
+
+__attribute__((format (gnu_printf, 2, 3), nonnull))
+int fprintf_plus(FILE *stream, const char *format, ...){
+  va_list ap;
+  va_start (ap, format);
+  
+  TEMP_FAILURE_RETRY(fprintf(stream, "Mandos plugin %s: ",
+			     program_invocation_short_name));
+  return (int)TEMP_FAILURE_RETRY(vfprintf(stream, format, ap));
+}
+
 /*
  * Make additional room in "buffer" for at least BUFFER_SIZE more
  * bytes. "buffer_capacity" is how much is currently allocated,
  * "buffer_length" is how much is already used.
  */
+__attribute__((nonnull, warn_unused_result))
 size_t incbuffer(char **buffer, size_t buffer_length,
-		  size_t buffer_capacity){
+		 size_t buffer_capacity){
   if(buffer_length + BUFFER_SIZE > buffer_capacity){
-    *buffer = realloc(*buffer, buffer_capacity + BUFFER_SIZE);
-    if(buffer == NULL){
+    char *new_buf = realloc(*buffer, buffer_capacity + BUFFER_SIZE);
+    if(new_buf == NULL){
+      int old_errno = errno;
+      free(*buffer);
+      errno = old_errno;
+      *buffer = NULL;
       return 0;
     }
+    *buffer = new_buf;
     buffer_capacity += BUFFER_SIZE;
   }
   return buffer_capacity;
 }
 
+/* Add server to set of servers to retry periodically */
+__attribute__((nonnull, warn_unused_result))
+bool add_server(const char *ip, in_port_t port, AvahiIfIndex if_index,
+		int af, server **current_server){
+  int ret;
+  server *new_server = malloc(sizeof(server));
+  if(new_server == NULL){
+    perror_plus("malloc");
+    return false;
+  }
+  *new_server = (server){ .ip = strdup(ip),
+			  .port = port,
+			  .if_index = if_index,
+			  .af = af };
+  if(new_server->ip == NULL){
+    perror_plus("strdup");
+    free(new_server);
+    return false;
+  }
+  ret = clock_gettime(CLOCK_MONOTONIC, &(new_server->last_seen));
+  if(ret == -1){
+    perror_plus("clock_gettime");
+#ifdef __GNUC__
+#pragma GCC diagnostic push
+#pragma GCC diagnostic ignored "-Wcast-qual"
+#endif
+    free((char *)(new_server->ip));
+#ifdef __GNUC__
+#pragma GCC diagnostic pop
+#endif
+    free(new_server);
+    return false;
+  }
+  /* Special case of first server */
+  if(*current_server == NULL){
+    new_server->next = new_server;
+    new_server->prev = new_server;
+    *current_server = new_server;
+  } else {
+    /* Place the new server last in the list */
+    new_server->next = *current_server;
+    new_server->prev = (*current_server)->prev;
+    new_server->prev->next = new_server;
+    (*current_server)->prev = new_server;
+  }
+  return true;
+}
+
 /* 
  * Initialize GPGME.
  */
-static bool init_gpgme(const char *seckey,
-		       const char *pubkey, const char *tempdir){
+__attribute__((nonnull, warn_unused_result))
+static bool init_gpgme(const char * const seckey,
+		       const char * const pubkey,
+		       const char * const tempdir,
+		       mandos_context *mc){
   gpgme_error_t rc;
   gpgme_engine_info_t engine_info;
   
-  
   /*
    * Helper function to insert pub and seckey to the engine keyring.
    */
-  bool import_key(const char *filename){
+  bool import_key(const char * const filename){
     int ret;
     int fd;
     gpgme_data_t pgp_data;
     
     fd = (int)TEMP_FAILURE_RETRY(open(filename, O_RDONLY));
     if(fd == -1){
-      perror("open");
+      perror_plus("open");
       return false;
     }
     
     rc = gpgme_data_new_from_fd(&pgp_data, fd);
     if(rc != GPG_ERR_NO_ERROR){
-      fprintf(stderr, "bad gpgme_data_new_from_fd: %s: %s\n",
-	      gpgme_strsource(rc), gpgme_strerror(rc));
+      fprintf_plus(stderr, "bad gpgme_data_new_from_fd: %s: %s\n",
+		   gpgme_strsource(rc), gpgme_strerror(rc));
       return false;
     }
     
-    rc = gpgme_op_import(mc.ctx, pgp_data);
+    rc = gpgme_op_import(mc->ctx, pgp_data);
     if(rc != GPG_ERR_NO_ERROR){
-      fprintf(stderr, "bad gpgme_op_import: %s: %s\n",
-	      gpgme_strsource(rc), gpgme_strerror(rc));
+      fprintf_plus(stderr, "bad gpgme_op_import: %s: %s\n",
+		   gpgme_strsource(rc), gpgme_strerror(rc));
       return false;
     }
     
-    ret = (int)TEMP_FAILURE_RETRY(close(fd));
+    ret = close(fd);
     if(ret == -1){
-      perror("close");
+      perror_plus("close");
     }
     gpgme_data_release(pgp_data);
     return true;
   }
   
   if(debug){
-    fprintf(stderr, "Initializing GPGME\n");
+    fprintf_plus(stderr, "Initializing GPGME\n");
   }
   
   /* Init GPGME */
   gpgme_check_version(NULL);
   rc = gpgme_engine_check_version(GPGME_PROTOCOL_OpenPGP);
   if(rc != GPG_ERR_NO_ERROR){
-    fprintf(stderr, "bad gpgme_engine_check_version: %s: %s\n",
-	    gpgme_strsource(rc), gpgme_strerror(rc));
+    fprintf_plus(stderr, "bad gpgme_engine_check_version: %s: %s\n",
+		 gpgme_strsource(rc), gpgme_strerror(rc));
     return false;
   }
   
-    /* Set GPGME home directory for the OpenPGP engine only */
+  /* Set GPGME home directory for the OpenPGP engine only */
   rc = gpgme_get_engine_info(&engine_info);
   if(rc != GPG_ERR_NO_ERROR){
-    fprintf(stderr, "bad gpgme_get_engine_info: %s: %s\n",
-	    gpgme_strsource(rc), gpgme_strerror(rc));
+    fprintf_plus(stderr, "bad gpgme_get_engine_info: %s: %s\n",
+		 gpgme_strsource(rc), gpgme_strerror(rc));
     return false;
   }
   while(engine_info != NULL){
@@ -240,15 +347,17 @@
     engine_info = engine_info->next;
   }
   if(engine_info == NULL){
-    fprintf(stderr, "Could not set GPGME home dir to %s\n", tempdir);
+    fprintf_plus(stderr, "Could not set GPGME home dir to %s\n",
+		 tempdir);
     return false;
   }
   
   /* Create new GPGME "context" */
-  rc = gpgme_new(&(mc.ctx));
+  rc = gpgme_new(&(mc->ctx));
   if(rc != GPG_ERR_NO_ERROR){
-    fprintf(stderr, "bad gpgme_new: %s: %s\n",
-	    gpgme_strsource(rc), gpgme_strerror(rc));
+    fprintf_plus(stderr, "Mandos plugin mandos-client: "
+		 "bad gpgme_new: %s: %s\n", gpgme_strsource(rc),
+		 gpgme_strerror(rc));
     return false;
   }
   
@@ -263,9 +372,11 @@
  * Decrypt OpenPGP data.
  * Returns -1 on error
  */
+__attribute__((nonnull, warn_unused_result))
 static ssize_t pgp_packet_decrypt(const char *cryptotext,
 				  size_t crypto_size,
-				  char **plaintext){
+				  char **plaintext,
+				  mandos_context *mc){
   gpgme_data_t dh_crypto, dh_plain;
   gpgme_error_t rc;
   ssize_t ret;
@@ -273,56 +384,58 @@
   ssize_t plaintext_length = 0;
   
   if(debug){
-    fprintf(stderr, "Trying to decrypt OpenPGP data\n");
+    fprintf_plus(stderr, "Trying to decrypt OpenPGP data\n");
   }
   
   /* Create new GPGME data buffer from memory cryptotext */
   rc = gpgme_data_new_from_mem(&dh_crypto, cryptotext, crypto_size,
 			       0);
   if(rc != GPG_ERR_NO_ERROR){
-    fprintf(stderr, "bad gpgme_data_new_from_mem: %s: %s\n",
-	    gpgme_strsource(rc), gpgme_strerror(rc));
+    fprintf_plus(stderr, "bad gpgme_data_new_from_mem: %s: %s\n",
+		 gpgme_strsource(rc), gpgme_strerror(rc));
     return -1;
   }
   
   /* Create new empty GPGME data buffer for the plaintext */
   rc = gpgme_data_new(&dh_plain);
   if(rc != GPG_ERR_NO_ERROR){
-    fprintf(stderr, "bad gpgme_data_new: %s: %s\n",
-	    gpgme_strsource(rc), gpgme_strerror(rc));
+    fprintf_plus(stderr, "Mandos plugin mandos-client: "
+		 "bad gpgme_data_new: %s: %s\n",
+		 gpgme_strsource(rc), gpgme_strerror(rc));
     gpgme_data_release(dh_crypto);
     return -1;
   }
   
   /* Decrypt data from the cryptotext data buffer to the plaintext
      data buffer */
-  rc = gpgme_op_decrypt(mc.ctx, dh_crypto, dh_plain);
+  rc = gpgme_op_decrypt(mc->ctx, dh_crypto, dh_plain);
   if(rc != GPG_ERR_NO_ERROR){
-    fprintf(stderr, "bad gpgme_op_decrypt: %s: %s\n",
-	    gpgme_strsource(rc), gpgme_strerror(rc));
+    fprintf_plus(stderr, "bad gpgme_op_decrypt: %s: %s\n",
+		 gpgme_strsource(rc), gpgme_strerror(rc));
     plaintext_length = -1;
     if(debug){
       gpgme_decrypt_result_t result;
-      result = gpgme_op_decrypt_result(mc.ctx);
+      result = gpgme_op_decrypt_result(mc->ctx);
       if(result == NULL){
-	fprintf(stderr, "gpgme_op_decrypt_result failed\n");
+	fprintf_plus(stderr, "gpgme_op_decrypt_result failed\n");
       } else {
-	fprintf(stderr, "Unsupported algorithm: %s\n",
-		result->unsupported_algorithm);
-	fprintf(stderr, "Wrong key usage: %u\n",
-		result->wrong_key_usage);
+	fprintf_plus(stderr, "Unsupported algorithm: %s\n",
+		     result->unsupported_algorithm);
+	fprintf_plus(stderr, "Wrong key usage: %u\n",
+		     result->wrong_key_usage);
 	if(result->file_name != NULL){
-	  fprintf(stderr, "File name: %s\n", result->file_name);
+	  fprintf_plus(stderr, "File name: %s\n", result->file_name);
 	}
 	gpgme_recipient_t recipient;
 	recipient = result->recipients;
 	while(recipient != NULL){
-	  fprintf(stderr, "Public key algorithm: %s\n",
-		  gpgme_pubkey_algo_name(recipient->pubkey_algo));
-	  fprintf(stderr, "Key ID: %s\n", recipient->keyid);
-	  fprintf(stderr, "Secret key available: %s\n",
-		  recipient->status == GPG_ERR_NO_SECKEY
-		  ? "No" : "Yes");
+	  fprintf_plus(stderr, "Public key algorithm: %s\n",
+		       gpgme_pubkey_algo_name
+		       (recipient->pubkey_algo));
+	  fprintf_plus(stderr, "Key ID: %s\n", recipient->keyid);
+	  fprintf_plus(stderr, "Secret key available: %s\n",
+		       recipient->status == GPG_ERR_NO_SECKEY
+		       ? "No" : "Yes");
 	  recipient = recipient->next;
 	}
       }
@@ -331,12 +444,12 @@
   }
   
   if(debug){
-    fprintf(stderr, "Decryption of OpenPGP data succeeded\n");
+    fprintf_plus(stderr, "Decryption of OpenPGP data succeeded\n");
   }
   
   /* Seek back to the beginning of the GPGME plaintext data buffer */
   if(gpgme_data_seek(dh_plain, (off_t)0, SEEK_SET) == -1){
-    perror("gpgme_data_seek");
+    perror_plus("gpgme_data_seek");
     plaintext_length = -1;
     goto decrypt_end;
   }
@@ -344,12 +457,12 @@
   *plaintext = NULL;
   while(true){
     plaintext_capacity = incbuffer(plaintext,
-				      (size_t)plaintext_length,
-				      plaintext_capacity);
+				   (size_t)plaintext_length,
+				   plaintext_capacity);
     if(plaintext_capacity == 0){
-	perror("incbuffer");
-	plaintext_length = -1;
-	goto decrypt_end;
+      perror_plus("incbuffer");
+      plaintext_length = -1;
+      goto decrypt_end;
     }
     
     ret = gpgme_data_read(dh_plain, *plaintext + plaintext_length,
@@ -360,7 +473,7 @@
       break;
     }
     if(ret < 0){
-      perror("gpgme_data_read");
+      perror_plus("gpgme_data_read");
       plaintext_length = -1;
       goto decrypt_end;
     }
@@ -368,7 +481,7 @@
   }
   
   if(debug){
-    fprintf(stderr, "Decrypted password is: ");
+    fprintf_plus(stderr, "Decrypted password is: ");
     for(ssize_t i = 0; i < plaintext_length; i++){
       fprintf(stderr, "%02hhX ", (*plaintext)[i]);
     }
@@ -385,33 +498,36 @@
   return plaintext_length;
 }
 
-static const char * safer_gnutls_strerror(int value){
-  const char *ret = gnutls_strerror(value); /* Spurious warning from
-					       -Wunreachable-code */
-  if(ret == NULL)
-    ret = "(unknown)";
-  return ret;
+__attribute__((warn_unused_result, const))
+static const char *safe_string(const char *str){
+  if(str == NULL)
+    return "(unknown)";
+  return str;
+}
+
+__attribute__((warn_unused_result))
+static const char *safer_gnutls_strerror(int value){
+  const char *ret = gnutls_strerror(value);
+  return safe_string(ret);
 }
 
 /* GnuTLS log function callback */
+__attribute__((nonnull))
 static void debuggnutls(__attribute__((unused)) int level,
 			const char* string){
-  fprintf(stderr, "GnuTLS: %s", string);
+  fprintf_plus(stderr, "GnuTLS: %s", string);
 }
 
+__attribute__((nonnull(1, 2, 4), warn_unused_result))
 static int init_gnutls_global(const char *pubkeyfilename,
-			      const char *seckeyfilename){
+			      const char *seckeyfilename,
+			      const char *dhparamsfilename,
+			      mandos_context *mc){
   int ret;
+  unsigned int uret;
   
   if(debug){
-    fprintf(stderr, "Initializing GnuTLS\n");
-  }
-  
-  ret = gnutls_global_init();
-  if(ret != GNUTLS_E_SUCCESS){
-    fprintf(stderr, "GnuTLS global_init: %s\n",
-	    safer_gnutls_strerror(ret));
-    return -1;
+    fprintf_plus(stderr, "Initializing GnuTLS\n");
   }
   
   if(debug){
@@ -423,62 +539,227 @@
   }
   
   /* OpenPGP credentials */
-  gnutls_certificate_allocate_credentials(&mc.cred);
+  ret = gnutls_certificate_allocate_credentials(&mc->cred);
   if(ret != GNUTLS_E_SUCCESS){
-    fprintf(stderr, "GnuTLS memory error: %s\n", /* Spurious warning
-						    from
-						    -Wunreachable-code
-						 */
-	    safer_gnutls_strerror(ret));
-    gnutls_global_deinit();
+    fprintf_plus(stderr, "GnuTLS memory error: %s\n",
+		 safer_gnutls_strerror(ret));
     return -1;
   }
   
   if(debug){
-    fprintf(stderr, "Attempting to use OpenPGP public key %s and"
-	    " secret key %s as GnuTLS credentials\n", pubkeyfilename,
-	    seckeyfilename);
+    fprintf_plus(stderr, "Attempting to use OpenPGP public key %s and"
+		 " secret key %s as GnuTLS credentials\n",
+		 pubkeyfilename,
+		 seckeyfilename);
   }
   
   ret = gnutls_certificate_set_openpgp_key_file
-    (mc.cred, pubkeyfilename, seckeyfilename,
+    (mc->cred, pubkeyfilename, seckeyfilename,
      GNUTLS_OPENPGP_FMT_BASE64);
   if(ret != GNUTLS_E_SUCCESS){
-    fprintf(stderr,
-	    "Error[%d] while reading the OpenPGP key pair ('%s',"
-	    " '%s')\n", ret, pubkeyfilename, seckeyfilename);
-    fprintf(stderr, "The GnuTLS error is: %s\n",
-	    safer_gnutls_strerror(ret));
+    fprintf_plus(stderr,
+		 "Error[%d] while reading the OpenPGP key pair ('%s',"
+		 " '%s')\n", ret, pubkeyfilename, seckeyfilename);
+    fprintf_plus(stderr, "The GnuTLS error is: %s\n",
+		 safer_gnutls_strerror(ret));
     goto globalfail;
   }
   
   /* GnuTLS server initialization */
-  ret = gnutls_dh_params_init(&mc.dh_params);
-  if(ret != GNUTLS_E_SUCCESS){
-    fprintf(stderr, "Error in GnuTLS DH parameter initialization:"
-	    " %s\n", safer_gnutls_strerror(ret));
-    goto globalfail;
-  }
-  ret = gnutls_dh_params_generate2(mc.dh_params, mc.dh_bits);
-  if(ret != GNUTLS_E_SUCCESS){
-    fprintf(stderr, "Error in GnuTLS prime generation: %s\n",
-	    safer_gnutls_strerror(ret));
-    goto globalfail;
-  }
-  
-  gnutls_certificate_set_dh_params(mc.cred, mc.dh_params);
+  ret = gnutls_dh_params_init(&mc->dh_params);
+  if(ret != GNUTLS_E_SUCCESS){
+    fprintf_plus(stderr, "Error in GnuTLS DH parameter"
+		 " initialization: %s\n",
+		 safer_gnutls_strerror(ret));
+    goto globalfail;
+  }
+  /* If a Diffie-Hellman parameters file was given, try to use it */
+  if(dhparamsfilename != NULL){
+    gnutls_datum_t params = { .data = NULL, .size = 0 };
+    do {
+      int dhpfile = open(dhparamsfilename, O_RDONLY);
+      if(dhpfile == -1){
+	perror_plus("open");
+	dhparamsfilename = NULL;
+	break;
+      }
+      size_t params_capacity = 0;
+      while(true){
+	params_capacity = incbuffer((char **)&params.data,
+				    (size_t)params.size,
+				    (size_t)params_capacity);
+	if(params_capacity == 0){
+	  perror_plus("incbuffer");
+	  free(params.data);
+	  params.data = NULL;
+	  dhparamsfilename = NULL;
+	  break;
+	}
+	ssize_t bytes_read = read(dhpfile,
+				  params.data + params.size,
+				  BUFFER_SIZE);
+	/* EOF */
+	if(bytes_read == 0){
+	  break;
+	}
+	/* check bytes_read for failure */
+	if(bytes_read < 0){
+	  perror_plus("read");
+	  free(params.data);
+	  params.data = NULL;
+	  dhparamsfilename = NULL;
+	  break;
+	}
+	params.size += (unsigned int)bytes_read;
+      }
+      if(params.data == NULL){
+	dhparamsfilename = NULL;
+      }
+      if(dhparamsfilename == NULL){
+	break;
+      }
+      ret = gnutls_dh_params_import_pkcs3(mc->dh_params, &params,
+					  GNUTLS_X509_FMT_PEM);
+      if(ret != GNUTLS_E_SUCCESS){
+	fprintf_plus(stderr, "Failed to parse DH parameters in file"
+		     " \"%s\": %s\n", dhparamsfilename,
+		     safer_gnutls_strerror(ret));
+	dhparamsfilename = NULL;
+      }
+      free(params.data);
+    } while(false);
+  }
+  if(dhparamsfilename == NULL){
+    if(mc->dh_bits == 0){
+      /* Find out the optimal number of DH bits */
+      /* Try to read the private key file */
+      gnutls_datum_t buffer = { .data = NULL, .size = 0 };
+      do {
+	int secfile = open(seckeyfilename, O_RDONLY);
+	if(secfile == -1){
+	  perror_plus("open");
+	  break;
+	}
+	size_t buffer_capacity = 0;
+	while(true){
+	  buffer_capacity = incbuffer((char **)&buffer.data,
+				      (size_t)buffer.size,
+				      (size_t)buffer_capacity);
+	  if(buffer_capacity == 0){
+	    perror_plus("incbuffer");
+	    free(buffer.data);
+	    buffer.data = NULL;
+	    break;
+	  }
+	  ssize_t bytes_read = read(secfile,
+				    buffer.data + buffer.size,
+				    BUFFER_SIZE);
+	  /* EOF */
+	  if(bytes_read == 0){
+	    break;
+	  }
+	  /* check bytes_read for failure */
+	  if(bytes_read < 0){
+	    perror_plus("read");
+	    free(buffer.data);
+	    buffer.data = NULL;
+	    break;
+	  }
+	  buffer.size += (unsigned int)bytes_read;
+	}
+	close(secfile);
+      } while(false);
+      /* If successful, use buffer to parse private key */
+      gnutls_sec_param_t sec_param = GNUTLS_SEC_PARAM_ULTRA;
+      if(buffer.data != NULL){
+	{
+	  gnutls_openpgp_privkey_t privkey = NULL;
+	  ret = gnutls_openpgp_privkey_init(&privkey);
+	  if(ret != GNUTLS_E_SUCCESS){
+	    fprintf_plus(stderr, "Error initializing OpenPGP key"
+			 " structure: %s",
+			 safer_gnutls_strerror(ret));
+	    free(buffer.data);
+	    buffer.data = NULL;
+	  } else {
+	    ret = gnutls_openpgp_privkey_import
+	      (privkey, &buffer, GNUTLS_OPENPGP_FMT_BASE64, "", 0);
+	    if(ret != GNUTLS_E_SUCCESS){
+	      fprintf_plus(stderr, "Error importing OpenPGP key : %s",
+			   safer_gnutls_strerror(ret));
+	      privkey = NULL;
+	    }
+	    free(buffer.data);
+	    buffer.data = NULL;
+	    if(privkey != NULL){
+	      /* Use private key to suggest an appropriate
+		 sec_param */
+	      sec_param = gnutls_openpgp_privkey_sec_param(privkey);
+	      gnutls_openpgp_privkey_deinit(privkey);
+	      if(debug){
+		fprintf_plus(stderr, "This OpenPGP key implies using"
+			     " a GnuTLS security parameter \"%s\".\n",
+			     safe_string(gnutls_sec_param_get_name
+					 (sec_param)));
+	      }
+	    }
+	  }
+	}
+	if(sec_param == GNUTLS_SEC_PARAM_UNKNOWN){
+	  /* Err on the side of caution */
+	  sec_param = GNUTLS_SEC_PARAM_ULTRA;
+	  if(debug){
+	    fprintf_plus(stderr, "Falling back to security parameter"
+			 " \"%s\"\n",
+			 safe_string(gnutls_sec_param_get_name
+				     (sec_param)));
+	  }
+	}
+      }
+      uret = gnutls_sec_param_to_pk_bits(GNUTLS_PK_DH, sec_param);
+      if(uret != 0){
+	mc->dh_bits = uret;
+	if(debug){
+	  fprintf_plus(stderr, "A \"%s\" GnuTLS security parameter"
+		       " implies %u DH bits; using that.\n",
+		       safe_string(gnutls_sec_param_get_name
+				   (sec_param)),
+		       mc->dh_bits);
+	}
+      } else {
+	fprintf_plus(stderr, "Failed to get implied number of DH"
+		     " bits for security parameter \"%s\"): %s\n",
+		     safe_string(gnutls_sec_param_get_name
+				 (sec_param)),
+		     safer_gnutls_strerror(ret));
+	goto globalfail;
+      }
+    } else if(debug){
+      fprintf_plus(stderr, "DH bits explicitly set to %u\n",
+		   mc->dh_bits);
+    }
+    ret = gnutls_dh_params_generate2(mc->dh_params, mc->dh_bits);
+    if(ret != GNUTLS_E_SUCCESS){
+      fprintf_plus(stderr, "Error in GnuTLS prime generation (%u"
+		   " bits): %s\n", mc->dh_bits,
+		   safer_gnutls_strerror(ret));
+      goto globalfail;
+    }
+  }
+  gnutls_certificate_set_dh_params(mc->cred, mc->dh_params);
   
   return 0;
   
  globalfail:
   
-  gnutls_certificate_free_credentials(mc.cred);
-  gnutls_global_deinit();
-  gnutls_dh_params_deinit(mc.dh_params);
+  gnutls_certificate_free_credentials(mc->cred);
+  gnutls_dh_params_deinit(mc->dh_params);
   return -1;
 }
 
-static int init_gnutls_session(gnutls_session_t *session){
+__attribute__((nonnull, warn_unused_result))
+static int init_gnutls_session(gnutls_session_t *session,
+			       mandos_context *mc){
   int ret;
   /* GnuTLS session creation */
   do {
@@ -488,23 +769,24 @@
     }
   } while(ret == GNUTLS_E_INTERRUPTED or ret == GNUTLS_E_AGAIN);
   if(ret != GNUTLS_E_SUCCESS){
-    fprintf(stderr, "Error in GnuTLS session initialization: %s\n",
-	    safer_gnutls_strerror(ret));
+    fprintf_plus(stderr,
+		 "Error in GnuTLS session initialization: %s\n",
+		 safer_gnutls_strerror(ret));
   }
   
   {
     const char *err;
     do {
-      ret = gnutls_priority_set_direct(*session, mc.priority, &err);
+      ret = gnutls_priority_set_direct(*session, mc->priority, &err);
       if(quit_now){
 	gnutls_deinit(*session);
 	return -1;
       }
     } while(ret == GNUTLS_E_INTERRUPTED or ret == GNUTLS_E_AGAIN);
     if(ret != GNUTLS_E_SUCCESS){
-      fprintf(stderr, "Syntax error at: %s\n", err);
-      fprintf(stderr, "GnuTLS error: %s\n",
-	      safer_gnutls_strerror(ret));
+      fprintf_plus(stderr, "Syntax error at: %s\n", err);
+      fprintf_plus(stderr, "GnuTLS error: %s\n",
+		   safer_gnutls_strerror(ret));
       gnutls_deinit(*session);
       return -1;
     }
@@ -512,15 +794,15 @@
   
   do {
     ret = gnutls_credentials_set(*session, GNUTLS_CRD_CERTIFICATE,
-				 mc.cred);
+				 mc->cred);
     if(quit_now){
       gnutls_deinit(*session);
       return -1;
     }
   } while(ret == GNUTLS_E_INTERRUPTED or ret == GNUTLS_E_AGAIN);
   if(ret != GNUTLS_E_SUCCESS){
-    fprintf(stderr, "Error setting GnuTLS credentials: %s\n",
-	    safer_gnutls_strerror(ret));
+    fprintf_plus(stderr, "Error setting GnuTLS credentials: %s\n",
+		 safer_gnutls_strerror(ret));
     gnutls_deinit(*session);
     return -1;
   }
@@ -528,8 +810,6 @@
   /* ignore client certificate if any. */
   gnutls_certificate_server_set_request(*session, GNUTLS_CERT_IGNORE);
   
-  gnutls_dh_set_prime_bits(*session, mc.dh_bits);
-  
   return 0;
 }
 
@@ -537,16 +817,232 @@
 static void empty_log(__attribute__((unused)) AvahiLogLevel level,
 		      __attribute__((unused)) const char *txt){}
 
+/* Set effective uid to 0, return errno */
+__attribute__((warn_unused_result))
+int raise_privileges(void){
+  int old_errno = errno;
+  int ret = 0;
+  if(seteuid(0) == -1){
+    ret = errno;
+  }
+  errno = old_errno;
+  return ret;
+}
+
+/* Set effective and real user ID to 0.  Return errno. */
+__attribute__((warn_unused_result))
+int raise_privileges_permanently(void){
+  int old_errno = errno;
+  int ret = raise_privileges();
+  if(ret != 0){
+    errno = old_errno;
+    return ret;
+  }
+  if(setuid(0) == -1){
+    ret = errno;
+  }
+  errno = old_errno;
+  return ret;
+}
+
+/* Set effective user ID to unprivileged saved user ID */
+__attribute__((warn_unused_result))
+int lower_privileges(void){
+  int old_errno = errno;
+  int ret = 0;
+  if(seteuid(uid) == -1){
+    ret = errno;
+  }
+  errno = old_errno;
+  return ret;
+}
+
+/* Lower privileges permanently */
+__attribute__((warn_unused_result))
+int lower_privileges_permanently(void){
+  int old_errno = errno;
+  int ret = 0;
+  if(setuid(uid) == -1){
+    ret = errno;
+  }
+  errno = old_errno;
+  return ret;
+}
+
+/* Helper function to add_local_route() and delete_local_route() */
+__attribute__((nonnull, warn_unused_result))
+static bool add_delete_local_route(const bool add,
+				   const char *address,
+				   AvahiIfIndex if_index){
+  int ret;
+  char helper[] = "mandos-client-iprouteadddel";
+  char add_arg[] = "add";
+  char delete_arg[] = "delete";
+  char debug_flag[] = "--debug";
+  char *pluginhelperdir = getenv("MANDOSPLUGINHELPERDIR");
+  if(pluginhelperdir == NULL){
+    if(debug){
+      fprintf_plus(stderr, "MANDOSPLUGINHELPERDIR environment"
+		   " variable not set; cannot run helper\n");
+    }
+    return false;
+  }
+  
+  char interface[IF_NAMESIZE];
+  if(if_indextoname((unsigned int)if_index, interface) == NULL){
+    perror_plus("if_indextoname");
+    return false;
+  }
+  
+  int devnull = (int)TEMP_FAILURE_RETRY(open("/dev/null", O_RDONLY));
+  if(devnull == -1){
+    perror_plus("open(\"/dev/null\", O_RDONLY)");
+    return false;
+  }
+  pid_t pid = fork();
+  if(pid == 0){
+    /* Child */
+    /* Raise privileges */
+    errno = raise_privileges_permanently();
+    if(errno != 0){
+      perror_plus("Failed to raise privileges");
+      /* _exit(EX_NOPERM); */
+    } else {
+      /* Set group */
+      errno = 0;
+      ret = setgid(0);
+      if(ret == -1){
+	perror_plus("setgid");
+	_exit(EX_NOPERM);
+      }
+      /* Reset supplementary groups */
+      errno = 0;
+      ret = setgroups(0, NULL);
+      if(ret == -1){
+	perror_plus("setgroups");
+	_exit(EX_NOPERM);
+      }
+    }
+    ret = dup2(devnull, STDIN_FILENO);
+    if(ret == -1){
+      perror_plus("dup2(devnull, STDIN_FILENO)");
+      _exit(EX_OSERR);
+    }
+    ret = close(devnull);
+    if(ret == -1){
+      perror_plus("close");
+      _exit(EX_OSERR);
+    }
+    ret = dup2(STDERR_FILENO, STDOUT_FILENO);
+    if(ret == -1){
+      perror_plus("dup2(STDERR_FILENO, STDOUT_FILENO)");
+      _exit(EX_OSERR);
+    }
+    int helperdir_fd = (int)TEMP_FAILURE_RETRY(open(pluginhelperdir,
+						    O_RDONLY
+						    | O_DIRECTORY
+						    | O_PATH
+						    | O_CLOEXEC));
+    if(helperdir_fd == -1){
+      perror_plus("open");
+      _exit(EX_UNAVAILABLE);
+    }
+    int helper_fd = (int)TEMP_FAILURE_RETRY(openat(helperdir_fd,
+						   helper, O_RDONLY));
+    if(helper_fd == -1){
+      perror_plus("openat");
+      close(helperdir_fd);
+      _exit(EX_UNAVAILABLE);
+    }
+    close(helperdir_fd);
+#ifdef __GNUC__
+#pragma GCC diagnostic push
+#pragma GCC diagnostic ignored "-Wcast-qual"
+#endif
+    if(fexecve(helper_fd, (char *const [])
+	       { helper, add ? add_arg : delete_arg, (char *)address,
+		   interface, debug ? debug_flag : NULL, NULL },
+	       environ) == -1){
+#ifdef __GNUC__
+#pragma GCC diagnostic pop
+#endif
+      perror_plus("fexecve");
+      _exit(EXIT_FAILURE);
+    }
+  }
+  if(pid == -1){
+    perror_plus("fork");
+    return false;
+  }
+  int status;
+  pid_t pret = -1;
+  errno = 0;
+  do {
+    pret = waitpid(pid, &status, 0);
+    if(pret == -1 and errno == EINTR and quit_now){
+      int errno_raising = 0;
+      if((errno = raise_privileges()) != 0){
+	errno_raising = errno;
+	perror_plus("Failed to raise privileges in order to"
+		    " kill helper program");
+      }
+      if(kill(pid, SIGTERM) == -1){
+	perror_plus("kill");
+      }
+      if((errno_raising == 0) and (errno = lower_privileges()) != 0){
+	perror_plus("Failed to lower privileges after killing"
+		    " helper program");
+      }
+      return false;
+    }
+  } while(pret == -1 and errno == EINTR);
+  if(pret == -1){
+    perror_plus("waitpid");
+    return false;
+  }
+  if(WIFEXITED(status)){
+    if(WEXITSTATUS(status) != 0){
+      fprintf_plus(stderr, "Error: iprouteadddel exited"
+		   " with status %d\n", WEXITSTATUS(status));
+      return false;
+    }
+    return true;
+  }
+  if(WIFSIGNALED(status)){
+    fprintf_plus(stderr, "Error: iprouteadddel died by"
+		 " signal %d\n", WTERMSIG(status));
+    return false;
+  }
+  fprintf_plus(stderr, "Error: iprouteadddel crashed\n");
+  return false;
+}
+
+__attribute__((nonnull, warn_unused_result))
+static bool add_local_route(const char *address,
+			    AvahiIfIndex if_index){
+  if(debug){
+    fprintf_plus(stderr, "Adding route to %s\n", address);
+  }
+  return add_delete_local_route(true, address, if_index);
+}
+
+__attribute__((nonnull, warn_unused_result))
+static bool delete_local_route(const char *address,
+			       AvahiIfIndex if_index){
+  if(debug){
+    fprintf_plus(stderr, "Removing route to %s\n", address);
+  }
+  return add_delete_local_route(false, address, if_index);
+}
+
 /* Called when a Mandos server is found */
-static int start_mandos_communication(const char *ip, uint16_t port,
+__attribute__((nonnull, warn_unused_result))
+static int start_mandos_communication(const char *ip, in_port_t port,
 				      AvahiIfIndex if_index,
-				      int af){
+				      int af, mandos_context *mc){
   int ret, tcp_sd = -1;
   ssize_t sret;
-  union {
-    struct sockaddr_in in;
-    struct sockaddr_in6 in6;
-  } to;
+  struct sockaddr_storage to;
   char *buffer = NULL;
   char *decrypted_buffer = NULL;
   size_t buffer_length = 0;
@@ -555,6 +1051,7 @@
   int retval = -1;
   gnutls_session_t session;
   int pf;			/* Protocol family */
+  bool route_added = false;
   
   errno = 0;
   
@@ -571,25 +1068,57 @@
     pf = PF_INET;
     break;
   default:
-    fprintf(stderr, "Bad address family: %d\n", af);
+    fprintf_plus(stderr, "Bad address family: %d\n", af);
     errno = EINVAL;
     return -1;
   }
   
-  ret = init_gnutls_session(&session);
+  /* If the interface is specified and we have a list of interfaces */
+  if(if_index != AVAHI_IF_UNSPEC and mc->interfaces != NULL){
+    /* Check if the interface is one of the interfaces we are using */
+    bool match = false;
+    {
+      char *interface = NULL;
+      while((interface=argz_next(mc->interfaces, mc->interfaces_size,
+				 interface))){
+	if(if_nametoindex(interface) == (unsigned int)if_index){
+	  match = true;
+	  break;
+	}
+      }
+    }
+    if(not match){
+      /* This interface does not match any in the list, so we don't
+	 connect to the server */
+      if(debug){
+	char interface[IF_NAMESIZE];
+	if(if_indextoname((unsigned int)if_index, interface) == NULL){
+	  perror_plus("if_indextoname");
+	} else {
+	  fprintf_plus(stderr, "Skipping server on non-used interface"
+		       " \"%s\"\n",
+		       if_indextoname((unsigned int)if_index,
+				      interface));
+	}
+      }
+      return -1;
+    }
+  }
+  
+  ret = init_gnutls_session(&session, mc);
   if(ret != 0){
     return -1;
   }
   
   if(debug){
-    fprintf(stderr, "Setting up a TCP connection to %s, port %" PRIu16
-	    "\n", ip, port);
+    fprintf_plus(stderr, "Setting up a TCP connection to %s, port %"
+		 PRIuMAX "\n", ip, (uintmax_t)port);
   }
   
-  tcp_sd = socket(pf, SOCK_STREAM, 0);
+  tcp_sd = socket(pf, SOCK_STREAM | SOCK_CLOEXEC, 0);
   if(tcp_sd < 0){
     int e = errno;
-    perror("socket");
+    perror_plus("socket");
     errno = e;
     goto mandos_end;
   }
@@ -599,47 +1128,42 @@
     goto mandos_end;
   }
   
-  memset(&to, 0, sizeof(to));
   if(af == AF_INET6){
-    to.in6.sin6_family = (sa_family_t)af;
-    ret = inet_pton(af, ip, &to.in6.sin6_addr);
+    struct sockaddr_in6 *to6 = (struct sockaddr_in6 *)&to;
+    *to6 = (struct sockaddr_in6){ .sin6_family = (sa_family_t)af };
+    ret = inet_pton(af, ip, &to6->sin6_addr);
   } else {			/* IPv4 */
-    to.in.sin_family = (sa_family_t)af;
-    ret = inet_pton(af, ip, &to.in.sin_addr);
+    struct sockaddr_in *to4 = (struct sockaddr_in *)&to;
+    *to4 = (struct sockaddr_in){ .sin_family = (sa_family_t)af };
+    ret = inet_pton(af, ip, &to4->sin_addr);
   }
   if(ret < 0 ){
     int e = errno;
-    perror("inet_pton");
+    perror_plus("inet_pton");
     errno = e;
     goto mandos_end;
   }
   if(ret == 0){
     int e = errno;
-    fprintf(stderr, "Bad address: %s\n", ip);
+    fprintf_plus(stderr, "Bad address: %s\n", ip);
     errno = e;
     goto mandos_end;
   }
   if(af == AF_INET6){
-    to.in6.sin6_port = htons(port); /* Spurious warnings from
-				       -Wconversion and
-				       -Wunreachable-code */
-    
-    if(IN6_IS_ADDR_LINKLOCAL /* Spurious warnings from */
-       (&to.in6.sin6_addr)){ /* -Wstrict-aliasing=2 or lower and
-			      -Wunreachable-code*/
+    ((struct sockaddr_in6 *)&to)->sin6_port = htons(port);
+    if(IN6_IS_ADDR_LINKLOCAL
+       (&((struct sockaddr_in6 *)&to)->sin6_addr)){
       if(if_index == AVAHI_IF_UNSPEC){
-	fprintf(stderr, "An IPv6 link-local address is incomplete"
-		" without a network interface\n");
+	fprintf_plus(stderr, "An IPv6 link-local address is"
+		     " incomplete without a network interface\n");
 	errno = EINVAL;
 	goto mandos_end;
       }
       /* Set the network interface number as scope */
-      to.in6.sin6_scope_id = (uint32_t)if_index;
+      ((struct sockaddr_in6 *)&to)->sin6_scope_id = (uint32_t)if_index;
     }
   } else {
-    to.in.sin_port = htons(port); /* Spurious warnings from
-				     -Wconversion and
-				     -Wunreachable-code */
+    ((struct sockaddr_in *)&to)->sin_port = htons(port);
   }
   
   if(quit_now){
@@ -651,56 +1175,97 @@
     if(af == AF_INET6 and if_index != AVAHI_IF_UNSPEC){
       char interface[IF_NAMESIZE];
       if(if_indextoname((unsigned int)if_index, interface) == NULL){
-	perror("if_indextoname");
+	perror_plus("if_indextoname");
       } else {
-	fprintf(stderr, "Connection to: %s%%%s, port %" PRIu16 "\n",
-		ip, interface, port);
+	fprintf_plus(stderr, "Connection to: %s%%%s, port %" PRIuMAX
+		     "\n", ip, interface, (uintmax_t)port);
       }
     } else {
-      fprintf(stderr, "Connection to: %s, port %" PRIu16 "\n", ip,
-	      port);
+      fprintf_plus(stderr, "Connection to: %s, port %" PRIuMAX "\n",
+		   ip, (uintmax_t)port);
     }
     char addrstr[(INET_ADDRSTRLEN > INET6_ADDRSTRLEN) ?
 		 INET_ADDRSTRLEN : INET6_ADDRSTRLEN] = "";
-    const char *pcret;
-    if(af == AF_INET6){
-      pcret = inet_ntop(af, &(to.in6.sin6_addr), addrstr,
-			sizeof(addrstr));
-    } else {
-      pcret = inet_ntop(af, &(to.in.sin_addr), addrstr,
-			sizeof(addrstr));
-    }
-    if(pcret == NULL){
-      perror("inet_ntop");
-    } else {
-      if(strcmp(addrstr, ip) != 0){
-	fprintf(stderr, "Canonical address form: %s\n", addrstr);
-      }
-    }
-  }
-  
-  if(quit_now){
-    errno = EINTR;
-    goto mandos_end;
-  }
-  
-  if(af == AF_INET6){
-    ret = connect(tcp_sd, &to.in6, sizeof(to));
-  } else {
-    ret = connect(tcp_sd, &to.in, sizeof(to)); /* IPv4 */
-  }
-  if(ret < 0){
-    if ((errno != ECONNREFUSED and errno != ENETUNREACH) or debug){
-      int e = errno;
-      perror("connect");
-      errno = e;
-    }
-    goto mandos_end;
-  }
-  
-  if(quit_now){
-    errno = EINTR;
-    goto mandos_end;
+    if(af == AF_INET6){
+      ret = getnameinfo((struct sockaddr *)&to,
+			sizeof(struct sockaddr_in6),
+			addrstr, sizeof(addrstr), NULL, 0,
+			NI_NUMERICHOST);
+    } else {
+      ret = getnameinfo((struct sockaddr *)&to,
+			sizeof(struct sockaddr_in),
+			addrstr, sizeof(addrstr), NULL, 0,
+			NI_NUMERICHOST);
+    }
+    if(ret == EAI_SYSTEM){
+      perror_plus("getnameinfo");
+    } else if(ret != 0) {
+      fprintf_plus(stderr, "getnameinfo: %s", gai_strerror(ret));
+    } else if(strcmp(addrstr, ip) != 0){
+      fprintf_plus(stderr, "Canonical address form: %s\n", addrstr);
+    }
+  }
+  
+  if(quit_now){
+    errno = EINTR;
+    goto mandos_end;
+  }
+  
+  while(true){
+    if(af == AF_INET6){
+      ret = connect(tcp_sd, (struct sockaddr *)&to,
+		    sizeof(struct sockaddr_in6));
+    } else {
+      ret = connect(tcp_sd, (struct sockaddr *)&to, /* IPv4 */
+		    sizeof(struct sockaddr_in));
+    }
+    if(ret < 0){
+      if(((errno == ENETUNREACH) or (errno == EHOSTUNREACH))
+	 and if_index != AVAHI_IF_UNSPEC
+	 and connect_to == NULL
+	 and not route_added and
+	 ((af == AF_INET6 and not
+	   IN6_IS_ADDR_LINKLOCAL(&(((struct sockaddr_in6 *)
+				    &to)->sin6_addr)))
+	  or (af == AF_INET and
+	      /* Not a a IPv4LL address */
+	      (ntohl(((struct sockaddr_in *)&to)->sin_addr.s_addr)
+	       & 0xFFFF0000L) != 0xA9FE0000L))){
+	/* Work around Avahi bug - Avahi does not announce link-local
+	   addresses if it has a global address, so local hosts with
+	   *only* a link-local address (e.g. Mandos clients) cannot
+	   connect to a Mandos server announced by Avahi on a server
+	   host with a global address.  Work around this by retrying
+	   with an explicit route added with the server's address.
+	   
+	   Avahi bug reference:
+	   https://lists.freedesktop.org/archives/avahi/2010-February/001833.html
+	   https://bugs.debian.org/587961
+	*/
+	if(debug){
+	  fprintf_plus(stderr, "Mandos server unreachable, trying"
+		       " direct route\n");
+	}
+	int e = errno;
+	route_added = add_local_route(ip, if_index);
+	if(route_added){
+	  continue;
+	}
+	errno = e;
+      }
+      if(errno != ECONNREFUSED or debug){
+	int e = errno;
+	perror_plus("connect");
+	errno = e;
+      }
+      goto mandos_end;
+    }
+    
+    if(quit_now){
+      errno = EINTR;
+      goto mandos_end;
+    }
+    break;
   }
   
   const char *out = mandos_protocol_version;
@@ -708,10 +1273,10 @@
   while(true){
     size_t out_size = strlen(out);
     ret = (int)TEMP_FAILURE_RETRY(write(tcp_sd, out + written,
-				   out_size - written));
+					out_size - written));
     if(ret == -1){
       int e = errno;
-      perror("write");
+      perror_plus("write");
       errno = e;
       goto mandos_end;
     }
@@ -734,7 +1299,7 @@
   }
   
   if(debug){
-    fprintf(stderr, "Establishing TLS session with %s\n", ip);
+    fprintf_plus(stderr, "Establishing TLS session with %s\n", ip);
   }
   
   if(quit_now){
@@ -742,7 +1307,11 @@
     goto mandos_end;
   }
   
-  gnutls_transport_set_ptr(session, (gnutls_transport_ptr_t) tcp_sd);
+  /* This casting via intptr_t is to eliminate warning about casting
+     an int to a pointer type.  This is exactly how the GnuTLS Guile
+     function "set-session-transport-fd!" does it. */
+  gnutls_transport_set_ptr(session,
+			   (gnutls_transport_ptr_t)(intptr_t)tcp_sd);
   
   if(quit_now){
     errno = EINTR;
@@ -759,7 +1328,7 @@
   
   if(ret != GNUTLS_E_SUCCESS){
     if(debug){
-      fprintf(stderr, "*** GnuTLS Handshake failed ***\n");
+      fprintf_plus(stderr, "*** GnuTLS Handshake failed ***\n");
       gnutls_perror(ret);
     }
     errno = EPROTO;
@@ -769,8 +1338,8 @@
   /* Read OpenPGP packet that contains the wanted password */
   
   if(debug){
-    fprintf(stderr, "Retrieving OpenPGP encrypted password from %s\n",
-	    ip);
+    fprintf_plus(stderr, "Retrieving OpenPGP encrypted password from"
+		 " %s\n", ip);
   }
   
   while(true){
@@ -781,10 +1350,10 @@
     }
     
     buffer_capacity = incbuffer(&buffer, buffer_length,
-				   buffer_capacity);
+				buffer_capacity);
     if(buffer_capacity == 0){
       int e = errno;
-      perror("incbuffer");
+      perror_plus("incbuffer");
       errno = e;
       goto mandos_end;
     }
@@ -814,15 +1383,16 @@
 	  }
 	} while(ret == GNUTLS_E_AGAIN or ret == GNUTLS_E_INTERRUPTED);
 	if(ret < 0){
-	  fprintf(stderr, "*** GnuTLS Re-handshake failed ***\n");
+	  fprintf_plus(stderr, "*** GnuTLS Re-handshake failed "
+		       "***\n");
 	  gnutls_perror(ret);
 	  errno = EPROTO;
 	  goto mandos_end;
 	}
 	break;
       default:
-	fprintf(stderr, "Unknown error while reading data from"
-		" encrypted session with Mandos server\n");
+	fprintf_plus(stderr, "Unknown error while reading data from"
+		     " encrypted session with Mandos server\n");
 	gnutls_bye(session, GNUTLS_SHUT_RDWR);
 	errno = EIO;
 	goto mandos_end;
@@ -833,7 +1403,7 @@
   }
   
   if(debug){
-    fprintf(stderr, "Closing TLS session\n");
+    fprintf_plus(stderr, "Closing TLS session\n");
   }
   
   if(quit_now){
@@ -851,11 +1421,11 @@
   
   if(buffer_length > 0){
     ssize_t decrypted_buffer_size;
-    decrypted_buffer_size = pgp_packet_decrypt(buffer,
-					       buffer_length,
-					       &decrypted_buffer);
+    decrypted_buffer_size = pgp_packet_decrypt(buffer, buffer_length,
+					       &decrypted_buffer, mc);
     if(decrypted_buffer_size >= 0){
       
+      clearerr(stdout);
       written = 0;
       while(written < (size_t) decrypted_buffer_size){
 	if(quit_now){
@@ -869,14 +1439,24 @@
 	if(ret == 0 and ferror(stdout)){
 	  int e = errno;
 	  if(debug){
-	    fprintf(stderr, "Error writing encrypted data: %s\n",
-		    strerror(errno));
+	    fprintf_plus(stderr, "Error writing encrypted data: %s\n",
+			 strerror(errno));
 	  }
 	  errno = e;
 	  goto mandos_end;
 	}
 	written += (size_t)ret;
       }
+      ret = fflush(stdout);
+      if(ret != 0){
+	int e = errno;
+	if(debug){
+	  fprintf_plus(stderr, "Error writing encrypted data: %s\n",
+		       strerror(errno));
+	}
+	errno = e;
+	goto mandos_end;
+      }
       retval = 0;
     }
   }
@@ -885,28 +1465,35 @@
   
  mandos_end:
   {
+    if(route_added){
+      if(not delete_local_route(ip, if_index)){
+	fprintf_plus(stderr, "Failed to delete local route to %s on"
+		     " interface %d", ip, if_index);
+      }
+    }
     int e = errno;
     free(decrypted_buffer);
     free(buffer);
     if(tcp_sd >= 0){
-      ret = (int)TEMP_FAILURE_RETRY(close(tcp_sd));
+      ret = close(tcp_sd);
     }
     if(ret == -1){
       if(e == 0){
 	e = errno;
       }
-      perror("close");
+      perror_plus("close");
     }
     gnutls_deinit(session);
+    errno = e;
     if(quit_now){
-      e = EINTR;
+      errno = EINTR;
       retval = -1;
     }
-    errno = e;
   }
   return retval;
 }
 
+__attribute__((nonnull))
 static void resolve_callback(AvahiSServiceResolver *r,
 			     AvahiIfIndex interface,
 			     AvahiProtocol proto,
@@ -920,22 +1507,27 @@
 			     AVAHI_GCC_UNUSED AvahiStringList *txt,
 			     AVAHI_GCC_UNUSED AvahiLookupResultFlags
 			     flags,
-			     AVAHI_GCC_UNUSED void* userdata){
-  assert(r);
+			     void *mc){
+  if(r == NULL){
+    return;
+  }
   
   /* Called whenever a service has been resolved successfully or
      timed out */
   
   if(quit_now){
+    avahi_s_service_resolver_free(r);
     return;
   }
   
   switch(event){
   default:
   case AVAHI_RESOLVER_FAILURE:
-    fprintf(stderr, "(Avahi Resolver) Failed to resolve service '%s'"
-	    " of type '%s' in domain '%s': %s\n", name, type, domain,
-	    avahi_strerror(avahi_server_errno(mc.server)));
+    fprintf_plus(stderr, "(Avahi Resolver) Failed to resolve service "
+		 "'%s' of type '%s' in domain '%s': %s\n", name, type,
+		 domain,
+		 avahi_strerror(avahi_server_errno
+				(((mandos_context*)mc)->server)));
     break;
     
   case AVAHI_RESOLVER_FOUND:
@@ -943,14 +1535,23 @@
       char ip[AVAHI_ADDRESS_STR_MAX];
       avahi_address_snprint(ip, sizeof(ip), address);
       if(debug){
-	fprintf(stderr, "Mandos server \"%s\" found on %s (%s, %"
-		PRIdMAX ") on port %" PRIu16 "\n", name, host_name,
-		ip, (intmax_t)interface, port);
+	fprintf_plus(stderr, "Mandos server \"%s\" found on %s (%s, %"
+		     PRIdMAX ") on port %" PRIu16 "\n", name,
+		     host_name, ip, (intmax_t)interface, port);
       }
-      int ret = start_mandos_communication(ip, port, interface,
-					   avahi_proto_to_af(proto));
+      int ret = start_mandos_communication(ip, (in_port_t)port,
+					   interface,
+					   avahi_proto_to_af(proto),
+					   mc);
       if(ret == 0){
-	avahi_simple_poll_quit(mc.simple_poll);
+	avahi_simple_poll_quit(simple_poll);
+      } else {
+	if(not add_server(ip, (in_port_t)port, interface,
+			  avahi_proto_to_af(proto),
+			  &((mandos_context*)mc)->current_server)){
+	  fprintf_plus(stderr, "Failed to add server \"%s\" to server"
+		       " list\n", name);
+	}
       }
     }
   }
@@ -966,8 +1567,10 @@
 			    const char *domain,
 			    AVAHI_GCC_UNUSED AvahiLookupResultFlags
 			    flags,
-			    AVAHI_GCC_UNUSED void* userdata){
-  assert(b);
+			    void *mc){
+  if(b == NULL){
+    return;
+  }
   
   /* Called whenever a new services becomes available on the LAN or
      is removed from the LAN */
@@ -980,9 +1583,10 @@
   default:
   case AVAHI_BROWSER_FAILURE:
     
-    fprintf(stderr, "(Avahi browser) %s\n",
-	    avahi_strerror(avahi_server_errno(mc.server)));
-    avahi_simple_poll_quit(mc.simple_poll);
+    fprintf_plus(stderr, "(Avahi browser) %s\n",
+		 avahi_strerror(avahi_server_errno
+				(((mandos_context*)mc)->server)));
+    avahi_simple_poll_quit(simple_poll);
     return;
     
   case AVAHI_BROWSER_NEW:
@@ -991,11 +1595,14 @@
        the callback function is called the Avahi server will free the
        resolver for us. */
     
-    if(avahi_s_service_resolver_new(mc.server, interface, protocol,
-				    name, type, domain, protocol, 0,
-				    resolve_callback, NULL) == NULL)
-      fprintf(stderr, "Avahi: Failed to resolve service '%s': %s\n",
-	      name, avahi_strerror(avahi_server_errno(mc.server)));
+    if(avahi_s_service_resolver_new(((mandos_context*)mc)->server,
+				    interface, protocol, name, type,
+				    domain, protocol, 0,
+				    resolve_callback, mc) == NULL)
+      fprintf_plus(stderr, "Avahi: Failed to resolve service '%s':"
+		   " %s\n", name,
+		   avahi_strerror(avahi_server_errno
+				  (((mandos_context*)mc)->server)));
     break;
     
   case AVAHI_BROWSER_REMOVE:
@@ -1004,13 +1611,14 @@
   case AVAHI_BROWSER_ALL_FOR_NOW:
   case AVAHI_BROWSER_CACHE_EXHAUSTED:
     if(debug){
-      fprintf(stderr, "No Mandos server found, still searching...\n");
+      fprintf_plus(stderr, "No Mandos server found, still"
+		   " searching...\n");
     }
     break;
   }
 }
 
-/* stop main loop after sigterm has been called */
+/* Signal handler that stops main loop after SIGTERM */
 static void handle_sigterm(int sig){
   if(quit_now){
     return;
@@ -1018,129 +1626,695 @@
   quit_now = 1;
   signal_received = sig;
   int old_errno = errno;
-  if(mc.simple_poll != NULL){
-    avahi_simple_poll_quit(mc.simple_poll);
+  /* set main loop to exit */
+  if(simple_poll != NULL){
+    avahi_simple_poll_quit(simple_poll);
   }
   errno = old_errno;
 }
 
+__attribute__((nonnull, warn_unused_result))
+bool get_flags(const char *ifname, struct ifreq *ifr){
+  int ret;
+  int old_errno;
+  
+  int s = socket(PF_INET6, SOCK_DGRAM, IPPROTO_IP);
+  if(s < 0){
+    old_errno = errno;
+    perror_plus("socket");
+    errno = old_errno;
+    return false;
+  }
+  strncpy(ifr->ifr_name, ifname, IF_NAMESIZE);
+  ifr->ifr_name[IF_NAMESIZE-1] = '\0'; /* NUL terminate */
+  ret = ioctl(s, SIOCGIFFLAGS, ifr);
+  if(ret == -1){
+    if(debug){
+      old_errno = errno;
+      perror_plus("ioctl SIOCGIFFLAGS");
+      errno = old_errno;
+    }
+    return false;
+  }
+  return true;
+}
+
+__attribute__((nonnull, warn_unused_result))
+bool good_flags(const char *ifname, const struct ifreq *ifr){
+  
+  /* Reject the loopback device */
+  if(ifr->ifr_flags & IFF_LOOPBACK){
+    if(debug){
+      fprintf_plus(stderr, "Rejecting loopback interface \"%s\"\n",
+		   ifname);
+    }
+    return false;
+  }
+  /* Accept point-to-point devices only if connect_to is specified */
+  if(connect_to != NULL and (ifr->ifr_flags & IFF_POINTOPOINT)){
+    if(debug){
+      fprintf_plus(stderr, "Accepting point-to-point interface"
+		   " \"%s\"\n", ifname);
+    }
+    return true;
+  }
+  /* Otherwise, reject non-broadcast-capable devices */
+  if(not (ifr->ifr_flags & IFF_BROADCAST)){
+    if(debug){
+      fprintf_plus(stderr, "Rejecting non-broadcast interface"
+		   " \"%s\"\n", ifname);
+    }
+    return false;
+  }
+  /* Reject non-ARP interfaces (including dummy interfaces) */
+  if(ifr->ifr_flags & IFF_NOARP){
+    if(debug){
+      fprintf_plus(stderr, "Rejecting non-ARP interface \"%s\"\n",
+		   ifname);
+    }
+    return false;
+  }
+  
+  /* Accept this device */
+  if(debug){
+    fprintf_plus(stderr, "Interface \"%s\" is good\n", ifname);
+  }
+  return true;
+}
+
 /* 
  * This function determines if a directory entry in /sys/class/net
  * corresponds to an acceptable network device.
  * (This function is passed to scandir(3) as a filter function.)
  */
+__attribute__((nonnull, warn_unused_result))
 int good_interface(const struct dirent *if_entry){
-  ssize_t ssret;
-  char *flagname = NULL;
-  int ret = asprintf(&flagname, "%s/%s/flags", sys_class_net,
-		     if_entry->d_name);
-  if(ret < 0){
-    perror("asprintf");
-    return 0;
-  }
   if(if_entry->d_name[0] == '.'){
     return 0;
   }
-  int flags_fd = (int)TEMP_FAILURE_RETRY(open(flagname, O_RDONLY));
-  if(flags_fd == -1){
-    perror("open");
-    return 0;
-  }
-  typedef short ifreq_flags;	/* ifreq.ifr_flags in netdevice(7) */
-  /* read line from flags_fd */
-  ssize_t to_read = (sizeof(ifreq_flags)*2)+3; /* "0x1003\n" */
-  char *flagstring = malloc((size_t)to_read+1); /* +1 for final \0 */
-  flagstring[(size_t)to_read] = '\0';
-  if(flagstring == NULL){
-    perror("malloc");
-    close(flags_fd);
-    return 0;
-  }
-  while(to_read > 0){
-    ssret = (ssize_t)TEMP_FAILURE_RETRY(read(flags_fd, flagstring,
-					     (size_t)to_read));
-    if(ssret == -1){
-      perror("read");
-      free(flagstring);
-      close(flags_fd);
-      return 0;
-    }
-    to_read -= ssret;
-    if(ssret == 0){
+  
+  struct ifreq ifr;
+  if(not get_flags(if_entry->d_name, &ifr)){
+    if(debug){
+      fprintf_plus(stderr, "Failed to get flags for interface "
+		   "\"%s\"\n", if_entry->d_name);
+    }
+    return 0;
+  }
+  
+  if(not good_flags(if_entry->d_name, &ifr)){
+    return 0;
+  }
+  return 1;
+}
+
+/* 
+ * This function determines if a network interface is up.
+ */
+__attribute__((nonnull, warn_unused_result))
+bool interface_is_up(const char *interface){
+  struct ifreq ifr;
+  if(not get_flags(interface, &ifr)){
+    if(debug){
+      fprintf_plus(stderr, "Failed to get flags for interface "
+		   "\"%s\"\n", interface);
+    }
+    return false;
+  }
+  
+  return (bool)(ifr.ifr_flags & IFF_UP);
+}
+
+/* 
+ * This function determines if a network interface is running
+ */
+__attribute__((nonnull, warn_unused_result))
+bool interface_is_running(const char *interface){
+  struct ifreq ifr;
+  if(not get_flags(interface, &ifr)){
+    if(debug){
+      fprintf_plus(stderr, "Failed to get flags for interface "
+		   "\"%s\"\n", interface);
+    }
+    return false;
+  }
+  
+  return (bool)(ifr.ifr_flags & IFF_RUNNING);
+}
+
+__attribute__((nonnull, pure, warn_unused_result))
+int notdotentries(const struct dirent *direntry){
+  /* Skip "." and ".." */
+  if(direntry->d_name[0] == '.'
+     and (direntry->d_name[1] == '\0'
+	  or (direntry->d_name[1] == '.'
+	      and direntry->d_name[2] == '\0'))){
+    return 0;
+  }
+  return 1;
+}
+
+/* Is this directory entry a runnable program? */
+__attribute__((nonnull, warn_unused_result))
+int runnable_hook(const struct dirent *direntry){
+  int ret;
+  size_t sret;
+  struct stat st;
+  
+  if((direntry->d_name)[0] == '\0'){
+    /* Empty name? */
+    return 0;
+  }
+  
+  sret = strspn(direntry->d_name, "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
+		"abcdefghijklmnopqrstuvwxyz"
+		"0123456789"
+		"_.-");
+  if((direntry->d_name)[sret] != '\0'){
+    /* Contains non-allowed characters */
+    if(debug){
+      fprintf_plus(stderr, "Ignoring hook \"%s\" with bad name\n",
+		   direntry->d_name);
+    }
+    return 0;
+  }
+  
+  ret = fstatat(hookdir_fd, direntry->d_name, &st, 0);
+  if(ret == -1){
+    if(debug){
+      perror_plus("Could not stat hook");
+    }
+    return 0;
+  }
+  if(not (S_ISREG(st.st_mode))){
+    /* Not a regular file */
+    if(debug){
+      fprintf_plus(stderr, "Ignoring hook \"%s\" - not a file\n",
+		   direntry->d_name);
+    }
+    return 0;
+  }
+  if(not (st.st_mode & (S_IXUSR | S_IXGRP | S_IXOTH))){
+    /* Not executable */
+    if(debug){
+      fprintf_plus(stderr, "Ignoring hook \"%s\" - not executable\n",
+		   direntry->d_name);
+    }
+    return 0;
+  }
+  if(debug){
+    fprintf_plus(stderr, "Hook \"%s\" is acceptable\n",
+		 direntry->d_name);
+  }
+  return 1;
+}
+
+__attribute__((nonnull, warn_unused_result))
+int avahi_loop_with_timeout(AvahiSimplePoll *s, int retry_interval,
+			    mandos_context *mc){
+  int ret;
+  struct timespec now;
+  struct timespec waited_time;
+  intmax_t block_time;
+  
+  while(true){
+    if(mc->current_server == NULL){
+      if(debug){
+	fprintf_plus(stderr, "Wait until first server is found."
+		     " No timeout!\n");
+      }
+      ret = avahi_simple_poll_iterate(s, -1);
+    } else {
+      if(debug){
+	fprintf_plus(stderr, "Check current_server if we should run"
+		     " it, or wait\n");
+      }
+      /* the current time */
+      ret = clock_gettime(CLOCK_MONOTONIC, &now);
+      if(ret == -1){
+	perror_plus("clock_gettime");
+	return -1;
+      }
+      /* Calculating in ms how long time between now and server
+	 who we visted longest time ago. Now - last seen.  */
+      waited_time.tv_sec = (now.tv_sec
+			    - mc->current_server->last_seen.tv_sec);
+      waited_time.tv_nsec = (now.tv_nsec
+			     - mc->current_server->last_seen.tv_nsec);
+      /* total time is 10s/10,000ms.
+	 Converting to s from ms by dividing by 1,000,
+	 and ns to ms by dividing by 1,000,000. */
+      block_time = ((retry_interval
+		     - ((intmax_t)waited_time.tv_sec * 1000))
+		    - ((intmax_t)waited_time.tv_nsec / 1000000));
+      
+      if(debug){
+	fprintf_plus(stderr, "Blocking for %" PRIdMAX " ms\n",
+		     block_time);
+      }
+      
+      if(block_time <= 0){
+	ret = start_mandos_communication(mc->current_server->ip,
+					 mc->current_server->port,
+					 mc->current_server->if_index,
+					 mc->current_server->af, mc);
+	if(ret == 0){
+	  avahi_simple_poll_quit(s);
+	  return 0;
+	}
+	ret = clock_gettime(CLOCK_MONOTONIC,
+			    &mc->current_server->last_seen);
+	if(ret == -1){
+	  perror_plus("clock_gettime");
+	  return -1;
+	}
+	mc->current_server = mc->current_server->next;
+	block_time = 0; 	/* Call avahi to find new Mandos
+				   servers, but don't block */
+      }
+      
+      ret = avahi_simple_poll_iterate(s, (int)block_time);
+    }
+    if(ret != 0){
+      if(ret > 0 or errno != EINTR){
+	return (ret != 1) ? ret : 0;
+      }
+    }
+  }
+}
+
+__attribute__((nonnull))
+void run_network_hooks(const char *mode, const char *interface,
+		       const float delay){
+  struct dirent **direntries = NULL;
+  if(hookdir_fd == -1){
+    hookdir_fd = open(hookdir, O_RDONLY | O_DIRECTORY | O_PATH
+		      | O_CLOEXEC);
+    if(hookdir_fd == -1){
+      if(errno == ENOENT){
+	if(debug){
+	  fprintf_plus(stderr, "Network hook directory \"%s\" not"
+		       " found\n", hookdir);
+	}
+      } else {
+	perror_plus("open");
+      }
+      return;
+    }
+  }
+  int numhooks = scandirat(hookdir_fd, ".", &direntries,
+			   runnable_hook, alphasort);
+  if(numhooks == -1){
+    perror_plus("scandir");
+    return;
+  }
+  struct dirent *direntry;
+  int ret;
+  int devnull = (int)TEMP_FAILURE_RETRY(open("/dev/null", O_RDONLY));
+  if(devnull == -1){
+    perror_plus("open(\"/dev/null\", O_RDONLY)");
+    return;
+  }
+  for(int i = 0; i < numhooks; i++){
+    direntry = direntries[i];
+    if(debug){
+      fprintf_plus(stderr, "Running network hook \"%s\"\n",
+		   direntry->d_name);
+    }
+    pid_t hook_pid = fork();
+    if(hook_pid == 0){
+      /* Child */
+      /* Raise privileges */
+      errno = raise_privileges_permanently();
+      if(errno != 0){
+	perror_plus("Failed to raise privileges");
+	_exit(EX_NOPERM);
+      }
+      /* Set group */
+      errno = 0;
+      ret = setgid(0);
+      if(ret == -1){
+	perror_plus("setgid");
+	_exit(EX_NOPERM);
+      }
+      /* Reset supplementary groups */
+      errno = 0;
+      ret = setgroups(0, NULL);
+      if(ret == -1){
+	perror_plus("setgroups");
+	_exit(EX_NOPERM);
+      }
+      ret = setenv("MANDOSNETHOOKDIR", hookdir, 1);
+      if(ret == -1){
+	perror_plus("setenv");
+	_exit(EX_OSERR);
+      }
+      ret = setenv("DEVICE", interface, 1);
+      if(ret == -1){
+	perror_plus("setenv");
+	_exit(EX_OSERR);
+      }
+      ret = setenv("VERBOSITY", debug ? "1" : "0", 1);
+      if(ret == -1){
+	perror_plus("setenv");
+	_exit(EX_OSERR);
+      }
+      ret = setenv("MODE", mode, 1);
+      if(ret == -1){
+	perror_plus("setenv");
+	_exit(EX_OSERR);
+      }
+      char *delaystring;
+      ret = asprintf(&delaystring, "%f", (double)delay);
+      if(ret == -1){
+	perror_plus("asprintf");
+	_exit(EX_OSERR);
+      }
+      ret = setenv("DELAY", delaystring, 1);
+      if(ret == -1){
+	free(delaystring);
+	perror_plus("setenv");
+	_exit(EX_OSERR);
+      }
+      free(delaystring);
+      if(connect_to != NULL){
+	ret = setenv("CONNECT", connect_to, 1);
+	if(ret == -1){
+	  perror_plus("setenv");
+	  _exit(EX_OSERR);
+	}
+      }
+      int hook_fd = (int)TEMP_FAILURE_RETRY(openat(hookdir_fd,
+						   direntry->d_name,
+						   O_RDONLY));
+      if(hook_fd == -1){
+	perror_plus("openat");
+	_exit(EXIT_FAILURE);
+      }
+      if(close(hookdir_fd) == -1){
+	perror_plus("close");
+	_exit(EXIT_FAILURE);
+      }
+      ret = dup2(devnull, STDIN_FILENO);
+      if(ret == -1){
+	perror_plus("dup2(devnull, STDIN_FILENO)");
+	_exit(EX_OSERR);
+      }
+      ret = close(devnull);
+      if(ret == -1){
+	perror_plus("close");
+	_exit(EX_OSERR);
+      }
+      ret = dup2(STDERR_FILENO, STDOUT_FILENO);
+      if(ret == -1){
+	perror_plus("dup2(STDERR_FILENO, STDOUT_FILENO)");
+	_exit(EX_OSERR);
+      }
+      if(fexecve(hook_fd, (char *const []){ direntry->d_name, NULL },
+		 environ) == -1){
+	perror_plus("fexecve");
+	_exit(EXIT_FAILURE);
+      }
+    } else {
+      if(hook_pid == -1){
+	perror_plus("fork");
+	free(direntry);
+	continue;
+      }
+      int status;
+      if(TEMP_FAILURE_RETRY(waitpid(hook_pid, &status, 0)) == -1){
+	perror_plus("waitpid");
+	free(direntry);
+	continue;
+      }
+      if(WIFEXITED(status)){
+	if(WEXITSTATUS(status) != 0){
+	  fprintf_plus(stderr, "Warning: network hook \"%s\" exited"
+		       " with status %d\n", direntry->d_name,
+		       WEXITSTATUS(status));
+	  free(direntry);
+	  continue;
+	}
+      } else if(WIFSIGNALED(status)){
+	fprintf_plus(stderr, "Warning: network hook \"%s\" died by"
+		     " signal %d\n", direntry->d_name,
+		     WTERMSIG(status));
+	free(direntry);
+	continue;
+      } else {
+	fprintf_plus(stderr, "Warning: network hook \"%s\""
+		     " crashed\n", direntry->d_name);
+	free(direntry);
+	continue;
+      }
+    }
+    if(debug){
+      fprintf_plus(stderr, "Network hook \"%s\" ran successfully\n",
+		   direntry->d_name);
+    }
+    free(direntry);
+  }
+  free(direntries);
+  if(close(hookdir_fd) == -1){
+    perror_plus("close");
+  } else {
+    hookdir_fd = -1;
+  }
+  close(devnull);
+}
+
+__attribute__((nonnull, warn_unused_result))
+int bring_up_interface(const char *const interface,
+		       const float delay){
+  int old_errno = errno;
+  int ret;
+  struct ifreq network;
+  unsigned int if_index = if_nametoindex(interface);
+  if(if_index == 0){
+    fprintf_plus(stderr, "No such interface: \"%s\"\n", interface);
+    errno = old_errno;
+    return ENXIO;
+  }
+  
+  if(quit_now){
+    errno = old_errno;
+    return EINTR;
+  }
+  
+  if(not interface_is_up(interface)){
+    int ret_errno = 0;
+    int ioctl_errno = 0;
+    if(not get_flags(interface, &network)){
+      ret_errno = errno;
+      fprintf_plus(stderr, "Failed to get flags for interface "
+		   "\"%s\"\n", interface);
+      errno = old_errno;
+      return ret_errno;
+    }
+    network.ifr_flags |= IFF_UP; /* set flag */
+    
+    int sd = socket(PF_INET6, SOCK_DGRAM, IPPROTO_IP);
+    if(sd == -1){
+      ret_errno = errno;
+      perror_plus("socket");
+      errno = old_errno;
+      return ret_errno;
+    }
+    
+    if(quit_now){
+      ret = close(sd);
+      if(ret == -1){
+	perror_plus("close");
+      }
+      errno = old_errno;
+      return EINTR;
+    }
+    
+    if(debug){
+      fprintf_plus(stderr, "Bringing up interface \"%s\"\n",
+		   interface);
+    }
+    
+    /* Raise privileges */
+    ret_errno = raise_privileges();
+    if(ret_errno != 0){
+      errno = ret_errno;
+      perror_plus("Failed to raise privileges");
+    }
+    
+#ifdef __linux__
+    int ret_linux;
+    bool restore_loglevel = false;
+    if(ret_errno == 0){
+      /* Lower kernel loglevel to KERN_NOTICE to avoid KERN_INFO
+	 messages about the network interface to mess up the prompt */
+      ret_linux = klogctl(8, NULL, 5);
+      if(ret_linux == -1){
+	perror_plus("klogctl");
+      } else {
+	restore_loglevel = true;
+      }
+    }
+#endif	/* __linux__ */
+    int ret_setflags = ioctl(sd, SIOCSIFFLAGS, &network);
+    ioctl_errno = errno;
+#ifdef __linux__
+    if(restore_loglevel){
+      ret_linux = klogctl(7, NULL, 0);
+      if(ret_linux == -1){
+	perror_plus("klogctl");
+      }
+    }
+#endif	/* __linux__ */
+    
+    /* If raise_privileges() succeeded above */
+    if(ret_errno == 0){
+      /* Lower privileges */
+      ret_errno = lower_privileges();
+      if(ret_errno != 0){
+	errno = ret_errno;
+	perror_plus("Failed to lower privileges");
+      }
+    }
+    
+    /* Close the socket */
+    ret = close(sd);
+    if(ret == -1){
+      perror_plus("close");
+    }
+    
+    if(ret_setflags == -1){
+      errno = ioctl_errno;
+      perror_plus("ioctl SIOCSIFFLAGS +IFF_UP");
+      errno = old_errno;
+      return ioctl_errno;
+    }
+  } else if(debug){
+    fprintf_plus(stderr, "Interface \"%s\" is already up; good\n",
+		 interface);
+  }
+  
+  /* Sleep checking until interface is running.
+     Check every 0.25s, up to total time of delay */
+  for(int i=0; i < delay * 4; i++){
+    if(interface_is_running(interface)){
       break;
     }
-  }
-  close(flags_fd);
-  intmax_t tmpmax;
-  char *tmp;
-  errno = 0;
-  tmpmax = strtoimax(flagstring, &tmp, 0);
-  if(errno != 0 or tmp == flagstring or (*tmp != '\0'
-					 and not (isspace(*tmp)))
-     or tmpmax != (ifreq_flags)tmpmax){
-    if(debug){
-      fprintf(stderr, "Invalid flags \"%s\" for interface \"%s\"\n",
-	      flagstring, if_entry->d_name);
-    }
-    free(flagstring);
-    return 0;
-  }
-  free(flagstring);
-  ifreq_flags flags = (ifreq_flags)tmpmax;
-  /* Reject the loopback device */
-  if(flags & IFF_LOOPBACK){
-    if(debug){
-      fprintf(stderr, "Rejecting loopback interface \"%s\"\n",
-	      if_entry->d_name);
-    }
-    return 0;
-  }
-  /* Accept point-to-point devices only if connect_to is specified */
-  if(connect_to != NULL and (flags & IFF_POINTOPOINT)){
-    if(debug){
-      fprintf(stderr, "Accepting point-to-point interface \"%s\"\n",
-	      if_entry->d_name);
-    }
-    return 1;
-  }
-  /* Otherwise, reject non-broadcast-capable devices */
-  if(not (flags & IFF_BROADCAST)){
-    if(debug){
-      fprintf(stderr, "Rejecting non-broadcast interface \"%s\"\n",
-	      if_entry->d_name);
-    }
-    return 0;
-  }
-  /* Accept this device */
-  if(debug){
-    fprintf(stderr, "Interface \"%s\" is acceptable\n",
-	    if_entry->d_name);
-  }
-  return 1;
+    struct timespec sleeptime = { .tv_nsec = 250000000 };
+    ret = nanosleep(&sleeptime, NULL);
+    if(ret == -1 and errno != EINTR){
+      perror_plus("nanosleep");
+    }
+  }
+  
+  errno = old_errno;
+  return 0;
+}
+
+__attribute__((nonnull, warn_unused_result))
+int take_down_interface(const char *const interface){
+  int old_errno = errno;
+  struct ifreq network;
+  unsigned int if_index = if_nametoindex(interface);
+  if(if_index == 0){
+    fprintf_plus(stderr, "No such interface: \"%s\"\n", interface);
+    errno = old_errno;
+    return ENXIO;
+  }
+  if(interface_is_up(interface)){
+    int ret_errno = 0;
+    int ioctl_errno = 0;
+    if(not get_flags(interface, &network) and debug){
+      ret_errno = errno;
+      fprintf_plus(stderr, "Failed to get flags for interface "
+		   "\"%s\"\n", interface);
+      errno = old_errno;
+      return ret_errno;
+    }
+    network.ifr_flags &= ~(short)IFF_UP; /* clear flag */
+    
+    int sd = socket(PF_INET6, SOCK_DGRAM, IPPROTO_IP);
+    if(sd == -1){
+      ret_errno = errno;
+      perror_plus("socket");
+      errno = old_errno;
+      return ret_errno;
+    }
+    
+    if(debug){
+      fprintf_plus(stderr, "Taking down interface \"%s\"\n",
+		   interface);
+    }
+    
+    /* Raise privileges */
+    ret_errno = raise_privileges();
+    if(ret_errno != 0){
+      errno = ret_errno;
+      perror_plus("Failed to raise privileges");
+    }
+    
+    int ret_setflags = ioctl(sd, SIOCSIFFLAGS, &network);
+    ioctl_errno = errno;
+    
+    /* If raise_privileges() succeeded above */
+    if(ret_errno == 0){
+      /* Lower privileges */
+      ret_errno = lower_privileges();
+      if(ret_errno != 0){
+	errno = ret_errno;
+	perror_plus("Failed to lower privileges");
+      }
+    }
+    
+    /* Close the socket */
+    int ret = close(sd);
+    if(ret == -1){
+      perror_plus("close");
+    }
+    
+    if(ret_setflags == -1){
+      errno = ioctl_errno;
+      perror_plus("ioctl SIOCSIFFLAGS -IFF_UP");
+      errno = old_errno;
+      return ioctl_errno;
+    }
+  } else if(debug){
+    fprintf_plus(stderr, "Interface \"%s\" is already down; odd\n",
+		 interface);
+  }
+  
+  errno = old_errno;
+  return 0;
 }
 
 int main(int argc, char *argv[]){
+  mandos_context mc = { .server = NULL, .dh_bits = 0,
+			.priority = "SECURE256:!CTYPE-X.509"
+			":+CTYPE-OPENPGP:!RSA:+SIGN-DSA-SHA256",
+			.current_server = NULL, .interfaces = NULL,
+			.interfaces_size = 0 };
   AvahiSServiceBrowser *sb = NULL;
-  int error;
+  error_t ret_errno;
   int ret;
   intmax_t tmpmax;
   char *tmp;
   int exitcode = EXIT_SUCCESS;
-  const char *interface = "";
-  struct ifreq network;
-  int sd = -1;
-  bool take_down_interface = false;
-  uid_t uid;
-  gid_t gid;
-  char tempdir[] = "/tmp/mandosXXXXXX";
-  bool tempdir_created = false;
+  char *interfaces_to_take_down = NULL;
+  size_t interfaces_to_take_down_size = 0;
+  char run_tempdir[] = "/run/tmp/mandosXXXXXX";
+  char old_tempdir[] = "/tmp/mandosXXXXXX";
+  char *tempdir = NULL;
   AvahiIfIndex if_index = AVAHI_IF_UNSPEC;
   const char *seckey = PATHDIR "/" SECKEY;
   const char *pubkey = PATHDIR "/" PUBKEY;
+  const char *dh_params_file = NULL;
+  char *interfaces_hooks = NULL;
   
   bool gnutls_initialized = false;
   bool gpgme_initialized = false;
   float delay = 2.5f;
+  double retry_interval = 10; /* 10s between trying a server and
+				 retrying the same server again */
   
   struct sigaction old_sigterm_action = { .sa_handler = SIG_DFL };
   struct sigaction sigterm_action = { .sa_handler = handle_sigterm };
@@ -1152,14 +2326,14 @@
   errno = 0;
   ret = setgid(gid);
   if(ret == -1){
-    perror("setgid");
+    perror_plus("setgid");
   }
   
   /* Lower user privileges (temporarily) */
   errno = 0;
   ret = seteuid(uid);
   if(ret == -1){
-    perror("seteuid");
+    perror_plus("seteuid");
   }
   
   if(quit_now){
@@ -1192,6 +2366,11 @@
 	.doc = "Bit length of the prime number used in the"
 	" Diffie-Hellman key exchange",
 	.group = 2 },
+      { .name = "dh-params", .key = 134,
+	.arg = "FILE",
+	.doc = "PEM-encoded PKCS#3 file with pre-generated parameters"
+	" for the Diffie-Hellman key exchange",
+	.group = 2 },
       { .name = "priority", .key = 130,
 	.arg = "STRING",
 	.doc = "GnuTLS priority string for the TLS handshake",
@@ -1200,6 +2379,14 @@
 	.arg = "SECONDS",
 	.doc = "Maximum delay to wait for interface startup",
 	.group = 2 },
+      { .name = "retry", .key = 132,
+	.arg = "SECONDS",
+	.doc = "Retry interval used when denied by the Mandos server",
+	.group = 2 },
+      { .name = "network-hook-dir", .key = 133,
+	.arg = "DIR",
+	.doc = "Directory where network hooks are located",
+	.group = 2 },
       /*
        * These reproduce what we would get without ARGP_NO_HELP
        */
@@ -1223,7 +2410,11 @@
 	connect_to = arg;
 	break;
       case 'i':			/* --interface */
-	interface = arg;
+	ret_errno = argz_add_sep(&mc.interfaces, &mc.interfaces_size,
+				 arg, (int)',');
+	if(ret_errno != 0){
+	  argp_error(state, "%s", strerror(ret_errno));
+	}
 	break;
       case 's':			/* --seckey */
 	seckey = arg;
@@ -1240,6 +2431,9 @@
 	}
 	mc.dh_bits = (typeof(mc.dh_bits))tmpmax;
 	break;
+      case 134:			/* --dh-params */
+	dh_params_file = arg;
+	break;
       case 130:			/* --priority */
 	mc.priority = arg;
 	break;
@@ -1249,6 +2443,17 @@
 	if(errno != 0 or tmp == arg or *tmp != '\0'){
 	  argp_error(state, "Bad delay");
 	}
+      case 132:			/* --retry */
+	errno = 0;
+	retry_interval = strtod(arg, &tmp);
+	if(errno != 0 or tmp == arg or *tmp != '\0'
+	   or (retry_interval * 1000) > INT_MAX
+	   or retry_interval < 0){
+	  argp_error(state, "Bad retry interval");
+	}
+	break;
+      case 133:			/* --network-hook-dir */
+	hookdir = arg;
 	break;
 	/*
 	 * These reproduce what we would get without ARGP_NO_HELP
@@ -1261,7 +2466,7 @@
 	argp_state_help(state, state->out_stream,
 			ARGP_HELP_USAGE | ARGP_HELP_EXIT_ERR);
       case 'V':			/* --version */
-	fprintf(state->out_stream, "%s\n", argp_program_version);
+	fprintf_plus(state->out_stream, "%s\n", argp_program_version);
 	exit(argp_err_exit_status);
 	break;
       default:
@@ -1274,15 +2479,15 @@
 			 .args_doc = "",
 			 .doc = "Mandos client -- Get and decrypt"
 			 " passwords from a Mandos server" };
-    ret = argp_parse(&argp, argc, argv,
-		     ARGP_IN_ORDER | ARGP_NO_HELP, 0, NULL);
-    switch(ret){
+    ret_errno = argp_parse(&argp, argc, argv,
+			   ARGP_IN_ORDER | ARGP_NO_HELP, 0, NULL);
+    switch(ret_errno){
     case 0:
       break;
     case ENOMEM:
     default:
-      errno = ret;
-      perror("argp_parse");
+      errno = ret_errno;
+      perror_plus("argp_parse");
       exitcode = EX_OSERR;
       goto end;
     case EINVAL:
@@ -1291,42 +2496,135 @@
     }
   }
   
+  {
+    /* Work around Debian bug #633582:
+       <https://bugs.debian.org/633582> */
+    
+    /* Re-raise privileges */
+    ret = raise_privileges();
+    if(ret != 0){
+      errno = ret;
+      perror_plus("Failed to raise privileges");
+    } else {
+      struct stat st;
+      
+      if(strcmp(seckey, PATHDIR "/" SECKEY) == 0){
+	int seckey_fd = open(seckey, O_RDONLY);
+	if(seckey_fd == -1){
+	  perror_plus("open");
+	} else {
+	  ret = (int)TEMP_FAILURE_RETRY(fstat(seckey_fd, &st));
+	  if(ret == -1){
+	    perror_plus("fstat");
+	  } else {
+	    if(S_ISREG(st.st_mode)
+	       and st.st_uid == 0 and st.st_gid == 0){
+	      ret = fchown(seckey_fd, uid, gid);
+	      if(ret == -1){
+		perror_plus("fchown");
+	      }
+	    }
+	  }
+	  close(seckey_fd);
+	}
+      }
+      
+      if(strcmp(pubkey, PATHDIR "/" PUBKEY) == 0){
+	int pubkey_fd = open(pubkey, O_RDONLY);
+	if(pubkey_fd == -1){
+	  perror_plus("open");
+	} else {
+	  ret = (int)TEMP_FAILURE_RETRY(fstat(pubkey_fd, &st));
+	  if(ret == -1){
+	    perror_plus("fstat");
+	  } else {
+	    if(S_ISREG(st.st_mode)
+	       and st.st_uid == 0 and st.st_gid == 0){
+	      ret = fchown(pubkey_fd, uid, gid);
+	      if(ret == -1){
+		perror_plus("fchown");
+	      }
+	    }
+	  }
+	  close(pubkey_fd);
+	}
+      }
+      
+      if(dh_params_file != NULL
+	 and strcmp(dh_params_file, PATHDIR "/dhparams.pem" ) == 0){
+	int dhparams_fd = open(dh_params_file, O_RDONLY);
+	if(dhparams_fd == -1){
+	  perror_plus("open");
+	} else {
+	  ret = (int)TEMP_FAILURE_RETRY(fstat(dhparams_fd, &st));
+	  if(ret == -1){
+	    perror_plus("fstat");
+	  } else {
+	    if(S_ISREG(st.st_mode)
+	       and st.st_uid == 0 and st.st_gid == 0){
+	      ret = fchown(dhparams_fd, uid, gid);
+	      if(ret == -1){
+		perror_plus("fchown");
+	      }
+	    }
+	  }
+	  close(dhparams_fd);
+	}
+      }
+      
+      /* Lower privileges */
+      ret = lower_privileges();
+      if(ret != 0){
+	errno = ret;
+	perror_plus("Failed to lower privileges");
+      }
+    }
+  }
+  
+  /* Remove invalid interface names (except "none") */
+  {
+    char *interface = NULL;
+    while((interface = argz_next(mc.interfaces, mc.interfaces_size,
+				 interface))){
+      if(strcmp(interface, "none") != 0
+	 and if_nametoindex(interface) == 0){
+	if(interface[0] != '\0'){
+	  fprintf_plus(stderr, "Not using nonexisting interface"
+		       " \"%s\"\n", interface);
+	}
+	argz_delete(&mc.interfaces, &mc.interfaces_size, interface);
+	interface = NULL;
+      }
+    }
+  }
+  
+  /* Run network hooks */
+  {
+    if(mc.interfaces != NULL){
+      interfaces_hooks = malloc(mc.interfaces_size);
+      if(interfaces_hooks == NULL){
+	perror_plus("malloc");
+	goto end;
+      }
+      memcpy(interfaces_hooks, mc.interfaces, mc.interfaces_size);
+      argz_stringify(interfaces_hooks, mc.interfaces_size, (int)',');
+    }
+    run_network_hooks("start", interfaces_hooks != NULL ?
+		      interfaces_hooks : "", delay);
+  }
+  
   if(not debug){
     avahi_set_log_function(empty_log);
   }
-
-  if(interface[0] == '\0'){
-    struct dirent **direntries;
-    ret = scandir(sys_class_net, &direntries, good_interface,
-		  alphasort);
-    if(ret >= 1){
-      /* Pick the first good interface */
-      interface = strdup(direntries[0]->d_name);
-      if(debug){
-	fprintf(stderr, "Using interface \"%s\"\n", interface);
-      }
-      if(interface == NULL){
-	perror("malloc");
-	free(direntries);
-	exitcode = EXIT_FAILURE;
-	goto end;
-      }
-      free(direntries);
-    } else {
-      free(direntries);
-      fprintf(stderr, "Could not find a network interface\n");
-      exitcode = EXIT_FAILURE;
-      goto end;
-    }
-  }
   
   /* Initialize Avahi early so avahi_simple_poll_quit() can be called
      from the signal handler */
   /* Initialize the pseudo-RNG for Avahi */
   srand((unsigned int) time(NULL));
-  mc.simple_poll = avahi_simple_poll_new();
-  if(mc.simple_poll == NULL){
-    fprintf(stderr, "Avahi: Failed to create simple poll object.\n");
+  simple_poll = avahi_simple_poll_new();
+  if(simple_poll == NULL){
+    fprintf_plus(stderr,
+		 "Avahi: Failed to create simple poll object.\n");
     exitcode = EX_UNAVAILABLE;
     goto end;
   }
@@ -1334,19 +2632,19 @@
   sigemptyset(&sigterm_action.sa_mask);
   ret = sigaddset(&sigterm_action.sa_mask, SIGINT);
   if(ret == -1){
-    perror("sigaddset");
+    perror_plus("sigaddset");
     exitcode = EX_OSERR;
     goto end;
   }
   ret = sigaddset(&sigterm_action.sa_mask, SIGHUP);
   if(ret == -1){
-    perror("sigaddset");
+    perror_plus("sigaddset");
     exitcode = EX_OSERR;
     goto end;
   }
   ret = sigaddset(&sigterm_action.sa_mask, SIGTERM);
   if(ret == -1){
-    perror("sigaddset");
+    perror_plus("sigaddset");
     exitcode = EX_OSERR;
     goto end;
   }
@@ -1356,195 +2654,136 @@
   */
   ret = sigaction(SIGINT, NULL, &old_sigterm_action);
   if(ret == -1){
-    perror("sigaction");
+    perror_plus("sigaction");
     return EX_OSERR;
   }
   if(old_sigterm_action.sa_handler != SIG_IGN){
     ret = sigaction(SIGINT, &sigterm_action, NULL);
     if(ret == -1){
-      perror("sigaction");
+      perror_plus("sigaction");
       exitcode = EX_OSERR;
       goto end;
     }
   }
   ret = sigaction(SIGHUP, NULL, &old_sigterm_action);
   if(ret == -1){
-    perror("sigaction");
+    perror_plus("sigaction");
     return EX_OSERR;
   }
   if(old_sigterm_action.sa_handler != SIG_IGN){
     ret = sigaction(SIGHUP, &sigterm_action, NULL);
     if(ret == -1){
-      perror("sigaction");
+      perror_plus("sigaction");
       exitcode = EX_OSERR;
       goto end;
     }
   }
   ret = sigaction(SIGTERM, NULL, &old_sigterm_action);
   if(ret == -1){
-    perror("sigaction");
+    perror_plus("sigaction");
     return EX_OSERR;
   }
   if(old_sigterm_action.sa_handler != SIG_IGN){
     ret = sigaction(SIGTERM, &sigterm_action, NULL);
     if(ret == -1){
-      perror("sigaction");
-      exitcode = EX_OSERR;
-      goto end;
-    }
-  }
-  
-  /* If the interface is down, bring it up */
-  if(strcmp(interface, "none") != 0){
-    if_index = (AvahiIfIndex) if_nametoindex(interface);
-    if(if_index == 0){
-      fprintf(stderr, "No such interface: \"%s\"\n", interface);
-      exitcode = EX_UNAVAILABLE;
-      goto end;
-    }
-    
-    if(quit_now){
-      goto end;
-    }
-    
-    /* Re-raise priviliges */
-    errno = 0;
-    ret = seteuid(0);
-    if(ret == -1){
-      perror("seteuid");
-    }
-    
-#ifdef __linux__
-    /* Lower kernel loglevel to KERN_NOTICE to avoid KERN_INFO
-       messages about the network interface to mess up the prompt */
-    ret = klogctl(8, NULL, 5);
-    bool restore_loglevel = true;
-    if(ret == -1){
-      restore_loglevel = false;
-      perror("klogctl");
-    }
-#endif	/* __linux__ */
-    
-    sd = socket(PF_INET6, SOCK_DGRAM, IPPROTO_IP);
-    if(sd < 0){
-      perror("socket");
-      exitcode = EX_OSERR;
-#ifdef __linux__
-      if(restore_loglevel){
-	ret = klogctl(7, NULL, 0);
-	if(ret == -1){
-	  perror("klogctl");
-	}
-      }
-#endif	/* __linux__ */
-      /* Lower privileges */
-      errno = 0;
-      ret = seteuid(uid);
-      if(ret == -1){
-	perror("seteuid");
-      }
-      goto end;
-    }
-    strcpy(network.ifr_name, interface);
-    ret = ioctl(sd, SIOCGIFFLAGS, &network);
-    if(ret == -1){
-      perror("ioctl SIOCGIFFLAGS");
-#ifdef __linux__
-      if(restore_loglevel){
-	ret = klogctl(7, NULL, 0);
-	if(ret == -1){
-	  perror("klogctl");
-	}
-      }
-#endif	/* __linux__ */
-      exitcode = EX_OSERR;
-      /* Lower privileges */
-      errno = 0;
-      ret = seteuid(uid);
-      if(ret == -1){
-	perror("seteuid");
-      }
-      goto end;
-    }
-    if((network.ifr_flags & IFF_UP) == 0){
-      network.ifr_flags |= IFF_UP;
-      take_down_interface = true;
-      ret = ioctl(sd, SIOCSIFFLAGS, &network);
-      if(ret == -1){
-	take_down_interface = false;
-	perror("ioctl SIOCSIFFLAGS +IFF_UP");
-	exitcode = EX_OSERR;
-#ifdef __linux__
-	if(restore_loglevel){
-	  ret = klogctl(7, NULL, 0);
-	  if(ret == -1){
-	    perror("klogctl");
+      perror_plus("sigaction");
+      exitcode = EX_OSERR;
+      goto end;
+    }
+  }
+  
+  /* If no interfaces were specified, make a list */
+  if(mc.interfaces == NULL){
+    struct dirent **direntries = NULL;
+    /* Look for any good interfaces */
+    ret = scandir(sys_class_net, &direntries, good_interface,
+		  alphasort);
+    if(ret >= 1){
+      /* Add all found interfaces to interfaces list */
+      for(int i = 0; i < ret; ++i){
+	ret_errno = argz_add(&mc.interfaces, &mc.interfaces_size,
+			     direntries[i]->d_name);
+	if(ret_errno != 0){
+	  errno = ret_errno;
+	  perror_plus("argz_add");
+	  free(direntries[i]);
+	  continue;
+	}
+	if(debug){
+	  fprintf_plus(stderr, "Will use interface \"%s\"\n",
+		       direntries[i]->d_name);
+	}
+	free(direntries[i]);
+      }
+      free(direntries);
+    } else {
+      if(ret == 0){
+	free(direntries);
+      }
+      fprintf_plus(stderr, "Could not find a network interface\n");
+      exitcode = EXIT_FAILURE;
+      goto end;
+    }
+  }
+  
+  /* Bring up interfaces which are down, and remove any "none"s */
+  {
+    char *interface = NULL;
+    while((interface = argz_next(mc.interfaces, mc.interfaces_size,
+				 interface))){
+      /* If interface name is "none", stop bringing up interfaces.
+	 Also remove all instances of "none" from the list */
+      if(strcmp(interface, "none") == 0){
+	argz_delete(&mc.interfaces, &mc.interfaces_size,
+		    interface);
+	interface = NULL;
+	while((interface = argz_next(mc.interfaces,
+				     mc.interfaces_size, interface))){
+	  if(strcmp(interface, "none") == 0){
+	    argz_delete(&mc.interfaces, &mc.interfaces_size,
+			interface);
+	    interface = NULL;
 	  }
 	}
-#endif	/* __linux__ */
-	/* Lower privileges */
-	errno = 0;
-	ret = seteuid(uid);
-	if(ret == -1){
-	  perror("seteuid");
-	}
-	goto end;
-      }
-    }
-    /* sleep checking until interface is running */
-    for(int i=0; i < delay * 4; i++){
-      ret = ioctl(sd, SIOCGIFFLAGS, &network);
-      if(ret == -1){
-	perror("ioctl SIOCGIFFLAGS");
-      } else if(network.ifr_flags & IFF_RUNNING){
 	break;
       }
-      struct timespec sleeptime = { .tv_nsec = 250000000 };
-      ret = nanosleep(&sleeptime, NULL);
-      if(ret == -1 and errno != EINTR){
-	perror("nanosleep");
-      }
-    }
-    if(not take_down_interface){
-      /* We won't need the socket anymore */
-      ret = (int)TEMP_FAILURE_RETRY(close(sd));
-      if(ret == -1){
-	perror("close");
-      }
-    }
-#ifdef __linux__
-    if(restore_loglevel){
-      /* Restores kernel loglevel to default */
-      ret = klogctl(7, NULL, 0);
-      if(ret == -1){
-	perror("klogctl");
-      }
-    }
-#endif	/* __linux__ */
-    /* Lower privileges */
-    errno = 0;
-    if(take_down_interface){
-      /* Lower privileges */
-      ret = seteuid(uid);
-      if(ret == -1){
-	perror("seteuid");
-      }
-    } else {
-      /* Lower privileges permanently */
-      ret = setuid(uid);
-      if(ret == -1){
-	perror("setuid");
-      }
-    }
+      bool interface_was_up = interface_is_up(interface);
+      errno = bring_up_interface(interface, delay);
+      if(not interface_was_up){
+	if(errno != 0){
+	  fprintf_plus(stderr, "Failed to bring up interface \"%s\":"
+		       " %s\n", interface, strerror(errno));
+	} else {
+	  errno = argz_add(&interfaces_to_take_down,
+			   &interfaces_to_take_down_size,
+			   interface);
+	  if(errno != 0){
+	    perror_plus("argz_add");
+	  }
+	}
+      }
+    }
+    if(debug and (interfaces_to_take_down == NULL)){
+      fprintf_plus(stderr, "No interfaces were brought up\n");
+    }
+  }
+  
+  /* If we only got one interface, explicitly use only that one */
+  if(argz_count(mc.interfaces, mc.interfaces_size) == 1){
+    if(debug){
+      fprintf_plus(stderr, "Using only interface \"%s\"\n",
+		   mc.interfaces);
+    }
+    if_index = (AvahiIfIndex)if_nametoindex(mc.interfaces);
   }
   
   if(quit_now){
     goto end;
   }
   
-  ret = init_gnutls_global(pubkey, seckey);
+  ret = init_gnutls_global(pubkey, seckey, dh_params_file, &mc);
   if(ret == -1){
-    fprintf(stderr, "init_gnutls_global failed\n");
+    fprintf_plus(stderr, "init_gnutls_global failed\n");
     exitcode = EX_UNAVAILABLE;
     goto end;
   } else {
@@ -1555,10 +2794,17 @@
     goto end;
   }
   
-  tempdir_created = true;
-  if(mkdtemp(tempdir) == NULL){
-    tempdir_created = false;
-    perror("mkdtemp");
+  /* Try /run/tmp before /tmp */
+  tempdir = mkdtemp(run_tempdir);
+  if(tempdir == NULL and errno == ENOENT){
+      if(debug){
+	fprintf_plus(stderr, "Tempdir %s did not work, trying %s\n",
+		     run_tempdir, old_tempdir);
+      }
+      tempdir = mkdtemp(old_tempdir);
+  }
+  if(tempdir == NULL){
+    perror_plus("mkdtemp");
     goto end;
   }
   
@@ -1566,8 +2812,8 @@
     goto end;
   }
   
-  if(not init_gpgme(pubkey, seckey, tempdir)){
-    fprintf(stderr, "init_gpgme failed\n");
+  if(not init_gpgme(pubkey, seckey, tempdir, &mc)){
+    fprintf_plus(stderr, "init_gpgme failed\n");
     exitcode = EX_UNAVAILABLE;
     goto end;
   } else {
@@ -1582,8 +2828,9 @@
     /* Connect directly, do not use Zeroconf */
     /* (Mainly meant for debugging) */
     char *address = strrchr(connect_to, ':');
+    
     if(address == NULL){
-      fprintf(stderr, "No colon in address\n");
+      fprintf_plus(stderr, "No colon in address\n");
       exitcode = EX_USAGE;
       goto end;
     }
@@ -1592,47 +2839,58 @@
       goto end;
     }
     
-    uint16_t port;
+    in_port_t port;
     errno = 0;
     tmpmax = strtoimax(address+1, &tmp, 10);
     if(errno != 0 or tmp == address+1 or *tmp != '\0'
-       or tmpmax != (uint16_t)tmpmax){
-      fprintf(stderr, "Bad port number\n");
+       or tmpmax != (in_port_t)tmpmax){
+      fprintf_plus(stderr, "Bad port number\n");
       exitcode = EX_USAGE;
       goto end;
     }
-  
+    
     if(quit_now){
       goto end;
     }
     
-    port = (uint16_t)tmpmax;
+    port = (in_port_t)tmpmax;
     *address = '\0';
-    address = connect_to;
     /* Colon in address indicates IPv6 */
     int af;
-    if(strchr(address, ':') != NULL){
+    if(strchr(connect_to, ':') != NULL){
       af = AF_INET6;
+      /* Accept [] around IPv6 address - see RFC 5952 */
+      if(connect_to[0] == '[' and address[-1] == ']')
+	{
+	  connect_to++;
+	  address[-1] = '\0';
+	}
     } else {
       af = AF_INET;
     }
+    address = connect_to;
     
     if(quit_now){
       goto end;
     }
-
+    
     while(not quit_now){
-      ret = start_mandos_communication(address, port, if_index, af);
+      ret = start_mandos_communication(address, port, if_index, af,
+				       &mc);
       if(quit_now or ret == 0){
 	break;
       }
-      sleep(15);
-    };
-
-    if (not quit_now){
+      if(debug){
+	fprintf_plus(stderr, "Retrying in %d seconds\n",
+		     (int)retry_interval);
+      }
+      sleep((unsigned int)retry_interval);
+    }
+    
+    if(not quit_now){
       exitcode = EXIT_SUCCESS;
     }
-
+    
     goto end;
   }
   
@@ -1650,9 +2908,8 @@
     config.publish_domain = 0;
     
     /* Allocate a new server */
-    mc.server = avahi_server_new(avahi_simple_poll_get
-				 (mc.simple_poll), &config, NULL,
-				 NULL, &error);
+    mc.server = avahi_server_new(avahi_simple_poll_get(simple_poll),
+				 &config, NULL, NULL, &ret);
     
     /* Free the Avahi configuration data */
     avahi_server_config_free(&config);
@@ -1660,8 +2917,8 @@
   
   /* Check if creating the Avahi server object succeeded */
   if(mc.server == NULL){
-    fprintf(stderr, "Failed to create Avahi server: %s\n",
-	    avahi_strerror(error));
+    fprintf_plus(stderr, "Failed to create Avahi server: %s\n",
+		 avahi_strerror(ret));
     exitcode = EX_UNAVAILABLE;
     goto end;
   }
@@ -1673,10 +2930,11 @@
   /* Create the Avahi service browser */
   sb = avahi_s_service_browser_new(mc.server, if_index,
 				   AVAHI_PROTO_UNSPEC, "_mandos._tcp",
-				   NULL, 0, browse_callback, NULL);
+				   NULL, 0, browse_callback,
+				   (void *)&mc);
   if(sb == NULL){
-    fprintf(stderr, "Failed to create service browser: %s\n",
-	    avahi_strerror(avahi_server_errno(mc.server)));
+    fprintf_plus(stderr, "Failed to create service browser: %s\n",
+		 avahi_strerror(avahi_server_errno(mc.server)));
     exitcode = EX_UNAVAILABLE;
     goto end;
   }
@@ -1688,30 +2946,42 @@
   /* Run the main loop */
   
   if(debug){
-    fprintf(stderr, "Starting Avahi loop search\n");
+    fprintf_plus(stderr, "Starting Avahi loop search\n");
   }
   
-  avahi_simple_poll_loop(mc.simple_poll);
+  ret = avahi_loop_with_timeout(simple_poll,
+				(int)(retry_interval * 1000), &mc);
+  if(debug){
+    fprintf_plus(stderr, "avahi_loop_with_timeout exited %s\n",
+		 (ret == 0) ? "successfully" : "with error");
+  }
   
  end:
   
   if(debug){
-    fprintf(stderr, "%s exiting\n", argv[0]);
+    if(signal_received){
+      fprintf_plus(stderr, "%s exiting due to signal %d: %s\n",
+		   argv[0], signal_received,
+		   strsignal(signal_received));
+    } else {
+      fprintf_plus(stderr, "%s exiting\n", argv[0]);
+    }
   }
   
   /* Cleanup things */
+  free(mc.interfaces);
+  
   if(sb != NULL)
     avahi_s_service_browser_free(sb);
   
   if(mc.server != NULL)
     avahi_server_free(mc.server);
   
-  if(mc.simple_poll != NULL)
-    avahi_simple_poll_free(mc.simple_poll);
+  if(simple_poll != NULL)
+    avahi_simple_poll_free(simple_poll);
   
   if(gnutls_initialized){
     gnutls_certificate_free_credentials(mc.cred);
-    gnutls_global_deinit();
     gnutls_dh_params_deinit(mc.dh_params);
   }
   
@@ -1719,80 +2989,125 @@
     gpgme_release(mc.ctx);
   }
   
-  /* Take down the network interface */
-  if(take_down_interface){
-    /* Re-raise priviliges */
-    errno = 0;
-    ret = seteuid(0);
-    if(ret == -1){
-      perror("seteuid");
-    }
-    if(geteuid() == 0){
-      ret = ioctl(sd, SIOCGIFFLAGS, &network);
-      if(ret == -1){
-	perror("ioctl SIOCGIFFLAGS");
-      } else if(network.ifr_flags & IFF_UP) {
-	network.ifr_flags &= ~(short)IFF_UP; /* clear flag */
-	ret = ioctl(sd, SIOCSIFFLAGS, &network);
-	if(ret == -1){
-	  perror("ioctl SIOCSIFFLAGS -IFF_UP");
-	}
-      }
-      ret = (int)TEMP_FAILURE_RETRY(close(sd));
-      if(ret == -1){
-	perror("close");
-      }
-      /* Lower privileges permanently */
-      errno = 0;
-      ret = setuid(uid);
-      if(ret == -1){
-	perror("setuid");
-      }
-    }
-  }
-  
-  /* Removes the temp directory used by GPGME */
-  if(tempdir_created){
-    DIR *d;
-    struct dirent *direntry;
-    d = opendir(tempdir);
-    if(d == NULL){
-      if(errno != ENOENT){
-	perror("opendir");
-      }
-    } else {
-      while(true){
-	direntry = readdir(d);
-	if(direntry == NULL){
-	  break;
-	}
-	/* Skip "." and ".." */
-	if(direntry->d_name[0] == '.'
-	   and (direntry->d_name[1] == '\0'
-		or (direntry->d_name[1] == '.'
-		    and direntry->d_name[2] == '\0'))){
-	  continue;
-	}
-	char *fullname = NULL;
-	ret = asprintf(&fullname, "%s/%s", tempdir,
-		       direntry->d_name);
-	if(ret < 0){
-	  perror("asprintf");
-	  continue;
-	}
-	ret = remove(fullname);
-	if(ret == -1){
-	  fprintf(stderr, "remove(\"%s\"): %s\n", fullname,
-		  strerror(errno));
-	}
-	free(fullname);
-      }
-      closedir(d);
-    }
-    ret = rmdir(tempdir);
-    if(ret == -1 and errno != ENOENT){
-      perror("rmdir");
-    }
+  /* Cleans up the circular linked list of Mandos servers the client
+     has seen */
+  if(mc.current_server != NULL){
+    mc.current_server->prev->next = NULL;
+    while(mc.current_server != NULL){
+      server *next = mc.current_server->next;
+#ifdef __GNUC__
+#pragma GCC diagnostic push
+#pragma GCC diagnostic ignored "-Wcast-qual"
+#endif
+      free((char *)(mc.current_server->ip));
+#ifdef __GNUC__
+#pragma GCC diagnostic pop
+#endif
+      free(mc.current_server);
+      mc.current_server = next;
+    }
+  }
+  
+  /* Re-raise privileges */
+  {
+    ret = raise_privileges();
+    if(ret != 0){
+      errno = ret;
+      perror_plus("Failed to raise privileges");
+    } else {
+      
+      /* Run network hooks */
+      run_network_hooks("stop", interfaces_hooks != NULL ?
+			interfaces_hooks : "", delay);
+      
+      /* Take down the network interfaces which were brought up */
+      {
+	char *interface = NULL;
+	while((interface=argz_next(interfaces_to_take_down,
+				   interfaces_to_take_down_size,
+				   interface))){
+	  ret = take_down_interface(interface);
+	  if(ret != 0){
+	    errno = ret;
+	    perror_plus("Failed to take down interface");
+	  }
+	}
+	if(debug and (interfaces_to_take_down == NULL)){
+	  fprintf_plus(stderr, "No interfaces needed to be taken"
+		       " down\n");
+	}
+      }
+    }
+    
+    ret = lower_privileges_permanently();
+    if(ret != 0){
+      errno = ret;
+      perror_plus("Failed to lower privileges permanently");
+    }
+  }
+  
+  free(interfaces_to_take_down);
+  free(interfaces_hooks);
+  
+  void clean_dir_at(int base, const char * const dirname,
+		    uintmax_t level){
+    struct dirent **direntries = NULL;
+    int dret;
+    int dir_fd = (int)TEMP_FAILURE_RETRY(openat(base, dirname,
+						O_RDONLY
+						| O_NOFOLLOW
+						| O_DIRECTORY
+						| O_PATH));
+    if(dir_fd == -1){
+      perror_plus("open");
+    }
+    int numentries = scandirat(dir_fd, ".", &direntries,
+			       notdotentries, alphasort);
+    if(numentries >= 0){
+      for(int i = 0; i < numentries; i++){
+	if(debug){
+	  fprintf_plus(stderr, "Unlinking \"%s/%s\"\n",
+		       dirname, direntries[i]->d_name);
+	}
+	dret = unlinkat(dir_fd, direntries[i]->d_name, 0);
+	if(dret == -1){
+	  if(errno == EISDIR){
+	      dret = unlinkat(dir_fd, direntries[i]->d_name,
+			      AT_REMOVEDIR);
+	  }	    
+	  if((dret == -1) and (errno == ENOTEMPTY)
+	     and (strcmp(direntries[i]->d_name, "private-keys-v1.d")
+		  == 0) and (level == 0)){
+	    /* Recurse only in this special case */
+	    clean_dir_at(dir_fd, direntries[i]->d_name, level+1);
+	    dret = 0;
+	  }
+	  if(dret == -1){
+	    fprintf_plus(stderr, "unlink(\"%s/%s\"): %s\n", dirname,
+			 direntries[i]->d_name, strerror(errno));
+	  }
+	}
+	free(direntries[i]);
+      }
+      
+      /* need to clean even if 0 because man page doesn't specify */
+      free(direntries);
+      if(numentries == -1){
+	perror_plus("scandirat");
+      }
+      dret = unlinkat(base, dirname, AT_REMOVEDIR);
+      if(dret == -1 and errno != ENOENT){
+	perror_plus("rmdir");
+      }
+    } else {
+      perror_plus("scandirat");
+    }
+    close(dir_fd);
+  }
+  
+  /* Removes the GPGME temp directory and all files inside */
+  if(tempdir != NULL){
+    clean_dir_at(-1, tempdir, 0);
   }
   
   if(quit_now){
@@ -1802,13 +3117,13 @@
 					    &old_sigterm_action,
 					    NULL));
     if(ret == -1){
-      perror("sigaction");
+      perror_plus("sigaction");
     }
     do {
       ret = raise(signal_received);
     } while(ret != 0 and errno == EINTR);
     if(ret != 0){
-      perror("raise");
+      perror_plus("raise");
       abort();
     }
     TEMP_FAILURE_RETRY(pause());

=== modified file 'plugins.d/mandos-client.xml'
--- plugins.d/mandos-client.xml	2010-09-26 18:32:58 +0000
+++ plugins.d/mandos-client.xml	2016-07-10 03:43:48 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-client">
-<!ENTITY TIMESTAMP "2010-09-26">
+<!ENTITY TIMESTAMP "2016-07-10">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -19,20 +19,27 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@fukt.bsnet.se</email>
+	  <email>belorn@recompile.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@fukt.bsnet.se</email>
+	  <email>teddy@recompile.se</email>
 	</address>
       </author>
     </authorgroup>
     <copyright>
       <year>2008</year>
       <year>2009</year>
+      <year>2010</year>
+      <year>2011</year>
+      <year>2012</year>
+      <year>2013</year>
+      <year>2014</year>
+      <year>2015</year>
+      <year>2016</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -63,11 +70,13 @@
 	><replaceable>PORT</replaceable></option></arg>
       </group>
       <sbr/>
-      <group>
+      <group rep='repeat'>
 	<arg choice="plain"><option>--interface
-	<replaceable>NAME</replaceable></option></arg>
-	<arg choice="plain"><option>-i
-	<replaceable>NAME</replaceable></option></arg>
+	<replaceable>NAME</replaceable><arg rep='repeat'
+	>,<replaceable>NAME</replaceable></arg></option></arg>
+	<arg choice="plain"><option>-i <replaceable>NAME</replaceable
+	><arg rep='repeat'>,<replaceable>NAME</replaceable></arg
+	></option></arg>
       </group>
       <sbr/>
       <group>
@@ -93,10 +102,23 @@
       </arg>
       <sbr/>
       <arg>
+	<option>--dh-params <replaceable>FILE</replaceable></option>
+      </arg>
+      <sbr/>
+      <arg>
 	<option>--delay <replaceable>SECONDS</replaceable></option>
       </arg>
       <sbr/>
       <arg>
+	<option>--retry <replaceable>SECONDS</replaceable></option>
+      </arg>
+      <sbr/>
+      <arg>
+	<option>--network-hook-dir
+	<replaceable>DIR</replaceable></option>
+      </arg>
+      <sbr/>
+      <arg>
 	<option>--debug</option>
       </arg>
     </cmdsynopsis>
@@ -127,15 +149,33 @@
       communicates with <citerefentry><refentrytitle
       >mandos</refentrytitle><manvolnum>8</manvolnum></citerefentry>
       to get a password.  In slightly more detail, this client program
-      brings up a network interface, uses the interface’s IPv6
-      link-local address to get network connectivity, uses Zeroconf to
-      find servers on the local network, and communicates with servers
-      using TLS with an OpenPGP key to ensure authenticity and
+      brings up network interfaces, uses the interfaces’ IPv6
+      link-local addresses to get network connectivity, uses Zeroconf
+      to find servers on the local network, and communicates with
+      servers using TLS with an OpenPGP key to ensure authenticity and
       confidentiality.  This client program keeps running, trying all
       servers on the network, until it receives a satisfactory reply
-      or a TERM signal is received.  If no servers are found, or after
-      all servers have been tried, it waits indefinitely for new
-      servers to appear.
+      or a TERM signal.  After all servers have been tried, all
+      servers are periodically retried.  If no servers are found it
+      will wait indefinitely for new servers to appear.
+    </para>
+    <para>
+      The network interfaces are selected like this: If any interfaces
+      are specified using the <option>--interface</option> option,
+      those interface are used.  Otherwise,
+      <command>&COMMANDNAME;</command> will use all interfaces that
+      are not loopback interfaces, are not point-to-point interfaces,
+      are capable of broadcasting and do not have the NOARP flag (see
+      <citerefentry><refentrytitle>netdevice</refentrytitle>
+      <manvolnum>7</manvolnum></citerefentry>).  (If the
+      <option>--connect</option> option is used, point-to-point
+      interfaces and non-broadcast interfaces are accepted.)  If any
+      used interfaces are not up and running, they are first taken up
+      (and later taken down again on program exit).
+    </para>
+    <para>
+      Before network interfaces are selected, all <quote>network
+      hooks</quote> are run; see <xref linkend="network-hooks"/>.
     </para>
     <para>
       This program is not meant to be run directly; it is really meant
@@ -188,44 +228,50 @@
 	    assumed to separate the address from the port number.
 	  </para>
 	  <para>
-	    This option is normally only useful for testing and
-	    debugging.
+	    Normally, Zeroconf would be used to locate Mandos servers,
+	    in which case this option would only be used when testing
+	    and debugging.
 	  </para>
 	</listitem>
       </varlistentry>
       
       <varlistentry>
 	<term><option>--interface=<replaceable
-	>NAME</replaceable></option></term>
+	>NAME</replaceable><arg rep='repeat'>,<replaceable
+	>NAME</replaceable></arg></option></term>
 	<term><option>-i
-	<replaceable>NAME</replaceable></option></term>
+	<replaceable>NAME</replaceable><arg rep='repeat'>,<replaceable
+	>NAME</replaceable></arg></option></term>
 	<listitem>
 	  <para>
-	    Network interface that will be brought up and scanned for
-	    Mandos servers to connect to.  The default is the empty
-	    string, which will automatically choose an appropriate
-	    interface.
+	    Comma separated list of network interfaces that will be
+	    brought up and scanned for Mandos servers to connect to.
+	    The default is the empty string, which will automatically
+	    use all appropriate interfaces.
 	  </para>
 	  <para>
-	    If the <option>--connect</option> option is used, this
-	    specifies the interface to use to connect to the address
-	    given.
+	    If the <option>--connect</option> option is used, and
+	    exactly one interface name is specified (except
+	    <quote><literal>none</literal></quote>), this specifies
+	    the interface to use to connect to the address given.
 	  </para>
 	  <para>
 	    Note that since this program will normally run in the
 	    initial RAM disk environment, the interface must be an
 	    interface which exists at that stage.  Thus, the interface
-	    can not be a pseudo-interface such as <quote>br0</quote>
-	    or <quote>tun0</quote>; such interfaces will not exist
-	    until much later in the boot process, and can not be used
-	    by this program.
+	    can normally not be a pseudo-interface such as
+	    <quote>br0</quote> or <quote>tun0</quote>; such interfaces
+	    will not exist until much later in the boot process, and
+	    can not be used by this program, unless created by a
+	    <quote>network hook</quote> — see <xref
+	    linkend="network-hooks"/>.
 	  </para>
 	  <para>
 	    <replaceable>NAME</replaceable> can be the string
-	    <quote><literal>none</literal></quote>; this will not use
-	    any specific interface, and will not bring up an interface
-	    on startup.  This is not recommended, and only meant for
-	    advanced users.
+	    <quote><literal>none</literal></quote>; this will make
+	    <command>&COMMANDNAME;</command> only bring up interfaces
+	    specified <emphasis>before</emphasis> this string.  This
+	    is not recommended, and only meant for advanced users.
 	  </para>
 	</listitem>
       </varlistentry>
@@ -273,7 +319,27 @@
 	<listitem>
 	  <para>
 	    Sets the number of bits to use for the prime number in the
-	    TLS Diffie-Hellman key exchange.  Default is 1024.
+	    TLS Diffie-Hellman key exchange.  The default value is
+	    selected automatically based on the OpenPGP key.  Note
+	    that if the <option>--dh-params</option> option is used,
+	    the values from that file will be used instead.
+	  </para>
+	</listitem>
+      </varlistentry>
+      
+      <varlistentry>
+	<term><option>--dh-params=<replaceable
+	>FILE</replaceable></option></term>
+	<listitem>
+	  <para>
+	    Specifies a PEM-encoded PKCS#3 file to read the parameters
+	    needed by the TLS Diffie-Hellman key exchange from.  If
+	    this option is not given, or if the file for some reason
+	    could not be used, the parameters will be generated on
+	    startup, which will take some time and processing power.
+	    Those using servers running under time, power or processor
+	    constraints may want to generate such a file in advance
+	    and use this option.
 	  </para>
 	</listitem>
       </varlistentry>
@@ -283,7 +349,7 @@
 	>SECONDS</replaceable></option></term>
 	<listitem>
 	  <para>
-	    After bringing the network interface up, the program waits
+	    After bringing a network interface up, the program waits
 	    for the interface to arrive in a <quote>running</quote>
 	    state before proceeding.  During this time, the kernel log
 	    level will be lowered to reduce clutter on the system
@@ -293,6 +359,31 @@
 	  </para>
 	</listitem>
       </varlistentry>
+
+      <varlistentry>
+	<term><option>--retry=<replaceable
+	>SECONDS</replaceable></option></term>
+	<listitem>
+	  <para>
+	    All Mandos servers are tried repeatedly until a password
+	    is received.  This value specifies, in seconds, how long
+	    between each successive try <emphasis>for the same
+	    server</emphasis>.  The default is 10 seconds.
+	  </para>
+	</listitem>
+      </varlistentry>
+
+      <varlistentry>
+	<term><option>--network-hook-dir=<replaceable
+	>DIR</replaceable></option></term>
+	<listitem>
+	  <para>
+	    Network hook directory.  The default directory is
+	    <quote><filename class="directory"
+	    >/lib/mandos/network-hooks.d</filename></quote>.
+	  </para>
+	</listitem>
+      </varlistentry>
       
       <varlistentry>
 	<term><option>--debug</option></term>
@@ -359,8 +450,10 @@
       <refentrytitle>plugin-runner</refentrytitle>
       <manvolnum>8mandos</manvolnum></citerefentry>) is used to run
       both this program and others in in parallel,
-      <emphasis>one</emphasis> of which will prompt for passwords on
-      the system console.
+      <emphasis>one</emphasis> of which (<citerefentry>
+      <refentrytitle>password-prompt</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>) will prompt for
+      passwords on the system console.
     </para>
   </refsect1>
   
@@ -371,22 +464,204 @@
       server could be found and the password received from it could be
       successfully decrypted and output on standard output.  The
       program will exit with a non-zero exit status only if a critical
-      error occurs.  Otherwise, it will forever connect to new
-      <application>Mandos</application> servers as they appear, trying
-      to get a decryptable password and print it.
+      error occurs.  Otherwise, it will forever connect to any
+      discovered <application>Mandos</application> servers, trying to
+      get a decryptable password and print it.
     </para>
   </refsect1>
   
   <refsect1 id="environment">
     <title>ENVIRONMENT</title>
+    <variablelist>
+      <varlistentry>
+	<term><envar>MANDOSPLUGINHELPERDIR</envar></term>
+	<listitem>
+	  <para>
+	    This environment variable will be assumed to contain the
+	    directory containing any helper executables.  The use and
+	    nature of these helper executables, if any, is
+	    purposefully not documented.
+	</para>
+	</listitem>
+      </varlistentry>
+    </variablelist>
     <para>
-      This program does not use any environment variables, not even
-      the ones provided by <citerefentry><refentrytitle
+      This program does not use any other environment variables, not
+      even the ones provided by <citerefentry><refentrytitle
       >cryptsetup</refentrytitle><manvolnum>8</manvolnum>
     </citerefentry>.
     </para>
   </refsect1>
   
+  <refsect1 id="network-hooks">
+    <title>NETWORK HOOKS</title>
+    <para>
+      If a network interface like a bridge or tunnel is required to
+      find a Mandos server, this requires the interface to be up and
+      running before <command>&COMMANDNAME;</command> starts looking
+      for Mandos servers.  This can be accomplished by creating a
+      <quote>network hook</quote> program, and placing it in a special
+      directory.
+    </para>
+    <para>
+      Before the network is used (and again before program exit), any
+      runnable programs found in the network hook directory are run
+      with the argument <quote><literal>start</literal></quote> or
+      <quote><literal>stop</literal></quote>.  This should bring up or
+      down, respectively, any network interface which
+      <command>&COMMANDNAME;</command> should use.
+    </para>
+    <refsect2 id="hook-requirements">
+      <title>REQUIREMENTS</title>
+      <para>
+	A network hook must be an executable file, and its name must
+	consist entirely of upper and lower case letters, digits,
+	underscores, periods, and hyphens.
+      </para>
+      <para>
+	A network hook will receive one argument, which can be one of
+	the following:
+      </para>
+      <variablelist>
+	<varlistentry>
+	  <term><literal>start</literal></term>
+	  <listitem>
+	    <para>
+	      This should make the network hook create (if necessary)
+	      and bring up a network interface.
+	    </para>
+	  </listitem>
+	</varlistentry>
+	<varlistentry>
+	  <term><literal>stop</literal></term>
+	  <listitem>
+	    <para>
+	      This should make the network hook take down a network
+	      interface, and delete it if it did not exist previously.
+	    </para>
+	  </listitem>
+	</varlistentry>
+	<varlistentry>
+	  <term><literal>files</literal></term>
+	  <listitem>
+	    <para>
+	      This should make the network hook print, <emphasis>one
+	      file per line</emphasis>, all the files needed for it to
+	      run.  (These files will be copied into the initial RAM
+	      filesystem.)  Typical use is for a network hook which is
+	      a shell script to print its needed binaries.
+	    </para>
+	    <para>
+	      It is not necessary to print any non-executable files
+	      already in the network hook directory, these will be
+	      copied implicitly if they otherwise satisfy the name
+	      requirements.
+	    </para>
+	  </listitem>
+	</varlistentry>
+	<varlistentry>
+	  <term><literal>modules</literal></term>
+	  <listitem>
+	    <para>
+	      This should make the network hook print, <emphasis>on
+	      separate lines</emphasis>, all the kernel modules needed
+	      for it to run.  (These modules will be copied into the
+	      initial RAM filesystem.)  For instance, a tunnel
+	      interface needs the
+	      <quote><literal>tun</literal></quote> module.
+	    </para>
+	  </listitem>
+	</varlistentry>
+      </variablelist>
+      <para>
+	The network hook will be provided with a number of environment
+	variables:
+      </para>
+      <variablelist>
+	<varlistentry>
+	  <term><envar>MANDOSNETHOOKDIR</envar></term>
+	  <listitem>
+	    <para>
+	      The network hook directory, specified to
+	      <command>&COMMANDNAME;</command> by the
+	      <option>--network-hook-dir</option> option.  Note: this
+	      should <emphasis>always</emphasis> be used by the
+	      network hook to refer to itself or any files in the hook
+	      directory it may require.
+	    </para>
+	  </listitem>
+	</varlistentry>
+	<varlistentry>
+	  <term><envar>DEVICE</envar></term>
+	  <listitem>
+	    <para>
+	      The network interfaces, as specified to
+	      <command>&COMMANDNAME;</command> by the
+	      <option>--interface</option> option, combined to one
+	      string and separated by commas.  If this is set, and
+	      does not contain the interface a hook will bring up,
+	      there is no reason for a hook to continue.
+	    </para>
+	  </listitem>
+	</varlistentry>
+	<varlistentry>
+	  <term><envar>MODE</envar></term>
+	  <listitem>
+	    <para>
+	      This will be the same as the first argument;
+	      i.e. <quote><literal>start</literal></quote>,
+	      <quote><literal>stop</literal></quote>,
+	      <quote><literal>files</literal></quote>, or
+	      <quote><literal>modules</literal></quote>.
+	    </para>
+	  </listitem>
+	</varlistentry>
+	<varlistentry>
+	  <term><envar>VERBOSITY</envar></term>
+	  <listitem>
+	    <para>
+	      This will be the <quote><literal>1</literal></quote> if
+	      the <option>--debug</option> option is passed to
+	      <command>&COMMANDNAME;</command>, otherwise
+	      <quote><literal>0</literal></quote>.
+	    </para>
+	  </listitem>
+	</varlistentry>
+	<varlistentry>
+	  <term><envar>DELAY</envar></term>
+	  <listitem>
+	    <para>
+	      This will be the same as the <option>--delay</option>
+	      option passed to <command>&COMMANDNAME;</command>.  Is
+	      only set if <envar>MODE</envar> is
+	      <quote><literal>start</literal></quote> or
+	      <quote><literal>stop</literal></quote>.
+	    </para>
+	  </listitem>
+	</varlistentry>
+	<varlistentry>
+	  <term><envar>CONNECT</envar></term>
+	  <listitem>
+	    <para>
+	      This will be the same as the <option>--connect</option>
+	      option passed to <command>&COMMANDNAME;</command>.  Is
+	      only set if <option>--connect</option> is passed and
+	      <envar>MODE</envar> is
+	      <quote><literal>start</literal></quote> or
+	      <quote><literal>stop</literal></quote>.
+	    </para>
+	  </listitem>
+	</varlistentry>
+      </variablelist>
+      <para>
+	A hook may not read from standard input, and should be
+	restrictive in printing to standard output or standard error
+	unless <varname>VERBOSITY</varname> is
+	<quote><literal>1</literal></quote>.
+      </para>
+    </refsect2>
+  </refsect1>
+  
   <refsect1 id="files">
     <title>FILES</title>
     <variablelist>
@@ -404,14 +679,24 @@
 	  </para>
 	</listitem>
       </varlistentry>
+      <varlistentry>
+	<term><filename
+	class="directory">/lib/mandos/network-hooks.d</filename></term>
+	<listitem>
+	  <para>
+	    Directory where network hooks are located.  Change this
+	    with the <option>--network-hook-dir</option> option.  See
+	    <xref linkend="network-hooks"/>.
+	  </para>
+	</listitem>
+      </varlistentry>
     </variablelist>
   </refsect1>
   
-<!--   <refsect1 id="bugs"> -->
-<!--     <title>BUGS</title> -->
-<!--     <para> -->
-<!--     </para> -->
-<!--   </refsect1> -->
+  <refsect1 id="bugs">
+    <title>BUGS</title>
+    <xi:include href="../bugs.xml"/>
+  </refsect1>
   
   <refsect1 id="example">
     <title>EXAMPLE</title>
@@ -423,8 +708,8 @@
     </para>
     <informalexample>
       <para>
-	Normal invocation needs no options, if the network interface
-	is <quote>eth0</quote>:
+	Normal invocation needs no options, if the network interfaces
+	can be automatically determined:
       </para>
       <para>
 	<userinput>&COMMANDNAME;</userinput>
@@ -432,8 +717,8 @@
     </informalexample>
     <informalexample>
       <para>
-	Search for Mandos servers (and connect to them) using another
-	interface:
+	Search for Mandos servers (and connect to them) using one
+	specific interface:
       </para>
       <para>
 	<!-- do not wrap this line -->
@@ -503,8 +788,9 @@
     <para>
       It will also help if the checker program on the server is
       configured to request something from the client which can not be
-      spoofed by someone else on the network, unlike unencrypted
-      <acronym>ICMP</acronym> echo (<quote>ping</quote>) replies.
+      spoofed by someone else on the network, like SSH server key
+      fingerprints, and unlike unencrypted <acronym>ICMP</acronym>
+      echo (<quote>ping</quote>) replies.
     </para>
     <para>
       <emphasis>Note</emphasis>: This makes it completely insecure to
@@ -518,6 +804,8 @@
   <refsect1 id="see_also">
     <title>SEE ALSO</title>
     <para>
+      <citerefentry><refentrytitle>intro</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>cryptsetup</refentrytitle>
       <manvolnum>8</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>crypttab</refentrytitle>
@@ -554,8 +842,7 @@
       </varlistentry>
       <varlistentry>
 	<term>
-	  <ulink url="http://www.gnu.org/software/gnutls/"
-	  >GnuTLS</ulink>
+	  <ulink url="https://www.gnutls.org/">GnuTLS</ulink>
 	</term>
       <listitem>
 	<para>
@@ -567,7 +854,7 @@
       </varlistentry>
       <varlistentry>
 	<term>
-	  <ulink url="http://www.gnupg.org/related_software/gpgme/"
+	  <ulink url="https://www.gnupg.org/related_software/gpgme/"
 		 >GPGME</ulink>
 	</term>
 	<listitem>
@@ -601,7 +888,7 @@
 	      <para>
 		This client uses IPv6 link-local addresses, which are
 		immediately usable since a link-local addresses is
-		automatically assigned to a network interfaces when it
+		automatically assigned to a network interface when it
 		is brought up.
 	      </para>
 	    </listitem>
@@ -611,12 +898,12 @@
       </varlistentry>
       <varlistentry>
 	<term>
-	  RFC 4346: <citetitle>The Transport Layer Security (TLS)
-	  Protocol Version 1.1</citetitle>
+	  RFC 5246: <citetitle>The Transport Layer Security (TLS)
+	  Protocol Version 1.2</citetitle>
 	</term>
       <listitem>
 	<para>
-	  TLS 1.1 is the protocol implemented by GnuTLS.
+	  TLS 1.2 is the protocol implemented by GnuTLS.
 	</para>
       </listitem>
       </varlistentry>
@@ -633,7 +920,7 @@
       </varlistentry>
       <varlistentry>
 	<term>
-	  RFC 5081: <citetitle>Using OpenPGP Keys for Transport Layer
+	  RFC 6091: <citetitle>Using OpenPGP Keys for Transport Layer
 	  Security</citetitle>
 	</term>
       <listitem>

=== modified file 'plugins.d/password-prompt.c'
--- plugins.d/password-prompt.c	2010-09-26 18:32:58 +0000
+++ plugins.d/password-prompt.c	2016-02-28 14:22:10 +0000
@@ -2,8 +2,8 @@
 /*
  * Password-prompt - Read a password from the terminal and print it
  * 
- * Copyright © 2008-2010 Teddy Hogeborn
- * Copyright © 2008-2010 Björn Påhlsson
+ * Copyright © 2008-2016 Teddy Hogeborn
+ * Copyright © 2008-2016 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -19,35 +19,40 @@
  * along with this program.  If not, see
  * <http://www.gnu.org/licenses/>.
  * 
- * Contact the authors at <mandos@fukt.bsnet.se>.
+ * Contact the authors at <mandos@recompile.se>.
  */
 
-#define _GNU_SOURCE		/* getline() */
+#define _GNU_SOURCE		/* getline(), asprintf() */
 
-#include <termios.h> 		/* struct termios, tcsetattr(),
+#include <termios.h>		/* struct termios, tcsetattr(),
 				   TCSAFLUSH, tcgetattr(), ECHO */
 #include <unistd.h>		/* struct termios, tcsetattr(),
 				   STDIN_FILENO, TCSAFLUSH,
-				   tcgetattr(), ECHO */
+				   tcgetattr(), ECHO, readlink() */
 #include <signal.h>		/* sig_atomic_t, raise(), struct
 				   sigaction, sigemptyset(),
 				   sigaction(), sigaddset(), SIGINT,
 				   SIGQUIT, SIGHUP, SIGTERM,
 				   raise() */
 #include <stddef.h>		/* NULL, size_t, ssize_t */
-#include <sys/types.h>		/* ssize_t */
+#include <sys/types.h>		/* ssize_t, struct dirent, pid_t,
+				   ssize_t, open() */
 #include <stdlib.h>		/* EXIT_SUCCESS, EXIT_FAILURE,
-				   getenv() */
+				   getenv(), free() */
+#include <dirent.h>		/* scandir(), alphasort() */
 #include <stdio.h>		/* fprintf(), stderr, getline(),
-				   stdin, feof(), fputc()
-				*/
+				   stdin, feof(), fputc(), vfprintf(),
+				   vasprintf() */
 #include <errno.h>		/* errno, EBADF, ENOTTY, EINVAL,
 				   EFAULT, EFBIG, EIO, ENOSPC, EINTR
 				*/
 #include <error.h>		/* error() */
 #include <iso646.h>		/* or, not */
 #include <stdbool.h>		/* bool, false, true */
-#include <string.h> 		/* strlen, rindex */
+#include <inttypes.h>		/* strtoumax() */
+#include <sys/stat.h>		/* struct stat, lstat(), open() */
+#include <string.h>		/* strlen, rindex, memcmp, strerror()
+				 */
 #include <argp.h>		/* struct argp_option, struct
 				   argp_state, struct argp,
 				   argp_parse(), error_t,
@@ -55,12 +60,40 @@
 				   ARGP_ERR_UNKNOWN */
 #include <sysexits.h>		/* EX_SOFTWARE, EX_OSERR,
 				   EX_UNAVAILABLE, EX_IOERR, EX_OK */
+#include <fcntl.h>		/* open() */
+#include <stdarg.h>		/* va_list, va_start(), ... */
 
 volatile sig_atomic_t quit_now = 0;
 int signal_received;
 bool debug = false;
 const char *argp_program_version = "password-prompt " VERSION;
-const char *argp_program_bug_address = "<mandos@fukt.bsnet.se>";
+const char *argp_program_bug_address = "<mandos@recompile.se>";
+
+/* Needed for conflict resolution */
+const char plymouth_name[] = "plymouthd";
+
+/* Function to use when printing errors */
+__attribute__((format (gnu_printf, 3, 4)))
+void error_plus(int status, int errnum, const char *formatstring,
+		...){
+  va_list ap;
+  char *text;
+  int ret;
+  
+  va_start(ap, formatstring);
+  ret = vasprintf(&text, formatstring, ap);
+  if(ret == -1){
+    fprintf(stderr, "Mandos plugin %s: ",
+	    program_invocation_short_name);
+    vfprintf(stderr, formatstring, ap);
+    fprintf(stderr, ": %s\n", strerror(errnum));
+    error(status, errno, "vasprintf while printing error");
+    return;
+  }
+  fprintf(stderr, "Mandos plugin ");
+  error(status, errnum, "%s", text);
+  free(text);
+}
 
 static void termination_handler(int signum){
   if(quit_now){
@@ -70,6 +103,123 @@
   signal_received = signum;
 }
 
+bool conflict_detection(void){
+
+  /* plymouth conflicts with password-prompt since both want to read
+     from the terminal.  Password-prompt will exit if it detects
+     plymouth since plymouth performs the same functionality.
+   */
+  __attribute__((nonnull))
+  int is_plymouth(const struct dirent *proc_entry){
+    int ret;
+    int cl_fd;
+    {
+      uintmax_t proc_id;
+      char *tmp;
+      errno = 0;
+      proc_id = strtoumax(proc_entry->d_name, &tmp, 10);
+      
+      if(errno != 0 or *tmp != '\0'
+	 or proc_id != (uintmax_t)((pid_t)proc_id)){
+	return 0;
+      }
+    }
+    
+    char *cmdline_filename;
+    ret = asprintf(&cmdline_filename, "/proc/%s/cmdline",
+		   proc_entry->d_name);
+    if(ret == -1){
+      error_plus(0, errno, "asprintf");
+      return 0;
+    }
+    
+    /* Open /proc/<pid>/cmdline */
+    cl_fd = open(cmdline_filename, O_RDONLY);
+    free(cmdline_filename);
+    if(cl_fd == -1){
+      if(errno != ENOENT){
+	error_plus(0, errno, "open");
+      }
+      return 0;
+    }
+    
+    char *cmdline = NULL;
+    {
+      size_t cmdline_len = 0;
+      size_t cmdline_allocated = 0;
+      char *tmp;
+      const size_t blocksize = 1024;
+      ssize_t sret;
+      do {
+	/* Allocate more space? */
+	if(cmdline_len + blocksize + 1 > cmdline_allocated){
+	  tmp = realloc(cmdline, cmdline_allocated + blocksize + 1);
+	  if(tmp == NULL){
+	    error_plus(0, errno, "realloc");
+	    free(cmdline);
+	    close(cl_fd);
+	    return 0;
+	  }
+	  cmdline = tmp;
+	  cmdline_allocated += blocksize;
+	}
+	
+	/* Read data */
+	sret = read(cl_fd, cmdline + cmdline_len,
+		    cmdline_allocated - cmdline_len);
+	if(sret == -1){
+	  error_plus(0, errno, "read");
+	  free(cmdline);
+	  close(cl_fd);
+	  return 0;
+	}
+	cmdline_len += (size_t)sret;
+      } while(sret != 0);
+      ret = close(cl_fd);
+      if(ret == -1){
+	error_plus(0, errno, "close");
+	free(cmdline);
+	return 0;
+      }
+      cmdline[cmdline_len] = '\0'; /* Make sure it is terminated */
+    }
+    /* we now have cmdline */
+    
+    /* get basename */
+    char *cmdline_base = strrchr(cmdline, '/');
+    if(cmdline_base != NULL){
+      cmdline_base += 1;		/* skip the slash */
+    } else {
+      cmdline_base = cmdline;
+    }
+    
+    if(strcmp(cmdline_base, plymouth_name) != 0){
+      if(debug){
+	fprintf(stderr, "\"%s\" is not \"%s\"\n", cmdline_base,
+		plymouth_name);
+      }
+      free(cmdline);
+      return 0;
+    }
+    if(debug){
+      fprintf(stderr, "\"%s\" equals \"%s\"\n", cmdline_base,
+	      plymouth_name);
+    }
+    free(cmdline);
+    return 1;
+  }
+  
+  struct dirent **direntries = NULL;
+  int ret;
+  ret = scandir("/proc", &direntries, is_plymouth, alphasort);
+  if(ret == -1){
+    error_plus(1, errno, "scandir");
+  }
+  free(direntries);
+  return ret > 0;
+}
+
+
 int main(int argc, char **argv){
   ssize_t sret;
   int ret;
@@ -100,6 +250,7 @@
       { .name = NULL }
     };
     
+    __attribute__((nonnull(3)))
     error_t parse_opt (int key, char *arg, struct argp_state *state){
       errno = 0;
       switch (key){
@@ -141,7 +292,7 @@
     case ENOMEM:
     default:
       errno = ret;
-      error(0, errno, "argp_parse");
+      error_plus(0, errno, "argp_parse");
       return EX_OSERR;
     case EINVAL:
       return EX_USAGE;
@@ -151,13 +302,21 @@
   if(debug){
     fprintf(stderr, "Starting %s\n", argv[0]);
   }
+
+  if(conflict_detection()){
+    if(debug){
+      fprintf(stderr, "Stopping %s because of conflict\n", argv[0]);
+    }
+    return EXIT_FAILURE;
+  }
+  
   if(debug){
     fprintf(stderr, "Storing current terminal attributes\n");
   }
   
   if(tcgetattr(STDIN_FILENO, &t_old) != 0){
     int e = errno;
-    error(0, errno, "tcgetattr");
+    error_plus(0, errno, "tcgetattr");
     switch(e){
     case EBADF:
     case ENOTTY:
@@ -170,17 +329,17 @@
   sigemptyset(&new_action.sa_mask);
   ret = sigaddset(&new_action.sa_mask, SIGINT);
   if(ret == -1){
-    error(0, errno, "sigaddset");
+    error_plus(0, errno, "sigaddset");
     return EX_OSERR;
   }
   ret = sigaddset(&new_action.sa_mask, SIGHUP);
   if(ret == -1){
-    error(0, errno, "sigaddset");
+    error_plus(0, errno, "sigaddset");
     return EX_OSERR;
   }
   ret = sigaddset(&new_action.sa_mask, SIGTERM);
   if(ret == -1){
-    error(0, errno, "sigaddset");
+    error_plus(0, errno, "sigaddset");
     return EX_OSERR;
   }
   /* Need to check if the handler is SIG_IGN before handling:
@@ -189,37 +348,37 @@
   */
   ret = sigaction(SIGINT, NULL, &old_action);
   if(ret == -1){
-    error(0, errno, "sigaction");
+    error_plus(0, errno, "sigaction");
     return EX_OSERR;
   }
   if(old_action.sa_handler != SIG_IGN){
     ret = sigaction(SIGINT, &new_action, NULL);
     if(ret == -1){
-      error(0, errno, "sigaction");
+      error_plus(0, errno, "sigaction");
       return EX_OSERR;
     }
   }
   ret = sigaction(SIGHUP, NULL, &old_action);
   if(ret == -1){
-    error(0, errno, "sigaction");
+    error_plus(0, errno, "sigaction");
     return EX_OSERR;
   }
   if(old_action.sa_handler != SIG_IGN){
     ret = sigaction(SIGHUP, &new_action, NULL);
     if(ret == -1){
-      error(0, errno, "sigaction");
+      error_plus(0, errno, "sigaction");
       return EX_OSERR;
     }
   }
   ret = sigaction(SIGTERM, NULL, &old_action);
   if(ret == -1){
-    error(0, errno, "sigaction");
+    error_plus(0, errno, "sigaction");
     return EX_OSERR;
   }
   if(old_action.sa_handler != SIG_IGN){
     ret = sigaction(SIGTERM, &new_action, NULL);
     if(ret == -1){
-      error(0, errno, "sigaction");
+      error_plus(0, errno, "sigaction");
       return EX_OSERR;
     }
   }
@@ -233,7 +392,7 @@
   t_new.c_lflag &= ~(tcflag_t)ECHO;
   if(tcsetattr(STDIN_FILENO, TCSAFLUSH, &t_new) != 0){
     int e = errno;
-    error(0, errno, "tcsetattr-echo");
+    error_plus(0, errno, "tcsetattr-echo");
     switch(e){
     case EBADF:
     case ENOTTY:
@@ -303,7 +462,7 @@
 	sret = write(STDOUT_FILENO, buffer + written, n - written);
 	if(sret < 0){
 	  int e = errno;
-	  error(0, errno, "write");
+	  error_plus(0, errno, "write");
 	  switch(e){
 	  case EBADF:
 	  case EFAULT:
@@ -325,7 +484,7 @@
       sret = close(STDOUT_FILENO);
       if(sret == -1){
 	int e = errno;
-	error(0, errno, "close");
+	error_plus(0, errno, "close");
 	switch(e){
 	case EBADF:
 	  status = EX_OSFILE;
@@ -341,10 +500,11 @@
     if(sret < 0){
       int e = errno;
       if(errno != EINTR and not feof(stdin)){
-	error(0, errno, "getline");
+	error_plus(0, errno, "getline");
 	switch(e){
 	case EBADF:
 	  status = EX_UNAVAILABLE;
+	  break;
 	case EIO:
 	case EINVAL:
 	default:
@@ -354,8 +514,8 @@
 	break;
       }
     }
-    /* if(sret == 0), then the only sensible thing to do is to retry to
-       read from stdin */
+    /* if(sret == 0), then the only sensible thing to do is to retry
+       to read from stdin */
     fputc('\n', stderr);
     if(debug and not quit_now){
       /* If quit_now is nonzero, we were interrupted by a signal, and
@@ -370,7 +530,7 @@
     fprintf(stderr, "Restoring terminal attributes\n");
   }
   if(tcsetattr(STDIN_FILENO, TCSAFLUSH, &t_old) != 0){
-    error(0, errno, "tcsetattr+echo");
+    error_plus(0, errno, "tcsetattr+echo");
   }
   
   if(quit_now){
@@ -378,7 +538,7 @@
     old_action.sa_handler = SIG_DFL;
     ret = sigaction(signal_received, &old_action, NULL);
     if(ret == -1){
-      error(0, errno, "sigaction");
+      error_plus(0, errno, "sigaction");
     }
     raise(signal_received);
   }

=== modified file 'plugins.d/password-prompt.xml'
--- plugins.d/password-prompt.xml	2009-10-30 16:23:43 +0000
+++ plugins.d/password-prompt.xml	2016-03-05 21:42:56 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "password-prompt">
-<!ENTITY TIMESTAMP "2009-10-30">
+<!ENTITY TIMESTAMP "2016-03-05">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -19,20 +19,27 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@fukt.bsnet.se</email>
+	  <email>belorn@recompile.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@fukt.bsnet.se</email>
+	  <email>teddy@recompile.se</email>
 	</address>
       </author>
     </authorgroup>
     <copyright>
       <year>2008</year>
       <year>2009</year>
+      <year>2010</year>
+      <year>2011</year>
+      <year>2012</year>
+      <year>2013</year>
+      <year>2014</year>
+      <year>2015</year>
+      <year>2016</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -219,9 +226,7 @@
   
   <refsect1 id="bugs">
     <title>BUGS</title>
-    <para>
-      None are known at this time.
-    </para>
+    <xi:include href="../bugs.xml"/>
   </refsect1>
   
   <refsect1 id="example">
@@ -292,6 +297,8 @@
   <refsect1 id="see_also">
     <title>SEE ALSO</title>
     <para>
+      <citerefentry><refentrytitle>intro</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>
       <citerefentry><refentrytitle>crypttab</refentrytitle>
       <manvolnum>5</manvolnum></citerefentry>
       <citerefentry><refentrytitle>mandos-client</refentrytitle>

=== modified file 'plugins.d/plymouth.c'
--- plugins.d/plymouth.c	2010-09-26 18:32:58 +0000
+++ plugins.d/plymouth.c	2016-03-17 20:40:55 +0000
@@ -1,9 +1,9 @@
 /*  -*- coding: utf-8 -*- */
 /*
- * Usplash - Read a password from usplash and output it
+ * Plymouth - Read a password from Plymouth and output it
  * 
- * Copyright © 2010 Teddy Hogeborn
- * Copyright © 2010 Björn Påhlsson
+ * Copyright © 2010-2016 Teddy Hogeborn
+ * Copyright © 2010-2016 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -19,7 +19,7 @@
  * along with this program.  If not, see
  * <http://www.gnu.org/licenses/>.
  * 
- * Contact the authors at <mandos@fukt.bsnet.se>.
+ * Contact the authors at <mandos@recompile.se>.
  */
 
 #define _GNU_SOURCE		/* asprintf(), TEMP_FAILURE_RETRY() */
@@ -36,7 +36,8 @@
 #include <stddef.h>		/* NULL */
 #include <string.h>		/* strchr(), memcmp() */
 #include <stdio.h>		/* asprintf(), perror(), fopen(),
-				   fscanf() */
+				   fscanf(), vasprintf(), fprintf(),
+				   vfprintf() */
 #include <unistd.h>		/* close(), readlink(), read(),
 				   fork(), setsid(), chdir(), dup2(),
 				   STDERR_FILENO, execv(), access() */
@@ -50,17 +51,20 @@
 #include <error.h>		/* error() */
 #include <errno.h>		/* TEMP_FAILURE_RETRY */
 #include <argz.h>		/* argz_count(), argz_extract() */
+#include <stdarg.h>		/* va_list, va_start(), ... */
 
 sig_atomic_t interrupted_by_signal = 0;
-const char plymouth_pid[] = "/dev/.initramfs/plymouth.pid";
+
+/* Used by Ubuntu 11.04 (Natty Narwahl) */
+const char plymouth_old_pid[] = "/dev/.initramfs/plymouth.pid";
+/* Used by Ubuntu 11.10 (Oneiric Ocelot) */
+const char plymouth_pid[] = "/run/initramfs/plymouth.pid";
+
 const char plymouth_path[] = "/bin/plymouth";
 const char plymouthd_path[] = "/sbin/plymouthd";
 const char *plymouthd_default_argv[] = {"/sbin/plymouthd",
 					"--mode=boot",
 					"--attach-to-session",
-					"--pid-file="
-					"/dev/.initramfs/"
-					"plymouth.pid",
 					NULL };
 
 static void termination_handler(__attribute__((unused))int signum){
@@ -70,27 +74,53 @@
   interrupted_by_signal = 1;
 }
 
+/* Function to use when printing errors */
+__attribute__((format (gnu_printf, 3, 4)))
+void error_plus(int status, int errnum, const char *formatstring,
+		...){
+  va_list ap;
+  char *text;
+  int ret;
+  
+  va_start(ap, formatstring);
+  ret = vasprintf(&text, formatstring, ap);
+  if(ret == -1){
+    fprintf(stderr, "Mandos plugin %s: ",
+	    program_invocation_short_name);
+    vfprintf(stderr, formatstring, ap);
+    fprintf(stderr, ": ");
+    fprintf(stderr, "%s\n", strerror(errnum));
+    error(status, errno, "vasprintf while printing error");
+    return;
+  }
+  fprintf(stderr, "Mandos plugin ");
+  error(status, errnum, "%s", text);
+  free(text);
+}
+
 /* Create prompt string */
 char *makeprompt(void){
   int ret = 0;
   char *prompt;
   const char *const cryptsource = getenv("cryptsource");
   const char *const crypttarget = getenv("crypttarget");
-  const char prompt_start[] = "Enter passphrase to unlock the disk";
+  const char prompt_start[] = "Unlocking the disk";
+  const char prompt_end[] = "Enter passphrase";
   
   if(cryptsource == NULL){
     if(crypttarget == NULL){
-      ret = asprintf(&prompt, "%s: ", prompt_start);
+      ret = asprintf(&prompt, "%s\n%s", prompt_start, prompt_end);
     } else {
-      ret = asprintf(&prompt, "%s (%s): ", prompt_start,
-		     crypttarget);
+      ret = asprintf(&prompt, "%s (%s)\n%s", prompt_start,
+		     crypttarget, prompt_end);
     }
   } else {
     if(crypttarget == NULL){
-      ret = asprintf(&prompt, "%s %s: ", prompt_start, cryptsource);
+      ret = asprintf(&prompt, "%s %s\n%s", prompt_start, cryptsource,
+		     prompt_end);
     } else {
-      ret = asprintf(&prompt, "%s %s (%s): ", prompt_start,
-		     cryptsource, crypttarget);
+      ret = asprintf(&prompt, "%s %s (%s)\n%s", prompt_start,
+		     cryptsource, crypttarget, prompt_end);
     }
   }
   if(ret == -1){
@@ -107,32 +137,33 @@
 bool become_a_daemon(void){
   int ret = setuid(geteuid());
   if(ret == -1){
-    error(0, errno, "setuid");
+    error_plus(0, errno, "setuid");
   }
     
   setsid();
   ret = chdir("/");
   if(ret == -1){
-    error(0, errno, "chdir");
+    error_plus(0, errno, "chdir");
     return false;
   }
   ret = dup2(STDERR_FILENO, STDOUT_FILENO); /* replace our stdout */
   if(ret == -1){
-    error(0, errno, "dup2");
+    error_plus(0, errno, "dup2");
     return false;
   }
   return true;
 }
 
+__attribute__((nonnull (2, 3)))
 bool exec_and_wait(pid_t *pid_return, const char *path,
-		   const char **argv, bool interruptable,
+		   const char * const *argv, bool interruptable,
 		   bool daemonize){
   int status;
   int ret;
   pid_t pid;
   pid = fork();
   if(pid == -1){
-    error(0, errno, "fork");
+    error_plus(0, errno, "fork");
     return false;
   }
   if(pid == 0){
@@ -142,24 +173,28 @@
 	_exit(EX_OSERR);
       }
     }
-
-    char **new_argv = NULL;
-    char *tmp;
+    
+    char **new_argv = malloc(sizeof(const char *));
+    if(new_argv == NULL){
+      error_plus(0, errno, "malloc");
+      _exit(EX_OSERR);
+    }
+    char **tmp;
     int i = 0;
-    for (; argv[i]!=(char *)NULL; i++){
-      tmp = realloc(new_argv, sizeof(const char *) * ((size_t)i + 1));
-      if (tmp == NULL){
-	error(0, errno, "realloc");
+    for (; argv[i]!=NULL; i++){
+      tmp = realloc(new_argv, sizeof(const char *) * ((size_t)i + 2));
+      if(tmp == NULL){
+	error_plus(0, errno, "realloc");
 	free(new_argv);
 	_exit(EX_OSERR);
       }
-      new_argv = (char **)tmp;
+      new_argv = tmp;
       new_argv[i] = strdup(argv[i]);
     }
-    new_argv[i] = (char *) NULL;
+    new_argv[i] = NULL;
     
     execv(path, (char *const *)new_argv);
-    error(0, errno, "execv");
+    error_plus(0, errno, "execv");
     _exit(EXIT_FAILURE);
   }
   if(pid_return != NULL){
@@ -174,7 +209,7 @@
     return false;
   }
   if(ret == -1){
-    error(0, errno, "waitpid");
+    error_plus(0, errno, "waitpid");
     return false;
   }
   if(WIFEXITED(status) and (WEXITSTATUS(status) == 0)){
@@ -183,24 +218,25 @@
   return false;
 }
 
+__attribute__((nonnull))
 int is_plymouth(const struct dirent *proc_entry){
   int ret;
   {
-    uintmax_t maxvalue;
+    uintmax_t proc_id;
     char *tmp;
     errno = 0;
-    maxvalue = strtoumax(proc_entry->d_name, &tmp, 10);
+    proc_id = strtoumax(proc_entry->d_name, &tmp, 10);
 
     if(errno != 0 or *tmp != '\0'
-       or maxvalue != (uintmax_t)((pid_t)maxvalue)){
+       or proc_id != (uintmax_t)((pid_t)proc_id)){
       return 0;
     }
   }
-  char exe_target[sizeof(plymouth_path)];
+  char exe_target[sizeof(plymouthd_path)];
   char *exe_link;
   ret = asprintf(&exe_link, "/proc/%s/exe", proc_entry->d_name);
   if(ret == -1){
-    error(0, errno, "asprintf");
+    error_plus(0, errno, "asprintf");
     return 0;
   }
   
@@ -209,7 +245,7 @@
   if(ret == -1){
     free(exe_link);
     if(errno != ENOENT){
-      error(0, errno, "lstat");
+      error_plus(0, errno, "lstat");
     }
     return 0;
   }
@@ -223,9 +259,9 @@
   
   ssize_t sret = readlink(exe_link, exe_target, sizeof(exe_target));
   free(exe_link);
-  if((sret != (ssize_t)sizeof(plymouth_path)-1) or
-      (memcmp(plymouth_path, exe_target,
-	      sizeof(plymouth_path)-1) != 0)){
+  if((sret != (ssize_t)sizeof(plymouthd_path)-1) or
+      (memcmp(plymouthd_path, exe_target,
+	      sizeof(plymouthd_path)-1) != 0)){
     return 0;
   }
   return 1;
@@ -233,30 +269,54 @@
 
 pid_t get_pid(void){
   int ret;
+  uintmax_t proc_id = 0;
   FILE *pidfile = fopen(plymouth_pid, "r");
-  uintmax_t maxvalue = 0;
+  /* Try the new pid file location */
   if(pidfile != NULL){
-    ret = fscanf(pidfile, "%" SCNuMAX, &maxvalue);
+    ret = fscanf(pidfile, "%" SCNuMAX, &proc_id);
     if(ret != 1){
-      maxvalue = 0;
+      proc_id = 0;
     }
     fclose(pidfile);
   }
-  if(maxvalue == 0){
-    struct dirent **direntries;
+  /* Try the old pid file location */
+  if(proc_id == 0){
+    pidfile = fopen(plymouth_pid, "r");
+    if(pidfile != NULL){
+      ret = fscanf(pidfile, "%" SCNuMAX, &proc_id);
+      if(ret != 1){
+	proc_id = 0;
+      }
+      fclose(pidfile);
+    }
+  }
+  /* Look for a plymouth process */
+  if(proc_id == 0){
+    struct dirent **direntries = NULL;
     ret = scandir("/proc", &direntries, is_plymouth, alphasort);
-    sscanf(direntries[0]->d_name, "%" SCNuMAX, &maxvalue);
+    if(ret == -1){
+      error_plus(0, errno, "scandir");
+    }
+    if(ret > 0){
+      ret = sscanf(direntries[0]->d_name, "%" SCNuMAX, &proc_id);
+      if(ret < 0){
+	error_plus(0, errno, "sscanf");
+      }
+    }
+    /* scandir might preallocate for this variable (man page unclear).
+       even if ret == 0, therefore we need to free it. */
+    free(direntries);
   }
   pid_t pid;
-  pid = (pid_t)maxvalue;
-  if((uintmax_t)pid == maxvalue){
+  pid = (pid_t)proc_id;
+  if((uintmax_t)pid == proc_id){
     return pid;
   }
   
   return 0;
 }
 
-const char **getargv(pid_t pid){
+const char * const * getargv(pid_t pid){
   int cl_fd;
   char *cmdline_filename;
   ssize_t sret;
@@ -265,7 +325,7 @@
   ret = asprintf(&cmdline_filename, "/proc/%" PRIuMAX "/cmdline",
 		 (uintmax_t)pid);
   if(ret == -1){
-    error(0, errno, "asprintf");
+    error_plus(0, errno, "asprintf");
     return NULL;
   }
   
@@ -273,7 +333,7 @@
   cl_fd = open(cmdline_filename, O_RDONLY);
   free(cmdline_filename);
   if(cl_fd == -1){
-    error(0, errno, "open");
+    error_plus(0, errno, "open");
     return NULL;
   }
   
@@ -287,7 +347,7 @@
     if(cmdline_len + blocksize > cmdline_allocated){
       tmp = realloc(cmdline, cmdline_allocated + blocksize);
       if(tmp == NULL){
-	error(0, errno, "realloc");
+	error_plus(0, errno, "realloc");
 	free(cmdline);
 	close(cl_fd);
 	return NULL;
@@ -300,7 +360,7 @@
     sret = read(cl_fd, cmdline + cmdline_len,
 		cmdline_allocated - cmdline_len);
     if(sret == -1){
-      error(0, errno, "read");
+      error_plus(0, errno, "read");
       free(cmdline);
       close(cl_fd);
       return NULL;
@@ -309,7 +369,7 @@
   } while(sret != 0);
   ret = close(cl_fd);
   if(ret == -1){
-    error(0, errno, "close");
+    error_plus(0, errno, "close");
     free(cmdline);
     return NULL;
   }
@@ -318,12 +378,12 @@
   char **argv = malloc((argz_count(cmdline, cmdline_len) + 1)
 		       * sizeof(char *)); /* Get number of args */
   if(argv == NULL){
-    error(0, errno, "argv = malloc()");
+    error_plus(0, errno, "argv = malloc()");
     free(cmdline);
     return NULL;
   }
   argz_extract(cmdline, cmdline_len, argv); /* Create argv */
-  return (const char **)argv;
+  return (const char * const *)argv;
 }
 
 int main(__attribute__((unused))int argc,
@@ -351,16 +411,16 @@
 	*sig != 0; sig++){
       ret = sigaddset(&new_action.sa_mask, *sig);
       if(ret == -1){
-	error(EX_OSERR, errno, "sigaddset");
+	error_plus(EX_OSERR, errno, "sigaddset");
       }
       ret = sigaction(*sig, NULL, &old_action);
       if(ret == -1){
-	error(EX_OSERR, errno, "sigaction");
+	error_plus(EX_OSERR, errno, "sigaction");
       }
       if(old_action.sa_handler != SIG_IGN){
 	ret = sigaction(*sig, &new_action, NULL);
 	if(ret == -1){
-	  error(EX_OSERR, errno, "sigaction");
+	  error_plus(EX_OSERR, errno, "sigaction");
 	}
       }
     }
@@ -385,7 +445,7 @@
   ret = asprintf(&prompt_arg, "--prompt=%s", prompt);
   free(prompt);
   if(ret == -1){
-    error(EX_OSERR, errno, "asprintf");
+    error_plus(EX_OSERR, errno, "asprintf");
   }
   
   /* plymouth ask-for-password --prompt="$prompt" */
@@ -404,10 +464,10 @@
   }
   kill_and_wait(plymouth_command_pid);
   
-  const char **plymouthd_argv;
+  const char * const *plymouthd_argv;
   pid_t pid = get_pid();
   if(pid == 0){
-    error(0, 0, "plymouthd pid not found");
+    error_plus(0, 0, "plymouthd pid not found");
     plymouthd_argv = plymouthd_default_argv;
   } else {
     plymouthd_argv = getargv(pid);

=== modified file 'plugins.d/plymouth.xml'
--- plugins.d/plymouth.xml	2010-09-26 18:32:58 +0000
+++ plugins.d/plymouth.xml	2016-03-05 21:42:56 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "plymouth">
-<!ENTITY TIMESTAMP "2010-09-26">
+<!ENTITY TIMESTAMP "2016-03-05">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -19,19 +19,25 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@fukt.bsnet.se</email>
+	  <email>belorn@recompile.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@fukt.bsnet.se</email>
+	  <email>teddy@recompile.se</email>
 	</address>
       </author>
     </authorgroup>
     <copyright>
       <year>2010</year>
+      <year>2011</year>
+      <year>2012</year>
+      <year>2013</year>
+      <year>2014</year>
+      <year>2015</year>
+      <year>2016</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -160,7 +166,7 @@
 	</listitem>
       </varlistentry>
       <varlistentry>
-	<term><filename>/proc</filename></term>
+	<term><filename class="directory">/proc</filename></term>
 	<listitem>
 	  <para>
 	    To find the running <citerefentry><refentrytitle
@@ -199,6 +205,7 @@
       daemon and starting a new one is ugly, but necessary as long as
       it does not support aborting a password request.
     </para>
+    <xi:include href="../bugs.xml"/>
   </refsect1>
   
   <refsect1 id="example">
@@ -260,6 +267,8 @@
   <refsect1 id="see_also">
     <title>SEE ALSO</title>
     <para>
+      <citerefentry><refentrytitle>intro</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>crypttab</refentrytitle>
       <manvolnum>5</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>plugin-runner</refentrytitle>

=== modified file 'plugins.d/splashy.c'
--- plugins.d/splashy.c	2010-10-07 17:46:56 +0000
+++ plugins.d/splashy.c	2016-02-28 14:22:10 +0000
@@ -2,8 +2,8 @@
 /*
  * Splashy - Read a password from splashy and output it
  * 
- * Copyright © 2008-2010 Teddy Hogeborn
- * Copyright © 2008-2010 Björn Påhlsson
+ * Copyright © 2008-2016 Teddy Hogeborn
+ * Copyright © 2008-2016 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -19,7 +19,7 @@
  * along with this program.  If not, see
  * <http://www.gnu.org/licenses/>.
  * 
- * Contact the authors at <mandos@fukt.bsnet.se>.
+ * Contact the authors at <mandos@recompile.se>.
  */
 
 #define _GNU_SOURCE		/* TEMP_FAILURE_RETRY(), asprintf() */
@@ -29,7 +29,8 @@
 				   SIG_IGN, kill(), SIGKILL */
 #include <stddef.h>		/* NULL */
 #include <stdlib.h>		/* getenv() */
-#include <stdio.h>		/* asprintf() */
+#include <stdio.h>		/* asprintf(), vasprintf(), vprintf(),
+				   fprintf() */
 #include <stdlib.h>		/* EXIT_FAILURE, free(),
 				   EXIT_SUCCESS */
 #include <sys/types.h>		/* pid_t, DIR, struct dirent,
@@ -42,7 +43,7 @@
 				   sleep(), dup2() STDERR_FILENO,
 				   STDOUT_FILENO, _exit(),
 				   pause() */
-#include <string.h>		/* memcmp() */
+#include <string.h>		/* memcmp(), strerror() */
 #include <errno.h>		/* errno, EACCES, ENOTDIR, ELOOP,
 				   ENOENT, ENAMETOOLONG, EMFILE,
 				   ENFILE, ENOMEM, ENOEXEC, EINVAL,
@@ -54,10 +55,36 @@
 				   WEXITSTATUS() */
 #include <sysexits.h>		/* EX_OSERR, EX_OSFILE,
 				   EX_UNAVAILABLE */
+#include <stdarg.h>		/* va_list, va_start(), ... */
 
 sig_atomic_t interrupted_by_signal = 0;
 int signal_received;
 
+/* Function to use when printing errors */
+__attribute__((format (gnu_printf, 3, 4)))
+void error_plus(int status, int errnum, const char *formatstring,
+		...){
+  va_list ap;
+  char *text;
+  int ret;
+  
+  va_start(ap, formatstring);
+  ret = vasprintf(&text, formatstring, ap);
+  if(ret == -1){
+    fprintf(stderr, "Mandos plugin %s: ",
+	    program_invocation_short_name);
+    vfprintf(stderr, formatstring, ap);
+    fprintf(stderr, ": ");
+    fprintf(stderr, "%s\n", strerror(errnum));
+    error(status, errno, "vasprintf while printing error");
+    return;
+  }
+  fprintf(stderr, "Mandos plugin ");
+  error(status, errnum, "%s", text);
+  free(text);
+}
+
+
 static void termination_handler(int signum){
   if(interrupted_by_signal){
     return;
@@ -110,7 +137,7 @@
     proc_dir = opendir("/proc");
     if(proc_dir == NULL){
       int e = errno;
-      error(0, errno, "opendir");
+      error_plus(0, errno, "opendir");
       switch(e){
       case EACCES:
       case ENOTDIR:
@@ -152,7 +179,7 @@
 	char *exe_link;
 	ret = asprintf(&exe_link, "/proc/%s/exe", proc_ent->d_name);
 	if(ret == -1){
-	  error(0, errno, "asprintf");
+	  error_plus(0, errno, "asprintf");
 	  exitstatus = EX_OSERR;
 	  goto failure;
 	}
@@ -166,7 +193,7 @@
 	    continue;
 	  }
 	  int e = errno;
-	  error(0, errno, "lstat");
+	  error_plus(0, errno, "lstat");
 	  free(exe_link);
 	  switch(e){
 	  case EACCES:
@@ -214,60 +241,60 @@
     sigemptyset(&new_action.sa_mask);
     ret = sigaddset(&new_action.sa_mask, SIGINT);
     if(ret == -1){
-      error(0, errno, "sigaddset");
+      error_plus(0, errno, "sigaddset");
       exitstatus = EX_OSERR;
       goto failure;
     }
     ret = sigaddset(&new_action.sa_mask, SIGHUP);
     if(ret == -1){
-      error(0, errno, "sigaddset");
+      error_plus(0, errno, "sigaddset");
       exitstatus = EX_OSERR;
       goto failure;
     }
     ret = sigaddset(&new_action.sa_mask, SIGTERM);
     if(ret == -1){
-      error(0, errno, "sigaddset");
+      error_plus(0, errno, "sigaddset");
       exitstatus = EX_OSERR;
       goto failure;
     }
     ret = sigaction(SIGINT, NULL, &old_action);
     if(ret == -1){
-      error(0, errno, "sigaction");
+      error_plus(0, errno, "sigaction");
       exitstatus = EX_OSERR;
       goto failure;
     }
     if(old_action.sa_handler != SIG_IGN){
       ret = sigaction(SIGINT, &new_action, NULL);
       if(ret == -1){
-	error(0, errno, "sigaction");
+	error_plus(0, errno, "sigaction");
 	exitstatus = EX_OSERR;
 	goto failure;
       }
     }
     ret = sigaction(SIGHUP, NULL, &old_action);
     if(ret == -1){
-      error(0, errno, "sigaction");
+      error_plus(0, errno, "sigaction");
       exitstatus = EX_OSERR;
       goto failure;
     }
     if(old_action.sa_handler != SIG_IGN){
       ret = sigaction(SIGHUP, &new_action, NULL);
       if(ret == -1){
-	error(0, errno, "sigaction");
+	error_plus(0, errno, "sigaction");
 	exitstatus = EX_OSERR;
 	goto failure;
       }
     }
     ret = sigaction(SIGTERM, NULL, &old_action);
     if(ret == -1){
-      error(0, errno, "sigaction");
+      error_plus(0, errno, "sigaction");
       exitstatus = EX_OSERR;
       goto failure;
     }
     if(old_action.sa_handler != SIG_IGN){
       ret = sigaction(SIGTERM, &new_action, NULL);
       if(ret == -1){
-	error(0, errno, "sigaction");
+	error_plus(0, errno, "sigaction");
 	exitstatus = EX_OSERR;
 	goto failure;
       }
@@ -284,7 +311,7 @@
     goto failure;
   }
   if(splashy_command_pid == -1){
-    error(0, errno, "fork");
+    error_plus(0, errno, "fork");
     exitstatus = EX_OSERR;
     goto failure;
   }
@@ -294,7 +321,7 @@
       const char splashy_command[] = "/sbin/splashy_update";
       execl(splashy_command, splashy_command, prompt, (char *)NULL);
       int e = errno;
-      error(0, errno, "execl");
+      error_plus(0, errno, "execl");
       switch(e){
       case EACCES:
       case ENOENT:
@@ -344,7 +371,7 @@
       goto failure;
     }
     if(ret == -1){
-      error(0, errno, "waitpid");
+      error_plus(0, errno, "waitpid");
       if(errno == ECHILD){
 	splashy_command_pid = 0;
       }
@@ -382,27 +409,27 @@
 	 the real user ID (_mandos) */
       ret = setuid(geteuid());
       if(ret == -1){
-	error(0, errno, "setuid");
+	error_plus(0, errno, "setuid");
       }
       
       setsid();
       ret = chdir("/");
       if(ret == -1){
-	error(0, errno, "chdir");
+	error_plus(0, errno, "chdir");
       }
 /*       if(fork() != 0){ */
 /* 	_exit(EXIT_SUCCESS); */
 /*       } */
       ret = dup2(STDERR_FILENO, STDOUT_FILENO); /* replace stdout */
       if(ret == -1){
-	error(0, errno, "dup2");
+	error_plus(0, errno, "dup2");
 	_exit(EX_OSERR);
       }
       
       execl("/sbin/splashy", "/sbin/splashy", "boot", (char *)NULL);
       {
 	int e = errno;
-	error(0, errno, "execl");
+	error_plus(0, errno, "execl");
 	switch(e){
 	case EACCES:
 	case ENOENT:
@@ -428,13 +455,13 @@
     ret = (int)TEMP_FAILURE_RETRY(sigaction(signal_received,
 					    &signal_action, NULL));
     if(ret == -1){
-      error(0, errno, "sigaction");
+      error_plus(0, errno, "sigaction");
     }
     do {
       ret = raise(signal_received);
     } while(ret != 0 and errno == EINTR);
     if(ret != 0){
-      error(0, errno, "raise");
+      error_plus(0, errno, "raise");
       abort();
     }
     TEMP_FAILURE_RETRY(pause());

=== modified file 'plugins.d/splashy.xml'
--- plugins.d/splashy.xml	2009-01-04 21:54:55 +0000
+++ plugins.d/splashy.xml	2016-03-05 21:42:56 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "splashy">
-<!ENTITY TIMESTAMP "2009-01-04">
+<!ENTITY TIMESTAMP "2016-03-05">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -19,20 +19,27 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@fukt.bsnet.se</email>
+	  <email>belorn@recompile.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@fukt.bsnet.se</email>
+	  <email>teddy@recompile.se</email>
 	</address>
       </author>
     </authorgroup>
     <copyright>
       <year>2008</year>
       <year>2009</year>
+      <year>2010</year>
+      <year>2011</year>
+      <year>2012</year>
+      <year>2013</year>
+      <year>2014</year>
+      <year>2015</year>
+      <year>2016</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -202,6 +209,7 @@
       is ugly, but necessary as long as it does not support aborting a
       password request.
     </para>
+    <xi:include href="../bugs.xml"/>
   </refsect1>
   
   <refsect1 id="example">
@@ -263,6 +271,8 @@
   <refsect1 id="see_also">
     <title>SEE ALSO</title>
     <para>
+      <citerefentry><refentrytitle>intro</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>crypttab</refentrytitle>
       <manvolnum>5</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>plugin-runner</refentrytitle>

=== modified file 'plugins.d/usplash.c'
--- plugins.d/usplash.c	2010-09-26 18:32:58 +0000
+++ plugins.d/usplash.c	2016-02-28 14:22:10 +0000
@@ -2,8 +2,8 @@
 /*
  * Usplash - Read a password from usplash and output it
  * 
- * Copyright © 2008-2010 Teddy Hogeborn
- * Copyright © 2008-2010 Björn Påhlsson
+ * Copyright © 2008-2016 Teddy Hogeborn
+ * Copyright © 2008-2016 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -19,7 +19,7 @@
  * along with this program.  If not, see
  * <http://www.gnu.org/licenses/>.
  * 
- * Contact the authors at <mandos@fukt.bsnet.se>.
+ * Contact the authors at <mandos@recompile.se>.
  */
 
 #define _GNU_SOURCE		/* asprintf(), TEMP_FAILURE_RETRY() */
@@ -35,8 +35,9 @@
 #include <sys/types.h>		/* size_t, ssize_t, pid_t, DIR, struct
 				   dirent */
 #include <stddef.h>		/* NULL */
-#include <string.h>		/* strlen(), memcmp() */
-#include <stdio.h>		/* asprintf()*/
+#include <string.h>		/* strlen(), memcmp(), strerror() */
+#include <stdio.h>		/* asprintf(), vasprintf(), vprintf(),
+				   fprintf() */
 #include <unistd.h>		/* close(), write(), readlink(),
 				   read(), STDOUT_FILENO, sleep(),
 				   fork(), setuid(), geteuid(),
@@ -50,11 +51,36 @@
 #include <sys/stat.h>		/* struct stat, lstat(), S_ISLNK */
 #include <sysexits.h>		/* EX_OSERR, EX_UNAVAILABLE */
 #include <argz.h>		/* argz_count(), argz_extract() */
+#include <stdarg.h>		/* va_list, va_start(), ... */
 
 sig_atomic_t interrupted_by_signal = 0;
 int signal_received;
 const char usplash_name[] = "/sbin/usplash";
 
+/* Function to use when printing errors */
+__attribute__((format (gnu_printf, 3, 4)))
+void error_plus(int status, int errnum, const char *formatstring,
+		...){
+  va_list ap;
+  char *text;
+  int ret;
+  
+  va_start(ap, formatstring);
+  ret = vasprintf(&text, formatstring, ap);
+  if(ret == -1){
+    fprintf(stderr, "Mandos plugin %s: ",
+	    program_invocation_short_name);
+    vfprintf(stderr, formatstring, ap);
+    fprintf(stderr, ": ");
+    fprintf(stderr, "%s\n", strerror(errnum));
+    error(status, errno, "vasprintf while printing error");
+    return;
+  }
+  fprintf(stderr, "Mandos plugin ");
+  error(status, errnum, "%s", text);
+  free(text);
+}
+
 static void termination_handler(int signum){
   if(interrupted_by_signal){
     return;
@@ -91,7 +117,7 @@
       ret = asprintf(&cmd_line_alloc, "%s %s", cmd, arg);
       if(ret == -1){
 	int e = errno;
-	TEMP_FAILURE_RETRY(close(*fifo_fd_r));
+	close(*fifo_fd_r);
 	errno = e;
 	return false;
       }
@@ -107,7 +133,7 @@
 		 cmd_line_len - written);
     if(sret == -1){
       int e = errno;
-      TEMP_FAILURE_RETRY(close(*fifo_fd_r));
+      close(*fifo_fd_r);
       free(cmd_line_alloc);
       errno = e;
       return false;
@@ -155,7 +181,7 @@
   size_t cmdline_len = 0;
   DIR *proc_dir = opendir("/proc");
   if(proc_dir == NULL){
-    error(0, errno, "opendir");
+    error_plus(0, errno, "opendir");
     return -1;
   }
   errno = 0;
@@ -183,7 +209,7 @@
       char *exe_link;
       ret = asprintf(&exe_link, "/proc/%s/exe", proc_ent->d_name);
       if(ret == -1){
-	error(0, errno, "asprintf");
+	error_plus(0, errno, "asprintf");
 	goto fail_find_usplash;
       }
       
@@ -195,7 +221,7 @@
 	  free(exe_link);
 	  continue;
 	}
-	error(0, errno, "lstat");
+	error_plus(0, errno, "lstat");
 	free(exe_link);
 	goto fail_find_usplash;
       }
@@ -226,13 +252,13 @@
 	ret = asprintf(&cmdline_filename, "/proc/%s/cmdline",
 		       proc_ent->d_name);
 	if(ret == -1){
-	  error(0, errno, "asprintf");
+	  error_plus(0, errno, "asprintf");
 	  goto fail_find_usplash;
 	}
 	cl_fd = open(cmdline_filename, O_RDONLY);
 	free(cmdline_filename);
 	if(cl_fd == -1){
-	  error(0, errno, "open");
+	  error_plus(0, errno, "open");
 	  goto fail_find_usplash;
 	}
       }
@@ -244,7 +270,7 @@
 	if(cmdline_len + blocksize > cmdline_allocated){
 	  tmp = realloc(cmdline, cmdline_allocated + blocksize);
 	  if(tmp == NULL){
-	    error(0, errno, "realloc");
+	    error_plus(0, errno, "realloc");
 	    close(cl_fd);
 	    goto fail_find_usplash;
 	  }
@@ -255,7 +281,7 @@
 	sret = read(cl_fd, cmdline + cmdline_len,
 		    cmdline_allocated - cmdline_len);
 	if(sret == -1){
-	  error(0, errno, "read");
+	  error_plus(0, errno, "read");
 	  close(cl_fd);
 	  goto fail_find_usplash;
 	}
@@ -263,14 +289,14 @@
       } while(sret != 0);
       ret = close(cl_fd);
       if(ret == -1){
-	error(0, errno, "close");
+	error_plus(0, errno, "close");
 	goto fail_find_usplash;
       }
     }
     /* Close directory */
     ret = closedir(proc_dir);
     if(ret == -1){
-      error(0, errno, "closedir");
+      error_plus(0, errno, "closedir");
       goto fail_find_usplash;
     }
     /* Success */
@@ -325,26 +351,26 @@
     sigemptyset(&new_action.sa_mask);
     ret = sigaddset(&new_action.sa_mask, SIGINT);
     if(ret == -1){
-      error(0, errno, "sigaddset");
+      error_plus(0, errno, "sigaddset");
       status = EX_OSERR;
       goto failure;
     }
     ret = sigaddset(&new_action.sa_mask, SIGHUP);
     if(ret == -1){
-      error(0, errno, "sigaddset");
+      error_plus(0, errno, "sigaddset");
       status = EX_OSERR;
       goto failure;
     }
     ret = sigaddset(&new_action.sa_mask, SIGTERM);
     if(ret == -1){
-      error(0, errno, "sigaddset");
+      error_plus(0, errno, "sigaddset");
       status = EX_OSERR;
       goto failure;
     }
     ret = sigaction(SIGINT, NULL, &old_action);
     if(ret == -1){
       if(errno != EINTR){
-	error(0, errno, "sigaction");
+	error_plus(0, errno, "sigaction");
 	status = EX_OSERR;
       }
       goto failure;
@@ -353,7 +379,7 @@
       ret = sigaction(SIGINT, &new_action, NULL);
       if(ret == -1){
 	if(errno != EINTR){
-	  error(0, errno, "sigaction");
+	  error_plus(0, errno, "sigaction");
 	  status = EX_OSERR;
 	}
 	goto failure;
@@ -362,7 +388,7 @@
     ret = sigaction(SIGHUP, NULL, &old_action);
     if(ret == -1){
       if(errno != EINTR){
-	error(0, errno, "sigaction");
+	error_plus(0, errno, "sigaction");
 	status = EX_OSERR;
       }
       goto failure;
@@ -371,7 +397,7 @@
       ret = sigaction(SIGHUP, &new_action, NULL);
       if(ret == -1){
 	if(errno != EINTR){
-	  error(0, errno, "sigaction");
+	  error_plus(0, errno, "sigaction");
 	  status = EX_OSERR;
 	}
 	goto failure;
@@ -380,7 +406,7 @@
     ret = sigaction(SIGTERM, NULL, &old_action);
     if(ret == -1){
       if(errno != EINTR){
-	error(0, errno, "sigaction");
+	error_plus(0, errno, "sigaction");
 	status = EX_OSERR;
       }
       goto failure;
@@ -389,7 +415,7 @@
       ret = sigaction(SIGTERM, &new_action, NULL);
       if(ret == -1){
 	if(errno != EINTR){
-	  error(0, errno, "sigaction");
+	  error_plus(0, errno, "sigaction");
 	  status = EX_OSERR;
 	}
 	goto failure;
@@ -401,7 +427,7 @@
   /* Write command to FIFO */
   if(not usplash_write(&fifo_fd, "TIMEOUT", "0")){
     if(errno != EINTR){
-      error(0, errno, "usplash_write");
+      error_plus(0, errno, "usplash_write");
       status = EX_OSERR;
     }
     goto failure;
@@ -413,7 +439,7 @@
   
   if(not usplash_write(&fifo_fd, "INPUTQUIET", prompt)){
     if(errno != EINTR){
-      error(0, errno, "usplash_write");
+      error_plus(0, errno, "usplash_write");
       status = EX_OSERR;
     }
     goto failure;
@@ -431,7 +457,7 @@
   outfifo_fd = open("/dev/.initramfs/usplash_outfifo", O_RDONLY);
   if(outfifo_fd == -1){
     if(errno != EINTR){
-      error(0, errno, "open");
+      error_plus(0, errno, "open");
       status = EX_OSERR;
     }
     goto failure;
@@ -450,7 +476,7 @@
       char *tmp = realloc(buf, buf_allocated + blocksize);
       if(tmp == NULL){
 	if(errno != EINTR){
-	  error(0, errno, "realloc");
+	  error_plus(0, errno, "realloc");
 	  status = EX_OSERR;
 	}
 	goto failure;
@@ -462,10 +488,10 @@
 		buf_allocated - buf_len);
     if(sret == -1){
       if(errno != EINTR){
-	error(0, errno, "read");
+	error_plus(0, errno, "read");
 	status = EX_OSERR;
       }
-      TEMP_FAILURE_RETRY(close(outfifo_fd));
+      close(outfifo_fd);
       goto failure;
     }
     if(interrupted_by_signal){
@@ -477,7 +503,7 @@
   ret = close(outfifo_fd);
   if(ret == -1){
     if(errno != EINTR){
-      error(0, errno, "close");
+      error_plus(0, errno, "close");
       status = EX_OSERR;
     }
     goto failure;
@@ -490,7 +516,7 @@
   
   if(not usplash_write(&fifo_fd, "TIMEOUT", "15")){
     if(errno != EINTR){
-      error(0, errno, "usplash_write");
+      error_plus(0, errno, "usplash_write");
       status = EX_OSERR;
     }
     goto failure;
@@ -503,7 +529,7 @@
   ret = close(fifo_fd);
   if(ret == -1){
     if(errno != EINTR){
-      error(0, errno, "close");
+      error_plus(0, errno, "close");
       status = EX_OSERR;
     }
     goto failure;
@@ -517,7 +543,7 @@
       sret = write(STDOUT_FILENO, buf + written, buf_len - written);
       if(sret == -1){
 	if(errno != EINTR){
-	  error(0, errno, "write");
+	  error_plus(0, errno, "write");
 	  status = EX_OSERR;
 	}
 	goto failure;
@@ -552,18 +578,18 @@
   
   /* Close FIFO */
   if(fifo_fd != -1){
-    ret = (int)TEMP_FAILURE_RETRY(close(fifo_fd));
+    ret = close(fifo_fd);
     if(ret == -1 and errno != EINTR){
-      error(0, errno, "close");
+      error_plus(0, errno, "close");
     }
     fifo_fd = -1;
   }
   
   /* Close output FIFO */
   if(outfifo_fd != -1){
-    ret = (int)TEMP_FAILURE_RETRY(close(outfifo_fd));
+    ret = close(outfifo_fd);
     if(ret == -1){
-      error(0, errno, "close");
+      error_plus(0, errno, "close");
     }
   }
   
@@ -571,7 +597,7 @@
   char **cmdline_argv = malloc((argz_count(cmdline, cmdline_len) + 1)
 			       * sizeof(char *)); /* Count args */
   if(cmdline_argv == NULL){
-    error(0, errno, "malloc");
+    error_plus(0, errno, "malloc");
     return status;
   }
   argz_extract(cmdline, cmdline_len, cmdline_argv); /* Create argv */
@@ -592,13 +618,13 @@
        the real user ID (_mandos) */
     ret = setuid(geteuid());
     if(ret == -1){
-      error(0, errno, "setuid");
+      error_plus(0, errno, "setuid");
     }
     
     setsid();
     ret = chdir("/");
     if(ret == -1){
-      error(0, errno, "chdir");
+      error_plus(0, errno, "chdir");
       _exit(EX_OSERR);
     }
 /*     if(fork() != 0){ */
@@ -606,13 +632,13 @@
 /*     } */
     ret = dup2(STDERR_FILENO, STDOUT_FILENO); /* replace our stdout */
     if(ret == -1){
-      error(0, errno, "dup2");
+      error_plus(0, errno, "dup2");
       _exit(EX_OSERR);
     }
     
     execv(usplash_name, cmdline_argv);
     if(not interrupted_by_signal){
-      error(0, errno, "execv");
+      error_plus(0, errno, "execv");
     }
     free(cmdline);
     free(cmdline_argv);
@@ -623,15 +649,15 @@
   sleep(2);
   if(not usplash_write(&fifo_fd, "PULSATE", NULL)){
     if(errno != EINTR){
-      error(0, errno, "usplash_write");
+      error_plus(0, errno, "usplash_write");
     }
   }
   
   /* Close FIFO (again) */
   if(fifo_fd != -1){
-    ret = (int)TEMP_FAILURE_RETRY(close(fifo_fd));
+    ret = close(fifo_fd);
     if(ret == -1 and errno != EINTR){
-      error(0, errno, "close");
+      error_plus(0, errno, "close");
     }
     fifo_fd = -1;
   }
@@ -642,13 +668,13 @@
     ret = (int)TEMP_FAILURE_RETRY(sigaction(signal_received,
 					    &signal_action, NULL));
     if(ret == -1){
-      error(0, errno, "sigaction");
+      error_plus(0, errno, "sigaction");
     }
     do {
       ret = raise(signal_received);
     } while(ret != 0 and errno == EINTR);
     if(ret != 0){
-      error(0, errno, "raise");
+      error_plus(0, errno, "raise");
       abort();
     }
     TEMP_FAILURE_RETRY(pause());

=== modified file 'plugins.d/usplash.xml'
--- plugins.d/usplash.xml	2009-01-04 21:54:55 +0000
+++ plugins.d/usplash.xml	2016-03-05 21:42:56 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "usplash">
-<!ENTITY TIMESTAMP "2009-01-04">
+<!ENTITY TIMESTAMP "2016-03-05">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -19,20 +19,27 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@fukt.bsnet.se</email>
+	  <email>belorn@recompile.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@fukt.bsnet.se</email>
+	  <email>teddy@recompile.se</email>
 	</address>
       </author>
     </authorgroup>
     <copyright>
       <year>2008</year>
       <year>2009</year>
+      <year>2010</year>
+      <year>2011</year>
+      <year>2012</year>
+      <year>2013</year>
+      <year>2014</year>
+      <year>2015</year>
+      <year>2016</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -177,7 +184,7 @@
 	</listitem>
       </varlistentry>
       <varlistentry>
-	<term><filename>/proc</filename></term>
+	<term><filename class="directory">/proc</filename></term>
 	<listitem>
 	  <para>
 	    To find the running <citerefentry><refentrytitle
@@ -216,6 +223,7 @@
       is ugly, but necessary as long as it does not support aborting a
       password request.
     </para>
+    <xi:include href="../bugs.xml"/>
   </refsect1>
   
   <refsect1 id="example">
@@ -277,6 +285,8 @@
   <refsect1 id="see_also">
     <title>SEE ALSO</title>
     <para>
+      <citerefentry><refentrytitle>intro</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>crypttab</refentrytitle>
       <manvolnum>5</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>fifo</refentrytitle>

=== added file 'tmpfiles.d-mandos.conf'
--- tmpfiles.d-mandos.conf	1970-01-01 00:00:00 +0000
+++ tmpfiles.d-mandos.conf	2016-03-19 03:51:23 +0000
@@ -0,0 +1,1 @@
+d	/var/lib/mandos	700	_mandos	_mandos

